package model

type HwOrder struct {
	Id                int     `json:"id" xorm:"not null pk autoincr index INT(11)"`
	Oid               string  `json:"oid" xorm:"default '' comment('订单编号') VARCHAR(255)"`
	Info              string  `json:"info" xorm:"default '' comment('商品标题') VARCHAR(100)"`
	Commission        float64 `json:"commission" xorm:"default 0.00 comment('佣金') DOUBLE(30,2)"`
	Type              string  `json:"type" xorm:"default '' comment('平台') VARCHAR(100)"`
	TakePhoneNumber   string  `json:"take_phone_number" xorm:"default '' comment('手机号') VARCHAR(100)"`
	RestaurantAddress string  `json:"restaurant_address" xorm:"default '' comment('地址') VARCHAR(100)"`
	Uid               int     `json:"uid" xorm:"default 0 comment('站长id') index INT(11)"`
	Payment           float64 `json:"payment" xorm:"default 0.00 comment('付款金额') DOUBLE(11,2)"`
	Status            string  `json:"status" xorm:"default '' comment('状态描述') VARCHAR(10)"`
	CreateTime        int     `json:"create_time" xorm:"default 0 comment('订单创建时间') INT(11)"`
	Fanli             int     `json:"fanli" xorm:"default 0 comment('是否已返利') INT(1)"`
	Data              string  `json:"data" xorm:"comment('附加内容') LONGTEXT"`
	TakeMealCode      string  `json:"take_meal_code" xorm:"comment('取餐口令') LONGTEXT"`
	SettleTime        int     `json:"settle_time" xorm:"default 0 comment('返利时间') INT(11)"`
	UpdateTime        int     `json:"update_time" xorm:"default 0 comment('订单最后更新时间') INT(11)"`
	Zuid              string  `json:"zuid" xorm:"default '0' comment('站长平台的用户id') VARCHAR(100)"`
	Extra             string  `json:"extra" xorm:"default '' comment('自定义参数') VARCHAR(100)"`
	Code              string  `json:"code" xorm:"default '' comment('取餐口令') VARCHAR(100)"`
	UserId            string  `json:"user_id" xorm:"default '' comment('自定义参数') VARCHAR(100)"`
	LmJsTime          int     `json:"lm_js_time" xorm:"default 0 comment('结算时间') INT(11)"`
	PlatformTypes     string  `json:"platform_types" xorm:"default '' VARCHAR(50)"`
	IsShare           int     `json:"is_share" xorm:"default 0 INT(11)"`
	RefundTime        int     `json:"refund_time" xorm:"default 0 comment('订单退款成功时间') INT(11)"`
	OutMealTime       int     `json:"out_meal_time" xorm:"default 0 comment('订单出餐成功时间') INT(11)"`
	ExtendUid         string  `json:"extend_uid" xorm:"VARCHAR(255)"`
}
