package model

import (
	"time"
)

type MasterWithdrawalFlow struct {
	Id          int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Uid         string    `json:"uid" xorm:"VARCHAR(255)"`
	Time        time.Time `json:"time" xorm:"DATETIME"`
	UpdateTime  time.Time `json:"update_time" xorm:"DATETIME"`
	Remark      string    `json:"remark" xorm:"VARCHAR(255)"`
	Alipay      string    `json:"alipay" xorm:"VARCHAR(255)"`
	AlipayName  string    `json:"alipay_name" xorm:"VARCHAR(255)"`
	Amount      string    `json:"amount" xorm:"default 0.00 DECIMAL(20,2)"`
	Fee         string    `json:"fee" xorm:"default 0.00 DECIMAL(20,2)"`
	Reason      string    `json:"reason" xorm:"VARCHAR(255)"`
	Status      string    `json:"status" xorm:"VARCHAR(255)"`
	CheckTime   time.Time `json:"check_time" xorm:"DATETIME"`
	Img         string    `json:"img" xorm:"VARCHAR(500)"`
	RealAmount  string    `json:"real_amount" xorm:"default 0.00 DECIMAL(20,2)"`
	HasInvoice  int       `json:"has_invoice" xorm:"default 0 comment('是否有发票') INT(1)"`
	InvoiceBili string    `json:"invoice_bili" xorm:"comment('发票比例') VARCHAR(255)"`
	ExtendUid   string    `json:"extend_uid" xorm:"VARCHAR(255)"`
}
