package model

import (
	"time"
)

type PlayletSaleOrder struct {
	Id                 int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Uid                string    `json:"uid" xorm:"default '0' comment('用户id') VARCHAR(255)"`
	Data               string    `json:"data" xorm:"comment('第三方返回数据') VARCHAR(5000)"`
	Oid                string    `json:"oid" xorm:"comment('订单号') unique VARCHAR(255)"`
	Amount             string    `json:"amount" xorm:"default 0.00 comment('金额') DECIMAL(20,2)"`
	Commission         string    `json:"commission" xorm:"default 0.00 comment('佣金') DECIMAL(20,2)"`
	Status             string    `json:"status" xorm:"comment('状态') VARCHAR(255)"`
	CreateTime         time.Time `json:"create_time" xorm:"comment('下单时间') DATETIME"`
	RefundTime         time.Time `json:"refund_time" xorm:"comment('退款时间') DATETIME"`
	UpdateTime         time.Time `json:"update_time" xorm:"comment('广告统计更新时间') DATETIME"`
	Title              string    `json:"title" xorm:"comment('标题') VARCHAR(255)"`
	VideoType          string    `json:"video_type" xorm:"comment('视频类型') VARCHAR(255)"`
	PlatformType       string    `json:"platform_type" xorm:"comment('平台类型') VARCHAR(255)"`
	GoodsType          string    `json:"goods_type" xorm:"comment('商品数据') VARCHAR(255)"`
	SettleTime         int       `json:"settle_time" xorm:"default 0 INT(11)"`
	OrdType            string    `json:"ord_type" xorm:"VARCHAR(255)"`
	TimesNum           string    `json:"times_num" xorm:"VARCHAR(255)"`
	PeopleNum          string    `json:"people_num" xorm:"VARCHAR(255)"`
	SubUid             int       `json:"sub_uid" xorm:"default 0 INT(11)"`
	PlatformSettleTime time.Time `json:"platform_settle_time" xorm:"DATETIME"`
	CustomOid          string    `json:"custom_oid" xorm:"VARCHAR(255)"`
	ExtendUid          string    `json:"extend_uid" xorm:"VARCHAR(255)"`
	Fee                string    `json:"fee" xorm:"default 0.00 DECIMAL(20,2)"`
	TikFee             string    `json:"tik_fee" xorm:"default 0.00 DECIMAL(20,2)"`
	PlatformFee        string    `json:"platform_fee" xorm:"default 0.00 DECIMAL(20,2)"`
}
