package enum

type QrcodeBatchState int32

const (
	QrcodeBatchStateForUseIng     = 1
	QrcodeBatchStateForUseAlready = 2
	QrcodeBatchStateForExpire     = 3
	QrcodeBatchStateForCancel     = 4
)

func (gt QrcodeBatchState) String() string {
	switch gt {
	case QrcodeBatchStateForUseIng:
		return "使用中"
	case QrcodeBatchStateForUseAlready:
		return "使用完"
	case QrcodeBatchStateForExpire:
		return "已过期"
	case QrcodeBatchStateForCancel:
		return "已作废"
	default:
		return "未知"
	}
}

type QrcodeWithBatchRecordsSate int32

const (
	QrcodeWithBatchRecordsStateForWait    = 1
	QrcodeWithBatchRecordsStateForAlready = 2
	QrcodeWithBatchRecordsStateForExpire  = 3
	QrcodeWithBatchRecordsStateForCancel  = 4
)

func (gt QrcodeWithBatchRecordsSate) String() string {
	switch gt {
	case QrcodeWithBatchRecordsStateForWait:
		return "待使用"
	case QrcodeWithBatchRecordsStateForAlready:
		return "已使用"
	case QrcodeWithBatchRecordsStateForExpire:
		return "已过期"
	case QrcodeWithBatchRecordsStateForCancel:
		return "已作废"
	default:
		return "未知"
	}
}

type QrcodeSate int32

const (
	QrcodeSateAllowUse    = 1
	QrcodeSateAllowNotUse = 2
)

func (gt QrcodeSate) String() string {
	switch gt {
	case QrcodeSateAllowUse:
		return "可使用"
	case QrcodeSateAllowNotUse:
		return "不可用"
	default:
		return "未知"
	}
}
