package md

const ZhiosLianlianProductEsIndex = "zhios_lianlian_product"
const ZhiosLianlianProductEsIndexProd = "zhios_lianlian_product_prod"
const ZhiosLianlianProductEsMapping = `
{ 
	"settings" : {
      "number_of_shards" : 2,
      "number_of_replicas" : 1 
    },
	"mappings":{
		"properties":{
			"id":{
				"type": "integer"
			},
			"locationIds":{
				"type": "keyword"
			},
			"shopKey":{
				"type": "keyword"
			},
			"locationId":{
				"type": "integer"
			},
			"productTitle":{
				"type": "text",
         		"analyzer": "ik_smart"
			},
			"faceImg":{
				"type": "keyword"
			},
			"address":{
				"type": "keyword"
			},
			"tel":{
				"type": "keyword"
			},
			"endTime":{
				"type": "integer"
			},
			"beginTime":{
				"type": "integer"
			},
			"validEndDate":{
				"type": "integer"
			},
			"validBeginDate":{
				"type": "integer"
			},
			"singleMin":{
				"type": "integer"
			},
			"singleMax":{
				"type": "integer"
			},
			"channelStock":{
				"type": "integer"
			},
			"stock":{
				"type": "integer"
			},
			"saleAmount":{
				"type": "integer"
			},
			"itemStock":{
				"type": "integer"
			},
			"bookingType":{
				"type": "integer"
			},
			"bookingBeginDate":{
				"type": "integer"
			},
			"bookingShowAddress":{
				"type": "integer"
			},
			"orderShowIdCard":{
				"type": "integer"
			},
			"orderShowDate":{
				"type": "integer"
			},
			"bookingText":{
				"type": "keyword"
			},
			"attention":{
				"type": "keyword"
			},
			"soldOutTime":{
				"type": "integer"
			},
			"isSoldOut":{
				"type": "integer"
			},
			"city":{
				"type": "text",
         		"analyzer": "ik_smart"
			},
			"cityCode":{
				"type": "keyword"
			},
			"latitude":{
				"type": "double"
			},
			"longitude":{
				"type": "double"
			},
			"bookingShowPostTime":{
				"type": "integer"
			},
			"posterUrl":{
				"type": "keyword"
			},
			"items":{
				"type": "keyword"
			},
			"shops":{
				"type": "keyword"
			},
			"categoryPath":{
				"type": "keyword"
			},
			"categoryName":{
				"type": "keyword"
			},
			"productCategoryId":{
				"type": "integer"
			},
			"firstCategoryId":{
				"type": "integer"
			},
			"isReFund":{
				"type": "integer"
			},
			"contractId":{
				"type": "integer"
			},
			"qualificationsList":{
				"type": "keyword"
			},
			"releaseTime":{
				"type": "integer"
			},
			"channelMallPosterImg":{
				"type": "keyword"
			},
			"codeDelay":{
				"type": "integer"
			},
			"name":{
				"type": "keyword"
			},
			"price":{
				"type": "keyword"
			},
			"costPrice":{
				"type": "keyword"
			},
			"lianlianPrice":{
				"type": "keyword"
			},
			"productSequence":{
				"type": "integer"
			},
			"ecommerce":{
				"type": "integer"
			},
			"location":{
				"type": "geo_point"
			}
		}
	}
}`
