package zhimeng_platform

import (
	"applet/app/e"
	"applet/app/md"
	"applet/app/svc/platform"
	"applet/app/utils"
	"github.com/gin-gonic/gin"
)

func LifeOrderList(c *gin.Context) {
	var args map[string]string
	if err := c.ShouldBindJSON(&args); err != nil {
		e.OutErr(c, e.ERR_INVALID_ARGS, err)
		return
	}
	platformMap := md.LifeSettlePvd

	data, total := platform.LifeOrderList(c, args)
	var sourceList []map[string]string

	for k, v := range platformMap {
		tmp := map[string]string{
			"name": v, "value": k,
		}
		sourceList = append(sourceList, tmp)
	}
	statusList := []map[string]string{
		{"name": "订单付款", "value": "订单付款"},
		{"name": "订单成功", "value": "订单成功"},
		{"name": "订单结算", "value": "订单结算"},
		{"name": "订单退款", "value": "订单退款"},
	}
	settleStatusList := []map[string]string{
		{"name": "未结算", "value": "未结算"},
		{"name": "已结算", "value": "已结算"},
	}
	var res = map[string]interface{}{
		"list":               data,
		"total":              total,
		"source_list":        sourceList,
		"status_list":        statusList,
		"settle_status_list": settleStatusList,
	}
	e.OutSuc(c, res, nil)
	return
}
func LifeOrderOutput(c *gin.Context) {
	var args map[string]string
	if err := c.ShouldBindJSON(&args); err != nil {
		e.OutErr(c, e.ERR_INVALID_ARGS, err)
		return
	}
	name, data := platform.LifeOrderOutput(c, args)
	file := utils.Output(c, name, data)
	filename := name + ".xlsx"
	r := map[string]string{
		"file":     file,
		"filename": filename,
	}
	e.OutSuc(c, r, nil)
	return
}
