package zhimeng_platform

import (
	"applet/app/e"
	"applet/app/svc/platform"
	"applet/app/utils"
	"github.com/gin-gonic/gin"
)

func OrderList(c *gin.Context) {
	var args map[string]string
	if err := c.ShouldBindJSON(&args); err != nil {
		e.OutErr(c, e.ERR_INVALID_ARGS, err)
		return
	}

	var data = make([]map[string]string, 0)
	var total int64

	data, total = platform.OrderList(c, args)
	sourceList := []map[string]string{
		{"name": "短剧", "value": "video"},
		{"name": "广告", "value": "adv"},
		{"name": "电影票", "value": "cinema"},
		{"name": "小说", "value": "story"},
	}

	videoList := []map[string]string{
		{"name": "抖音", "value": "douyin"},
		{"name": "快手", "value": "kuaishou"},
		{"name": "视频号", "value": "channel"},
	}
	statusList := []map[string]string{
		{"name": "订单付款", "value": "订单付款"},
		{"name": "订单成功", "value": "订单成功"},
		{"name": "订单结算", "value": "订单结算"},
	}
	settleStatusList := []map[string]string{
		{"name": "未结算", "value": "未结算"},
		{"name": "已结算", "value": "已结算"},
	}
	var res = map[string]interface{}{
		"list":               data,
		"total":              total,
		"source_list":        sourceList,
		"video_ist":          videoList,
		"status_list":        statusList,
		"settle_status_list": settleStatusList,
	}
	e.OutSuc(c, res, nil)
	return
}
func OrderOutput(c *gin.Context) {
	var args map[string]string
	if err := c.ShouldBindJSON(&args); err != nil {
		e.OutErr(c, e.ERR_INVALID_ARGS, err)
		return
	}

	var data map[string]string
	var name string
	name, data = platform.OrderOutput(c, args)
	file := utils.Output(c, name, data)
	filename := name + ".xlsx"
	r := map[string]string{
		"file":     file,
		"filename": filename,
	}
	e.OutSuc(c, r, nil)
	return
}
