package platform

import (
	"applet/app/db"
	"applet/app/utils"
	"github.com/gin-gonic/gin"
	"time"
)

func HwOrderList(c *gin.Context, args map[string]string) ([]map[string]string, int64) {
	masterId, _ := c.Get("master_id")
	args["uid"] = utils.AnyToString(masterId)
	list, total := db.GetHwOrderListTotal(args)
	var data = make([]map[string]string, 0)
	platformMap := map[string]string{
		"starbucks": "星巴克", "movie": "电影", "mcdonald": "麦当劳", "nayuki": "奈雪", "luckin": "瑞幸咖啡", "pizza": "必胜客",
		"pagoda": "百果园", "burger_king": "汉堡王", "heytea": "喜茶", "to_kfc": "肯德基", "wallace": "华莱士", "flowerCake": "鲜花", "delivery": "比价寄", "tourism": "出游",
	}
	if len(list) > 0 {
		for _, v := range list {
			settleStatus := "未结算"
			settleTime := "-"
			if v.SettleTime > 0 {
				settleStatus = "已结算"
				settleTime = time.Unix(int64(v.SettleTime), 0).Format("2006-01-02 15:04:05")
			}
			var tmp = map[string]string{
				"oid":                  v.Oid,
				"uid":                  v.Zuid,
				"title":                v.Info,
				"platform_fee":         "0",
				"commission_bili":      "",
				"source":               platformMap[v.Type],
				"amount":               utils.Float64ToStr(v.Payment),
				"commission":           utils.Float64ToStr(v.Commission),
				"real_commission":      utils.Float64ToStr(v.Commission),
				"platform_settle_time": "-",
				"status":               v.Status,
				"settle_status":        settleStatus,
				"create_time":          time.Unix(int64(v.CreateTime), 0).Format("2006-01-02 15:04:05"),
				"settle_time":          settleTime,
			}
			data = append(data, tmp)
		}
	}
	return data, total
}

func HwOrderOutput(c *gin.Context, args map[string]string) (string, map[string]string) {
	masterId, _ := c.Get("master_id")
	args["mid"] = utils.AnyToString(masterId)
	args["size"] = "3000"
	if args["ids"] != "" {
		args["size"] = "0"
	}
	name := "订单_" + args["p"]
	//写入数据
	data := map[string]string{
		"A1": "订单号",
		"B1": "会员ID",
		"C1": "标题",
		"D1": "来源",
		"E1": "结算时间",
		"F1": "订单状态",
		"G1": "金额",
		"H1": "佣金",
	}
	platformMap := map[string]string{
		"starbucks": "星巴克", "movie": "电影", "mcdonald": "麦当劳", "nayuki": "奈雪", "luckin": "瑞幸咖啡", "pizza": "必胜客",
		"pagoda": "百果园", "burger_king": "汉堡王", "heytea": "喜茶", "to_kfc": "肯德基", "wallace": "华莱士", "flowerCake": "鲜花", "delivery": "比价寄", "tourism": "出游",
	}

	list, _ := db.GetHwOrderListTotal(args)
	if len(list) > 0 {
		for k, v := range list {
			settleTime := "-"
			if v.SettleTime > 0 {
				settleTime = time.Unix(int64(v.SettleTime), 0).Format("2006-01-02 15:04:05")
			}
			i := utils.IntToStr(k + 2)
			data["A"+i] = v.Oid
			data["B"+i] = v.Zuid
			data["C"+i] = v.Info
			data["D"+i] = platformMap[v.Type]
			data["E"+i] = settleTime
			data["F"+i] = v.Status
			data["G"+i] = utils.Float64ToStr(v.Payment)
			data["H"+i] = utils.Float64ToStr(v.Commission)
		}
	}

	return name, data
}
