package md

var SourceCate = map[string]string{
	"tt99fdef4006c36ff001": "dianzhong",
	"tt38e94e54a7d70c4601": "bihai",
	"ttd02aa6974f166cca01": "bihai",
	"tt8a93fc2e15affaaa01": "beiwo",
	"tt87bdf1001882dd4b01": "lutang",  //鹿糖故事会
	"ttdc8aaa3743b4853f01": "xinghe",  //星河剧场
	"ttbed9c86421e54c8501": "kujiang", //酷匠短剧
}
var SourceBili = map[string]string{
	"tt99fdef4006c36ff001": "30",
	"tt38e94e54a7d70c4601": "30",
	"ttd02aa6974f166cca01": "30",
	"tt8a93fc2e15affaaa01": "30",
	"tt87bdf1001882dd4b01": "30",
	"ttdc8aaa3743b4853f01": "30",
}
var TaskAddList = []map[string]string{
	{
		"name":        "tt87bdf1001882dd4b01",
		"type":        "story",
		"second_type": "lutang",
	},
	{
		"name":        "ttdc8aaa3743b4853f01",
		"type":        "video",
		"second_type": "xinghe",
	},
	{
		"name":        "ttbed9c86421e54c8501",
		"type":        "video",
		"second_type": "kujiang",
	},
}

type TikTokTaskDetail struct {
	AnchorTitle           string   `json:"anchor_title"`
	Appid                 string   `json:"appid"`
	PaymentAllocateRatio  int      `json:"payment_allocate_ratio"`
	PlatformAddressApp    string   `json:"platform_address_app"`
	PlatformAddressWeb    string   `json:"platform_address_web"`
	ReferMaCaptures       []string `json:"refer_ma_captures"`
	ReferVideoCaptures    []string `json:"refer_video_captures"`
	RejectReason          string   `json:"reject_reason"`
	StartPage             string   `json:"start_page"`
	Status                int      `json:"status"`
	TaskDesc              string   `json:"task_desc"`
	TaskEndTime           int      `json:"task_end_time"`
	TaskIcon              string   `json:"task_icon"`
	TaskId                int64    `json:"task_id"`
	TaskName              string   `json:"task_name"`
	TaskRefundPeriod      int      `json:"task_refund_period"`
	TaskSettleType        int      `json:"task_settle_type"`
	TaskStartTime         int      `json:"task_start_time"`
	TaskTags              []string `json:"task_tags"`
	TaskType              int      `json:"task_type"`
	OrientedTalentRelList []struct {
		CooperationState int    `json:"cooperation_state"`
		DouyinId         string `json:"douyin_id"`
		CancelOperator   int    `json:"cancel_operator,omitempty"`
	} `json:"oriented_talent_rel_list"`
}
type TikTokTaskDetailSecond struct {
	AnchorTitle           string `json:"anchor_title"`
	Appid                 string `json:"appid"`
	PaymentAllocateRatio  int    `json:"payment_allocate_ratio"`
	PlatformAddressApp    string `json:"platform_address_app"`
	PlatformAddressWeb    string `json:"platform_address_web"`
	ReferMaCaptures       string `json:"refer_ma_captures"`
	ReferVideoCaptures    string `json:"refer_video_captures"`
	RejectReason          string `json:"reject_reason"`
	StartPage             string `json:"start_page"`
	Status                int    `json:"status"`
	TaskDesc              string `json:"task_desc"`
	TaskEndTime           int    `json:"task_end_time"`
	TaskIcon              string `json:"task_icon"`
	TaskId                int64  `json:"task_id"`
	VideoId               string `json:"video_id"`
	TaskName              string `json:"task_name"`
	TaskRefundPeriod      int    `json:"task_refund_period"`
	TaskSettleType        int    `json:"task_settle_type"`
	TaskStartTime         int    `json:"task_start_time"`
	TaskTags              string `json:"task_tags"`
	TaskType              int    `json:"task_type"`
	OrientedTalentRelList string `json:"oriented_talent_rel_list"`
}

type TikTokTaskOrder struct {
	VideoId            int64  `json:"VideoId"`
	TaskId             int    `json:"TaskId"`
	TaskName           string `json:"TaskName"`
	PublishTime        int    `json:"PublishTime"`
	Author             string `json:"Author"`
	DouyinID           string `json:"DouyinID"`
	VideoTitle         string `json:"VideoTitle"`
	MicroAppTitle      string `json:"MicroAppTitle"`
	VideoLink          string `json:"VideoLink"`
	AgentID            string `json:"AgentID"`
	TalentProfit1D     int    `json:"TalentProfit1d"`
	GMV1D              int    `json:"GMV1d"`
	RefundGMV1D        int    `json:"RefundGMV1d"`
	AdShareCost1D      int    `json:"AdShareCost1d"`
	FeedAdShareCost1D  int    `json:"FeedAdShareCost1d"`
	BillingRefundGMV1D int    `json:"BillingRefundGMV1d"`
	BillingGMV1D       int    `json:"BillingGMV1d"`
	Date               string `json:"date"`
}
type TikTokTaskRelate struct {
	AgencyTalentUid string `json:"agency_talent_uid"`
	AgentId         int64  `json:"agent_id"`
	BindTime        int    `json:"bind_time"`
	DouyinId        string `json:"douyin_id"`
}

type KuJiang struct {
	BookId                             int     `json:"book_id"`
	ApplyPlatform                      int     `json:"apply_platform"`
	Channel                            int     `json:"channel"`
	IsCompleted                        int     `json:"is_completed"`
	Seconds                            int     `json:"seconds"`
	Chapters                           int     `json:"chapters"`
	ReadableChapters                   int     `json:"readable_chapters"`
	Stars                              int     `json:"stars"`
	KujiangStars                       int     `json:"kujiang_stars"`
	Weight                             int     `json:"weight"`
	IsHidden                           int     `json:"is_hidden"`
	Status                             string  `json:"status"`
	KsStatus                           string  `json:"ks_status"`
	DouyinStatus                       string  `json:"douyin_status"`
	KujiangStatus                      string  `json:"kujiang_status"`
	KujiangKsStatus                    string  `json:"kujiang_ks_status"`
	KujiangDouyinStatus                string  `json:"kujiang_douyin_status"`
	ShowPlatform                       int     `json:"show_platform"`
	KyyStatus                          string  `json:"kyy_status"`
	CertifiedStatus                    string  `json:"certified_status"`
	CertifiedDouyinStatus              string  `json:"certified_douyin_status"`
	AppStatus                          string  `json:"app_status"`
	KujiangAppStatus                   string  `json:"kujiang_app_status"`
	KujiangCertifiedStatus             string  `json:"kujiang_certified_status"`
	KujiangCertifiedDouyinStatus       string  `json:"kujiang_certified_douyin_status"`
	KujiangKyyStatus                   string  `json:"kujiang_kyy_status"`
	KujiangKyyLikeCount                int     `json:"kujiang_kyy_like_count"`
	KujiangRealLikeCount               int     `json:"kujiang_real_like_count"`
	AppPublicedAt                      string  `json:"app_publiced_at"`
	PublicedAt                         string  `json:"publiced_at"`
	KujiangPublicedAt                  string  `json:"kujiang_publiced_at"`
	RefreshedAt                        string  `json:"refreshed_at"`
	BookName                           string  `json:"book_name"`
	CoverKey                           string  `json:"cover_key"`
	AuthorName                         string  `json:"author_name"`
	AuthorAvatarKey                    string  `json:"author_avatar_key"`
	Category                           string  `json:"category"`
	Category2                          string  `json:"category2"`
	CateId                             int     `json:"cate_id"`
	Introduce                          string  `json:"introduce"`
	Tag                                string  `json:"tag"`
	RecommendIntro                     string  `json:"recommend_intro"`
	Source                             string  `json:"source"`
	SourceDetail                       string  `json:"source_detail"`
	ProducerId                         int     `json:"producer_id"`
	KujiangBookId                      int     `json:"kujiang_book_id"`
	DramaType                          int     `json:"drama_type"`
	BookSource                         int     `json:"book_source"`
	OriBookId                          int     `json:"ori_book_id"`
	Grade                              string  `json:"grade"`
	AppGrade                           string  `json:"app_grade"`
	AppGradeSwitch                     int     `json:"app_grade_switch"`
	TotalChargeAmount                  string  `json:"total_charge_amount"`
	TodayChargeAmount                  string  `json:"today_charge_amount"`
	LastWeekChargeAmount               string  `json:"last_week_charge_amount"`
	YesterdayChargeAmount              string  `json:"yesterday_charge_amount"`
	ReadCount                          int     `json:"read_count"`
	TodayReadCount                     int     `json:"today_read_count"`
	YesterdayReadCount                 int     `json:"yesterday_read_count"`
	KujiangTotalChargeAmount           string  `json:"kujiang_total_charge_amount"`
	KujiangPublicTotalChargeAmount     string  `json:"kujiang_public_total_charge_amount"`
	KujiangTodayChargeAmount           string  `json:"kujiang_today_charge_amount"`
	KujiangLastWeekChargeAmount        string  `json:"kujiang_last_week_charge_amount"`
	KujiangYesterdayChargeAmount       string  `json:"kujiang_yesterday_charge_amount"`
	KujiangReadCount                   int     `json:"kujiang_read_count"`
	KujiangPublicReadCount             int     `json:"kujiang_public_read_count"`
	KujiangTodayReadCount              int     `json:"kujiang_today_read_count"`
	KujiangYesterdayReadCount          int     `json:"kujiang_yesterday_read_count"`
	Remarks                            *string `json:"remarks"`
	IsOriginal                         int     `json:"is_original"`
	IsBindWriter                       int     `json:"is_bind_writer"`
	WriterId                           int     `json:"writer_id"`
	IsOpenDouyinDistribution           int     `json:"is_open_douyin_distribution"`
	TalentStars                        int     `json:"talent_stars"`
	RecordNumber                       string  `json:"record_number"`
	CertifiedDistributionStatus        int     `json:"certified_distribution_status"`
	KujiangCertifiedDistributionStatus int     `json:"kujiang_certified_distribution_status"`
	DistributionStatus                 int     `json:"distribution_status"`
	KujiangDistributionStatus          int     `json:"kujiang_distribution_status"`
	IsOpenKuaishouDistribution         int     `json:"is_open_kuaishou_distribution"`
	StoryId                            int     `json:"story_id"`
	ScenarioId                         int     `json:"scenario_id"`
	PlotIntroduce                      string  `json:"plot_introduce"`
	Director                           string  `json:"director"`
	Performer                          string  `json:"performer"`
	Roles                              string  `json:"roles"`
	DouyingCoverUrl                    string  `json:"douying_cover_url"`
	DouyingCoverUri                    string  `json:"douying_cover_uri"`
	DouyingCoverKey                    string  `json:"douying_cover_key"`
	DouyinAlbumId                      int64   `json:"douyin_album_id"`
	DouyinAuditStatus                  int     `json:"douyin_audit_status"`
	DouyinOnline                       int     `json:"douyin_online"`
	RegistrationNumber                 string  `json:"registration_number"`
	IsDisplay                          int     `json:"is_display"`
	KujiangIsDisplay                   int     `json:"kujiang_is_display"`
	AuthArea                           int     `json:"auth_area"`
	NeedContract                       int     `json:"need_contract"`
	HasContract                        int     `json:"has_contract"`
	IsPartnership                      int     `json:"is_partnership"`
	ProducerRemark                     *string `json:"producer_remark"`
	WechatCoverKey                     string  `json:"wechat_cover_key"`
	SubName                            string  `json:"sub_name"`
	ThisMonthChargeAmount              string  `json:"this_month_charge_amount"`
	DouyinTags                         string  `json:"douyin_tags"`
	DouyinRecommend                    string  `json:"douyin_recommend"`
	DouyinDescription                  string  `json:"douyin_description"`
	OtherPlatformExamineStatus         int     `json:"other_platform_examine_status"`
	FilingNumber                       string  `json:"filing_number"`
	AppTotalChargeAmount               string  `json:"app_total_charge_amount"`
	AppTodayForecastChargeAmount       string  `json:"app_today_forecast_charge_amount"`
	AppYesterdayChargeAmount           string  `json:"app_yesterday_charge_amount"`
	AppLastWeekChargeAmount            string  `json:"app_last_week_charge_amount"`
	AppReadCount                       int     `json:"app_read_count"`
	AppTodayReadCount                  int     `json:"app_today_read_count"`
	AppYesterdayReadCount              int     `json:"app_yesterday_read_count"`
	AppTotalPayCount                   int     `json:"app_total_pay_count"`
	KujiangIsOpenDouyinDistribution    int     `json:"kujiang_is_open_douyin_distribution"`
	KujiangIsOpenKuaishouDistribution  int     `json:"kujiang_is_open_kuaishou_distribution"`
	KujiangTalentStars                 int     `json:"kujiang_talent_stars"`
	WxAuditStatus                      int     `json:"wx_audit_status"`
	CanPlay                            int     `json:"can_play"`
	CanAd                              int     `json:"can_ad"`
	CanMount                           int     `json:"can_mount"`
	ChapterCount                       int     `json:"chapter_count"`
	WebDiskUrl                         string  `json:"web_disk_url"`
	WebDiskPassword                    string  `json:"web_disk_password"`
	Pic                                string  `json:"pic"`
	ChapterPriceCount                  int     `json:"chapter_price_count"`
	BookShelf                          []struct {
		AppletId         int    `json:"applet_id"`
		MiniName         string `json:"mini_name"`
		OnlineStatus     int    `json:"online_status"`
		OnlineStatusDesc string `json:"online_status_desc"`
		Type             int    `json:"type"`
	} `json:"book_shelf"`
}
