package md

type TikTokLocalLifeOrder struct {
	Cursor     string                       `json:"cursor"`
	HasMore    bool                         `json:"has_more"`
	ItemOrders []TikTokLocalLifeOrderDetail `json:"item_orders"`
}
type TikTokLocalLifeOrderDetail struct {
	Status         int `json:"status"`
	UpdateTime     int `json:"update_time"`
	CommissionInfo struct {
		AllSettleRemitFinish bool `json:"all_settle_remit_finish"`
		CommissionRate       int  `json:"commission_rate"`
		DistributionInfo     struct {
			ExternalInfo string `json:"external_info"`
			Pid          string `json:"pid"`
		} `json:"distribution_info"`
		EstimateCommission int                    `json:"estimate_commission"`
		SettleInfoMap      map[string]interface{} `json:"settle_info_map"`
	} `json:"commission_info"`
	ItemOrderId string `json:"item_order_id"`
	PayAmount   int    `json:"pay_amount"`
	PayTime     int    `json:"pay_time"`
	ProductList []struct {
		SkuId     int64  `json:"sku_id"`
		Count     int    `json:"count"`
		Img       string `json:"img"`
		Name      string `json:"name"`
		ProductId int64  `json:"product_id"`
	} `json:"product_list"`
	RootOrderInfo struct {
		RootOrderId string `json:"root_order_id"`
	} `json:"root_order_info"`
}
