package hdl

import (
	"applet/app/db"
	"applet/app/e"
	md2 "applet/app/es/md"
	"applet/app/lib/validate"
	md3 "applet/app/md"
	"applet/app/svc"
	"applet/app/task/md"
	svc2 "applet/app/task/svc"
	"applet/app/utils"
	"bufio"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_es.git/es"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/playlet_bihai"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/playlet_kujiang"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/story"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/tik_tok"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"context"
	"encoding/csv"
	"encoding/json"
	"fmt"
	"github.com/gin-gonic/gin"
	"github.com/olivere/elastic/v7"
	"github.com/syyongx/php2go"
	"github.com/tidwall/gjson"
	"io"
	"net/http"
	"os"
	"path"
	"strconv"
	"strings"
	"time"
)

func ImgReqUpload(c *gin.Context) {
	var args struct {
		DirName  string `json:"dir_name,omitempty" default:"0"`
		FileName string `json:"file_name" binding:"required" label:"文件名"`
		FileSize int64  `json:"file_size" binding:"gt=1" label:"文件大小"` // 文件大小, 单位byte
	}
	err := c.ShouldBindJSON(&args)
	if err != nil {
		err = validate.HandleValidateErr(err)
		err1 := err.(e.E)
		e.OutErr(c, err1.Code, err1.Error())
		return
	}

	scheme := "http"
	if c.Request.TLS != nil {
		scheme = "https"
	}
	// 拼装回调地址
	callbackUrl := scheme + "://" + c.Request.Host + "/api/admin/file/upload/callback"
	res, err := svc.ImgReqUpload(c, "", args.DirName, args.FileName, callbackUrl, args.FileSize)
	if err != nil {
		e.OutErr(c, e.ERR_BAD_REQUEST, err.Error())
		return
	}
	my := utils.SerializeStr(res)
	var my1 map[string]interface{}
	utils.Unserialize([]byte(my), &my1)
	masterListCfgDb := db.MasterListCfgDb{}
	masterListCfgDb.Set()
	fileBucketRegion := masterListCfgDb.MasterListCfgGetOneData("0", "file_bucket_region")
	if err != nil {
		e.OutErr(c, e.ERR_BAD_REQUEST, err)
		return
	}
	my1["host"] = fileBucketRegion
	e.OutSuc(c, my1, nil)

}
func BihaiAdds(c *gin.Context) {
	for true {
		BihaiAdd(c)
		fmt.Println("=============", time.Now())
		time.Sleep(time.Minute * 60)
	}
}
func BihaiAdd(c *gin.Context) {
	data := "{\"\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"\",\"description\":\"\",\"second_cate\":\"\",\"episode\":0,\"platform\":\"\",\"update_time\":1720481256,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"1987今夜不眠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"1987今夜不眠\",\"description\":\"女儿憎恨父亲当年间接害死母亲，准备跳楼自杀，富豪陆浩在拯救女儿跳楼自杀的时候，一不小心自己也搭了进去，竟然在死后重生到80年代。重生后的他发誓，要改变妻子自杀的命运，改过自新，戒掉赌瘾恶习，用家里仅剩的钱重新发家致富，让妻女们过上幸福生活，让女儿原谅自己……\",\"second_cate\":\"男频重生/年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481596,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1jcwXjM0TDwyYajoLjytTiQ?pwd=xrvd\",\"online_time\":\"2024-01-15 00:00:00\",\"time\":1705248000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"90俏后妈嫁个大佬养崽崽\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"90俏后妈嫁个大佬养崽崽\",\"description\":\"二十一世纪的穆晚云在相亲时遇到奇葩男，愤而离席，却不料意外发生车祸身亡，没想到在九零年代一位叫季云的农村女孩身上获得新生。曾经的季云懦弱绵软，穆晚云穿越来时正在被同村人嘲笑是倒贴都没有要的破鞋。现代的穆晚云可是新时代的女性，自然不可能被这群愚昧的家人拿捏。为了应付家里人，她与顾长卿结婚，却在日积月累的相处中渐渐爱上对方。\",\"second_cate\":\"女频重生、创业\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480376,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1gOQ9SJLkF2BrUHGQ3GJcAg?pwd=cdyu\",\"online_time\":\"2023-11-27 00:00:00\",\"time\":1701014400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一人不入庙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一人不入庙\",\"description\":\"苑青青参演了一部小成本鬼片，为了省钱剧组不顾村里老人劝阻，进入深山中废弃的寺庙拍戏，没想到陆续发生真实灵异事件。女主作为电影剧本中原定会被祭祀给邪神、悲惨死去的主人公，被迫展开自救。\",\"second_cate\":\"男频悬疑\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479256,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/18zQuz4QTaXyEZkIV1pFpVA?pwd=zrzf\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一元秒杀，逆袭做首富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一元秒杀，逆袭做首富\",\"description\":\"世界首富陈总终于找到了失踪多年的儿子陈放，为了弥补离开儿子这么久的愧疚，陈总特意为儿子开发了一款秒杀app，无论是价值八亿的檀宫别墅，上亿的酒店股份，统统只需要陈放一元秒杀！一条神奇的打脸之路开始了\",\"second_cate\":\"男频神豪、都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480156,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1gTYcCgAYcZkyVS09EAwfMQ?pwd=532i\",\"online_time\":\"2023-11-19 00:00:00\",\"time\":1700323200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一叶遮天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一叶遮天\",\"description\":\"叶天本可成上京三大世家的供奉，却为沈家拒三大世家邀请。因叶天常年在街边摆摊算命，沈家不满故怂恿沈秋云与叶天离婚。离婚后，叶天要求天机宴一切照旧，后他打脸各大天师，并取消天机宴收徒仪式，沈家彻底绝望后悔。秦铭出现给予沈家希望，并带沈家众人找叶天复仇，皆被叶天瞬间击溃。叶天通过秦铭知晓真正鬼谷传人位置。陈修杰与沈秋云在拍卖会楼下相遇，陈修杰羞辱叶天，拍卖会上叶天击溃了鬼谷传人乾元。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482386,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1f55VsbDRAhWokFrts6RoSA?pwd=vk5t\",\"online_time\":\"2024-02-11 00:00:00\",\"time\":1707580800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一品家丁\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一品家丁\",\"description\":\"外卖员林和在送外卖的途中因为一场意外穿越到历史上没有记载的大夏朝，被误认为黄衣军，逃命途中为保命参加肖府成为一名家丁，斗奸商，诛逆贼，搞发明，最后被皇帝封为一品家丁\",\"second_cate\":\"男频穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477966,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ofRN7KM4OlzRRu7IqwhFAA?pwd=63wx复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-24 00:00:00\",\"time\":1692806400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一夜暴富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一夜暴富\",\"description\":\"人生至暗时刻，发现身世之谜，逆境崛起，反败为胜，演绎一段爱江山更爱美人的故事！\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480406,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1XjHjFnji_cjECnJ3BvGVng?pwd=9xwr\",\"online_time\":\"2023-11-27 00:00:00\",\"time\":1701014400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一孕成婚：大叔宠妻好撩人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一孕成婚：大叔宠妻好撩人\",\"description\":\"田甜是职场白领，上门挽留客户却被千亿总裁陆铭修手下错认，送给陆铭修当解药，田甜因此怀孕，得知自己怀孕的田甜预约打胎，陆母得知后急忙带着保镖浩浩荡荡阻止，因为她家十八代单传陆铭修还不近女色，陆母赶到时田甜正在被老板同事欺辱，陆母爆身份为她撑腰，陆铭修也被陆母催两人结婚。婚后田甜不想闲着，在陆铭修帮助下开了一家店，却遭到同行客户，陆铭修妹妹陆青青和其闺蜜江心仪的针对，在陆铭修的帮助下出甜悉次打脸反派，事业爱情双丰收。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720478586,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/12oy5zlKmb_EeepznqAWKxw?pwd=h57t\",\"online_time\":\"2023-09-21 00:00:00\",\"time\":1695225600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一晌贪欢\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一晌贪欢\",\"description\":\"时下最炙手可热，以“性冷淡风”著名的摄影师余笙，无意间与新人模特秦浩东共度春宵，秦浩东对余笙穷追不舍，而余笙却无心恋爱，只想保住父亲的遗产并为父报仇。秦浩东奶狗般的追求下，余笙渐渐对他产生爱意，最后才发现原来秦浩东早在大学时期就爱上了当时还在当老师的自己，此后两人共渡难关保住了父亲的遗产，并成功将逼死父亲的凶手绳之以法。 \",\"second_cate\":\"女频都市言情甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482946,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1QPhRau3kadiS41DyRtOBUA?pwd=kcag\",\"online_time\":\"2024-03-04 00:00:00\",\"time\":1709481600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一眼万年：绝美老公宠上天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一眼万年：绝美老公宠上天\",\"description\":\"她去祭拜奶奶，意外撞到喝醉的帝君，被扛回府娇宠一世\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479996,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1X-92R3dSBRzjc5l5tNSmBw?pwd=n45x\",\"online_time\":\"2023-11-15 00:00:00\",\"time\":1699977600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一胎二宝爹地来了妈咪快跑\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一胎二宝爹地来了妈咪快跑\",\"description\":\"久久宝贝帮着妈咪陆婉清盗回天价珍珠项链，却没想到准备脱身时被总裁 凌璟深撞见。凌璟深把久久当成了自己的儿子小星，陆婉清也阴差阳错的把小星带回了自己家。当两个一模一样的男宝同时出现在凌璟深面前时，陆婉清兰年所遭遇的真相也逐渐被还原。当年陆婉清被陷害却没想到遇到第一首富，一胎俩宝，两个萌宝机灵可爱，助攻妈咪手撕绿茶，最终陆婉清和凌璟深在两个萌宝的神助攻下展开了一段甜蜜爱恋。\",\"second_cate\":\"女频萌宝 甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481016,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":7,\"material\":\"https://pan.baidu.com/s/1rr2NNwLticzSrMp15hSSTA?pwd=9ijw\",\"online_time\":\"2023-12-22 00:00:00\",\"time\":1703174400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一胎二宝霸总爹地追妻忙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一胎二宝霸总爹地追妻忙\",\"description\":\"久久宝贝帮着妈咪陆婉清盗回天价珍珠项链，却没想到准备脱身时被总裁 凌璟深撞见。凌璟深把久久当成了自己的儿子小星，陆婉清也阴差阳错的把小星带回了自己家。当两个一模一样的男宝同时出现在凌璟深面前时，陆婉清兰年所遭遇的真相也逐渐被还原。当年陆婉清被陷害却没想到遇到第一首富，一胎俩宝，两个萌宝机灵可爱，助攻妈咪手撕绿茶，最终陆婉清和凌璟深在两个萌宝的神助攻下展开了一段甜蜜爱恋。\",\"second_cate\":\"女频萌宝 甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481026,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1G_NXednOFMbbVc84PwVZhA?pwd=8pna\",\"online_time\":\"2023-12-22 00:00:00\",\"time\":1703174400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一胎双宝，千亿爹地超宠妻！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一胎双宝，千亿爹地超宠妻！\",\"description\":\"舒雨朦醉酒和江南天误睡后出国，在国外成长为知名珠宝设计师，五年后带着一对儿女回国。江南天得知后找到舒雨朦领证结婚，舒雨朦为了孩子只得同意。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478416,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1jdt9slhVbiCyg6jDY7Jdyw?pwd=919w\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一胎双宝，爹地宠妻要趁早！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一胎双宝，爹地宠妻要趁早！\",\"description\":\"叶笙被私生女姐姐叶薇陷害，却意外与帝都首富慕辰宇误睡，叶笙被赶出家门后，慕辰宇找上门，问叶薇是不是昨晚跟他在一起的女人，叶薇顺势承认。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480206,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1uCEDoNpzBlidYv21RTNYjQ?pwd=zqb3\",\"online_time\":\"2023-11-21 00:00:00\",\"time\":1700496000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一胎双宝，老婆复仇超厉害！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一胎双宝，老婆复仇超厉害！\",\"description\":\"楚天祺奶奶生病非要楚天祺结婚，顾倾城的妈妈生重病，爸爸和姐姐不愿意给妈妈治疗，顾倾城为了个母亲治病答应和男主生孩子，姐姐得知顾倾城怀了楚天祺的孩子，抢走了顾倾城的女儿，冒认了顾倾城身份和楚天祺结婚，女主5年后带儿子回国，在姐姐生日宴上揭露姐姐身份，把爸爸公司收购，在两个孩子的助攻下和楚天祺在一起！\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478576,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"\\nhttps://pan.baidu.com/s/19NJP7CI29twiZsZyxyhg_A?pwd=jgbe\",\"online_time\":\"2023-09-15 00:00:00\",\"time\":1694707200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一胎双宝：神秘爹地是大佬\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一胎双宝：神秘爹地是大佬\",\"description\":\"秦苒和顾瑾修结婚多年，秦苒喜欢顾瑾修借助自己家族权势逼迫顾瑾修娶了自己，而顾瑾修为了家族放弃多年白月光迎娶秦苒，但是多年后秦苒家族破产。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478406,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1nqnGp-IlMkbQP9TVw6_lzQ?pwd=bt2c\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一胎双宝：豪门继承人追着我喊妈咪！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一胎双宝：豪门继承人追着我喊妈咪！\",\"description\":\"沈时薇是刚被找回沈家的真千金，被逼嫁给老男人，逃婚时误入同样中药的霍少东房内，与其一夜情导致怀孕。九个月后，沈时薇生下双胞胎，却被嫉妒她的假千金沈冰冰抢走孩子，放火想烧死她，结果她被人救走送出了国。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478566,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1j5uSZasjY57rAlLQrC4_fg?pwd=hubw\",\"online_time\":\"2023-09-15 00:00:00\",\"time\":1694707200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"一闪一闪亮星星\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"一闪一闪亮星星\",\"description\":\"平平无奇打工人虞可星，为了逃离“吸血鬼”家庭，在辰星娱乐经纪公司当保安，准备摆烂过一生，在巡逻过程中被顶流沈翊撞到摔倒在地上，本着有仇不过夜的想法，在追上去要求沈翊道歉时意外遇到电梯事故，两人摔倒时亲在一起，电梯碰巧打开门...\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484876,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1tA9hZbjyfAiJz_S2Gg1rhw?pwd=mnqw\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"万千风情予你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"万千风情予你\",\"description\":\"沈家被赶出门的落魄千金沈梦怡，在结婚当天被出轨。沈梦怡闪婚帮她脱困的总裁秦锐，成了出轨渣男的小婶婶。沈梦怡决心打脸渣男，重振沈家，在秦锐的帮助下和自己的努力奋斗中夺回家产，走向人生巅峰，并与秦锐相爱。\",\"second_cate\":\"女频甜宠/大女主\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480456,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1MZsNTKD2A3YFXcVv89OMhw?pwd=7m7t\",\"online_time\":\"2023-12-04 00:00:00\",\"time\":1701619200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"万古龍皇\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"万古龍皇\",\"description\":\"九声响，神子立！一朝顿悟，也能修炼成至尊武皇！火爆玄幻文！\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481836,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1B-rdlo44NPHVYIOMNLSG5w?pwd=5nkq\",\"online_time\":\"2024-01-26 00:00:00\",\"time\":1706198400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"万界超市\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"万界超市\",\"description\":\"男主苏辰本是现代都市的商界奇才，为了寻找女友，三年前穿越到了古代并且开了一家名为万界超市的杂货铺，利用穿梭时空的能力，做起了两界的倒爷生意，收服了一众大佬。\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485856,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1qllm8ChkSeC-5EzLOE1eYg?pwd=u4tn\",\"online_time\":\"2024-05-25 00:00:00\",\"time\":1716566400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"万疆剑帝\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"万疆剑帝\",\"description\":\"秦家大少秦放，被王世南设计陷害成强奸犯后，被充军当成炮灰，秦家也因此每况愈下，由京都四大家族之首一夜之间降为寻常家族，可秦放并未放弃，不仅从存活率极低的战场中杀了出来，还获得机缘成就了万疆剑帝之名！\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487836,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1SjseBVbto4FTQCN_nUZN_Q?pwd=jsvj\",\"online_time\":\"2024-06-19 00:00:00\",\"time\":1718726400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"万道神尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"万道神尊\",\"description\":\"玉皇道君沈容飞升在即为报答表姑当年救命之恩及寻找炼制飞升丹药材，选择独自返回人世间。结识中夏第一女强人秦梦莹，经历一系列事情后，秦梦莹对他芳心暗许，药材逐渐收集完毕，沈容即将飞升成仙，两人该何去何从？\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486546,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1PgJ1ce2uO-7g49Qsw9pk5w?pwd=b2b9\",\"online_time\":\"2024-05-17 00:00:00\",\"time\":1715875200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"三个哥哥被撞飞后我走上了人生巅峰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"三个哥哥被撞飞后我走上了人生巅峰\",\"description\":\"苏知语是世界首富遗失在外的女儿,首富父母把寻找她的任务交到了三个哥哥的手上！苏知语差点被恶毒的同学当场撞死，三哥哥为了救她，同时出了车祸，直到养父母逼她嫁人那天，三哥哥突然觉醒，虐渣打脸爽翻了。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485496,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1c3IWWP-0NVrlFcT6Rvd8Wg?pwd=madh\",\"online_time\":\"2024-05-20 00:00:00\",\"time\":1716134400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"三个大佬哥哥竟是宠妹狂魔\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"三个大佬哥哥竟是宠妹狂魔\",\"description\":\"帝国最强家族蜀中唐门终于找到自己失散多年的小妹吴暖月，三位哥哥亲自去迎接，可是吴暖月现在是苏家儿媳，老公苏明诚腿脚不利索，他们一直饱受欺负。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478316,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1qXb1DDgEexBQXin5ar98Sg?pwd=9hwm\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"三个姐姐天天要我花钱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"三个姐姐天天要我花钱\",\"description\":\"保安裴钱被神秘人物绑架，要他冒充钱家失踪五年的少爷，一个月内败光钱家千亿资产。裴钱为了保命，只能被迫接受任务，奈何不论他怎么花钱，钱都会变得越来越多，最后惹得神秘人物亲自下场，揭穿他的身份。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488566,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":16,\"material\":\"https://pan.baidu.com/s/1reuyqtw93ye5mNzMlmhoRg?pwd=c8ji\",\"online_time\":\"2024-06-29 00:00:00\",\"time\":1719590400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"三人行必有我夫\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"三人行必有我夫\",\"description\":\"顾唯一大婚在即，未婚夫林长青出轨顾家二小姐顾昕悦，企图借顾家势力挤进江城名流。顾唯一大闹林家宴会，被林家众人百般羞辱，于是决定表明自己是顾家大小姐，手撕渣男，接受真正属于自己的爱情。\",\"second_cate\":\"女频团宠、虐渣\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488496,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":17,\"material\":\"https://pan.baidu.com/s/12wNPBHAS4dzrBcFDsoBZ4w?pwd=jtse\",\"online_time\":\"2024-06-28 00:00:00\",\"time\":1719504000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"三爷别哭夫人她只爱99天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"三爷别哭夫人她只爱99天\",\"description\":\"女主宋恩尧无意中救了男主秦居寒，但男主没有看清楚女主相貌。女主为了获得秦家培育草药的方法，下山履行与秦氏的99天婚约，此时嫁给男主，而男主则是被爷爷逼着娶女主，两人都十分不情愿。婚礼当天，男主察觉女主就是救自己的人，态度发生巨大转变，然而女主却一直不肯承认救了男主，甚至找了罗茜冒充救命恩人，罗茜借着救命恩人这层身份，不断作妖，最终被女主整治，身份也被戳破，女主救命恩人身份揭开，男女主此时都对彼此有了不一样的感情。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481116,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1yk8xLmcpDFkXgKyBwXYbSw?pwd=2hah\",\"online_time\":\"2023-12-25 00:00:00\",\"time\":1703433600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"上门豪婿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"上门豪婿\",\"description\":\"入赘豪门的穷小子，在各路大神的支援下，最终让所有人刮目相看\",\"second_cate\":\"男频都市日常\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477896,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1qKmh0Y4ThYWIVxZWL7QLBQ?pwd=dikv复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-19 00:00:00\",\"time\":1692374400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"下山传\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"下山传\",\"description\":\"林平拜龙王殿尊主门下苦修十八年，一觉醒来，却突然被师傅赶下山，还多了七个倾国倾城的绝色师姐，青龙白虎朱雀玄武听令！敢欺负我师姐者，杀无赦！\",\"second_cate\":\"男频高手下山\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482076,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1K4lWSYvmRE50LSlMPF4S9Q?pwd=dfze\",\"online_time\":\"2024-02-04 00:00:00\",\"time\":1706976000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"下山后我帮姐姐重回巅峰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"下山后我帮姐姐重回巅峰\",\"description\":\"楚辰，居住玉鼎山，世人尊称显圣真君，本是孤儿院的一名弃婴，七岁时被玉鼎真仙沈素琼收养教导，二十五岁时奉师命下山，寻找自己在孤儿院相认的六个姐姐，楚辰运用自己的武力，医术，个人魅力，辗转在众女和东海各大家族中，解决了姐姐们与各家族之间的恩怨情仇，楚辰在收服各家族时，知晓了自己是第一豪强楚家遗失在民间的长子和自己背负的血海深仇，楚辰与姐姐们一起掀翻楚家，找到了幕后黑手，向他报仇雪恨，最后楚辰与自己的其中一位姐姐幸福的生活在了一起。\",\"second_cate\":\"男频高手下山\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481346,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":7,\"material\":\"https://pan.baidu.com/s/1kwCSpH5jhEY0LhWFFw9wMQ?pwd=is4r\",\"online_time\":\"2024-01-02 00:00:00\",\"time\":1704124800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"下山后美女总裁找上门\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"下山后美女总裁找上门\",\"description\":\"秦昊本在山中隐居，师娘让他下山完成多年前定下的婚约，不料却被周家当众反悔撕毁婚书。与此同时，云州魁首正寻找秦昊为其治病，最后在周家与秦昊相遇，帮助秦昊一次次化解危机，最后事业爱情双丰收。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486526,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1BhFOvNFwEUKptm7Hs1JhDQ?pwd=jabw\",\"online_time\":\"2024-05-16 00:00:00\",\"time\":1715788800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"不做养女三个哥哥蓄谋宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"不做养女三个哥哥蓄谋宠\",\"description\":\"八岁时，女主跟母亲出行被杀手追杀，母亲去世，女主倒在周家门口，从此成为周家养女，三个大佬哥哥找上门要认亲，周家亲生女儿顶替女主成为林家千金，认回身份后女主也成为哥哥们的心尖宠！\",\"second_cate\":\"女频霸总/团宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486946,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1MywmXpOpCtvHXGJCwFD6WQ?pwd=dgsm\",\"online_time\":\"2024-06-06 00:00:00\",\"time\":1717603200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"不做首富很多年\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"不做首富很多年\",\"description\":\"男主肖寒，致力于国产芯片研发，并成功建立属于自己的商业帝国。此时爱妻小梅却意外身亡，此后肖寒隐退，侄子肖天泽接掌集团，肖寒隐姓埋名回到与小梅发迹的烧烤店，当起了烧烤店老板。谁知国际资本为获更大利益，阻击国内芯片发展，肖寒再次踏上征程，这一次他要为民族品牌而战。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483396,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1ifbRW3ym37q4Of2CwcKdkw?pwd=jkaw\",\"online_time\":\"2024-03-17 00:00:00\",\"time\":1710604800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"不再沉默的女孩\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"不再沉默的女孩\",\"description\":\"省城已经事业有成的苏乐安，在父亲去世一周年后的端午节回到从小生活的农村。从小抛弃她的生母和弟弟，为争夺父亲的遗产陆续而来围绕着这场争夺遗产的葬礼，苏乐安将会面临怎样的困境，故事将就此展开。\",\"second_cate\":\"女频亲情 农村 情感复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487276,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1KSTLgnkKVCnZkU_9uSlfFw?pwd=8ayd\",\"online_time\":\"2024-06-09 00:00:00\",\"time\":1717862400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"不凡\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"不凡\",\"description\":\"萧凡为神界神尊，修炼神功时心魔作祟，爆体而亡。为救自己性命，男主逆转时空，回到过去，救回不幸身亡的母亲，追回因嫌自己弱小而退婚的未婚妻，更是以神的身份和能力打脸那些曾经看不起自己的人。\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487316,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1NFEJIjhjfOXqMhm2K9aniQ?pwd=s95b\",\"online_time\":\"2024-06-09 00:00:00\",\"time\":1717862400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"不坠青云志\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"不坠青云志\",\"description\":\"萧然一手缔造了萧氏集团的辉煌，却甘愿以赘婿之身留在苏家。当妻子面对父母，面对家主奶奶的压力，为保护丈夫选择离婚。怎忍妻子如此难捱，索性做万万人之上，为人间真龙，萧然一并力扛四大世家！\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481756,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":17,\"material\":\"https://pan.baidu.com/s/1qY0U-Zy5onEs2SM3yXYSjg?pwd=35ux\",\"online_time\":\"2024-01-22 00:00:00\",\"time\":1705852800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"不装了！其实我是女厂长\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"不装了！其实我是女厂长\",\"description\":\"90年代末首富孙女钟秀毓考察濒临破产的纺织厂，不小心落水，被即将下岗的工人宋捷救下，因此爱上宋捷，没想到宋捷前脚得知自己高升不仅将她扫地出门，还一千块钱将其卖给了流氓吴老三。\",\"second_cate\":\"女频年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487066,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1hanu3lS0nk3MroYSE2IJ2w?pwd=k9ps\",\"online_time\":\"2024-06-07 00:00:00\",\"time\":1717689600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"不败凌霄花\\u0026凌霄花开不败\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"不败凌霄花\\u0026凌霄花开不败\",\"description\":\"凌薇是大夏国神龙殿的凌霄战神，有失散十八年的女儿，开始以为周夏夏生活得很幸福，于是决定隐藏自己和周夏夏的母女关系。然而，周夏夏其实过着惨不忍睹的生活，直到凌薇费劲了千辛万苦，终于来到了周夏夏的婚宴......\",\"second_cate\":\"女频家庭情感\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487166,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1riJTo1ins1AGPr-8fKP3_g?pwd=42fv\",\"online_time\":\"2024-06-08 00:00:00\",\"time\":1717776000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"与你在深渊中起舞\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"与你在深渊中起舞\",\"description\":\"萧若蝶在养父母的强迫下，替妹妹嫁给了季家瞎了眼的小儿子季乘风，没想到被外界视为“瞎眼废物”的季乘风却心思缜密、头脑机智，同时替嫁到季家的萧若蝶发现在季乘风身边充满了各种波澜诡谲的危机，于是机缘巧合下原本只是商业联姻的两个人强强联手，展开了一系列复仇计划，两人在名为豪门斗争的“深渊”中步步为营，稍有不慎便会落入无尽的黑暗……\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483806,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1BsQFy_r4eSPNCWMCDiDdyw?pwd=6b44\",\"online_time\":\"2024-03-27 00:00:00\",\"time\":1711468800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"与你擦肩而过\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"与你擦肩而过\",\"description\":\"顾琛和叶夕年少相识，顾琛失忆，两人分离。多年后，叶夕为了钱被迫和顾琛结婚，屡遭顾琛秘书夏琪陷害，在夏琪的威胁下，认定夏琪才是白月光，后顾琛得知一切，幡然悔悟，最终求得叶夕原谅。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486636,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/11B3gs6hBJtJMhWeArDB7Iw?pwd=1m77\",\"online_time\":\"2024-05-25 00:00:00\",\"time\":1716566400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"丐婿之重回巅峰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"丐婿之重回巅峰\",\"description\":\"乞丐又如何?你今天爱答不理，明天你高攀不起。哑妻又怎样?你们眼中的草，是我一生守护的宝。年轻企业家被谋害，灵魂与乞丐吴二苟融合，为复仇、为报恩、为亲情、为挚爱、为情怀，吴二苟携哑妻开启了强势逆袭的热血之路!\",\"second_cate\":\"男频赘婿\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477906,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1PUJUE34Bc00d0Bch_J31BQ?pwd=abkf复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-19 00:00:00\",\"time\":1692374400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"丑妻逆袭之华丽归来\\u0026闪婚热恋总裁老公宠翻天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"丑妻逆袭之华丽归来\\u0026闪婚热恋总裁老公宠翻天\",\"description\":\"黎星月遭父亲和继妹毒手，失去记忆且容貌被毁，但在婚礼当天，她恢复记忆，装傻报复未婚夫和继妹。顾陌寒被奶奶拉来婚礼误成新郎。在婚后两人相处中，顾陌寒发现她身上的项链与自己幼年救过的白月光女孩有关。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487016,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1NnVB8yzhZhrPghfDFBMI8w?pwd=334n\",\"online_time\":\"2024-06-06 00:00:00\",\"time\":1717603200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"世上只有女儿好\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"世上只有女儿好\",\"description\":\"李宓因为赌鬼丈夫欠了赌债，将自己抵押给债主，在逃走的过程中与女儿赵婷婷不幸失散。十年后李宓功成名就，带着养女李思婷回到当初与女儿失散的地方重新开始寻找女儿。\",\"second_cate\":\"女频亲情\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720484046,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1zlB08Lj21OQEsPH48_iF7A?pwd=cvjd\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"世上只有妈妈好\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"世上只有妈妈好\",\"description\":\"林家遗孤林磊，落魄之际，孩子被抢，被伪造出生证明！幸而二叔已为神主，逆天改命，踏碎云霄！林磊誓破苍穹，风雨洗礼，终灭仇敌，书写属于自己的辉煌！\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483966,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1mcVwz4s1mu7dkP4OxAOQ_w?pwd=8crf\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"世仁之重回巅峰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"世仁之重回巅峰\",\"description\":\"乞丐又如何？你今天爱答不理，明天你高攀不起。 哑妻又怎样？你们眼中的草，是我一生守护的宝。 年轻企业家被谋害，灵魂与乞丐步世仁融合，为复仇、为报恩、为亲情、为挚爱、为情怀，步世仁携哑妻开启了强势逆袭的热血之路！\",\"second_cate\":\"男频重回\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482886,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1QYZEUcj4-F-V2lwcsGlNEw?pwd=83fh\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"世界以痛吻我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"世界以痛吻我\",\"description\":\"颜茸茸因为家庭原因导致了大学落榜，只能在自家店里打工，忍受家里对她的压榨。打工过程中，她无意间被司家继承人所救，才体会到，什么叫被人宠爱的感觉。\",\"second_cate\":\"女频甜宠、叔宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480616,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1JkBJh_7AofOq_PfzJ6elQg?pwd=3nua\",\"online_time\":\"2023-12-08 00:00:00\",\"time\":1701964800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"世界对我温柔以待\\n（爆款老剧）\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"世界对我温柔以待\\n（爆款老剧）\",\"description\":\"颜茸茸从小因为脸上的胎记而自卑，大学就被家里人逼迫打工赚钱养家，却在打工期间遭遇危险，被司家继承人所救。颜茸茸意外怀孕，被司家继承人带走，两人日久生情，还意外揭开了颜茸茸身世之谜……\",\"second_cate\":\"女频甜宠 女强\",\"episode\":0,\"platform\":\"tikTok\",\"update_time\":1720488996,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1rMX834qupxo2hhROepE6Jw?pwd=vng6\",\"online_time\":\"2024-07-09 00:00:00\",\"time\":1720454400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"为你披荆斩棘\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"为你披荆斩棘\",\"description\":\"苏夏在探寻害死母亲真凶的过程中，遇到慕氏集团总裁慕西沉。对异性过敏的慕西沉却唯独对苏夏免疫，两人误打误撞结婚，却不知道彼此正是对方苦苦寻找的那个人。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485696,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1yARLqhS7w2znwNxNYl6qcw?pwd=nndj\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"为爱奔赴\\u0026无法原谅的爱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"为爱奔赴\\u0026无法原谅的爱\",\"description\":\"宋子娴和赵若雪发生车祸，赵东山面临妻女生死抉择向岳母妥协换取郑春梅的输血和金钱。十八年后，赵月儿看到母亲组建家庭生了两个弟弟，认定是母亲不要他们。离去时，赵东山被宋少霆撞飞，母女宿命齿轮再度开始转动。\",\"second_cate\":\"女频现代/情亲\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487296,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":16,\"material\":\"https://pan.baidu.com/s/1XM8jGtNoNETqJZB0cHeevQ?pwd=sivs\",\"online_time\":\"2024-06-09 00:00:00\",\"time\":1717862400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"乖宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"乖宠\",\"description\":\"富家千金简欣被恶毒的后妈和继妹欺负，设计她被恶霸欺侮，正巧为陆季川所搭救。二人因为各自处境定下闪婚契约，二人冥冥注定产生情意，在和两边家庭的对抗中产生更多羁绊……\",\"second_cate\":\"女频甜宠/闪婚\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481886,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1oRsyyFytHpSv9xhVy8BjXQ?pwd=9krk\",\"online_time\":\"2024-01-29 00:00:00\",\"time\":1706457600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"九五之尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"九五之尊\",\"description\":\"千年之前，大乾王朝皇帝武帝御驾亲征，兵败战死，却意外魂穿至千年后的秦骁之身。重活一世，大乾武帝借秦骁之身进入娱乐圈，再造影帝辉煌，并踏平奸佞宵小，为秦家报血海深仇，最终携美逍遥人间。\",\"second_cate\":\"男频穿越、重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485396,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1a8GCOnoDYzTcor848ul_dg?pwd=qini\",\"online_time\":\"2024-05-18 00:00:00\",\"time\":1715961600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"九州\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"九州\",\"description\":\"大佬意外成为植物人，在乡下医院自生自灭五年，竟是被发妻抛弃，签下离婚协议书。当主角韩雨轩睁开眼，即风云归来…\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480726,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1nb0z-28kth-IXMzfIaEtGw?pwd=8wd6\",\"online_time\":\"2023-12-13 00:00:00\",\"time\":1702396800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"九幽龙帝\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"九幽龙帝\",\"description\":\"五年前被叶家冤枉强奸大嫂逐出家门，后嫁入九幽军，立下战功无数，成为九幽首领龙帝。五年后，龙帝归来夺回属于自己的一切…...\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479986,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1u9lcOrb2UevmB_1MD0ma3A?pwd=bc7s\",\"online_time\":\"2023-11-15 00:00:00\",\"time\":1699977600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"九星战帅\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"九星战帅\",\"description\":\"陈封本为九星战帅，却被身边最亲近之人背叛，重伤濒死之际，被同为袍泽的宁家大哥所救，宁家大哥也因此失踪。获救的陈封却因伤的太重，失去记忆，变成痴傻。宁家宁语嫣对陈封不离不弃，始终照顾，因缘际会之下，陈封恢复记忆，重新立于世间巅峰！\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480016,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1iEdeA46Q92WO-VYuhgbF-g?pwd=bd9g\",\"online_time\":\"2023-11-16 00:00:00\",\"time\":1700064000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"九零年代的致富传奇\\u0026我不接盘你急啥\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"九零年代的致富传奇\\u0026我不接盘你急啥\",\"description\":\"代赵国庆被查出癌症，绝望之际又发现被妻子陈芙蓉背叛，儿子不是亲生，意外穿越回九零年代，这时陈芙蓉已怀别人的孩子，想要男主当接盘侠，男主决定拒婚来改变命运，在过程中和在村里支教老师夏若兰感情升温。\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487036,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1trS-7ea7yXtpvBC1OBANlA?pwd=j2fr\",\"online_time\":\"2024-06-06 00:00:00\",\"time\":1717603200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"九霄神女\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"九霄神女\",\"description\":\"洛凝霜被继母陷害导致赶出家族成为弃女，后武道封神，但又因为渣男背叛封锁心穴就此潦倒了余生\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"\",\"update_time\":1720478096,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1KooyKZ6Og6Tx-5osyH70yg?pwd=vcm2复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-29 00:00:00\",\"time\":1693238400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"九龙医圣\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"九龙医圣\",\"description\":\"萧辰刚成年，师傅就为其准备了九份婚书，但小伙只想宅在仙府做快乐神仙，迟迟不下山履行婚约。不料四个美女竟直接上山请求小伙和自己结婚，小伙无奈赶走了四个美女，因此惹怒了师傅，被威胁剪断山上的唯一一根网线，不得已下山履行婚约。下山后遇到的每一个女孩，都是自己的未婚妻，都和自己有着很深的渊源，牵扯出自己真实的身世和母亲被害的仇恨。\",\"second_cate\":\"男频仙医\",\"episode\":0,\"platform\":\"\",\"update_time\":1720484176,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1HjAMiDDrCfQAAXd1DeTj4w?pwd=uv3d\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"九龙城龙虎斗\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"九龙城龙虎斗\",\"description\":\"陈小刀遭恶毒拜金妻子背叛和有权有势奸夫设局陷害想用五千块逼他顶罪坐二十年的牢。陈小刀拼死不从，反抗中意外穿越到三十年前港岛城寨，从内陆来到城寨投靠大佬叔叔想成就一番事业，结果遭人陷害顶锅坐三十年牢。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486776,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1bz9fDV_x7Xl149Z0PNp0Fw?pwd=m5px\",\"online_time\":\"2024-06-01 00:00:00\",\"time\":1717171200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"九龙拉棺轩辕出世\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"九龙拉棺轩辕出世\",\"description\":\"男主陆北玄诈死，九龙拉棺，歼灭来犯之敌阎国天神，得知未婚妻叶静怡被逼嫁给仇人，七省商会上各种打压男主，三皇子选妃宴选她为妃，后又被国师府掳走以她祭天，陆北玄被困大阵陷入死战，后得知幕后黑手竟然是？\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487736,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1Eq4cGa2d_b29jirj1wcjxg?pwd=2dit\",\"online_time\":\"2024-06-18 00:00:00\",\"time\":1718640000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"乡村卧龙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"乡村卧龙\",\"description\":\"吴凡为救父入赘孙家，妻子孙娇娇新婚当夜竟与金少苟合，各种羞辱吴凡，更将病重的吴父折磨致死。吴凡在首富帮助下，绝地反击，封杀金孙两家，成为首富集团继承人，与青梅竹马夏冰清修成正果，缔造商业传奇。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485556,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1knu5fOkCvTcc1p5qXJtgjA?pwd=9tsc\",\"online_time\":\"2024-05-21 00:00:00\",\"time\":1716220800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"乱世婚宠夫人要逃婚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"乱世婚宠夫人要逃婚\",\"description\":\"顾晚去霍家豪宅退婚，误闯冷面少帅房间，次日被绑去直接领证……\\n（孙樾、徐艺真高质量高预期自制民国新剧！！！）\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"\",\"update_time\":1720478756,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1DN2Y4rodiW71ZjE_jicajQ?pwd=9cg4\",\"online_time\":\"2023-09-27 00:00:00\",\"time\":1695744000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"予你99天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"予你99天\",\"description\":\"女主山里采药无意中救了男主，之后为了获得傅家培育草药的方法下山履行与傅氏99天的婚约，男主则是被爷爷逼迫，两人都不情愿。99天之后男女主离婚，他们约定好女主帮妈妈复仇结束后重新在一起。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485806,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/11L84IKkPIoaEpqlL7LZvzg?pwd=5igf\",\"online_time\":\"2024-05-25 00:00:00\",\"time\":1716566400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"二婚有点甜\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"二婚有点甜\",\"description\":\"为逃避父母安排的婚姻，她悄悄嫁了人，但婚后丈夫出轨了。为了报复，她在离婚之前招惹了一个她招惹不起的男人，原以为只是一晌贪欢，男人却缠上了她，诱她上钩，步步沉沦，原来他就是当年和自己有婚约的那个男人。\",\"second_cate\":\"女频/霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488066,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1GS5Axhnxrq1gPHcQ3z3t1w?pwd=k9au\",\"online_time\":\"2024-06-22 00:00:00\",\"time\":1718985600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"互换身体后，首富老公每天替我受虐\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"互换身体后，首富老公每天替我受虐\",\"description\":\"沈之挽和首富陆季年结婚五年，二人从相爱相守到互相厌弃，然后突然互换了身体，沈之挽变成了首富，陆季年变成了家里的受气小媳妇……沈之挽愉快的享受首富生活，而陆季年的在家里被迫做饭洗衣打扫卫生伺候难缠的婆婆，应对暂住家里的随时想要踩着沈之挽上位的魏诗鸾，被妯娌和三弟欺负，高嫁的大姑姐带着熊孩子屡次作怪，完全颠覆了陆季年对家里一群人的认知，终于明白了这么多年沈之挽的不容易，两人开始相互怨怼，闹出假怀孕，假总裁，假恩爱等一系列操作，到相互信任协助。两人把身体换了回来之后，解决了危机。陆季年想重归于好，沈之挽却拟好了离婚协议……\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483236,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1XXjr02OobGPV0hS8uPOpWQ?pwd=rpkw\",\"online_time\":\"2024-03-12 00:00:00\",\"time\":1710172800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"亡妻归来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"亡妻归来\",\"description\":\"渣男一家为夺家产伙同小三将原配杀害，被害妻子失散多年的双胞胎妹妹竟是商界大佬，为查清事实真相，双胞胎妹妹化身姐姐复活，重新回到渣男家中，经过与丈夫一家斗争后终于查到姐姐死亡真相，最终渣男一家得到应有的报应。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482186,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1r_iEn8GeOMTY8zoCaSKB6g?pwd=5ug6\",\"online_time\":\"2024-02-06 00:00:00\",\"time\":1707148800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"亡妻归来成女战神\\u0026亡妻归来竟是女战神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"亡妻归来成女战神\\u0026亡妻归来竟是女战神\",\"description\":\"明凰神君秦诗语，五年前遇害被救，归于凡尘嫁为人妇。没曾想丈夫周承邺攀附权贵，秦诗语被丈夫、小三以及婆婆三人置之死地，危机关头，女主只得找回神尊身份决心复仇，在此过程中也慢慢发现当年救自己竟是摄政王。\",\"second_cate\":\"通用赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487636,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1xVpIcNEx2AxhUVA2dWFWIA?pwd=84xh\",\"online_time\":\"2024-06-15 00:00:00\",\"time\":1718380800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"人间修罗\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"人间修罗\",\"description\":\"龙国头号人物“龙首”的对外联络人郭老，带着一星女将军陆雪，来到海中孤岛的死狱，请号称人间修罗的男主莫匪出狱，接受保护北省秦家孙女秦岚的任务。陆雪瞧不起莫匪，但狱中突发囚犯暴乱，莫匪没出面，仅凭两样洗浴用品就镇压下去，震惊陆雪。为了顺藤摸瓜，找出当年害死师父的幕后主使，莫匪决定出狱，誓要重组十殿阎罗，为师父报仇。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481666,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/19sR6-fO9idHsHaTnqV1S2A?pwd=6a6w\",\"online_time\":\"2024-01-18 00:00:00\",\"time\":1705507200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"人间皆是浪漫\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"人间皆是浪漫\",\"description\":\"唐菁菁为给弟弟唐青赚治疗钱，用社交名媛身份出入各种宴会，用黑客技术在权贵电脑上偷公司黑料卖给记者。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484396,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1Py8vumJAXpm4h5izU-eL0w?pwd=xi2p\",\"online_time\":\"2024-04-13 00:00:00\",\"time\":1712937600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"亿万盛宠：租个总裁当老公\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"亿万盛宠：租个总裁当老公\",\"description\":\"宫煜一直暗恋唐紫冉，为了能多见唐紫冉，长期在唐紫冉的咖啡厅订咖啡。唐紫冉照常来送咖啡，把咖啡给了她的哥哥唐致远，俩人闲聊中，宫煜听到唐紫冉要去相亲，于是他跑去找唐紫冉，而唐紫冉在相亲的过程中，遇到了奇葩男，她被刺激到，直接拉着宫煜问愿不愿娶她，打发了奇葩男后，唐紫冉又被妈狂轰滥炸，她机智的拉着宫煜假扮男女朋友，在宫煜的不断询问下，俩人协议结婚，唐致远得知后，去教育唐紫冉，却发现妹夫是自己的老板。唐紫冉的前男友带着现女友突然来到咖啡厅，对着唐紫冉炫耀挖苦，唐致远曝光宫煜的身份，打脸渣男。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479896,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1D_e95FSkFJKW4g_I9bSCBA?pwd=fi2a\",\"online_time\":\"2023-11-14 00:00:00\",\"time\":1699891200,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"今夕长相依\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"今夕长相依\",\"description\":\"上一世叶南依为亲人付出一切，却被算计到死，至死才发现最爱自己的人是被迫联姻的丈夫历北寒。重来一世，她要夺回本应属于自己的一切。\",\"second_cate\":\"女频复仇，甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481816,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1hlPVRL8Rflcq8-3Mj5Q4aA?pwd=k65w\",\"online_time\":\"2024-01-25 00:00:00\",\"time\":1706112000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"今宵尽欢颜\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"今宵尽欢颜\",\"description\":\"启承集团是南城最大的集团，是由江启和邢承共同创立，18 年前，启承集团刚坐稳南城龙头企业的位置，没成想江启一家外出游玩突发车祸，江启当场身亡，而江启的妻子和女儿离奇失踪，启承集团的重担便落在了邢承一个人的肩上，为了纪念挚友江启一家，邢承创立启承公益，关爱残疾人，为江启一家祈福，南城民众无不夸赞邢承重情重义，是杰出企业家代表。而最近，启承集团的董事长邢承年近半百，突然要娶一个年仅 25 岁的貌美妻子，和父亲闹翻外出自己创业的邢家少爷不得不重新踏进了邢家大门，回家参加父亲的婚礼，他惊讶发现，父亲迎娶的新婚妻子，竟然是自己遍寻无果的初恋情人姜蕊......\",\"second_cate\":\"女频复仇/豪门\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483096,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1-yyu4kQEQg_6zpRoaODAbQ?pwd=63z9\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"今日宜欢\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"今日宜欢\",\"description\":\"姜蕊为查明父母死亡的真相，不惜嫁给启承的负责人邢承，婚礼当天，她才知道，邢承那个从不回家的叛逆儿子，是自己曾经的初恋情人……\",\"second_cate\":\"女频甜宠、伦理\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480566,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1SB834FfKybEaFxE1G_bX0A?pwd=hzxd\",\"online_time\":\"2023-12-07 00:00:00\",\"time\":1701878400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"从今天开始当藩王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"从今天开始当藩王\",\"description\":\"小伙穿越到异世界成为藩王，竟俘获四国公主成为帝宫之主？\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479346,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/11G777TMVoY0bPRbZbZoT8Q?pwd=xaxx\",\"online_time\":\"2023-10-19 00:00:00\",\"time\":1697644800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"从外卖员开始崛起\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"从外卖员开始崛起\",\"description\":\"外卖小哥齐宇被未婚妻王萌萌要天价彩礼，无奈去找老同学朱启明要账反被教训，回家后又发现王萌萌给自己带绿帽子，一气之下狼狈离家，齐父死后，齐伯劝齐宇成为齐氏集团继承人，齐宇开启复仇之路。\",\"second_cate\":\"男频逆袭/复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485466,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1NRhJAynmFe4rmQX0PW2kxQ?pwd=nc77\",\"online_time\":\"2024-05-19 00:00:00\",\"time\":1716048000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"从头爱上对的人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"从头爱上对的人\",\"description\":\"南初被劭铭修害死后，灵魂离体才想起自己第一世被杀死的真相，她亲眼看着被自己无视、伤害、误会的宫砚承满身悲痛地抱着自己的尸体轻抚，宫砚承为自己报仇杀死劭铭修后，开枪殉情。南初在灵魂消散那刻重生了。\",\"second_cate\":\"女频重生/大女主\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484976,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"链接：https://pan.baidu.com/s/1nRtTwNTQWRsZrjHvFNDyUQ?pwd=vvz7\\n提取码：vvz7\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-02 00:00:00\",\"time\":1714579200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"他以痛吻我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"他以痛吻我\",\"description\":\"她曾经是风光无限的南大小姐，却因为一场错误的婚姻，葬送了家族，失去了至亲。出狱后她唯一的信念:吊打前夫和白莲花，查明两年前的真相，为父报仇。\",\"second_cate\":\"女频都市总裁爱恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480526,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1V2MdP9Deh6dPra402mXJng?pwd=ndrg\",\"online_time\":\"2023-12-06 00:00:00\",\"time\":1701792000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"他在古代当王妃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"他在古代当王妃\",\"description\":\"顶流演员姜强，在拍戏时魂穿到逃婚跳井的丞相女儿姜蔷身上。倒霉姜强从男人变成女人，在褚国展开了悲惨又搞笑的生活。他先是意外接了皇榜，后又被逼迫嫁给同为男人的七王爷褚子陵，从此和褚子陵开始基情满满又搞笑的爱情故事。同时，姜蔷和褚子陵一起斗渣男，虐渣男，姜蔷助褚子陵绊倒太子，问鼎皇位，太子帮姜蔷成为独立女性，成为褚国第一女商人。\",\"second_cate\":\"女频古装穿越/男穿女\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480436,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1fdezQpljFG4DVXLdHtB_bQ?pwd=ivpu\",\"online_time\":\"2023-12-01 00:00:00\",\"time\":1701360000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"他的黑玫瑰又疯又娇\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"他的黑玫瑰又疯又娇\",\"description\":\"因错位人生喜欢上邻家哥哥的姜也，无意间找回了自己真正的亲人，却迫于自身的家庭无奈站到了许温延的对立面，在恩情与亲情之间，姜也选择坚持心中的正义，和许温延一起战胜磨难终成眷属的故事。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482786,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1Sq2JjNZqAHhj__cc2qpG7A?pwd=ktmk\",\"online_time\":\"2024-02-27 00:00:00\",\"time\":1708963200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"他说爱情就像龙卷风\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"他说爱情就像龙卷风\",\"description\":\"方宛如沉寂在和睦的家庭、丈夫的宠爱、可爱的儿子的幸福生活中。然而完美生活背后，却充斥着丈夫李世豪的谎言，丈夫的出轨被发现，看似坚固的幸福开始逐渐出现裂痕，原本完美的生活也随之开始动摇。\\n故事开篇讲述方宛如偶然间发现自己丈夫李世豪出轨，幻想杀死李世豪，但是最终方宛如还是努力克制自己，火速提出离婚，李世豪净身出户。李世豪为了拿回在方宛如家里藏的私房钱，以孩子为筹码回到家中，此举却让方宛如看清李世豪的真面目，外面不仅仅有一个女人，其中还包括自己的闺蜜，并且李世豪离婚前已经转移了公司的大部分财产......\",\"second_cate\":\"女频家庭、甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480386,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1KUMgid9AhGPWrom6OE3hpg?pwd=t721\",\"online_time\":\"2023-11-27 00:00:00\",\"time\":1701014400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"仙尊师傅太诱人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"仙尊师傅太诱人\",\"description\":\"刻骨爱恋，仙尊担下绝情鞭，十世轮回为爱下凡\",\"second_cate\":\"女频仙侠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479406,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1y1Ds3kETjSrIeWw2wg2uhw?pwd=ib6f\",\"online_time\":\"2023-10-21 00:00:00\",\"time\":1697817600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"以她为饵\\u0026消失的未婚妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"以她为饵\\u0026消失的未婚妻\",\"description\":\"陆念撞见姐姐惨死工地，为调查杀害姐姐的真凶是谁，陆念整容成姐姐模样，接近人人称赞完美丈夫的姐夫顾晏，却不知未婚夫顾寒舟正是姐夫的侄子，周旋在两个男人之间的陆念，身份将隐瞒不住，她又该如何应对？\",\"second_cate\":\"女频悬疑\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487156,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/177WlBGTBjZ-RdjvD9sxMBg?pwd=dhvf\",\"online_time\":\"2024-06-07 00:00:00\",\"time\":1717689600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"以我深情祭余生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"以我深情祭余生\",\"description\":\"结婚纪念日，季云深抱着残废的白月光进门，逼她下跪伺候。“从此，你只配做她的仆人！”他们一起将她践踏在脚下。\\n夏若草不屈反抗：“我才是夏家真千金，凭什么伺候她一个冒牌货？”\\n他将她拖进房间，囚禁折磨。\\n夏若草心凉了。\\n深爱十年的人，原来就是一副穿肠毒药，害她至死。\\n离开，是她最大的报复。\\n“季云深，我死了，带着你的孩子，一起去了天堂！”\\n她留给他最后一条消息，彻底消失。\\n堂堂季少，从此疯了……\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477816,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/10hibKu0SqedBZjZYAbcjFg?pwd=4crp复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-11 00:00:00\",\"time\":1691683200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"以爱之名\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"以爱之名\",\"description\":\"十五年前，女主爸爸要卖女主还赌债，女主妈为了保护女主带着女主逃走，逃跑路上意外走失，女主妈决心一定要找到女儿，十五年后，女主妈成了实力雄厚的娱乐圈大佬，女主成为女主妈公司的打杂小助理，两人终于相遇。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720488166,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1KYenCwhM7mCh2YpTyWWGKA?pwd=k2qr\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"休夫后化身总裁惊艳全场\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"休夫后化身总裁惊艳全场\",\"description\":\"魏南青不顾家人阻拦与她完婚。慕宁雨为不伤及魏南青自尊，隐藏身份却一直被婆婆和小姑子刁难，男主与她离婚。女主恢复身份打脸所有人。男主向慕宁雨道歉，希望复婚。夏安生决定向慕宁雨求婚......\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485106,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1xjiuWB2rNUC1uhk2ZOegig?pwd=b51s\",\"online_time\":\"2024-05-10 00:00:00\",\"time\":1715270400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"传奇人生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"传奇人生\",\"description\":\"和老妈打赌，有了老婆就不用回家继承家产。传奇男主身披多层马甲，低调做事却处处被欺，索性脱掉马甲高调做人！ \",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483176,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1oefnQsK5pXiSeQ5QhNP-3g?pwd=yn62\",\"online_time\":\"2024-03-10 00:00:00\",\"time\":1710000000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"何以为兄\\u0026行者\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"何以为兄\\u0026行者\",\"description\":\"横压一世的天策军统帅被妻子和兄弟联手所害，同胞哥哥为了给弟弟复仇，用弟弟的身份以身入局，对仇人展开戏耍报复。\",\"second_cate\":\"男频兵王/战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486996,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1s2_XI_JrjjupzW0pcvmfvA?pwd=er39\",\"online_time\":\"2024-06-06 00:00:00\",\"time\":1717603200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"余生有你刚刚好\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"余生有你刚刚好\",\"description\":\"慕小小偶遇顾氏集团的总裁顾少淮，并与其发生了关系，一个月后发现自己怀孕。在得知顾少准身份后，不想给其添麻烦，选择隐瞒。母亲发现了她在医院的B超单，逼迫她打胎，顾少淮得知了一切真相赶来...\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485006,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"链接：https://pan.baidu.com/s/18RqQn0YFtzD3dQ6eaqnHIA?pwd=zrnx\\n提取码：zrnx\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-03 00:00:00\",\"time\":1714665600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"你似星辰入梦来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"你似星辰入梦来\",\"description\":\"苏琳芸被养母和姐姐陷害，和盛烯宸春风一度。姐姐苏小芹冒名顶替成为盛烯宸的救命恩人。六年后，苏琳芸改名时曦悦，带着三个孩子高调回国开启复仇，时曦悦为了掩饰三个孩子的存在，不得不和盛烯宸日日斗智斗勇。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485036,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"链接：https://pan.baidu.com/s/1rM-PndK3MunRCmFlNWkHcw?pwd=g6vy\\n提取码：g6vy\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-03 00:00:00\",\"time\":1714665600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"你是天堂也是地狱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"你是天堂也是地狱\",\"description\":\"离婚后，总裁陪初恋孕检，撞见前妻独自一人医院产子，他当场泪崩！\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477746,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1wi_RQzArMu34Dc6csOwzGg?pwd=2hrk\",\"online_time\":\"2023-08-15 00:00:00\",\"time\":1692028800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"你是年少的欢喜\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"你是年少的欢喜\",\"description\":\"阮嫆因为丈夫凌也对于婚姻的不负责任，一气之下和凌也协议离婚。阮嫆离婚后，一直被阮老爷催生，不得不找一名契约男友。对方（慕景琛）有个奇怪的条件——需要蒙上阮嫆的眼睛。为了完成爷爷心愿顾不得其他，在不知道对方真实面目的情况下缠绵，在契约期间，凌也多次找阮嫆复合均被拒绝，在和慕景琛完成契约过程中，阮嫆渐渐对慕景琛身份产生怀疑，直到慕景琛摘下面罩，终于，阮嫆看到了陪伴自己这么多夜晚的人，竟然是自己年少时就熟知的人，现在的梵慕总裁慕景琛......\",\"second_cate\":\"女配甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481326,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1DhlbRZIFcKFEPJiO6lc6vw?pwd=58b8\",\"online_time\":\"2024-01-02 00:00:00\",\"time\":1704124800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"你是我姗姗来迟的光\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"你是我姗姗来迟的光\",\"description\":\"姜宁婚礼上勇抓出轨，转而求婚毁容残疾的霍羡州并闪电领证。此后她深陷各种漩涡，与霍楚纠缠不清，怀孕后更是迷雾笼罩。面对重重困境，霍羡州能否力挽狂澜？来领略这场刺激又精彩的爱恨情仇大戏。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487336,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1EKCNuEWhVn7sUbJrxKQ1zg?pwd=9p3d\",\"online_time\":\"2024-06-10 00:00:00\",\"time\":1717948800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"你是我的掌心朱砂痣\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"你是我的掌心朱砂痣\",\"description\":\"公司破产，父亲自杀，母亲病危，江沅不得已拿了傅闻野母亲的钱，离开深爱自己的男人！经年之后，傅闻野母亲再次带着巨款找到她，求她回到傅闻野身边，只因离开江沅之后，傅闻野到处拈花惹草。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485896,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1rK74YA_q3zffVKK-g4jLzA?pwd=pphq\",\"online_time\":\"2024-05-27 00:00:00\",\"time\":1716739200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"你是我的救赎\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"你是我的救赎\",\"description\":\"时晚死了，灵魂却被禁锢在傅霆琛身边。她亲眼看着傅霆琛为替自己报仇而处死沈光华，为永远和自己在一起而殉情葬身火海。直到这一刻，时晚终于明白是自己一直以来信错了人。表面和气的血脉至亲对自己只有利用，而看似嗜血的傅霆琛才是深爱自己之人。一朝重生，时晚决心要好好爱傅霆琛，和他永远在一起。而对那些伤害过和要伤害他们的人，必斩草除根，不留半点怜悯。\",\"second_cate\":\"女频重生/甜宠/爽文/双强\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481576,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/18PQ0Psbe5gI-86L1hRC3Qw?pwd=9kpc\",\"online_time\":\"2024-01-12 00:00:00\",\"time\":1704988800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"你是我的眼\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"你是我的眼\",\"description\":\"失明的傅寒与灵灵年少相爱，一场车祸，灵灵捐献眼角膜令傅寒恢复光明。再次相遇，傅寒化身陆寒洲，花了三个亿娶怀孕的温乔（灵灵）给爷爷冲喜的，就这样，俩人再次开启命运的纠葛。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486006,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/14Nb5f9KyenM08JIA7JHQwQ?pwd=3ebg\",\"online_time\":\"2024-05-28 00:00:00\",\"time\":1716825600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"你是我的遥不可及\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"你是我的遥不可及\",\"description\":\"总裁，您找了7年的女人刚下飞机，还带了个和您长得一样的小孩……\",\"second_cate\":\"女频总裁\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478166,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1dKELIR5gGS5o-nwHDWPj5w?pwd=indu复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-09-03 00:00:00\",\"time\":1693670400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"你要等着我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"你要等着我\",\"description\":\"二十年前女儿童童出生。温舒撑着力气把长命锁挂在女儿脖子上，婆婆闯进来抢走婴儿，哥哥温云深追了出去，发誓找到妹妹。养母在大雪地里捡到女婴。二十年后，忍冬与母亲和哥哥遇见，却见面不相识。\",\"second_cate\":\"通用寻亲\",\"episode\":0,\"platform\":\"\",\"update_time\":1720487186,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1e1Ynjft_cWXFkms9JGqIig?pwd=rmm9\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"侯门怨\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"侯门怨\",\"description\":\"蔺云婉下嫁世子陆争流，婚后被冷落七年，依旧为他抚育养子，直到功成名就。养子大婚之日露出真面目将她送走。二十年经营拱手送人，连孩子也是替旁人养的，真是不甘。重活一世，蔺云婉不干了，她要让他们悔不当初！\",\"second_cate\":\"女频古代背景（非穿越、重生）\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487076,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/18hR98p2Cz4nVraG12ChrhQ?pwd=x8i9\",\"online_time\":\"2024-06-07 00:00:00\",\"time\":1717689600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"保安叶辰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"保安叶辰\",\"description\":\"原本叶凡地位尊崇，但为陪伴老婆，求生活安静，甘愿以保安身份做无名之辈。谁料，老婆因钱而提出离婚，丈母娘、小舅子、情敌纷纷发难！\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481216,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/14JMWRTUrK3MulMxVRi_TVQ?pwd=3b2q\",\"online_time\":\"2023-12-28 00:00:00\",\"time\":1703692800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"保安老爸真厉害\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"保安老爸真厉害\",\"description\":\"女主因为父亲的逃兵身份拖累自己，要和父亲签署断绝父女关系的协议。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484316,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/11ClJvUc_T8g3n4-ILbzvUw?pwd=c8bu\",\"online_time\":\"2024-04-11 00:00:00\",\"time\":1712764800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"保洁老爸是全球首富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"保洁老爸是全球首富\",\"description\":\"人到中年的裴东明表面上是一个普通的保洁员，实际却是华国第一大公司的幕后掌权人，一次偶然的见义勇为与女儿闺蜜顾雪晴合力从混混手中救下了受欺负的少女。二人的缘分就此开启。\",\"second_cate\":\"男频战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486056,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1L5u_6QyX4pUKu6nJM4tp_Q?pwd=hf3i\",\"online_time\":\"2024-05-29 00:00:00\",\"time\":1716912000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"修仙十年下山即无敌\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"修仙十年下山即无敌\",\"description\":\"十年前，他被老者带上山去，凭借天人之资，成就旷世之能。十年后，老者已随风而去，他回归都市。却发现家已被毁，妹妹也遭人欺辱。金丹期修仙者回归都市，化身宠妹狂魔，快意恩仇，群雄束手！一朝出世，我要还天下公道！\",\"second_cate\":\"男频高手下山\",\"episode\":0,\"platform\":\"\",\"update_time\":1720481316,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1VgQvR5h1--9s8cR3RAyReA?pwd=kd38\",\"online_time\":\"2024-01-02 00:00:00\",\"time\":1704124800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"修炼成为护宝使者\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"修炼成为护宝使者\",\"description\":\"1978年八贼同盟潜入龙国盗取传国玉玺，并杀死了近乎所有护宝者。何耀身为护宝一脉最后一人，练就了至尊功法窥天眼，临危受命踏上了寻找并保护传国玉玺、青铜龙首和帝王图这三件国宝的道路。\",\"second_cate\":\"男频兵王/战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485546,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1nhne3HvzcS4TvscoLOeFCA?pwd=ffft\",\"online_time\":\"2024-05-21 00:00:00\",\"time\":1716220800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"修罗道\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"修罗道\",\"description\":\"大夏战神、修罗王萧尘，隐藏身份守护体内含解毒基因的白亦彤，却遭遇了各方势力的针对，大夏与白家的安危全系在他一人身上…...\",\"second_cate\":\"男频战神、都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480576,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/10K-EGLXvCr7R50XecEe-rA?pwd=cwvb\",\"online_time\":\"2023-12-07 00:00:00\",\"time\":1701878400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"倾世医妃不好惹\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"倾世医妃不好惹\",\"description\":\"伊若扬意外身死，穿成了东灵皇朝正被刁民卖到青楼的宰相嫡女伊若扬，获知伊若扬记忆，占其身体，绝心帮她其讨回公道。教训嫖客，打杀老鸨，还顺手救了个六皇子殿下。她带弟弟回到相府，拿回了属于伊若扬的一切。最终与六皇子终成眷属。\",\"second_cate\":\"女频古装/甜宠/复仇/宅斗\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482866,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1JfNJMASbUEATZa6eRSuoVQ?pwd=euzb\",\"online_time\":\"2024-02-29 00:00:00\",\"time\":1709136000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"假千金手撕剧本\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"假千金手撕剧本\",\"description\":\"池浅穿越修真界渡劫失败之后直接穿到第一世被撞车前看的小说里，不幸穿到炮灰女配身上，但她性格潇酒、心地善良，又从不吃亏，开启了新一轮的斗智斗勇。\",\"second_cate\":\"女频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487786,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1MANxePnROSwNHrGRrxJCfw?pwd=u28j\",\"online_time\":\"2024-06-18 00:00:00\",\"time\":1718640000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"假千金被三个哥哥团宠了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"假千金被三个哥哥团宠了\",\"description\":\"慕家三兄弟找到了丢失十三年的亲妹妹慕北焉，但实际上这个女孩是慕北焉的朋友夏雪，为了福利院的孩子才去接近慕家。三兄弟先后发现了夏雪真实身份，对她从怀疑到接受。\",\"second_cate\":\"女频霸总/团宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485686,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/19fdwtMsWjD6efUi8hOkT9Q?pwd=qjkf\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"假太监：女帝让我攻略后宫\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"假太监：女帝让我攻略后宫\",\"description\":\"秦风穿越成为了一名失去记忆的小太监，受皇后逼迫去给皇帝下药，却无意中发现了惊天隐秘。\",\"second_cate\":\"男频穿越历史\",\"episode\":0,\"platform\":\"\",\"update_time\":1720477796,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1CDibSRi2cAXirggda-msJA?pwd=hkgc复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-11 00:00:00\",\"time\":1691683200,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"偏执大佬的病娇小撩精\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"偏执大佬的病娇小撩精\",\"description\":\"为解体内火毒，楚霆枭以两百亿筹码赢下体内具有“冷血”的冰冻人。可冰冻人刚苏醒，就对楚霆枭撒娇卖萌，不是让楚霆枭喂饭就是求抱抱，这让平日里的冷面阔少楚霆枭措手不及，长久下来竟双生情愫，就在这时，冰美人的真实来历，开始揭露……\",\"second_cate\":\"女频甜宠 动作 马甲\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720480866,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1Ed0jIzKM_WdzbZ5N1Exr2Q?pwd=dkr5\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"偏爱藏不住\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"偏爱藏不住\",\"description\":\"富家千金简欣被恶毒的后妈和继妹欺负，设计她被恶霸欺侮，正巧为陆季川所搭救。二人因为各自处境定下闪婚契约，二人冥冥注定产生情意，而此时，和女主长得一样的白月光回国了……\",\"second_cate\":\"女频甜宠/闪婚\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481896,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1M9IvgdmxYLgriH3GrUjgSg?pwd=u9hf\",\"online_time\":\"2024-01-29 00:00:00\",\"time\":1706457600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"偷不走的爱与光\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"偷不走的爱与光\",\"description\":\"20年前，身家优渥的陆家太太顾云淑，拼尽全力生下女儿，却在出生当日，被她视为亲友的林美如夫妇掉包。此后，陆家养育假千金陆芊玥20年，而真千金却流落到了城中村卖包子的夏家，以夏南溪的身份生活。二十年后，夏南溪为替家族完成承诺，替表姐嫁给了隐藏身份的华都首富战承砚。而战承砚恰巧又是假千金陆芊玥的梦中情郎。由此，真假千金在二十年后又被命运牵连在一处……\",\"second_cate\":\"女频甜宠 真假千金\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481786,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1VpI18n2k71q-ZzUmTiHZfw?pwd=x763\",\"online_time\":\"2024-01-22 00:00:00\",\"time\":1705852800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"偷怀上司崽池助理每天都想辞职\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"偷怀上司崽池助理每天都想辞职\",\"description\":\"池晚报道第一天就跟自己的上司周言深睡了，池晚仓皇而逃，周言深开启了漫漫追妻路。没想到他俩居然是结婚两年但没见过面也不知道对方姓名的联姻夫妻，自此他们总是处于差点掉马的边缘，令人啼笑皆非......\",\"second_cate\":\"女频/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488406,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1IIOjQDK9UB3Mq5ZcMAk8vw?pwd=ejid\",\"online_time\":\"2024-06-27 00:00:00\",\"time\":1719417600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"偷生继承人豪门老公找上门\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"偷生继承人豪门老公找上门\",\"description\":\"本剧讲述了顶流女影后时慕染因姐姐算计和男主厉君寒阴差阳错睡到一起，怀孕后东躲西藏10个月，不料直播生娃的时候，被男主发现，男主正好缺个继承人应付家里，遂和女主领证结婚。但男主有一个青梅竹马管家莫颜，对男主极尽喜欢，不断的设置阻碍，想要破坏两人的情感，时慕染和厉君寒二人经过一系列的感情纠葛，感情不断升温，最终恶人莫颜得到了应有的报应，男主女排除万难获得了众人的祝福，幸福的生活在一起。\",\"second_cate\":\"女频豪门/宅斗/先婚后爱/复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483056,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/17zUVYB6BwJJ8QV9i7Jkakw?pwd=uuty\",\"online_time\":\"2024-03-07 00:00:00\",\"time\":1709740800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"傅先生宠妻无度\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"傅先生宠妻无度\",\"description\":\"前世，沈知心作天作地，作死了宠她如命的男人。 自己也被渣男和亲妹妹联合残忍杀害。 一朝重生，她华丽转身，抱紧矜贵男人大腿不放。 老公，我知道错了，不如我们一起生孩子吧。\",\"second_cate\":\"女频重生/现代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483276,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1jkDi1UBvE3DN6h8NsS2JQQ?pwd=ukkq\",\"online_time\":\"2024-03-12 00:00:00\",\"time\":1710172800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"傅少怀里的学霸千金飒爆了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"傅少怀里的学霸千金飒爆了\",\"description\":\"苏氏集团的千金苏蔓在苏氏秘密培养下已经成了全能优异高材生，为了一个学籍考大学去一所当地中学准备高考，可是学校女校霸以为她农村身份处处欺凌。\",\"second_cate\":\"女频逆袭言情\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720478226,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1a9SQCo_t-QjAiof0B0mzzg?pwd=tcmd\",\"online_time\":\"2023-09-08 00:00:00\",\"time\":1694102400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"傅少，夫人带着小姐杀回来了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"傅少，夫人带着小姐杀回来了\",\"description\":\"赵汐月被叶止渝陷害，失去傅庭渊信任，造成父亲枉死，赵汐月怀着孕肚装死，五年后携爱女和闺蜜一起报复，傅庭渊甜蜜追妻。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479306,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1xX1S0xx4Wjlf0yIE6uq9Rw?pwd=sf2j\",\"online_time\":\"2023-10-17 00:00:00\",\"time\":1697472000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"傅总娇妻你别逃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"傅总娇妻你别逃\",\"description\":\"季小沫不慎中药，逃跑路上，季小沫遇见了酒醉的傅远琛，情急之下与傅远琛一夜缠绵。结果三个月后，发现自己肚子里有了崽崽，季小沫的父母要季小沫代替妹妹嫁给傻子，小沫因肚中有孕，情非得已下只能同意。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487256,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1fX_4DGfLhBvM1_8Yo0jA6Q?pwd=ny83\",\"online_time\":\"2024-06-08 00:00:00\",\"time\":1717776000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"傅总的冷情罪妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"傅总的冷情罪妻\",\"description\":\"傅星塞的心头爱回国，妻子沈言成了十恶不赦的罪人，被他弃之如敝履。他眼盲心瞎，极尽所能将她折磨到体无完肤，生如炼狱。直到真相大白，沈言死了，尸骨无存。傅星寒昏了过去\\\"求求你，沈言，你回来。求你再看我一眼好不好?\\\"\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477696,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1pkAKcZYVB3iQtFP4Jgtelw?pwd=rjas\",\"online_time\":\"2023-08-15 00:00:00\",\"time\":1692028800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"傅爷你的替嫁新娘是大佬\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"傅爷你的替嫁新娘是大佬\",\"description\":\"顾北笙被妹妹顾心语下药陷害坐牢四年。而此时顾家为了不让顾心语嫁给传说中样貌丑陋的病秧子傅西洲，让顾北笙替嫁傅西洲。出狱后顾北笙被揭露首富千金的身份，却拒绝家族帮助，靠自己成功报复顾家，并找到一生所爱。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487106,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/17gZkCPpZowgtOTKKdwvpJw?pwd=rmn3\",\"online_time\":\"2024-06-07 00:00:00\",\"time\":1717689600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"傲世帝尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"傲世帝尊\",\"description\":\"本剧的主人公秦昊是一位民族英雄，率领手下击破了损害国家利益的邪恶势力。秦昊在完成自己的英雄使命之后，回归家庭回归生活，带着老婆孩子过上幸福日子。秦昊的妻女被社会邪恶势力荼毒，奋勇反击，对邪恶势利进行报复复仇，并且扫除，而后又鼓励妻子林柔，让林柔奋勇拼搏，积极进取，成功帮助林柔从一个小人蜕变成了女强人。\",\"second_cate\":\"男频都市战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479756,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/14w0ArDD0fJsW3tUN_pmOKQ?pwd=vb8p\",\"online_time\":\"2023-11-09 00:00:00\",\"time\":1699459200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"傲娇总裁每天都在争风吃醋\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"傲娇总裁每天都在争风吃醋\",\"description\":\"全能女神沈一一，为了替外婆报恩嫁给了霍家三少冲喜，竟在结婚当天，三少就醒了过来，就此开启了全能大佬vs霸道总裁的爆笑甜宠故事~\",\"second_cate\":\"女频马甲、霸总、甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482146,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1fkXNBR05hfvyQhHyKhMsUw?pwd=rm44\",\"online_time\":\"2024-02-05 00:00:00\",\"time\":1707062400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"傲骨龙隐\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"傲骨龙隐\",\"description\":\"十八年前，庄氏被灭，庄崎成了落魄孤儿；十八年后，庄崎成为了北境统领，在得知自己妹妹未死的下落后，他放弃统领职位，独自到海市寻找世上唯一的亲人庄苒，并救她于危难中；哪知长老突然病重，统领之位虎视眈眈，内忧外患，庄崎为了找到当年的灭门下落，留在海市，暗自寻找灭门案的真凶。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478506,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1QDPKmYGnhQA4JmN_TlS02Q?pwd=ia2i\",\"online_time\":\"2023-09-14 00:00:00\",\"time\":1694620800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"儿子年夜下毒让我还债\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"儿子年夜下毒让我还债\",\"description\":\"他为了赌钱，大年夜活生生打死了自己的妻子；十八年后的今日，亲生儿子下毒毒死了他，让他重回1998，让他有机会把错过的失去的，都找回来……\",\"second_cate\":\"男频都市年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480896,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1ZYzZRgZz7ZHZtU1NHnyPiA?pwd=qn62\",\"online_time\":\"2023-12-18 00:00:00\",\"time\":1702828800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"先婚后爱小甜妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"先婚后爱小甜妻\",\"description\":\"该剧阐述了面临爱情和亲情的抉择，该何去何从，更体现了部分人，为达到自己的一己私利，不择手段，害人害己，永远邪不压正，一双有情人，经过反抗、误会、凌辱，几经波折，最终一家团聚。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485246,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"链接：https://pan.baidu.com/s/1ViWMpNY1sujw4RvLqYazFA?pwd=o2ab\\n提取码：o2ab\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-14 00:00:00\",\"time\":1715616000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"入赘五年，离婚即无敌\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"入赘五年，离婚即无敌\",\"description\":\"农民工秦枫实际上是隐世家族秦家的继承人，五年前在创建天财商会的辉煌时机却遭人暗算重伤，被唐思璇所救。秦枫为了报恩，成为唐家上门女婿，与其生下一女，一边暗中帮唐思璇创业，一边接搬砖的机会暗中打探当年害自己的人。谁知秦枫此举被唐思璇误会不求上进，惨遭离婚。离婚后，秦枫机缘巧合几次唐思璇相遇，发生矛盾。并且在这一过程中，卷入了华夏顶尖世家许家和薛家的争斗当中，在帮助许家对抗薛家时，秦枫找到了当年暗算自己的罪魁祸首，成功斩杀对手，并完成家族统一，在世人面前展露身份后，回归家族。\",\"second_cate\":\"男频都市战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479606,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1tFbTdH9wqHFPh3_LiN2iZg?pwd=8dby\",\"online_time\":\"2023-11-03 00:00:00\",\"time\":1698940800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"全世界都在演我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"全世界都在演我\",\"description\":\"凌凡常利用电脑知识和催眠手段帮助发小王进破案。和王进侦破一重大案件时重伤且因被催眠，脑受伤忘记很多事情且引发不好回忆侵蚀意志直至会脑死亡。王进和楚潇潇等人进入凌凡意识演了一场戏唤醒他。\",\"second_cate\":\"通用超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485426,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1ZRyTv9NJ_r9SOdYCbwM4XA?pwd=1cr8\",\"online_time\":\"2024-05-19 00:00:00\",\"time\":1716048000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"全员助攻豪门老公太撩人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"全员助攻豪门老公太撩人\",\"description\":\"沐婉意外和南宫炎发生了一夜情，被南宫奶奶得知后就去沐家提亲，南宫炎在逼迫下隐瞒身份和沐婉协议结婚。婚后南宫炎教训欺负沐婉的人，两人有甜蜜时刻，也产生过各种误会，最终有情人终成眷属。\",\"second_cate\":\"女频/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488116,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1Q8dwsyrcf_qhETXDVuKF_g?pwd=tfv3\",\"online_time\":\"2024-06-22 00:00:00\",\"time\":1718985600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"全球大佬欠我赊刀债\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"全球大佬欠我赊刀债\",\"description\":\"张炉身为天师府天师，为报恩娶了宋家长女宋婷婷，并暗中扶持宋家崛起。没想到宋家崛起后，宋婷婷选择跟他离婚，宋家的势利让张炉大失所望，于是在黑金晚宴上坦白身份，宋婷婷追悔莫及，而中州郡主顾青衣的到来，让宋婷婷失去了最后机会。\",\"second_cate\":\"男频/天师/赊刀债/战神/离婚\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481846,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/18Q55SvJWWVYNZtioqGALcw?pwd=i5z1\",\"online_time\":\"2024-01-26 00:00:00\",\"time\":1706198400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"全球强者欠我赊刀债\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"全球强者欠我赊刀债\",\"description\":\"张景玄作为天师传人，为报恩暗中扶持秦雪柔成为女总裁，属下送出二百亿贺礼后，秦雪柔却提出离婚。离婚后，张景玄身份曝光，秦雪柔追悔莫及，但为时已晚。中州女帝叶素衣，以张景玄未婚妻身份出现，率领诸多强者恳请天师出山！\",\"second_cate\":\"男频天师战神离婚后\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479436,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1CDX0TQeAlv06rLTv8s2ipg?pwd=2v8e\",\"online_time\":\"2023-10-24 00:00:00\",\"time\":1698076800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"全球爆宠：我四个大佬哥哥亿点点拽\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"全球爆宠：我四个大佬哥哥亿点点拽\",\"description\":\"首富千金陆濛濛为了追求真爱，隐藏身份嫁给了小公司老板苏城景，暗中让哥哥给苏城景投资，帮其发家致富。没想到投资的事情刚刚确定，苏城景却为了攀上“首富千金”逼迫陆濛濛离婚。面对苏城景一家人对自己处处折辱，陆濛濛自然要恩怨必报，即使渣男痛哭流涕也绝不回头，毕竟作为陆氏集团的千金，她可是有四个哥哥宠着呢。\",\"second_cate\":\"女频霸总/团宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486076,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1zinHTqht3CA_HX6jAWXzbQ?pwd=89dy\",\"online_time\":\"2024-05-29 00:00:00\",\"time\":1716912000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"全球直播双面宠妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"全球直播双面宠妻\",\"description\":\"江离三年前突发车祸，母亲双腿残废，流落在外，三年后，假装失忆被男主带回，与男主及四宝见招拆招推翻两大财阀家族，却不曾想因老辈却卷入更深的漩涡当中。\",\"second_cate\":\"女频直播、现言、萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482856,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1mgVt_OKaTRpLS5tuCHj41A?pwd=rwhw\",\"online_time\":\"2024-02-29 00:00:00\",\"time\":1709136000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"全能王妃杀疯了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"全能王妃杀疯了\",\"description\":\"21世纪医药科研学者慕云汐穿越到架空朝代，成为东岚国的冷宫弃妃。慕云汐随身携带穿越空间。皇帝楚临霄偶然发现了她的与众不同，两人互披马甲隐瞒身份，开始了各种斗智斗勇爆笑有趣的生活，直到渐渐产生情愫。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488206,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1W2Qj6rJGvjM0fT4DZH5abA?pwd=if4m\",\"online_time\":\"2024-06-24 00:00:00\",\"time\":1719158400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"八荒圣主\\u0026八荒圣王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"八荒圣主\\u0026八荒圣王\",\"description\":\"百年前，八荒圣王林枫在飞升时被偷袭，幸得四村民救助。林枫赐下滔天气运和四大圣象镇守，自己隐藏身份修养。百年后，四家族认为林枫的恩赐是骗局，于是计划斩圣大会。林枫面对四家族的背叛，盛怒下收回气运。\",\"second_cate\":\"男频兵王/战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487126,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1bIGRAjhmC8gG8otkJRsgJg?pwd=hfdh\",\"online_time\":\"2024-06-07 00:00:00\",\"time\":1717689600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"八零养娃往事\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"八零养娃往事\",\"description\":\"司念穿书后成了假千金，被养母一家逼着代替真千金林思思嫁给带着三个崽的老男人。司念熟知剧情知道老男人周越深沉稳可靠，决定履行婚约，一次次惊艳周越深，让周越深从一开始的无所谓，最后完全爱上她。\",\"second_cate\":\"女频年代/重生/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484196,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1BzpJmvA3X5Nsmdycn2nvhQ?pwd=pgbx\",\"online_time\":\"2024-04-06 00:00:00\",\"time\":1712332800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"八零漂亮后妈\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"八零漂亮后妈\",\"description\":\"司念因一场意外穿成了年代文里的假千金，不料被回归的真千金抢了未婚夫，最后更被养父母赶回农村嫁给了大龄二婚男。司念给自己定下人生目标，不放过任何一个赚钱的机会，率领乡亲走上了发家致富路。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485876,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"链接：https://pan.baidu.com/s/1V44drXU2HQ06D42dWSqiNw?pwd=aw7y\\n提取码：aw7y\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-26 00:00:00\",\"time\":1716652800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"公主手撕负心人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"公主手撕负心人\",\"description\":\"皇甫若离本是千金公主，却在爱上穷秀才梵绝尘后隐瞒了自己的真实身份，还辛苦劳作供其考取了功名。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477866,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1SiFSXAdSEYdXT7akqwFavQ?pwd=i995复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-19 00:00:00\",\"time\":1692374400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"再临\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"再临\",\"description\":\"男主被反派设计坑害，家破人亡。忍辱负偷生十余年，还是被反派找到，惨遭杀害。却重生回到自己赌博输掉家产的当天。这一世，他要弥补前世的遗憾！\",\"second_cate\":\"男频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481466,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1obDb-r72M6FMIs0YsuUb1w?pwd=i8hv\",\"online_time\":\"2024-01-08 00:00:00\",\"time\":1704643200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"再度重逢\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"再度重逢\",\"description\":\"宁夕被双胞胎妹妹宁洋陷害导致与战家继承人一夜情，怀了四胞胎，宁洋趁机抱走了一对，成为了战家继承人的未婚妻。宁夕误以为另外一对双胞胎已经死亡，只得带了剩下的两个孩子远走海外，五年后宁夕归来，发誓要为自己的孩子报仇，却因此得知了真相……\",\"second_cate\":\"女频萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483546,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1vK6MjE308wfle7kvA1gKvg?pwd=4enx\",\"online_time\":\"2024-03-21 00:00:00\",\"time\":1710950400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"再忆冰城往事\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"再忆冰城往事\",\"description\":\"1985年之前，宋永佳是一个普通瓦砖工人，妹妹考学、母亲重病，被一穷二白的家境逼上绝路不得不进城谋求财路，奈何人性复杂，处处被人欺压侮辱，为了家人奋起反抗，在求财道路上频出险招终脱胎换骨横行北方。\",\"second_cate\":\"男频/逆袭\",\"episode\":0,\"platform\":\"\",\"update_time\":1720487976,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"链接：https://pan.baidu.com/s/1oJcNnGLZH4Ztwp7Kk1RuZA?pwd=wblj\\n提取码：wblj\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"再次倾心\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"再次倾心\",\"description\":\"女主为孩子上户口和渣男男友领证却被放鸽子，男主查到女主的女儿就是自己的孩子，前来民政局两人拼婚，渣男母子不但虐待孩子还算计女主房产，女主为孩子开始智斗渣男母子，男主隐瞒自己是公司总裁，在这个过程中帮助女主处理各种问题并对女主和女儿极尽宠爱。最后一家人圆满在一起。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481366,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/18s-cC-QZBHd5g3dlLg63fw?pwd=bk8q\",\"online_time\":\"2024-01-02 00:00:00\",\"time\":1704124800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"再爱我一次\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"再爱我一次\",\"description\":\"幼年遭人陷害流落孤儿院的厉墨涵，结识了同在孤儿院的苏圆圆，两人青梅竹马，却因一场意外失散多年。命运齿轮转动，多年后，两人再次相遇，却被心机女冒充身份。\",\"second_cate\":\"女频霸总、虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488546,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1y1tSgEQbmFasCcePPBboXg?pwd=j493\",\"online_time\":\"2024-06-29 00:00:00\",\"time\":1719590400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"冒牌医圣（老剧）\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"冒牌医圣（老剧）\",\"description\":\"受伤闭关的医圣，为了解决突发危机，临时找到凌云来帮助他度过难关。最后凌云通过自己的刻苦努力，学会了医圣的针灸。不仅如此，凌云的刻苦努力也感动了医圣的护卫，收获了爱情。\",\"second_cate\":\"男频高手下山战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484626,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1MA3IfbZ42LQRaJgdYVUDFw?pwd=62wr\",\"online_time\":\"2024-04-20 00:00:00\",\"time\":1713542400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"冲喜夫人\\u0026霍少的锦鲤小娇妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"冲喜夫人\\u0026霍少的锦鲤小娇妻\",\"description\":\"女主苏沫为了高额奖金，嫁给了富二代植物人霍景宸。苏沫一个人在各方势力面前苦苦周旋，关键时刻，霍景宸突然出现，救了苏沫。原来，这一切都是霍景宸布的一个局，最终，苏沫与霍景宸过上了幸福的生活。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486436,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1GF-roBOzYVg872wBh3eeOw?pwd=vuf5\",\"online_time\":\"2024-05-09 00:00:00\",\"time\":1715184000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"冷面顾少的小娇妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"冷面顾少的小娇妻\",\"description\":\"白若离原本家境优渥，后父母死于意外，被姨母李兰收留，而白家财产也归李兰所有。后被姨母和新婚丈夫杜文彬所谋害，死之前得知父母死亡真相，重生后一心复仇，与顾凌深先婚后爱。最终与顾凌深两人有情人终成眷属。\",\"second_cate\":\"女频重生/复仇\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486706,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1E2ajMloMGvpXUmoe9uf7VQ?pwd=725m\",\"online_time\":\"2024-05-31 00:00:00\",\"time\":1717084800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"凌天传\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"凌天传\",\"description\":\"凌天神君为报许家救命之恩，以第一财团扶持妻子，又请妻子为自己复出加冕。未曾想百般真心却被随意践踏，五年相守的妻子只相信小人之言。反倒是只有一面之缘的天之骄女楚雨浠，为其两披嫁衣，面对所谓权贵，凌天抿唇一笑，既然你们不识抬举，那我便叫你们知道何为权势滔天。\",\"second_cate\":\"男频都市，无敌战神，男强女强\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482176,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":17,\"material\":\"https://pan.baidu.com/s/11JYmdv8uwMwDeZsrhX8lQg?pwd=wkkg\",\"online_time\":\"2024-02-06 00:00:00\",\"time\":1707148800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"凌霄\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"凌霄\",\"description\":\"五年前，叶倾城勾结天下会，血洗聂家满门，图谋聂家九阳真血，身为叶倾城未婚夫的聂风也被推下悬崖。不过聂风侥幸未死，被龙谷医仙、天机阁阁主冷月以及逍遥宫宫主碧瑶所救，拜三人为师。聂风苦修五年，修为达到大天境巅峰，掌握血饮魔刀，决心下山寻找当年的真相。但龙谷绝地有铁律——有进无出，聂风只能与三位师傅对抗...\",\"second_cate\":\"男频高手下山\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482916,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1I41mL6EgCRLOXx_KvV69Mw?pwd=kq6b\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"凤凰涅槃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"凤凰涅槃\",\"description\":\"沈雪本是龙国北月集团创始人龙国首富，五年前下嫁凤城苏家，本想无忧无虑的过着幸福生活，谁知遭遇丈夫背叛，婆婆羞辱，忍无可忍之际决定来一场正式的复仇反击。\",\"second_cate\":\"女频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485646,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1pEWIBY7tIprtQYgbmquD8w?pwd=3qfs\",\"online_time\":\"2024-05-23 00:00:00\",\"time\":1716393600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"凤起萧墙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"凤起萧墙\",\"description\":\"安沁雪一家满门被杀，在逃跑的过程中却意外与暴君互换了灵魂。安沁雪顶替了暴君的身体，而暴君却变成了一个洗马桶、被欺负被迫害的辛者库小宫女。无奈之下，他只能逼迫安沁雪纳自己为妃，后宫的宫斗路刚刚开始，一代暴君被迫开始手撕后宫白莲花，而他也在和安沁雪相处的过程中，内心逐渐变得柔软。两人共同开启了一条替父翻案、斗奸臣、斗后宫的奇妙之旅。\",\"second_cate\":\"女频古装、灵魂互穿\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483266,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1cgULCbKqZ7cNWi88RaW9YQ?pwd=y4pf\",\"online_time\":\"2024-03-12 00:00:00\",\"time\":1710172800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"凤飒归来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"凤飒归来\",\"description\":\"凤颜汐前世为了辅佐太子尽心尽力，却临到最后被太子一杯毒酒送走，临死之前她才得知，她心心念念的恩人，并不是太子，而是被她害死的铭王！就连养父母都是被自己的亲生父亲害死！这次重生，她是为复仇而来。\",\"second_cate\":\"女频古装、宫斗\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480246,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1AU7qZBnvXLFYn5HIgyjtGw?pwd=cve6\",\"online_time\":\"2023-11-22 00:00:00\",\"time\":1700582400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"凤飞九天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"凤飞九天\",\"description\":\"陆雪漫原是凤凰殿女皇，隐姓埋名嫁给许凡。在受尽屈辱后，得到凤凰殿的支持，成功反击许家和楚家，恢复名誉并帮助丈夫的事业。同时，她击败了试图破坏她婚姻的周琳琳，最终与许凡幸福地生活在一起。\",\"second_cate\":\"女频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487646,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1jXMfv9qrLYMBeAEK24Yhlg?pwd=yqvz\",\"online_time\":\"2024-06-15 00:00:00\",\"time\":1718380800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"凭爱意将月光私有\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"凭爱意将月光私有\",\"description\":\"【明艳小提琴家×深情不移商圈新贵】许莓追求陆知衍爱而不得，在领证当天收到陆知衍和别人拥吻的照片。 六年的苦苦追求被视若敝履，许莓不干了。 在走出民政局时偶遇当年的死对头薛岑， 她一时冲昏了头脑和他领证。 而事实上，薛岑已经暗恋许莓多年。阴差阳错的重逢， 让一段旷日持久的暗恋，有了盛大的续集。\",\"second_cate\":\"女频职场婚恋、甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483636,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1dOpOd2QhoU1AjMJjuyJUKA?pwd=t46v\",\"online_time\":\"2024-03-22 00:00:00\",\"time\":1711036800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"凶凶的铁拳\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"凶凶的铁拳\",\"description\":\"李小书降职陈氏集团的小职员，抓住机会就把毒药和李珊珊喝的中药进行了调包。李小书的生活却没有事情败露之前优渥，李小书接受不了经济上的落差，和肖成继续商量怎么侵吞陈氏集团，决定铤而走险，借着职务之便窃取公司的机密资料。不久后，陈奕发现自己的公司无论推出什么新产品，都会被肖成的公司抢先一步，怀疑公司里出现了内鬼，李珊珊同样也发现了此事，但陈奕和李珊珊不约而同地选择了按兵不动，私下里偷偷调查此事。李小书和肖成交易时，跟踪李小书的行踪的李珊珊突然胃癌发作，晕倒在地，被晚了一步的陈奕发现。\\n陈奕顾不上管李小书的事，急忙将李珊珊送到了医院，却得知了李珊珊胃癌晚期的事情，陈奕崩溃，李珊珊却安慰陈奕，告诉他李小书暗地里的勾当，将自己所调查的线索和证据一并交给了陈奕，随后就陷入了昏迷。陈奕无心公司，日夜在医院守着李珊珊。陈珍出现，告诉陈奕振作起来，要将害李珊珊的人和出卖公司的人抓到，为李珊珊报仇。陈奕立刻回到了公司，整理自己和李珊珊所掌握的证据，将李小书和肖成抓走调查。李小书和肖成将会在监狱中独活余生，公司也回到了正轨。李珊珊手术当天，陈奕焦急地等在手术室外，手术成功，李珊珊被推出病房，和陈奕拥抱在一起。\",\"second_cate\":\"女频现言\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485956,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1oS82lzrmD3VlIYTMBwITEw?pwd=eyqs\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"出狱后我闪婚了全城首富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"出狱后我闪婚了全城首富\",\"description\":\"保姆女儿江夏，因故意伤害罪而服刑五年，报警人却是自己的母亲，而后江夏在狱中产子却生父不详。五年后，江夏与“环卫工”顾景初闪婚，相处中彼此互生情愫，关于自己和儿子身世的秘密也逐渐浮出水面。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486976,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1CxfrVsBbkXBMdn7qhQz9Iw?pwd=19ez\",\"online_time\":\"2024-06-06 00:00:00\",\"time\":1717603200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"分手即巅峰我开启了无限复制\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"分手即巅峰我开启了无限复制\",\"description\":\"本剧讲述了男主林凡在为女友辛勤工作，甚至掏空自己的身体卖钱，却在虚弱昏迷之际被自己女友抛弃。后来得知林影早背叛自己 ，更是伙同情夫，想要卷走剩余财产。幸好林凡因祸得福获得了复制能力且在古董街赚了第一桶金。后遇到古珍阁老板刘道远，阴差阳错获得了刘道远的鉴宝术。林凡更是利用自己的复制能力在拍卖会上大放异彩并获得了女总裁柳羽嫣的青睐，后续帮助柳羽嫣在拍卖会上赢得了武皇无字碑，为她爷爷治病，两人因此感情升温，修得正果。\",\"second_cate\":\"男频金手指\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481606,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1CFZZG4tqreETSBrHFoNLhg?pwd=feqz\",\"online_time\":\"2024-01-15 00:00:00\",\"time\":1705248000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"分手后我回豪门当千金\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"分手后我回豪门当千金\",\"description\":\"姜遥始终信任的男友柳荣嘉拿到影帝当晚，姜遥感情遭到背叛，事业也被柳荣嘉和苏婉莹抹黑，谈好的角色被苏婉莹顶替，全网都黑她要她滚出娱乐圈。姜遥回到姜家，手握最顶级的资源，柳荣嘉和苏婉莹这才惊愕地发现，姜遥竟是姜氏集团的千金。危难时秦骁接近、保护姜遥，姜遥虽然动心了但因误会屡屡避让。你追我躲中，姜遥获得影后，事业成功，记忆也逐渐恢复。关键时刻，秦骁用性命守护姜遥，姜遥终于想起所有的事，两人终成眷属，同时姜遥记起八年前绑架案的幕后主使就是苏婉莹母亲。苏家破产后，苏婉莹和柳荣嘉的事业一落千丈，声名扫地锒铛入狱。\",\"second_cate\":\"女频复仇/甜宠\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482686,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1pu-Ul-xkVrQIjFbDGxv4NQ?pwd=2r3j\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"分手后我继承了千亿家产\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"分手后我继承了千亿家产\",\"description\":\"陈天浩工地打工三年，意外成为千亿家产继承人。浑然不知的未婚妻早已决定要与其分手，攀附一个富二代。陈天浩决定，亮明自己的真实身份，让这些嘲笑羞辱蔑视他的人，都付出代价！当一切真相大白，未婚妻后悔自己了自己的选择……\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480836,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1nMSW6Kmejk7BdvL1NwR16w?pwd=57hv\",\"online_time\":\"2023-12-16 00:00:00\",\"time\":1702656000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"刚下山就和逃婚大小姐同居\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"刚下山就和逃婚大小姐同居\",\"description\":\"鬼医门门主萧良，为了追查当年鬼医门被灭一事，来到云城，隐姓埋名做起了保安，偶遇柳家千金小姐柳轻舞，借助柳家千金的身份萧良一步一步揭开了当年鬼医门被灭门的真相。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487446,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1T6Uf5iL-JiEyi04X1ZZghg?pwd=huar\",\"online_time\":\"2024-06-13 00:00:00\",\"time\":1718208000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"初恋他是神君大人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"初恋他是神君大人\",\"description\":\"姜橙为了实现财务自由，选择了殡葬专业。准备辞职的第一天，处理的最后一具尸体忽然死而复生，暂时无家可归的她，被‘神仙’顾文昊捡回家中。本想找到房子就搬离，可顾文昊却‘引诱’她签下了与神的契约。她需要帮助顾文昊完成三件事，才可顺利脱身。陪着顾文昊回公司的第一天，公司里就发生了命案，顾文昊觉得这或许跟杀害他的凶手有关，于是展开了调查，同时为了尽快完成附加任务，他开始照着人间方式，与姜橙‘谈恋爱’。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483286,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1v6zxsz0qd9xoDcmFtdDjyQ?pwd=99ff\",\"online_time\":\"2024-03-12 00:00:00\",\"time\":1710172800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"别动我的美女徒弟\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"别动我的美女徒弟\",\"description\":\"千年前，仙庭老祖欲强占盈盈，摧毁天启门。门内天才江无奇出手，斩杀老祖，血洗仙庭。为保全门派，自毁金丹，成为了一个废人。千年后，江无奇偶然得到神农功法，重回颠覆。也因爱重塑金丹，开启了开挂模式。\",\"second_cate\":\"男频古代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484916,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1dhQmo7a42W4sVAUeQDQQxg?pwd=bm3c\",\"online_time\":\"2024-04-30 00:00:00\",\"time\":1714406400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"别叫我神王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"别叫我神王\",\"description\":\"本故事讲述了一个本来被众人瞧不起的平凡人物沈星琦，五年前外出征战，为星国立下赫赫战功。五年后，当成为星曜神王的沈星琦荣耀归来，如何让从前瞧不起他的人畏惧臣服、并俘获美人心的故事。\",\"second_cate\":\"男频小人物逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480816,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1zZnEi-nNKG8lbIg0cckW1g?pwd=wh9w\",\"online_time\":\"2023-12-16 00:00:00\",\"time\":1702656000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"别对我动心\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"别对我动心\",\"description\":\"林浅思生日当天发现闺蜜李悦和男友杨辰暗度陈仓，一气之下随手拉了个男人接吻，不料这个人就是第二天与林浅思相亲的陆氏总裁陆淮北。陆淮北提出想要林浅思成为契约妻子，林浅思欣然答应，两人领证闪婚。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487826,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Q7xj_lnL9BQQshR0VQCEjA?pwd=tnsw\",\"online_time\":\"2024-06-19 00:00:00\",\"time\":1718726400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"别惹叶小姐，她法术通天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"别惹叶小姐，她法术通天\",\"description\":\"现代叶倾城同宋子明有婚约，宋子明与叶子萱勾搭成奸，二人设计女主，害的女主做了乳房切除手术，后叶倾城在二人的羞辱下，悲愤自杀。华国叶倾城穿越而来恰好穿越到叶倾城身上，偶然间遇到天定之人男主战北野，死缠烂打与之结婚，后联手战北野灭了宋家和叶家。\",\"second_cate\":\"女频异能重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480966,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1lCMOlUZkouyzJrwWJENW9g?pwd=cemj\",\"online_time\":\"2023-12-20 00:00:00\",\"time\":1703001600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"别惹少帅夫人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"别惹少帅夫人\",\"description\":\"霸道少帅陆南平，娶回来的少夫人却是个假千金。就在两人揭开误会，想以真面目面对时，逃婚归来的沈府千金沈凌意外出现。两人欲爱不能，欲分不舍，展开了一段军阀少主和赝品夫人之间的爱情纠缠。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484946,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"链接：https://pan.baidu.com/s/1XTP43y5IXeSvSvweYlYkgQ?pwd=ch7m\\n提取码：ch7m\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-02 00:00:00\",\"time\":1714579200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"到我身边来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"到我身边来\",\"description\":\"司九音十年前被后妈用计关进了精神病院受尽折磨。十年隐忍回归，她誓要让陷害她的人付出代价。结果在阴差阳错下，偶然间救下了薄氏集团总裁薄西晏的奶奶，借着薄西晏的关系，开启了开挂的复仇之路。\",\"second_cate\":\"女频/霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488006,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"链接：https://pan.baidu.com/s/1bIwmI3JmpReGu_ghDQonqw?pwd=5z0p\\n提取码：5z0p\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"2024-06-21 00:00:00\",\"time\":1718899200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"前夫每天都在想复婚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"前夫每天都在想复婚\",\"description\":\"离婚三年，女儿玩我手机，误给前夫发：我爱你，看到回复我崩溃了\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480296,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1V6qoYL0WEqMdqLnzJaHxsw?pwd=jhtw\",\"online_time\":\"2023-11-23 00:00:00\",\"time\":1700668800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"前妻乖巧人设崩了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"前妻乖巧人设崩了\",\"description\":\"南颂与喻晋文的七年婚姻不抵白月光一句“我回来了”，南颂与喻晋文离婚后便消失不见，喻晋文动用一切力量打听南颂的消息，南家大小姐的身份掉马后，喻晋文才知自己的前妻竟然是大佬，踏上漫漫追妻之路。\",\"second_cate\":\"女频马甲文 离婚后 追妻火葬场 大女主\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481626,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1OEaMsp9mKugwkHCO_blunQ?pwd=c9qm\",\"online_time\":\"2024-01-15 00:00:00\",\"time\":1705248000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"前妻别逃霍先生乖乖宠我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"前妻别逃霍先生乖乖宠我\",\"description\":\"南知暖因三年前救过霍绍霆的爷爷一命，因此和霍绍霆结婚。但霍家上下除了爷爷，都认为南知暖嫁过来是贪图霍家的钱，瞧不上她，霍绍霆也不愿见，结婚三年从未见过面。三年后，在霍绍霆回国庆祝晚宴上，南知暖的继母为得到更多霍家的钱，给南知暖酒中下药，因此和霍绍霆产生了一夜情。南知暖本想告诉霍绍霆自己就是他三年未见的妻子，可她听到霍绍霆在电话中说自己要离婚，于是南知暖便决定不再多说。霍绍霆倒对她产生了一丝兴趣。\",\"second_cate\":\"女频都市、甜宠\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483916,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1zATI92WiFWYS07rg0uyjLw?pwd=qcqw\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"前妻太招摇程总别撩了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"前妻太招摇程总别撩了\",\"description\":\"被坏人追寻的女主逃跑躲进男厕时撞见程家三少，在三少的威胁下让女主发出不可描述的声音来躲过追兵，在这种情况下女主该如何逃过这一劫又会跟程家三少发生什么......\",\"second_cate\":\"女频霸总一夜情，闪婚替嫁，复仇\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483746,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1Pz_gW5XQYQm9seQhDAnsOA?pwd=kf4h\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"前妻撩人傅先生宠不停\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"前妻撩人傅先生宠不停\",\"description\":\"盛眠结婚三年的老公连她是谁都不知道。三年前她救了傅老爷子一命，傅老爷子提出让她与自己的孙子傅燕城结婚，并为盛家注资了三个亿。傅燕城全程都未出现。没想到两人第一次会面竟然是在床上。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484656,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1NOsrTcQTxwV98fa2e2qBHw?pwd=5hpy\",\"online_time\":\"2024-04-21 00:00:00\",\"time\":1713628800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"前妻的复仇\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"前妻的复仇\",\"description\":\"汪氏千金汪白凃遭凤凰男未婚夫构陷入狱，在狱中更惨遭监狱狱霸欺凌，得知未婚夫谋财害死父母后暗自展开复仇计划。五年后改名换面为陈雪，以舞蹈教师的身份接近夏霆渊，并联合狱中收服的亲信，一同向渣男展开报复。\",\"second_cate\":\"女频家庭伦理/复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482246,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1vs7iyX7gCKNmTdKgVEaT6g?pwd=kxt6\",\"online_time\":\"2024-02-08 00:00:00\",\"time\":1707321600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"副本女将军\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"副本女将军\",\"description\":\"剧中女主角是一位在古代立下赫赫战功的女将军，上一世被奸人陷害。穿越到现代一个没有背景的被谣言逼死的女演员于莹身上，依靠她熟稔的斗争经验和机智的应变能力，将强加在于莹身上不公平的对待一一化解。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486016,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1-93i_8Hq-oaA_mXRxcICGA?pwd=vcjs\",\"online_time\":\"2024-05-28 00:00:00\",\"time\":1716825600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"化神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"化神\",\"description\":\"帝宸玺珠蕴含龙国龙脉，由龙国战神叶氏一族保管，当时时局动荡，浪人入侵，叶氏族长不得已将帝宸玺珠交由七位故人保管，给龙国留下了一丝希望。如今男主叶丛学成归来，欲向东条鹰犬复仇，匡扶正义。而这复仇计划的首要任务就是集齐七颗帝宸玺珠。岂料东条鹰犬秘密掌握了男主动向，安排人手进行阻击。这场正邪之争，男主不仅要面对外部的敌人，还需要解决内部的矛盾和纷争。\",\"second_cate\":\"男频战神 高手下山\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483476,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Nzg3pTA8azX3xZanQ0jWFA?pwd=ppq6\",\"online_time\":\"2024-03-20 00:00:00\",\"time\":1710864000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"北境风云二十年\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"北境风云二十年\",\"description\":\"男主为守国门，修筑长城三年归来，却发现未婚妻悔婚要嫁给北境秦王，还将七旬老娘赶出家门，以树皮草根为为食，殊不知，男主正是北境的统治者.我有一剑，可使山峦成粉，可让江河倒流，可开天门，可通地府，剑来！\",\"second_cate\":\"男频民国\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485966,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1VFFjnPyLpSi_3V_xiXYBCw?pwd=pnq1\",\"online_time\":\"2024-05-28 00:00:00\",\"time\":1716825600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"北川不见锦鲤\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"北川不见锦鲤\",\"description\":\"宋锦鲤陆北川从年幼相识，阴差阳错分开，两人却一直记挂着对方。十几年后，两人分别被家人逼婚，不知道结婚对象就是自己要寻找的人。宋锦鲤为了母亲的安全，前去陆氏公司，即将相认之时，没想到被宋欣欣顶包身份......\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487376,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Ptu8xtgwmIcChRL2381YgQ?pwd=7y2b\",\"online_time\":\"2024-06-11 00:00:00\",\"time\":1718035200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"医妃在上，战王在下\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"医妃在上，战王在下\",\"description\":\"药师族圣女陆云瑶年幼时出谷采药时意外受伤，被卫国王爷墨沧澜所救，成年之后父亲为满足陆云瑶利用族人对卫国皇帝的救命之恩，将陆云瑶强嫁与墨沧澜成为正妃，婚后墨沧澜在与陆云瑶相处的过程中慢慢对其产生好感，一次墨沧澜带兵出征时身重毒箭，濒死之际被女扮男装随军的陆云瑶使用药师族的换血秘术相救......陆云瑶也因此寿命所剩无多，不料在陆云瑶疗伤之际，一名西域女子叶芸冒领功劳，墨沧澜以为叶芸才是自己的救命恩人，为答恩情将叶芸带回王府封为侧妃。一日叶芸与情人偷情时被墨沧澜孱弱多病的母妃晴妃发现，丧心病狂地叶芸惧伯晴妃告发，伙同情人搞来药师族的毒蛊毒杀了晴妃并嫁祸给陆云瑶，陆云瑶知道晴妃的死另有蹊晓，在封棺之前前去查探被叶芸发现，叶芸用迷药迷晕陆云瑶让墨沧澜误会陆云瑶与家奴在墨沧澜母亲的棺椁中私通，震怒之下墨沧澜囚禁了陆云瑶，数月之后陆云瑶怀孕，墨沧澜在叶芸的挑拨下对陆云瑶使尽各种刑罚，为了让墨沧澜对陆云瑶彻底死心，伪造自己被陆云瑶毒害的现场，串通太医谎称只有陆云瑶腹中胎儿的心头血可救，陆云瑶被剖腹，挖眼，打断双腿，几经折磨下，决定与墨沧澜和离，而墨沧澜并没有打算放过她..…\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479796,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1i6vDWnVRDpDQBZNrmthGWA?pwd=72m1\",\"online_time\":\"2023-11-09 00:00:00\",\"time\":1699459200,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"医妃撩人：重生嫡女不好惹\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"医妃撩人：重生嫡女不好惹\",\"description\":\"她是百年将门最小的女儿，身份尊贵，活得肆意随性，却被未婚夫和表妹联手害死，醒来竟成了当今煜王的王妃——秦晚，一个自小被放养到山村的庶女，而她的表妹幻化了她的容貌，取代了她的一切…… 卿月恨到极致，誓要揭开一切真相，手刃仇人，只是当身份明了，一切浮出水面，她面对两个男子，又该何去何从？\",\"second_cate\":\"女频古装重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480136,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Tso8augRJPLlshg_dmXn6Q?pwd=wm8q\",\"online_time\":\"2023-11-19 00:00:00\",\"time\":1700323200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"十年后我回村炸翻全场\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"十年后我回村炸翻全场\",\"description\":\"柳盼睇被重男轻女父母强逼卖给同村老男人，幸得大姐帮助逃出村子。十年归来，盼睇成为一方老总，而回村之路遭受各方阻拦，幸得身边小秘书一一化解，原来小秘书也是一方集团继承人。竟是与盼睇竞争地皮，盼睇陷入爱情与事业两难。\",\"second_cate\":\"女频农村，都市爽剧，霸总，甜宠\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483716,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1vxWkYamtKGdx4EMTsMZ0cQ?pwd=qhjw\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"千亿宝贝傻子妈制霸全家\\u0026傻子妈咪竟是全球首富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"千亿宝贝傻子妈制霸全家\\u0026傻子妈咪竟是全球首富\",\"description\":\"龙城首富傅羽五年前遭人设计与苏文瑾发生关系，苏文瑾生下双宝后遭陷害成傻子。五年后，苏文瑾意外救下自己的孩子，双宝天才智商，助攻苏文瑾和傅羽在一起。随后大家一起对抗陈瑶和苏文嫣的阴谋。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487716,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/15RgxxuKTGsIxA7dehYt5lA?pwd=q3ma\",\"online_time\":\"2024-06-17 00:00:00\",\"time\":1718553600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"千亿富豪请求与我交换人生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"千亿富豪请求与我交换人生\",\"description\":\"修车工刚被绿又莫名其妙被绑架，本以为倒霉到了极点，没想到竟意外开始了逆袭人生。\",\"second_cate\":\"男频 都市、逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488766,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Ij1rfsitXv2_w2-LB39-Nw?pwd=ba9z\",\"online_time\":\"2024-07-04 00:00:00\",\"time\":1720022400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"千亿破烂王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"千亿破烂王\",\"description\":\"领证前被丈母娘临时加彩礼，林北一气之下和女友分手。\",\"second_cate\":\"男频打脸/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486106,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/15TllLoMZ6oF5fKLLlqOKIQ?pwd=3uhy\",\"online_time\":\"2024-05-30 00:00:00\",\"time\":1716998400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"千山慕雪\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"千山慕雪\",\"description\":\"五年前，张家出手搞垮林家和沐家，威胁沐雪尘对外宣称都是沐家搞垮的林家。沐雪尘的爱人林千夜因此认定悲剧都是沐家造成的，转头与张家商业联姻。沐雪尘一边做保姆赚钱，一边遭受林千夜在订婚宴上的羞辱。\",\"second_cate\":\"女频/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488296,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1mzvBVr8u9unO1X_cr6vDYQ?pwd=pr1x\",\"online_time\":\"2024-06-26 00:00:00\",\"time\":1719331200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"千岁大人的初恋\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"千岁大人的初恋\",\"description\":\"人气女星白夏青前世在三途川与九尾狐战逸川以玉佩为誓言约定来世再见。时间来到现代，战逸川为救白夏青被注入针对性病毒后身体消散。三十年后白夏青来到自己年轻时与战逸川约定的地方，这次她终于等来了战逸川。\",\"second_cate\":\"女频武侠/仙侠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485916,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1aTVj9bPhs8uz6qWl548UeA?pwd=bbfn\",\"online_time\":\"2024-05-27 00:00:00\",\"time\":1716739200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"千王归来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"千王归来\",\"description\":\"男主方铭的父亲是上届赌王，由于同门师兄徐厉也想当赌王，所以联合钱家设计陷害方铭一家，最终方铭在父母的力保下侥幸逃脱，但是父母却惨死在徐厉的刀下，徐厉也在钱家的帮助下成为了新一届赌王。为了报仇重新夺回赌王之位，方铭在自己刻苦努力下，以及未婚妻夏颖和发小宋小诗的帮助下，一步一步揭穿钱家和徐厉的阴谋，最终方铭成功复仇，并重获赌王之名。\",\"second_cate\":\"男频反赌，复仇，动作\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483566,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1uigVYyGOytJNBbixDaqlCg?pwd=34sp\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"千秋我为凰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"千秋我为凰\",\"description\":\"他冷落丑妃5年，家宴上逼她为群臣献舞，她摘下面具，惊艳全场…\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478496,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1NFdXAPECnRxF58tT1poAig?pwd=epnt\",\"online_time\":\"2023-09-14 00:00:00\",\"time\":1694620800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"千金归来倾城养女杀疯了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"千金归来倾城养女杀疯了\",\"description\":\"女主婚礼上被未婚夫抛弃，在人生最艰难时刻遇到男主，二人经历磨难携手并进克服种种难关，互生情愫。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486746,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1N9BgwmF-srf1lqOfZ6z6rg?pwd=f79t\",\"online_time\":\"2024-06-04 00:00:00\",\"time\":1717430400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"千金归来前夫他高攀不起\\u0026总裁别虐了夫人就是你的白月光\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"千金归来前夫他高攀不起\\u0026总裁别虐了夫人就是你的白月光\",\"description\":\"霍容暄和夏初幼时分离互留信物，成年后两人结为夫妻却未相认。霍容暄受人唆使虐待夏初，夏初绝望时发现自己千金小姐身份开始反击。霍容暄意识到夏初是自己白月光，努力挽回，最终以真心重获夏初。\",\"second_cate\":\"女频霸总、虐恋\",\"episode\":0,\"platform\":\"\",\"update_time\":1720489036,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/14lIz0t7WzBgWvMLm94rA-Q?pwd=b7mu\",\"online_time\":\"2024-07-09 00:00:00\",\"time\":1720454400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"千金归来被霸总哥哥强势宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"千金归来被霸总哥哥强势宠\",\"description\":\"陆家千金叶小秋出生的时候被保姆李云香掉包，从小过着穷苦的生活。李云香更是为了彩礼钱逼迫叶小秋嫁给多次离婚的家暴男。叶小秋不甘命运，开始主动反抗，她究竟能否挣脱牢笼，找回真正的亲生父母呢？\",\"second_cate\":\"女频甜宠，霸道总裁，真假千金（家庭伦理）\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484786,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1hpX2yep_vNzGRGbTq3CSaA?pwd=hjte\",\"online_time\":\"2024-04-27 00:00:00\",\"time\":1714147200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"千金归来马甲掉一地\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"千金归来马甲掉一地\",\"description\":\"叶家大小姐叶欣瑶在和聂云川结婚前晚被同父异母的妹妹叶欣月所害，所幸叶欣瑶被医仙苦大师所救。三年后，叶欣瑶“重生”归来，施展各种马甲能力，自己成为了叶家掌舵人，同时还找到真心相爱的伴侣陆皓轩。\",\"second_cate\":\"女频大女主 复仇 都市爽剧\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484206,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1S0WJbPRfD6-3QjUFjQmkwg?pwd=k5wf\",\"online_time\":\"2024-04-08 00:00:00\",\"time\":1712505600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"千金的工地男友是大佬\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"千金的工地男友是大佬\",\"description\":\"温家千金温安瑶终于要和网恋五年的男友奔现了，只是不巧，她在男友的认知里是个服务员，更不巧的是，她那个据说工地搬砖的男友，也是司家集团的总裁……\",\"second_cate\":\"女频甜宠、轻喜\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480336,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1nPTSp3BZ-ScPAu-V-mLizA?pwd=4rc4\",\"online_time\":\"2023-11-24 00:00:00\",\"time\":1700755200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"千龙之首\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"千龙之首\",\"description\":\"十年前，京海徐家灭赵家满门，赵凡在苏家的帮助下，才逃出京海。十年后，赵凡成为众神殿殿主，灭掉倭国，回归复仇。但他不知道的是，十年前，自己和徐倩云一夜之后，徐倩云居然留下了个孩子。回归京海，赵凡寻子，觅妻，还结实苏家红颜苏纤柔。回归京海，更是一段复仇之旅，赵凡灭掉仇敌徐家，斩杀苏家仇敌钱家。更挖出钱徐两家背后的倭国余孽，秋子公主。秋子为了算计赵凡，绑架他的至亲之人，赵凡于绝境中斩灭秋子，救回家人。最终，全家团聚。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481936,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/159CsaFzW8ORwsGwXs6fBBw?pwd=fprf\",\"online_time\":\"2024-01-29 00:00:00\",\"time\":1706457600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"南乔传\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"南乔传\",\"description\":\"一朝权后宋南乔，被杀后穿越千年，成为霸总傅砚辞的掌中玩物，受尽身边佣人的白眼。宋南乔智勇双全，通过一步步的反击，逐渐拿回属于自己的尊严。与此同时，傅砚辞也开始高看宋南乔，并真正地懂得如何去爱宋南乔。只是大雍玉佩的出现，让这一切变得谜团重重。\",\"second_cate\":\"女频都市、言情、古穿今\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482276,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/13bFAUIwF9QO1AfMpDEyU7g?pwd=ixci\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"南宫少主的美飒甜妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"南宫少主的美飒甜妻\",\"description\":\"江若楠是走失的豪门千金和孤儿江月同被农村父母收养，江月总偷懒欺负江若楠，并且看清养父母为了儿子早晚会将两人卖掉的现实决定逃离。此时保镖上门接江若楠，江月将江若楠勒死抛尸并冒认身份成为假千金。霸总南宫宴经过救下江若楠，并调查真相得知江若楠身份，于是带着江若楠找假千金对峙，遇到了曾经被江若楠相救的豪门老太太。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478556,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1WSWaFlvHPacbevJqZrlRsw?pwd=ztdu\",\"online_time\":\"2023-09-15 00:00:00\",\"time\":1694707200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"南风知晚意\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"南风知晚意\",\"description\":\"贫穷的农村女孩舒晚意，在得知自己是有钱人家的亲生女儿后，失去亲情的舒晚意非常开心，她不断讨好亲生父母，想要得到父母的喜欢，却总是事与愿违，直到她发现亲生父母更加喜欢养女，于是，她在亲情与事业中，果断地选择完成梦想，获得成功的都市追梦故事。\",\"second_cate\":\"女频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484296,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1P4XIFaS8C23eXkH2o8UGEQ?pwd=iqt6\",\"online_time\":\"2024-04-11 00:00:00\",\"time\":1712764800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"卧虎藏龙之冒牌神婿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"卧虎藏龙之冒牌神婿\",\"description\":\"雄霸北境的狼牙王方岩遭手下毒害，谋权篡位。手上的方岩意外被当做沈家赘婿带回沈家。为报沈家大小姐沈清怡的恩亲，他帮沈清怡清理门户，并在暗中打到反派势力，众人这才发现一直以为的傻子赘婿竟是战神狼牙王？\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486586,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1_fjWy7DnBkFTgiTOkLVGWg?pwd=tsz8\",\"online_time\":\"2024-05-23 00:00:00\",\"time\":1716393600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"危墙之下\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"危墙之下\",\"description\":\"民国二十年，镇守湖城的齐司令刚封了二夫人的棺材，转头就娶了年轻美貌的安宁做了三夫人，自此齐公馆深陷美人杀局，新婚夜，齐家大少爷齐樾想要羞辱这个不知天高地厚的小妈，当着齐大帅的面演了一出戏，让他深信两人不和，私下里，安宁却是齐樾亲自送给齐大帅的。原来，齐樾竟是冒名顶替的齐家大少爷，因杀母之仇潜入齐公馆，并安排同样怀着深仇大恨的徐安宁嫁给齐司令，两人在齐家差点被齐大帅发现，每每靠着机智躲过他的怀疑，两人里应外合，一起解决齐司令的左膀右臂，逐渐瓦解他的势力，使其孤立无援。爱情跟在仇恨之后，感性和理性做着抗争。本来相爱的人，现在却成了不可逾距的关系。在这场复仇游戏里，谁才是那个笑到最后的人？\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482106,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/13i6Cr3s0Y2baQ924vUPJ_w?pwd=3wc2\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"厉总夫人又撩又野\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"厉总夫人又撩又野\",\"description\":\"叶南依原是云家千金，自幼流落在外，成年后被从贫民窟带回。本以为是认亲成功的好事，但实际只是为了让她帮妹妹替嫁给一个残疾老男人冲喜，被妹妹和渣男联手害死。叶南依重生归来，势要复仇。\",\"second_cate\":\"女频重生/复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485516,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1566yS6Z0tmHIhMSeMPttsQ?pwd=c33h\",\"online_time\":\"2024-05-20 00:00:00\",\"time\":1716134400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"厉总夫人她又跑了\\u0026蓄谋已久厉总他明撩暗哄\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"厉总夫人她又跑了\\u0026蓄谋已久厉总他明撩暗哄\",\"description\":\"厉北霆暗恋苏禾二十年，设计让苏禾发现她未婚夫出轨，苏禾气愤之下决定和厉北霆闪婚。婚后经历种种苏禾动心，却发现厉北霆有暗恋对象。苏禾痛苦，后知自己怀孕，发现厉北霆暗恋的是她，最终接受厉北霆。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487356,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1EIDTM3iRuII2OyMHoK1kzw?pwd=ercb\",\"online_time\":\"2024-06-10 00:00:00\",\"time\":1717948800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"厉总的独家宠爱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"厉总的独家宠爱\",\"description\":\"厉景川苦寻多年，总算是找到了当年的救命恩人苏清欢，于是迫不及待地去找她，想要见她一面。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479076,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1sobM_4oyqZLf2-Ukaayt5g?pwd=vuxc\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"原来你在我身边\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"原来你在我身边\",\"description\":\"卢漫漫（瑶瑶）和沈淮之再次相遇，却总阴差阳错错过。好友冒认身份，卢漫漫（瑶瑶）有口难言。沈淮之卢漫漫（瑶瑶）这对青梅竹马是命中注定还是终究无缘？\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488176,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1CHgt98N4QJP4gj0JBi_Aag?pwd=xyhp\",\"online_time\":\"2024-06-23 00:00:00\",\"time\":1719072000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"双姝\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"双姝\",\"description\":\"一则愚昧的祖训，让一对双胞胎，命运走向了完全不同的方向。一个出生差点被掐死，一个被视若至宝。多年后，差点被掐死的她，成为了姐姐的替身和药引。她像影子没有身份，自由，也没有人爱她。可有一天那个人出现了。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487566,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1wC-tWsPGpyzrUI3RscdFkA?pwd=vz8s\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"双子星黑白切\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"双子星黑白切\",\"description\":\"容真和傅绵是一对双胞胎，在她们刚出生不久，傅老三潜入容家，盗走容氏高科技产品，并杀害了其父母。容真被带下楼哄睡躲过一劫，而傅绵被带走当作养女。二十多年后双胞胎开启了为双亲复仇之路。\",\"second_cate\":\"女频复仇\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486596,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1NTgjjtE6iiG4ZjiLH12hlg?pwd=xghb\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"双株诀\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"双株诀\",\"description\":\"女主灵汐颜与男主枫逸轩联手对抗大国师屠枭，历经万难最终牺牲自己以身封印颠覆国运的大国师，拯救天下苍生的故事。\",\"second_cate\":\"通用/仙侠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488346,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1s-553Ut7_3_Ws2X6OfLlWQ?pwd=v6qy\",\"online_time\":\"2024-06-27 00:00:00\",\"time\":1719417600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"双面娇妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"双面娇妻\",\"description\":\"弃婴苏瑞雪遭到千家小姐千茉莉的欺负。总裁尹承勋多次相救，意外发现苏瑞雪竟然患有双重人格障碍症！苏瑞雪得知自己才是真正的千家小姐，决意夺回属于自己的一切，并在尹承勋的帮助下，治愈自己收获幸福。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487856,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1N1zQc7_BKggYrCoUEe4gOQ?pwd=rte3\",\"online_time\":\"2024-06-19 00:00:00\",\"time\":1718726400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"双面宠妃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"双面宠妃\",\"description\":\"苏月和贺锦州幼年相遇因人贩子分离。苏月成为杀手，一直寻找贺锦州。为脱离杀手组织，她接受刺杀太子任务却意外嫁给了贺锦州。两人经历误会与危机，最终确认彼此身份，联手揭露阴谋。两人终成眷属，过上幸福生活。\",\"second_cate\":\"女频古装、宫廷\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488816,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/126EG9P1GnckWzy_gHPXFKg?pwd=2wua\",\"online_time\":\"2024-07-04 00:00:00\",\"time\":1720022400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"双龙过江\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"双龙过江\",\"description\":\"一场灭门惨案，将原本的双胞胎兄弟分开。多年之后，已经成为集团大佬的双胞胎弟弟故地重游，却被人当成了他的双胞胎哥哥，一段误打误撞之下，兄弟两最终相认。性格迥异的兄弟二人开始并肩作战，他们誓要查出当年的灭门真相！\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479706,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1CINXxFYq1cd_EO1i01NHFA?pwd=y9fj\",\"online_time\":\"2023-11-09 00:00:00\",\"time\":1699459200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"口红女王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"口红女王\",\"description\":\"苏画上辈子被渣男欺骗，被闺蜜背叛，含恨而终。一朝重生后，苏画回到了十年前，她决心逆转自己的人生，并通过一只神奇的口红，改变了自己的人生轨迹，不仅收获了美满的爱情，而且还走上了事业的巅峰。\",\"second_cate\":\"女频重生/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485746,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/13pm2nqF2uWaXTvED_RD-7A?pwd=neh6\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"只愿从来不识君\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"只愿从来不识君\",\"description\":\"豪门王爷重伤失忆，误将姐妹花中的妹妹赵花鸢记为救命恩人，百般呵护。坏女人赵花鸢却陷害姐姐将其推下山崖致使终身不孕，王爷为妻报仇请求皇兄把自己的妃子，两姐妹中的姐姐赵芷灵赐给自己成婚。冷面王爷将其娶进门后百般虐待，但阴差阳错两人暗生情愫，开展极致虐恋。\",\"second_cate\":\"女频古言\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481966,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1uIlcBMT_-VN55ByKV2A1_w?pwd=a4xm\",\"online_time\":\"2024-01-31 00:00:00\",\"time\":1706630400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"史上最强假太监\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"史上最强假太监\",\"description\":\"龙承恩因一副神奇的画作穿越到神奇的女子为尊国家东周，醒来之时正是即将成为大监的关键时刻，目看假大监在全是女子的东周如何玩转后宫!\",\"second_cate\":\"男频古装\",\"episode\":0,\"platform\":\"\",\"update_time\":1720477656,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1AeyQ2hPPkqHnhyZqAux2Mw?pwd=47e3\",\"online_time\":\"2023-08-15 00:00:00\",\"time\":1692028800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"史上最强王妃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"史上最强王妃\",\"description\":\"现代女神医谢英然穿越到古代草包太子妃身上，利用现代先进的知识和技术，打脸、洗刷草包印象。通过现代自助餐、抽奖大转盘、酒精的研制与治瘟疫、防瘟疫，朝堂打脸洋人为女性争光，女主为女性普及教育求入仕科考等桥段展现现代女性独立的美。\",\"second_cate\":\"女频古装穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481946,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1R7bJZxk48m8NL63HPpnkpA?pwd=i3r4\",\"online_time\":\"2024-01-29 00:00:00\",\"time\":1706457600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"史上最强金手指\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"史上最强金手指\",\"description\":\"父亲重病，老婆抛弃，老板欺凌…秦宇，一个混的很失败的农民工。但善恶到头终有报，财神降临，他得到了回报率技能。从此一路开挂，鉴古董、买地皮、结识华夏首富、娶到温婉女总裁，打脸一个个狗眼看人低的货色，走上人生巅峰…\",\"second_cate\":\"男频喜剧 逆袭 反转\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482516,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/15UFdjhHJ_DSBWffhmOvjhg?pwd=2v3e\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"叶家弃少\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"叶家弃少\",\"description\":\"大夏第一王族武安君叶辰，悄然恢复记忆，虽实力重回巅峰，但因为妻子身份普通，所以甘愿隐匿武安君身份。为了妻子林予初顺利登上王妃之位，退婚第一美女战神，在册封大典的前一天竟被妻子离婚…\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480686,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1dykyCMJnrXHNni2Hig3i4w?pwd=myyz\",\"online_time\":\"2023-12-12 00:00:00\",\"time\":1702310400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"叶少，你老婆是仙界上神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"叶少，你老婆是仙界上神\",\"description\":\"仙界第一上神遭遇陷害被贬下凡，成了苏家弃女苏晚，只有找回弄丢的神光古玉才能重返天庭，如今古玉的线索全都指向叶氏财阀的传家宝，法力尽失的苏晚就这样嫁给了冷面冰山叶少，开启了令人啼笑皆非的凡间婚后生活，但在风平浪静的日常背后，其实还隐藏着一个巨大的阴谋，因为陷害苏晚的仙女同僚和叶景宸的影帝情敌还在暗中潜伏，虎视眈眈地看着他们......\",\"second_cate\":\"仙穿今轻喜甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479186,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/14dKViAYPvSWsgy0u_hJQcg?pwd=ewep\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"司机老爸竟是全球首富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"司机老爸竟是全球首富\",\"description\":\"低调的司机老爸张鸣，其真实身份竟是全球富豪。因为一场碰瓷，张鸣偶遇女明星苏玲雪，又因同学聚会，司机身份的张鸣受到同学嘲笑和羞辱，初恋情人黄秋雅当年的真相也不断被揭开。初恋情人黄秋雅和女明星苏玲雪到底存在什么关系？而另一方面，女儿和准女婿操持的四海集团，经历各种打击，危机四伏。多年前的老对手顾浩天也再次出现。张鸣护女心切，与顾浩天的商战如何收场？而老对手顾浩天与黄秋雅以及苏玲雪，又存在什么样的关系？\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484496,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1LehnFbjUE0sVZf-mjZPISw?pwd=xfqs\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"名门千金马甲掉不停\\u0026暖风甜入骨\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"名门千金马甲掉不停\\u0026暖风甜入骨\",\"description\":\"黎若幼时丢失被首富收养，但再找回亲生父母时却发现亲生父母误以为收养她的是农民，偏袒假千金，假千金更是设计黎若，想把黎若赶出家门，黎若见招拆招，在养父母家人的帮助下打脸假千金并最终揭示自己是被首富收养。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486906,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1sPIHty41n4g8C0BF2olaIw?pwd=2eft\",\"online_time\":\"2024-06-05 00:00:00\",\"time\":1717516800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"后宫神医太凶猛\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"后宫神医太凶猛\",\"description\":\"男主本是名神经科医生，因被病人孙丽丽调戏不成，孙丽丽气愤之下，一脚将男主踹飞，男主意外穿越到了羽化王朝宣威公主府上。为了活命，他只能伪装成一个太监，在危机四伏的皇宫中等待机会脱身。没成想却引发了更大的危机\",\"second_cate\":\"男频古装穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478976,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1lgKyMW1Yt4jYsquMGX-7HQ?pwd=ytde\",\"online_time\":\"2023-10-06 00:00:00\",\"time\":1696521600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"后来的我们\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"后来的我们\",\"description\":\"周怀瑾撞破江晚意出轨富二代，在江晚意羞辱下离婚。七年后，周怀瑾成首富总裁，警局重逢江晚意，她再婚且有个七岁孩子。为报复江晚意，他故意为难她。但他嫌弃的这个孩子是他亲生。他本心怀怨恨却在相处中渐旧情复燃。\",\"second_cate\":\"女频现言\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484126,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/14XOfVQohF8unP6qln9fVYw?pwd=3byw提取码:3byw复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2024-04-04 00:00:00\",\"time\":1712160000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"向古人直播\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"向古人直播\",\"description\":\"顾轻柔因在古代任务失败导致即将被系统抹杀，但再次睁眼时却已经回到了穿越之前，原来是深爱她的奶奶用自己的生命向系统换了一次机会给她，这一次，她的任务是，向辜负她的渣男皇帝直播……\",\"second_cate\":\"女频轻喜\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481536,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1AWf42TFoslzmvjuZf0SHpw?pwd=ufuj\",\"online_time\":\"2024-01-11 00:00:00\",\"time\":1704902400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"吞天帝\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"吞天帝\",\"description\":\"吞天帝宁辰盖世无双，以一己之力保家卫国，深爱妻子夏晶莹，为不让妻子因对他的身份感到自卑，特意隐藏身份，入赘夏家，暗中帮助夏晶莹成为美女总裁，事业有成，而就在宁辰以为他就此可以和妻子夏晶莹幸福生活时，等来的却是夏晶莹以两人不再是同一世界的人，宁辰配不上她夏晶莹，提出离婚……\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481336,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1h1AkTB0Zo0Pk48RjJ7lsXg?pwd=gvsb\",\"online_time\":\"2024-01-02 00:00:00\",\"time\":1704124800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"听风也听你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"听风也听你\",\"description\":\"不得宠的陆家大小姐陆清颜被迫替妹妹嫁给植物人秦肃，却意外发现只有她能够听到植物人老公的心声！而秦肃对此并不知情，由此开启了一段啼笑皆非的冤家生活。在秦肃的帮助下，陆清颜不仅在秦家站稳了脚跟，更是狠狠打脸陆家……\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480646,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1kLDABuy752EBF4L2Elvmqw?pwd=bx9i\",\"online_time\":\"2023-12-12 00:00:00\",\"time\":1702310400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"命中注定嫁给你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"命中注定嫁给你\",\"description\":\"唐诺不愿嫁给素为谋面的肖霁，在婚礼上逃婚却又遇见刚好也在逃婚的肖霁，两人经过碰瓷事件后为了躲避家中催婚隐瞒身份和对方协议结婚。唐诺去肖霁酒店上班，遇见假冒自己身份的总监，总监爱慕肖霁，处处和唐诺作对，唐诺一一打脸。\",\"second_cate\":\"女频言情逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479866,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1UvmCMR9kylW6cV8MOOq3Xw?pwd=775b\",\"online_time\":\"2023-11-14 00:00:00\",\"time\":1699891200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"命中注定守护你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"命中注定守护你\",\"description\":\"公司经营不善！亲姑姑来抢股份！最好的朋友竟然是卧底！女总裁许静最近有点烦！在这个众叛亲离的悲催时刻，身边竟然只剩下一个保安！然而许静慢慢发现， 这个保安不光又帅又酷，似乎还武艺高强。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486956,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1s23VSgAiTdJUxIbbSqmngg?pwd=4bqa\",\"online_time\":\"2024-06-06 00:00:00\",\"time\":1717603200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"命中注定我爱你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"命中注定我爱你\",\"description\":\"孤女江笙意外与顶头上司厉廷衍发生一夜情，为保小命她选择走为上计。谁知道，一份遗落的简历却让厉廷衍误以为江笙的闺蜜林晓晓是失身对象，阴差阳错成了情侣。而晋升为厉廷衍秘书的江笙，则在公司里步步为营，护紧马甲，一边对他避之不及，一边忍不住动了心。直至江笙查出有孕，正准备跟厉廷衍坦白，却发现他的神秘女友竟是自己的闺蜜。陷入爱情与友情的困局的江笙最终选择成全两人。可此时厉廷衍已经得知真相，两人开始了猫捉老鼠的游戏，从欢喜冤家到相濡以沫，克服重重阻碍后，最终有情人终成眷属，同时江笙在厉廷衍的爱与守护之下，重新找回了自己的亲生父母。\",\"second_cate\":\"女频甜宠/先婚后爱\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482566,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1j64YARIEmEmsi5bJdQB0fw?pwd=s92k\",\"online_time\":\"2024-02-18 00:00:00\",\"time\":1708185600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"命中注定爱上你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"命中注定爱上你\",\"description\":\"裴谨城作为帝国第一集团总裁，多年来一直没有女友，一直被下属送不同女人试图讨好裴谨城，裴谨城视察工作时候，和蓝可心误睡，裴谨城误会蓝可心是拜金虚荣试图接近自己的坏女人。\",\"second_cate\":\"男频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478696,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1fWbZpjSuVWX7LUlYZkx5Vg?pwd=s7ua\",\"online_time\":\"2023-09-25 00:00:00\",\"time\":1695571200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"和朋友的100顿聚餐\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"和朋友的100顿聚餐\",\"description\":\"来自五湖四海，但在同一个城市读高中的五个伙伴，他们性格相投、热爱美食，经常一起组队吃吃喝喝，结伴探店；无论是街头小吃、百年老店，还是胡同小巷、家常美味，总能看到他们相随的身影。他们在一张张桌子上谈天论地，互相吐槽；从高中的十八岁到人生五十岁，三十年的友谊，跌跌撞撞一路风雨，在平凡热闹的生活中，他们用友情互相陪伴，用美食治愈人生。\",\"second_cate\":\"女频都市生活\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482586,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1ba4wxYFK_SkMD268Xxt5Xg?pwd=bwxq\",\"online_time\":\"2024-02-18 00:00:00\",\"time\":1708185600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"和渣男离婚后我成了团宠千金\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"和渣男离婚后我成了团宠千金\",\"description\":\"中夏首富千金陆依依为爱隐瞒身份，嫁给穷小子厉寒洲，为让家人尽快接受他，陆依依暗中资助使得厉寒洲的公司三年上市，但是默默的付出，等来的确实厉家人的欺侮和离婚协议，陆依依愤怒休夫，回归陆家。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485046,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"链接：https://pan.baidu.com/s/1mFs6hrrozeipOCp8GlVK3Q?pwd=sneb\\n提取码：sneb\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-04 00:00:00\",\"time\":1714752000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"和离后，我成了太子白月光\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"和离后，我成了太子白月光\",\"description\":\"宋绾为全江宋两府颜面手捧江行戋牌位嫁入城阳侯府守寡六年。谁知六年后江行戋居然死而复生并带回一个女子，至此宠妾灭妻，各种荒诞事频出。宋绾屡次受伤后终是选择和离，在此期间蛰伏许久的太子一朝翻身，携手宋绾一起保家卫国厮守一生。\",\"second_cate\":\"女频古装\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482906,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1NwWedRq-DlNTU0oJgBtw3w?pwd=1prf\",\"online_time\":\"2024-03-01 00:00:00\",\"time\":1709222400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"哑女的复仇\\n（全28集）\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"哑女的复仇\\n（全28集）\",\"description\":\"小顾秋雨被村长选为守村人祭品，父亲顾丰林被乱棍打死，母亲沈清在这场事故中成为了疯子，疼爱自己的哥哥也下落不明，孤苦无依的顾秋雨惨遭献祭，变成了哑巴。直到15年后遇见了来寻亲的首富顾初墨，通过胎记顾秋雨认出他是自己失散多年的哥哥，林家村长得知顾秋雨是首富顾初墨的妹妹后，把顾秋雨的胎记剥了皮，换在了自己女儿身上顶替顾秋雨和哥哥相认。\",\"second_cate\":\"女频/复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488076,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1ht4tEIt2Zl1eRwDwDICRIQ?pwd=r43c\",\"online_time\":\"2024-06-22 00:00:00\",\"time\":1718985600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"哦莫我把总裁老公拉黑了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"哦莫我把总裁老公拉黑了\",\"description\":\"林筱误打误撞和富家少爷陆峥寒签订婚约，一个原本只是想玩玩，一个也只是想有个挡箭牌，谁知互相讨厌的二人却逐渐假戏真做。林筱：你今天休想占我半分便宜。陆峥寒：那就只占十分好了。\",\"second_cate\":\"女频霸总、闪婚\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488506,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/12RgJsli6WvXNXzvsXpMtww?pwd=wvgq\",\"online_time\":\"2024-06-29 00:00:00\",\"time\":1719590400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"商先生的独宠小娇妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"商先生的独宠小娇妻\",\"description\":\"商洛焱妈妈因为商洛焱一直不结婚邀请北城108位适龄女参加选媳宴会，顾安然为了不被选上，故意扮丑，落选离开时却因为跟闺蜜吐槽商洛焱，被赶回来的商洛焱听个正着，商洛焱故意选顾安然为结婚对象，两人结婚，顾安然以为商洛焱命不久矣，一直让着商洛焱，相处慢慢产生感情，顾安然上班后还发现商洛焱的真实身份，因为顾安然的功劳被绿茶女抢，被经理打压，被老板误会，顾安然去到商洛焱的公司上班，经历了被老同学欺压，被千金冒认身份后，和商洛焱一起不断打脸，相知相守！\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479946,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1y0lML02DNYd_CgMYqZeTQg?pwd=f8gw\",\"online_time\":\"2023-11-15 00:00:00\",\"time\":1699977600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"喜欢的少年是你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"喜欢的少年是你\",\"description\":\"刘念刚出生被医院院长调包，后被人贩子遗弃。刘福生路过并收养了刘念。刘念在贫苦家庭靠努力上了格温国际的预科班，同班同学中林珊非常反感刘念，林珊伙同同学谋划了好多次校园霸凌事件！巧合的是林珊就是当年和刘念调包的孩子，她本出身普通家庭亲生父亲是学校打扫卫生的老曹。林珊在得知自己不是江城首富傅晴的亲生女儿后，伙同老曹一次次阻止和破坏了傅晴和刘念的DNA比对结果。最终林珊和老曹计划杀掉刘念以绝后患！最后的结果是老曹和傅晴同归于尽！\",\"second_cate\":\"女频亲情/都市/校园/感人\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483666,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1YWpS4hYbevFnpe-97sBJyw?pwd=phmq\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"囚心\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"囚心\",\"description\":\"沐瑾瑶被张大千拐卖到山区囚禁六年，被男主妹妹叶晓琳所救。后张大千用毒害死叶晓琳，男主误以为是沐瑾瑶所为，将其带回叶家，对沐瑾瑶产生了爱恨交错的心理。沐瑾瑶既被男主折磨，又被其保护，在爱与恨中反复纠葛。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484476,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/16jTEm7XhMGIwobCjm8stwg?pwd=kvy3\",\"online_time\":\"2024-04-17 00:00:00\",\"time\":1713283200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"四个大佬哥哥重生以后狂宠我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"四个大佬哥哥重生以后狂宠我\",\"description\":\"迟夏从小流落在外，当被亲生家庭陆家找到后，家里已经没有她的位置了，三个哥哥对她很冷淡，完全向着心机深沉的养女陆潇潇，不给迟夏一点信任，直到陆家破产，养女陆潇潇第一时间卷钱跑路，而迟夏对三个哥哥不离不弃，三个哥哥这才知道迟夏才是真正对他们好的人。迟夏一人打多份工照顾着三个哥哥，三个哥哥也重整旗鼓东山再起，然而当陆家重新上市那天，迟夏却为了救人失去了生命。再次睁开眼睛，迟夏发现自己重生了，既然重获一世，迟夏打算换一种活法，就拒绝回到陆家。迟夏本以为这样就能过自己的生活了，结果她发现不知道为什么，三个哥哥好像和上一世不一样了，不但没有远离她，还千方百计地接近她讨好她。除了三个哥哥，还有一个神秘大佬也缠上了她，比三个哥哥还粘人……\",\"second_cate\":\"女频团宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482626,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/13Y2x5x5xiEfMoxv7fqq4RQ?pwd=gbmh\",\"online_time\":\"2024-02-21 00:00:00\",\"time\":1708444800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"四个弟子倾国倾城\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"四个弟子倾国倾城\",\"description\":\"叶天是一名支教教师，乐于资助山村学生。学生沈红玉成为帮会老大，钱如意成为首富，李雪溪成为医仙，荆羽成为第一杀手。在得知一场由彩礼引发的冲突让叶天饱受屈辱后，四名学生到场给老师撑腰。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486836,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1OQ_xAQJf_fU1zFN2WWSAYA?pwd=4ims\",\"online_time\":\"2024-06-04 00:00:00\",\"time\":1717430400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"四位师姐你们正常点\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"四位师姐你们正常点\",\"description\":\"叶家家主叶无双将方芸烧死，其子叶枫则被叶家污为一切的根源，逐出叶家。叶枫流浪期间，因为特殊的体质，被明霄阁阁主救至青云山，秘密收为关门弟子，和四位师姐一起修炼长大，并将明霄阁主之位传给了他。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484796,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1_Er7itKrm9pvj3lX7uqYwQ?pwd=1kxg\",\"online_time\":\"2024-04-27 00:00:00\",\"time\":1714147200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"四海（爆款老剧）\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"四海（爆款老剧）\",\"description\":\"男主惨死重生90年代后洗清前世罪孽大杀四方，从小工厂起步一路对抗外资收服商业大佬混迹上流社会建立商业帝国，完成了对妻子的承诺。\",\"second_cate\":\"男频重生/年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486156,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1hEJzuWUHIiFsq29Ap23SDA?pwd=g9wy\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"回到1913\\n（全30集）\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"回到1913\\n（全30集）\",\"description\":\"为新作寻找素材的作家周漪在睡梦中穿越到1913年，偶遇著名连环杀手号称民国“开膛手杰克”的魏徇。为了生存，她被迫成为少年魏徇的家庭老师，周漪本想改变魏徇的结局，却由于魏徇的迫害穿越回现代。打开电脑，周漪发现魏徇的简介从原来的连环杀手变成了为爱复仇的悲情养子，命运的轨迹悄悄地发生了转变，她真的改变了历史，资料尚未看完，一道白光闪过，她竟再次穿越，来到1921年......\",\"second_cate\":\"女频/穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488316,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1WjBjy1eadBF0X5iR1LuNXw?pwd=tjk6\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"回到八十年代当富翁\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"回到八十年代当富翁\",\"description\":\"大名鼎鼎的富豪周云峰在一次宴会应酬上意外喝多重生到一个窝囊废、嗜酒嗜赌虐待家人的混蛋身上。周云峰恢复上一世性格，善待家人妻子，查明父母死亡真相，用上一世智慧赋予的金手指，卖苹果、卖服装，成为超级富翁。\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486816,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1-dNZWyq64UK02jcoyle28A?pwd=im5p\",\"online_time\":\"2024-06-03 00:00:00\",\"time\":1717344000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"回到古代 当圣人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"回到古代 当圣人\",\"description\":\"方知从夜总会一朝穿越到了皇宫里，面对砍头危机，他伪装成天降圣人，试图扭转局面，谁知，竟然真的成为了圣人……\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479286,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1lDWbQPA_XRZ-DtNG3QeSzQ?pwd=pfe6\",\"online_time\":\"2023-10-17 00:00:00\",\"time\":1697472000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"回到古代当帝师\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"回到古代当帝师\",\"description\":\"方程恩穿越回古代，把原本及其贫困的富源县建设成富甲一方的县城，后被大景皇帝发现其才能，招入皇宫教导太子\",\"second_cate\":\"男频古装穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480886,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1V8FWeKbmaZsMBEkK8EvNbA?pwd=sguu\",\"online_time\":\"2023-12-18 00:00:00\",\"time\":1702828800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"回到妻女死亡的那一天\\n（快节奏版本）\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"回到妻女死亡的那一天\\n（快节奏版本）\",\"description\":\"林川重生到了妻女死亡前一天，为了弥补上辈子对妻女的遗憾，他计划利用前世的记忆，努力赚钱弥补家人，但是林川前世造下的孽，也慢慢开始浮现出来。外人的不理解，妻女的不信任，林川努力化解一切，携手秦梦莹走向美好的未来。\",\"second_cate\":\"男频年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484006,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1Nw3UP-n9neUxlAI2yCJqvA?pwd=ksf7\",\"online_time\":\"2024-04-01 00:00:00\",\"time\":1711900800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"回到悲剧发生的那一天\\n（慢节奏版本）\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"回到悲剧发生的那一天\\n（慢节奏版本）\",\"description\":\"林川重生到了妻女死亡前一天，为了弥补上辈子对妻女的遗憾，他计划利用前世的记忆，努力赚钱弥补家人，但是林川前世造下的孽，也慢慢开始浮现出来。外人的不理解，妻女的不信任，林川努力化解一切，携手秦梦莹走向美好的未来。\",\"second_cate\":\"男频年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483996,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Dejdiwv70odGIyD60gEAHA?pwd=sm43\",\"online_time\":\"2024-04-01 00:00:00\",\"time\":1711900800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"回国后飒爽妈咪一路虐渣\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"回国后飒爽妈咪一路虐渣\",\"description\":\"五年前，父母离异，狠心父亲将他们赶出家门。为了给有心脏病弟弟治病，宋暖偷偷潜进唐时言房间上演了一出“偷龙转凤”！五年后，她带一双萌娃回国，只为夺回应有的一切。却再遇江城最有权势的男人——唐时言。“你儿子为什么和我这么像？”唐时言声音低沉。\",\"second_cate\":\"女频都市萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482206,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1Ae-ZtBh1E2rfuFy5doqnuQ?pwd=inmq\",\"online_time\":\"2024-02-07 00:00:00\",\"time\":1707235200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"回家的诱惑之前妻做女王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"回家的诱惑之前妻做女王\",\"description\":\"傅家一夜破产，傅家大小姐傅清欢发现丈夫陆峥这个枕边人竟然是自己的仇人，在一直觊觎陆峥的沈柔的陷害下，傅清欢的日子水深火热。为了能带着女儿甜甜过上平淡幸福的生活，傅清欢提出与陆峥离婚，却被陆峥拒绝。在沈柔的操作下，甜甜重病死亡，傅清欢陷入崩溃……\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483086,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/13yVFBPeMrE4GANciGXF56A?pwd=jyid\",\"online_time\":\"2024-03-08 00:00:00\",\"time\":1709827200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"回家的诱惑之消失的她\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"回家的诱惑之消失的她\",\"description\":\"被大富之家收养的品如因父母双亡，继承了一笔丰厚的遗产，被高家觊觎。高家设计让长子高文彦接触品如，却没想到高文彦真的爱上了林品如，最终与林品如领证结婚。高文彦的妹妹高珊珊突然结束学业回国，打着和“嫂子”培养感情的幌子，将林品如骗去旅韩，而后将林品如推下悬崖。没想到林品如大难不死，还意外与财阀生母相认，并最终化名“姜妍”，低调回国…\",\"second_cate\":\"女频复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483786,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/14HhBKBggqEN1vGyvEqH89A?pwd=ekjv\",\"online_time\":\"2024-03-25 00:00:00\",\"time\":1711296000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"团宠妈咪是真千金\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"团宠妈咪是真千金\",\"description\":\"夜初棠在生产时被闺蜜苏雨柔背叛险些丧命，大儿子也因此丢失。五年后，为治疗女儿的病，夜初棠回国加入封氏，重遇了孩子的父亲封城熠，以及自命为其女友的苏雨柔，后发现封家小少爷就是自己的大儿子。在萌宝的助攻下，当年真相浮出水面...\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484546,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1MtEvXEJSm2KhY8NfIisaTw?pwd=twwf\",\"online_time\":\"2024-04-18 00:00:00\",\"time\":1713369600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"团宠归来三个哥哥帮我手撕渣男全家\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"团宠归来三个哥哥帮我手撕渣男全家\",\"description\":\"首富千金顾佳音隐姓埋名与酒店服务员何旭结婚生女，何旭也在顾佳音暗中帮助下成为商业新星。不料何旭盗窃顾家机密，顾佳音刚出产房便被送入监狱替何旭顶罪。五年后顾佳音出狱，她发誓要给渣男一家教训，重启人生。\",\"second_cate\":\"女频复仇\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486676,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/11hj_MhhIteptAzF5rKqhAw?pwd=q4uu\",\"online_time\":\"2024-05-29 00:00:00\",\"time\":1716912000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"园区潜行\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"园区潜行\",\"description\":\"周娜因为赚钱心切被骗去园区，不料被残忍杀害，重生后又回到可怕的园区，意外得到系统的加持，为得到园区老板的信任，在园区骗了好多不法分子的金钱，男主为救周娜，只身一人进入园区，最终二人合力将园区恶徒一网打尽。\",\"second_cate\":\"女频大女主反诈\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481356,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/12f6PA2G14UOdr1P4gZwBpA?pwd=m7pg\",\"online_time\":\"2024-01-02 00:00:00\",\"time\":1704124800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"困兽游戏百亿为王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"困兽游戏百亿为王\",\"description\":\"这是一部用浓烈的赛博色彩描绘的一个关于生死绝境下人性考验的故事。在封闭的环境当中，多样的人物之间，巨额的奖金面前，扭曲的人性会做出怎样的选择？\",\"second_cate\":\"通用现代、脑洞悬疑\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486536,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1o0sGt3PLKVJdUZvQI1efdA?pwd=8fk7\",\"online_time\":\"2024-05-16 00:00:00\",\"time\":1715788800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"困在时间里的父亲\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"困在时间里的父亲\",\"description\":\"姜涛遭妻子兰梅的情人王博陷害，两女儿因母亲欺骗而怨恨他。多年后姜涛找到女儿们，宴会上揭露真相，姜涛与小女儿姜星相认。反派绑架后真相大白，反派被捕兰梅精神崩溃，随后家庭在医院重聚和解。\",\"second_cate\":\"女频现代、寻亲\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488936,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1MedVzMrybQXlGsooFhpMmQ?pwd=wm37\",\"online_time\":\"2024-07-06 00:00:00\",\"time\":1720195200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"固国公主\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"固国公主\",\"description\":\"清冷固国长公主前世为国为家一生奔劳，最终被亲人背叛，家国抛弃，有幸异世重生，云为裳决心为自己而活。\",\"second_cate\":\"女频古装、战争\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483656,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1sPGpdwUmWUcjveJd1BQSAw?pwd=5apv\",\"online_time\":\"2024-03-22 00:00:00\",\"time\":1711036800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"圆湖城之王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"圆湖城之王\",\"description\":\"故事围绕着神秘男主林风展开，他是全球千亿身家黑客之子，却在30年生活中一直被隐藏身份，过着屈辱的生活。当意外得知自己身世后，开始走上人生巅峰。他不仅要面对背叛他的前妻苏梦婷，还要应对情敌张明的讥讽和周围市侩小人的嘲笑。与此同时，林风还与苏梦婷、李雨晴等女性角色产生了深厚的感情纠葛。他们的命运交织在一起，共同经历了爱情、亲情的考验。最终，林风凭借智慧和勇气，在惊心动魄的商战中成功击败了张明，携佳人共度辉煌。\",\"second_cate\":\"男频神豪\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480066,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1W0w2tGt0TYPqkt10m1hniw?pwd=f733\",\"online_time\":\"2023-11-17 00:00:00\",\"time\":1700150400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"土匪皇后\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"土匪皇后\",\"description\":\"跆拳道黑段沈梦溪穿书后成了书中反派炮灰女，利用自己前世所学成为山大王。因为知晓书中剧情，女主隐藏山寨身份，化身镖局老板娘；男主则化身镖局小打杂，两人彼此隐瞒身份，彼此算计又彼此相爱。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486786,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1pKAxLFPoef26StjNIjvVKQ?pwd=wp9k\",\"online_time\":\"2024-06-01 00:00:00\",\"time\":1717171200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"在古代我不装了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"在古代我不装了\",\"description\":\"意外穿越成未净身的小太监，从此皇帝后宫就是他的天下\",\"second_cate\":\"男频逆袭古装\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720478246,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1xh6vvXwGbsS8kVhrAUBeoQ?pwd=iay3\",\"online_time\":\"2023-09-08 00:00:00\",\"time\":1694102400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"在父母坟前，我立地成神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"在父母坟前，我立地成神\",\"description\":\"十年前，林家灭门，侥幸逃脱的林凡跟随师傅上山修行。在深山修炼十年的林凡，尘缘未了导致修为卡在瓶颈，奉师命下山游历。\\n林凡带着通天修为回到天都，势要手刃仇人，为父报仇。刚下山就遇到十年前的恩人叶婉儿，叶凡测算出叶婉儿陷入生命危机之中，为报恩潜伏在她身边保护。\",\"second_cate\":\"男频都市修真\",\"episode\":0,\"platform\":\"\",\"update_time\":1720478836,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/151D9zKELOyxJOSM9knEKTA?pwd=8bdy\",\"online_time\":\"2023-09-29 00:00:00\",\"time\":1695916800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"在病娇大佬怀里撒野\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"在病娇大佬怀里撒野\",\"description\":\"顾烟萝从小被视作智障低能儿，收养兄弟的遗孤林语韵，养女处处排挤顾烟萝，抢夺她父亲跟兄长的爱。直到顾烟萝被异世界天才魂穿，有了各种超能力，一次任务结识京都太子爷秦无妄，对她一见钟情。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487946,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1B5iZ-zuqadyd6DH9roOOUA?pwd=uren\",\"online_time\":\"2024-06-20 00:00:00\",\"time\":1718812800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"在逃契妻美又飒\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"在逃契妻美又飒\",\"description\":\"国内知名游戏公司，开展一项代号为“幽灵计划”的神秘项目，结果，所有参与人员全部离奇死亡，林雨柔母亲便是项目的负责人之一，由于母亲的意外死亡，导致林家陷入到生死存亡接近破产的境地，彼时，林家已经无力在追查林雨柔母亲的真正死因准备放弃调查，林雨柔出面反对，为避免破产及探索真相，林雨柔压上自身幸福选择借傅少琛之手查明真相与其契约结婚，傅少琛因不满家族联姻，避免奶奶催婚选择同林雨柔契约结婚，婚期约定为三年，契约结婚后，林雨柔选择出国发展，林雨柔凭借自身实力三年之内一举成为响彻国内外的游戏设计师X并更名林若涵，功成名就之际林若涵选择回国继续探明真相，并同傅少琛解除婚约追寻自己的生活。\\n三年后，林雨柔隐藏全球最神秘的游戏设计师身份更名林若涵从国外归来，酒吧聚会之际偶遇傅少琛，二人情靡当夜未曾相认，林若涵误将傅少琛当做夜店牛郎，二人在次相遇误会不断，矛盾升级，双方隐藏各自身份不断拉扯，二人共同破除办公室PUA，最终意外推开了两个家族过往的恩怨情仇，此后二人更是甜宠在线，手撕各种“新茶”，同时经过两人的共同努力揭露事实真相，妈妈的死是为了保护“幽灵计划”不被坏人所得用做坏事，二人挖出真相保护住研发者的心血不泄露，保住了相关技术的信息安全。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485096,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1E2Au83n35Qgh6UU1fFIHeQ?pwd=veq9\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"坏了，我被美女包围了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"坏了，我被美女包围了\",\"description\":\"于寒是个母胎单身的屌丝社畜，虽然他以奇葩的处事方式“坚强”地活得像只小强，但他内心的乐观阳光感染了七位有着各种困境的美女，让她们都爱上了他，他们一起谱写了一段奇妙的爱情狂想曲。\",\"second_cate\":\"通用一男多女\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486476,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/11Oid8HaS_BmUKjF4nvJgGw?pwd=m3yx\",\"online_time\":\"2024-05-13 00:00:00\",\"time\":1715529600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"坠入深渊后我手撕渣女\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"坠入深渊后我手撕渣女\",\"description\":\"六年前惨遭施暴的暖暖被打入无尽深渊，六年后她誓要手撕渣人将伤痛百倍奉还！暖暖冷哼报应还在后头！只是自己的心何时被聂之轩悄悄捂化了？\",\"second_cate\":\"女频都市/复仇/言情\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486366,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/14MlrdiE9PD94Yo_glgxBDA?pwd=tyg4\",\"online_time\":\"2024-04-30 00:00:00\",\"time\":1714406400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"坠落时空\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"坠落时空\",\"description\":\"三千年前的盛安国少将军沈毅和太子叶玄铭，意外穿越到现代。他们被神奇的种种先进设备吓到，在现代女孩楚若一的帮助下，慢慢习惯现代的一切。后来又遇到同样穿越过来的小公主，和跟反派二皇子长得一样的现代明星宋臻。经历了重重危险，最终找回麒麟玉佩，回到古代。\",\"second_cate\":\"女频古穿今\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479446,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1d4rHcIVEudKIVSG_U0Z9oA?pwd=rp9w\",\"online_time\":\"2023-10-24 00:00:00\",\"time\":1698076800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"坠龙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"坠龙\",\"description\":\"本剧讲述了数年前，原本积极向上的少年林朔因为一场误会，被迫离开权势滔天的家族，远走他乡，独自生活历练，命悬一线之际，被少女柳晚溪所救。但生活的重担和种种误会让两人都背负着巨大的压力，一度使感情破碎。最终，林朔还是凭借着自己的努力，赢得了柳晚溪和家人的肯定，支持，收获了属于他们的幸福生活。\",\"second_cate\":\"男频都市战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479736,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1vfi9g8sdZSCMW_Ck0QL7uQ?pwd=em6j\",\"online_time\":\"2023-11-09 00:00:00\",\"time\":1699459200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"墨少宠妻超高调\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"墨少宠妻超高调\",\"description\":\"十三年前，她收留无家可归的他；十三年后，他害她家破人亡。善良单纯的瓷音，与父亲收养的义子墨锦衍青梅竹马，却不曾墨锦衍对自己的深情，都是为了替父母报仇而伪装出来的。家破人亡的瓷音心灰意冷，意图逃走，却一次次地被抓回来…\",\"second_cate\":\"女频都市虐恋\",\"episode\":0,\"platform\":\"\",\"update_time\":1720478876,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1tIlhYKeleJPI3mUAqs7G3g?pwd=yhy7\",\"online_time\":\"2023-09-30 00:00:00\",\"time\":1696003200,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"墨雨云间之真假千金\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"墨雨云间之真假千金\",\"description\":\"徐贝是失散多年的大小姐，却被恩将仇报的白嘉嘉害死，冒充自己成为了首富的大小姐，享近荣华富贵，而徐贝意外失忆被墨沉渊救起，以未婚妻的身份夺回自己的一切。\",\"second_cate\":\"女频复仇、豪门\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488826,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":19,\"material\":\"链接：https://pan.baidu.com/s/1yWFEJ1EUs62aNqU1e5dVYg?pwd=vvh8\\n提取码：vvh8\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"复仇从手刃渣男开始\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"复仇从手刃渣男开始\",\"description\":\"安然隐瞒首富身份跟中等公司老板萧野在一起，安然为萧野照顾母亲，做家庭主妇，暗中让手下帮萧野公司上市，因为安然怀孕不上班，萧野开始嫌弃安然，并和公司老板女儿安然闺蜜许佳悦看对眼。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479026,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1TSeLyuC3eaVeH24EyrJfQQ?pwd=qs6m\",\"online_time\":\"2023-10-11 00:00:00\",\"time\":1696953600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"复仇从重生开始\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"复仇从重生开始\",\"description\":\"女友背叛、富二代欺压，一朝身死，他成为了万人之上的财阀。这一次，他决定痛痛快快过一生!教训富二代、打脸前女友、联姻白富美、纵横娱乐圈。我要告诉那些人，什么叫真正的公平!\",\"second_cate\":\"男频重生\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720478196,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/15bTsMxIHX9sL9Gs-FY4yKA?pwd=9weq\",\"online_time\":\"2023-09-07 00:00:00\",\"time\":1694016000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"复仇，从上海滩开始\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"复仇，从上海滩开始\",\"description\":\"历史系毕业的叶千峰倒霉二十多年，竟发现源头是他叱咤上海滩的太爷爷遭人算计，尸体被人镇压在困龙局之中，永无翻身之日。道士吴青霜出手帮助叶千峰破局，却不小心引发天象。叶千峰竟穿越回到了上海滩，他将与他太爷爷勇闯上海滩，他誓要逆转乾坤，破局重生！\",\"second_cate\":\"男频民国年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478986,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1COWQy3oICYj19Xxr4fOmKA?pwd=k8r4\",\"online_time\":\"2023-10-06 00:00:00\",\"time\":1696521600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"夕红市首富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"夕红市首富\",\"description\":\"夕红市豪门公子余闲，十年前大病住院，躲过家族灭门惨案，此后习练独门武功针灸家传，三年前入赘豪门装病潜伏不清闲，寻找线索破案，不料杨家人看出倪端，把他扫地出门。他逆袭复仇成功，成为夕红市首富。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485786,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/16Ef9m27VUkVq0imOPg6qiA?pwd=agrc\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"外卖皇帝\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"外卖皇帝\",\"description\":\"叶华本是一个平平无奇的外卖员，被前女友马丽当做提款机压榨。马丽还出轨于皇家公馆物业经理蔡文，两人骗走叶华最后的存款。就在叶华绝望之际，帝豪集团秘书红蝶找上了叶华，告知他是龙国首富帝豪集团的唯一合法继承人。自己真的继承了万亿家产，从外卖员翻身当了皇帝。叶华继承家产后做的第一件事，报复当初伤害自己的那些人，将他们全部开除。叶华爱上了江秋雅，但却没有告知江秋雅自己的真正身份。最终叶华在帝豪集团招商会上暴露身份，引得赵家，江家两家人懊悔不已，叶华没有给他们改过的机会，将他们彻底击垮，和江秋雅走到了一起。\",\"second_cate\":\"男频神豪\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479926,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1bpW5SFYCtpzFPMcWbCOvVA?pwd=akdv\",\"online_time\":\"2023-11-15 00:00:00\",\"time\":1699977600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"夜尊归来，你们都是弟弟\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"夜尊归来，你们都是弟弟\",\"description\":\"男主一年前在自己和杨静的订婚现场，被李文雪和义弟段云峰联合陷害变得痴傻，被哄骗和李文雪结婚，一年后段父和段母被李文雪和段云峰共同谋害后，继承段家财产被李文雪搞到手后，被李文雪和段云峰共同扔到北境，后顽强活下来，为了复仇成为夜尊...\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478746,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1wsrhSyuCiOrNJbyNnRFhaQ?pwd=xehh\",\"online_time\":\"2023-09-27 00:00:00\",\"time\":1695744000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"夜少的心尖宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"夜少的心尖宠\",\"description\":\"“王总，那您看，这酒我也喝了，那我们合作的事？”“你男朋友没跟你说，这合作，是要到床上去谈的吗？”“放开我！”\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478706,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1IRkC3aPGOQuyjyLWaqOvcA?pwd=j472\",\"online_time\":\"2023-09-25 00:00:00\",\"time\":1695571200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"大乾帝君\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"大乾帝君\",\"description\":\"大夏兵王风天启生前就被美女杀手祸害，穿越重生成太子后，乾朝还有女杀手跟奸臣要风天启命，风天启吸取教训，利用现代发明降维打击这群逆党，坐拥后宫三千，权倾天下......\",\"second_cate\":\"男频穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482096,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1DGExbppcKPrnbSHqTXArDw?pwd=ssi5\",\"online_time\":\"2024-02-04 00:00:00\",\"time\":1706976000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"大佬上位手册\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"大佬上位手册\",\"description\":\"王文武倾尽家当开了一家汉服馆，没想到生意惨淡，欠下巨债又被身边人背叛。跌落谷底的王文武被随身玉佩关联到两位古代大佬，大佬教他盖世武学，将汉服馆打理得蒸蒸日上，然而奇葩之事也接连出现。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486686,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1spWL7AoA-bV_a0Tf6C5frw?pwd=msh9\",\"online_time\":\"2024-05-30 00:00:00\",\"time\":1716998400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"大佬娇妻惹不得\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"大佬娇妻惹不得\",\"description\":\"母亲死后江童被送往乡下，结识师傅，成为医界大佬，得知母亲去世是人为便回到江城。江成立正头疼江思雨要嫁霍家残废霍北霆，江童因需入霍家找信物便同意。霍北霆一直在找神医治疗腿疾，却不知妻子江童是隐藏大佬。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484556,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/19ix3qm-NpaeVyNKuHFg-PA?pwd=t6pu\",\"online_time\":\"2024-04-19 00:00:00\",\"time\":1713456000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"大佬速回你爸被人打断了八根肋骨\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"大佬速回你爸被人打断了八根肋骨\",\"description\":\"穷小子陈天倾遭未婚妻追杀不幸掉落是崖，机缘巧合下习得秘术，获人间剑主称号。三年后，陈天倾携人间剑主名号回归故里，不料却发现父母被未婚妻唐倩刁难气压，父亲更是被其手下混混打成重伤，且看陈天倾复仇之路。\",\"second_cate\":\"男频都市、逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488596,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1YSjYG-Uk7yjNsQfe6xSe5Q?pwd=f623\",\"online_time\":\"2024-06-30 00:00:00\",\"time\":1719676800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"大力女子安晓然\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"大力女子安晓然\",\"description\":\"天生力大无穷的安晓然在夏氏集团做保安的时候正好遇上了盗贼偷金库，而安晓然收拾盗贼的这一幕正好被渊泽科技总裁夏渊泽看见。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486196,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1EJ7gbkdztJVTC_2Cqm21Iw?pwd=snpm\",\"online_time\":\"2024-05-31 00:00:00\",\"time\":1717084800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"大叔小妻首富老公上上宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"大叔小妻首富老公上上宠\",\"description\":\"该剧讲述了男女主在酒吧偶遇，出于家族压力，约定契约婚姻，之后在相处过程中相知、相识、相爱的暖心治愈爱情故事。\",\"second_cate\":\"女频霸总甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481266,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1BZyUeL_NqD5QzTjlv3oDyw?pwd=ir54\",\"online_time\":\"2023-12-29 00:00:00\",\"time\":1703779200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"大夏第一赘婿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"大夏第一赘婿\",\"description\":\"大夏兵王被人暗算，一朝穿越成了古代被奸夫害死的赘婿秦阳，情急之下，他假死脱身，却被下迷药的女将军霸王硬上弓，两人为摆脱各自困境假装成婚！在秦阳的帮助下，将军府不仅摆脱债务危机，还在外敌入侵的时候立下大功！\",\"second_cate\":\"男频古装、赘婿\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480416,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Yg8w0svLfm-0vX5hOzP_pQ?pwd=xa5j\",\"online_time\":\"2023-11-27 00:00:00\",\"time\":1701014400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"大小姐与绝世神厨\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"大小姐与绝世神厨\",\"description\":\"秦芊芊是美食集团首富继承人，一心想摆脱父亲光环收购怪不得面馆，面馆由神厨八哥和姐夫宝哥成立，二人号称“美食二人组”，不料引发了一场埋藏二十年的师门恩怨！传承中华美食，厨暴安良，热辣滚烫！\",\"second_cate\":\"女频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484846,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1tF3K14byJBnCHL5eMYtgIA?pwd=ssum\",\"online_time\":\"2024-04-29 00:00:00\",\"time\":1714320000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"大小姐归来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"大小姐归来\",\"description\":\"顾南乔母亲去世，从小就父亲继母虐待排挤，患上精神病，长大后复仇。谢宴辞被顾明远弄得家破人亡，为了报复接近顾南乔和顾云熙，是顾南乔心理医生，爱顾南乔却隔着深仇大恨，最后绝症身亡，女主与男二结婚。\",\"second_cate\":\"女频现代/复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486226,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1qcVio-q9YqnViHahgz5h3g?pwd=h75u\",\"online_time\":\"2024-05-31 00:00:00\",\"time\":1717084800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"大小姐画风不对\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"大小姐画风不对\",\"description\":\"前世的时锦忍让、忍耐却让自己落到悲惨至极的地步，这一世的时锦，她发誓要改变自己，她要让欺辱自己的林婉儿，一步步的失去爱人、朋友、亲人，所有！\",\"second_cate\":\"女频 甜宠 女强 爽剧\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481006,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1YtKSCHRRvseTJuQ5EyDPcA?pwd=jbtd\",\"online_time\":\"2023-12-22 00:00:00\",\"time\":1703174400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"大小姐的千层局中局\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"大小姐的千层局中局\",\"description\":\"大小姐宁青棠一步一步带钟景轩走进爱情的套路中，然而随着进一步相处，钟景轩发现是骗局后仍想和她在一起，但宁青棠竟然提出要和他离婚，钟景轩不得不开启了自己漫长的追妻之路\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485726,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1i5Ot831960a_zbJ517O3Dw?pwd=2vka\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"大小姐驾到渣男闪开\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"大小姐驾到渣男闪开\",\"description\":\"慕雨情年幼时，曾在孤儿院遇见了自己的挚爱，随后回归龙隐成为万人之上的大小姐，可当她以为顾睿泽就是曾经的那个小男孩时，却被他人投毒昏迷五年，大梦初醒时，一切都变了，自己最爱的男人竟然跟其他女人结婚。\",\"second_cate\":\"女频战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487136,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1B0uBNQSfTf62XMLQjOsXNg?pwd=wvnz\",\"online_time\":\"2024-06-07 00:00:00\",\"time\":1717689600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天下财皇\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天下财皇\",\"description\":\"甄无道英俊尊贵，身份是天下财皇，为了报恩来江城给儿时的救命恩人下聘礼。不料儿时的信物被莫灵儿拿走，让甄无道误以为莫灵儿就是当年他的救命恩人！这时真正的的救命恩人徐秋雪却遇到有人冒充财皇，想占有徐秋雪，好在甄无道及时赶到，甄无道惩治了冒充之人，却陷入超级势力的大阴谋！\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483906,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1_VpqTL_cdEVBAJCT4zdwsQ?pwd=ih7d\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天作之婚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天作之婚\",\"description\":\"她是流落在外的真千金，却惨遭渣男背叛，养父母更是要将她卖给大几十岁的老男人。情急之下，她闪婚地摊小贩，谁料小贩摇身一变，成了事业有成多金帅气的总裁。从此渣男贱女，直接横推，狠毒父母，手把拿掐。\",\"second_cate\":\"女频/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488356,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1G4_c6YE57QN6LhpEQYk79A?pwd=3kb7\",\"online_time\":\"2024-06-27 00:00:00\",\"time\":1719417600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天君下山霍霍三个绝色老婆\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天君下山霍霍三个绝色老婆\",\"description\":\"玄机山神童以双眼为代价助夏州三世家破除寿煞，三家之女活不过18岁命运被彻底改写，为报答神童，三家老门主许诺神童长大后愿与其缔结婚约。十年已过，罗战虽盲却已是武财双神一身，他前往夏州去兑现当年那三桩婚约。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484366,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1RHnP_qYU3AdlJ8rWe8xwNw?pwd=vgrx\",\"online_time\":\"2024-04-12 00:00:00\",\"time\":1712851200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天命神婿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天命神婿\",\"description\":\"天师徐春外出游玩救下秦家长女秦梦璃，为救其性命，逆天改命，失去记忆后流落仙家村，成为村子的守村人，为村子抵挡灾祸，变得痴傻。五年后，村子以气运耗尽，变痴傻为由想将其逐出村子，而这时，徐春的记忆苏醒。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486176,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1fTaplmckUzAlv-JIyZAMvA?pwd=7juc\",\"online_time\":\"2024-05-31 00:00:00\",\"time\":1717084800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天命赊刀人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天命赊刀人\",\"description\":\"摸金校尉找到龙脉，命人挖掘，地动山摇，鬼谷一脉传人楚老带着孙子楚风前来阻挡，却没想到迟了一步，龙脉却要化作真龙飞走，楚老使用鬼谷秘术，以自己为阵眼将真龙镇压，阵法完成时，楚老将自己刀魂传授给楚风。为完成祭祀大阵，解救爷爷，楚风下山寻找九大家族执行奢刀令。岂料都市人心难料，几大家族拒不认账，试图倒打一耙，将楚风置于死地。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481566,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1cwpDwHAWRzZbxrSMyWjPtA?pwd=ei3r\",\"online_time\":\"2024-01-12 00:00:00\",\"time\":1704988800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天官\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天官\",\"description\":\"大夏天官张玉清三年前遭人偷袭身受重伤，被安晚妆所救，从此隐姓埋名，入赘安家，却反被安晚妆及其母亲嫌弃离婚，安家寿宴上众多世家，对安家虎视眈眈，更有武王府欲杀害众人，于是显露真身，铲除仇敌，拯救众人。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720484256,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1KyaIXVZNA2OJ3MpuLGur6A?pwd=65tn\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天尊崛起之都市风云\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天尊崛起之都市风云\",\"description\":\"家道中落的宁无缺被师父收养栽培，接任新一届的共济会天尊，不料师父被歹人背叛绑架。宁无缺又因出身卑微被未婚妻退婚后招人嘲笑，但却因自身才华魅力吸引了梅家小姐梅子苏，二人携手共度一个又一个难关，展开了一段爱情佳话。最后宁无缺拿回天尊宝藏的钥匙，解救出落入歹人之手的师父和爱妻，用实力征服了所有人，登上天尊之位。\",\"second_cate\":\"男频战神、逆袭、成长\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483576,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/11UXzhdrpgKkyotrFa6xzxA?pwd=rij2\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天师出山之完美赘婿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天师出山之完美赘婿\",\"description\":\"林不凡本是神相门最卑微小师弟，因偶得祖师爷神技上身，逆天改命。原本他和江南市吴家长女有婚约，却因为吴家悔婚，他阴差阳错地成为吴家对头柳家的赘婿。赘婿不好当，他利用自己的神技过关斩将，开启了爽剧大男主的人生。\",\"second_cate\":\"男频赘婿\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477946,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1tqEkmf_72pimEmdnaDi_QQ?pwd=aixw复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-19 00:00:00\",\"time\":1692374400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天师我啊真的不想吃软饭\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天师我啊真的不想吃软饭\",\"description\":\"云龙宴作为本书最大高潮，是龙国五大天女的选亲大会，实际上是龙国天师的传承，龙国每一代天师，都会在云龙宴上选择五大天女之一作为天师夫人，这一代的五个人就是五大女主，而所有的名流云集，就是因为没被选中的天女，会在参加云龙宴的人选里选择夫婿，这些家族都会受到天师的庇佑和扶持。主角秦逍遥是个孤儿，十年前被天师收徒，上一任天师定下五份婚约，秦逍遥上山修炼，结果身上气运压身，需要勘破红尘才能突破，主角以为红尘只是儿女情长，实际上却并不是，而是要在红尘之中渡过自己的劫难，最后云龙宴退婚之后，隐世家族秦家，现世抢夺秦逍遥的气运，（男主就是秦家弃子）秦逍遥重伤，五大天女加上赵梦晗，贡献自己所有，为秦逍遥续命，勘破红尘，击败反派，从此一起修炼。\",\"second_cate\":\"男频高手下山\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482666,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1rW-6yBkC48PM3_WswFTdsA?pwd=dtyn\",\"online_time\":\"2024-02-23 00:00:00\",\"time\":1708617600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天府少帅\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天府少帅\",\"description\":\"南省少帅林睿在一次任务中身受重伤被江城赵家大小姐赵雪所救，为查出内奸隐藏两年。谁知两年后林睿江城，让青帮和赵雪结成联盟，就是为了给赵雪一个惊喜，弥补自己这些年的亏欠，感谢她当年救了自己。\",\"second_cate\":\"男频民国、战神、复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480756,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1SOyc1c0Cgqy9cfaBDh0m9g?pwd=fwxa\",\"online_time\":\"2023-12-14 00:00:00\",\"time\":1702483200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天庭帝尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天庭帝尊\",\"description\":\"君临天被昆仑仙人收为徒弟成天庭之主。君临天为报苏清漪恩情与其成婚帮苏家解决问题。苏清漪成总裁得龙爷重视开始嫌弃君临天。各大家族古武宴会对君临天出言不逊被打脸。君临天灭古武世家，苏清漪得知一切真相。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486606,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/18tnFnTJnK-QmX1FAIqBgcg?pwd=2vt6\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天才丐婿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天才丐婿\",\"description\":\"首富江明城被未婚妻和妹妹设计杀死后，重生在一个聋哑乞丐身上，江明城通过一系列手段不断报复前世害他的人，还横扫商界对手，成为新一代的首富神话，完成人生的华丽锐变，正在他准备下一步商业动作时，他忽然醒来，原来他所经历的一切都是一场梦，但是这个梦也给了他启示，让他对家人有所防备，果然，未婚妻和妹妹在筹划一场阴谋。\",\"second_cate\":\"男频复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486036,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1-4opn9fWCND1Zv_1mz7uQg?pwd=jqyn\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天才萌宝甜蜜辣妈\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天才萌宝甜蜜辣妈\",\"description\":\"男主作为一个总裁遭人算计，与女主发生关系，并生下一个男孩。女主却被自己的妹妹算计，抢走老公和儿子。五年后，偶然机会，萌娃给单身爹地相亲，鬼使神差却把亲自妈咪介绍了自己的爹地。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485356,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":20,\"material\":\"https://pan.baidu.com/s/1ZLLDxmIG6VMhwosKzT0_mg?pwd=6nkc\",\"online_time\":\"2024-05-18 00:00:00\",\"time\":1715961600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天才萌宝腹黑爹地\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天才萌宝腹黑爹地\",\"description\":\"青梅竹马十年，他的新娘不是她。她霸王硬上弓，睡服了景大少。安柔一夜之间消失的无影无踪，五年后，她带着一对萌宝回国，躲过藏过，还是被他抓个正着。“当年我发过誓，抓到你，一定让你下不了床。”\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484956,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"链接：https://pan.baidu.com/s/1tCVot1y3ggiSTAPSp6aHfQ?pwd=18sv\\n提取码：18sv\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-02 00:00:00\",\"time\":1714579200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天才萌宝重生甜妻飒爆了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天才萌宝重生甜妻飒爆了\",\"description\":\"顾昭夕前世错信姐姐，爱上渣男，让自己的女儿烧成了傻子，还害得老公为救她身亡，重回这一世，她不光要报复渣男渣女，她更好好好的爱女儿与老公，成为影后，重新拿回幸福美满的生活。\",\"second_cate\":\"女频重生、萌宝、娱乐圈、爽文\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480116,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1x_uWsS7llLl7QktqlTayiA?pwd=pv4x\",\"online_time\":\"2023-11-18 00:00:00\",\"time\":1700236800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天机眼\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天机眼\",\"description\":\"江北本是一名保安，意外获得了透视和预知未来的能力，遇到麻烦后被楚一诺及时救场，为了感谢楚一诺江北利用预知能力帮住楚市集团扶摇直上，更是俘获了霸道女总裁的芳心，从此走上人生巅峰！\",\"second_cate\":\"男频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487706,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1UPWosjLBZOZga1vbQUKVWA?pwd=eqxj\",\"online_time\":\"2024-06-17 00:00:00\",\"time\":1718553600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天涯赤子心\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天涯赤子心\",\"description\":\"齐越山身患癌症，养父母齐大强夫妇各处求人借钱，齐越山却被神秘人强行带走。八年后，神秘富豪下令全村乔迁别墅并补偿巨额现金，齐大强夫妇却被排挤欺辱。可谁知从豪车上下来的正是失踪的齐越山。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487656,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1aFwiRUC1KogtSm_b25zjiQ?pwd=vhsu\",\"online_time\":\"2024-06-15 00:00:00\",\"time\":1718380800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天王\",\"description\":\"男主陈循是大周顶级势力天王殿殿主，因为继承天王殿天王的祖传殿规，要以普通人的身份生活三年，三年时间，他以摆地摊为生，没想到却因此，被自己老婆慕晚宁一家看不起，因此百般刁难，要陈循和慕晚宁离婚，从而好让慕晚宁嫁给富二代叶浩。而今三年之期已到，陈循回归天王之位，同时这天也刚好是慕晚宁的奶奶大寿之日，因此富二代叶浩找了打手来对付陈循……\",\"second_cate\":\"男频战神赘婿\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481436,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/18bh4FkhadOPBSiAjQRmUvQ?pwd=e4v6\",\"online_time\":\"2024-01-08 00:00:00\",\"time\":1704643200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天神殿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天神殿\",\"description\":\"战场浴血征战，女儿打来电话求救，一夜之间，三千世界顶级强者，齐聚华夏！他萧天策一生凄苦，女儿跟妻子就是他生命中的一道光。他这辈子绝对不允许自己的女儿和妻子道藕丝一毫的伤害！\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480996,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":7,\"material\":\"https://pan.baidu.com/s/12tOIc28OuaXrGHY7Cb7b6A?pwd=grf1\",\"online_time\":\"2023-12-22 00:00:00\",\"time\":1703174400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天神殿主\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天神殿主\",\"description\":\"十年前，叶家举家搬迁至天域，在南省销声匿迹。十年后，叶凡带着一纸婚书回到南省，与林家大小姐林清雪成婚，却被嘲讽是破落户的废少，一场豪赌，叶凡爆出惊天身份。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481196,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1HFpwv5EFzfs2W3GNhBYM6Q?pwd=aqyu\",\"online_time\":\"2023-12-28 00:00:00\",\"time\":1703692800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天赐萌宝：豪门后妈娇又野\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天赐萌宝：豪门后妈娇又野\",\"description\":\"沈慈晚的姐姐在和傅凌枭的哥哥出车祸，哥哥当场死亡，姐姐难产，沈慈晚说保大，姐姐却说她肚子里的孩子是她和哥哥唯一在世的证明。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480236,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1fhIUOjSwS-omnuqir3TFFw?pwd=7bfn\",\"online_time\":\"2023-11-21 00:00:00\",\"time\":1700496000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天门医圣之渡劫双修\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天门医圣之渡劫双修\",\"description\":\"天门医圣魏无悬与蓝家千金蓝晶晶曾因前世魏无悬练功走火入魔，蓝晶晶以身救命而分离，如今魏无悬下山与蓝晶晶再续前缘。魏无悬医术更加精湛，蓝晶晶的容颜依旧。两人携手共进，共同书写着属于他们的传奇故事。\",\"second_cate\":\"男频都市、神医\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488476,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1ZzVBEpCFLlQfaiq8B8kHdA?pwd=v51h\",\"online_time\":\"2024-06-28 00:00:00\",\"time\":1719504000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天降实习财神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天降实习财神\",\"description\":\"离家出走的宋氏大少爷遇到一心想着完成任务转正的实习小财神：小财神招数百出要帮宋少爷发财致富，不料宋少爷居然有个隐藏的身份，小财神的努力眼看就要打水漂，这个时候财神老大出现了……\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484416,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":16,\"material\":\"https://pan.baidu.com/s/1mLQ1vB4COncgmzICTcgUbQ?pwd=fhbp\",\"online_time\":\"2024-04-15 00:00:00\",\"time\":1713110400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天降男神宠不停\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天降男神宠不停\",\"description\":\"豪门大小姐叶初心和穷学生夏燎在大学时代是一对甜蜜的小情侣,然而这段恋情很快引起了夏燎异母异父妹妹夏妍的妒忌。夏妍暗中离间两人的同时,还通知叶初心父亲叶怀林棒打鸳鸯。叶怀林为了迫使两人分离,对夏燎各种打压威胁,最终夏燎无奈与叶初心分手。两人分手以后,夏燎落魄潦倒时车祸重伤,失去了所有记忆,被亲生父亲接回家,成为商家大少商云翼。\\n五年后,叶家和商家因为家庭势力门当互对订下婚约。叶初心不想与未婚夫商云翼见面,逃跑路上却正好救下了化名夏燎的商云翼。叶初心以为父亲催自己结婚是担心叶家没有继承人,于是是利用救命之恩要求商云翼跟自己生一个孩子,了却父亲逼婚的念头。两人在不知对方是婚约对向的前提开始了各种牵扯。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487606,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1iwyY5PIuvuNs35j6MWFfsg?pwd=bjcz\",\"online_time\":\"2024-06-15 00:00:00\",\"time\":1718380800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天降神秘老公\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天降神秘老公\",\"description\":\"叶清欢本是一个普通女生，却误打误撞的撞到了大总裁宫黎川。宫黎川因失意忘记了自己的身份，被清欢收留当作躲避妈妈催婚的老公。之后宫黎川恢复记忆却为了继续和清欢过普通人的生活选择了隐瞒总裁身份。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487526,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1Yk2WnV86tZ_0iI1JMeJiJQ?pwd=j898\",\"online_time\":\"2024-06-14 00:00:00\",\"time\":1718294400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"天降萌宝：总裁爹地要复婚！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"天降萌宝：总裁爹地要复婚！\",\"description\":\"宋诗晴拒绝嫁给傅少，六年来独自带女儿寒寒生活，寒寒生病住院，为筹医药费去ktv上班遇到前男友厉北寒和傅少，傅少对当年毁婚怀恨在心，故意为难宋诗晴。厉北寒选择无视，但对宋诗晴余情未了帮助了她，得知竟然还有一个女儿的时候，他选择和宋诗晴再续前缘。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479966,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1bSu4O0DR1g6XHkS9krHEoQ?pwd=9gu5\",\"online_time\":\"2023-11-15 00:00:00\",\"time\":1699977600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"太古至尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"太古至尊\",\"description\":\"叶非凡，少年时期家族覆灭，被仇人追杀，在荆州时被具有婚约的沈家所救，逃亡海外后，叶非凡拜师至尊，镇守禁区多年，镇压成功后回荆州履行婚约，既是报恩也为报仇，为查明当年灭门之仇，沈家上下看不上当牢族的叶非凡，以为叶非凡回归，只是为了攀附沈家，还要将沈千瑶嫁给张家张少军，为了让沈家人看清双方差距，叶非凡在战神宴靠美女战神秦婧上打脸众人，之后叶非凡回归的消息，被张少军透漏给其父亲张志，张志当年追杀叶非凡时，出力极多，得知叶非凡回归后，想要将叶非凡除掉，但张志并不知道，叶非凡早就盯上了他。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481516,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1q_7rewCAQH4n8kljnAgxDQ?pwd=5nrh\",\"online_time\":\"2024-01-08 00:00:00\",\"time\":1704643200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"太子妃养成记\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"太子妃养成记\",\"description\":\"大学生云小禾意外穿越到古代并成为丞相庶女。她被逼嫁给纨绔王子肖琏，云小禾为了找到回到现代的方法，展开了一系列改造太子的行动，最终二人在各种困境中携手取得胜利，并由此产生爱情，后又穿回现代，修成正果。\",\"second_cate\":\"女频穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483166,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1j5PULUVmKOetbvrNFUeNxw?pwd=2f2m\",\"online_time\":\"2024-03-10 00:00:00\",\"time\":1710000000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"太子妃驾到，总裁你别跑\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"太子妃驾到，总裁你别跑\",\"description\":\"陆瑶是大夏王朝太子妃，皇子战云旗谋权篡位，杀了皇上，太子战云霆在战斗中为了保护陆瑶被杀，陆瑶随之自杀。再次醒来后，陆瑶穿越到了现代，成为了顶级富豪云霆的妻子，但因为原身的种种恶劣行为，云霆要和陆瑶离婚。陆瑶为了再续前缘，决定好好在现代生活，并把自己天工师的手艺发扬光大，好不再成为云霆的拖累。\",\"second_cate\":\"女频古言\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483796,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1jLz2Du5sjVdiJV4N4Tc_sg?pwd=pbkx\",\"online_time\":\"2024-03-26 00:00:00\",\"time\":1711382400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"太子英明\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"太子英明\",\"description\":\"箫逸作为岭南战狼团最年轻的兵王，被敌方派来的杀手张倩刺杀，张倩不敌被箫逸反杀，最后鱼死网破经历电击后穿越到了史上一个架空的王朝，成了当朝荒淫无度的废物太子！上有心机皇兄虎视眈眈各种下套，独权老爹不断打压！下有满朝文武等着看他的笑话，家里的两个妃子更是一个被逼改嫁，一个强抢而来，都想着要他的命......且看新时代医，武双全的兵王如何翻手为云，打脸虐渣重塑属于自己的王朝！\",\"second_cate\":\"男频古装\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480446,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1tPF43NuOTLRA59GMnwimQQ?pwd=rj17\",\"online_time\":\"2023-12-04 00:00:00\",\"time\":1701619200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"夫人回来吧，总裁心很痛\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"夫人回来吧，总裁心很痛\",\"description\":\"三年前一场意外，女主林杉杉的爱人季洲在车祸中不幸去世，她尊重季洲的意愿，将季洲的心脏捐献了。林杉杉无意中知道了季洲的心脏被捐给了霍景行，太过思念季洲的林杉杉，更名改姓后出现在霍景行身边，并且心甘情愿成为了霍景行白月光沈嫣然的替身。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479936,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1btIAwTylb8eaRrwLwHXbSg?pwd=s8wx\",\"online_time\":\"2023-11-15 00:00:00\",\"time\":1699977600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"夫人带球跑总裁夜夜哭\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"夫人带球跑总裁夜夜哭\",\"description\":\"三年前，苏意晚惨遭父亲跳楼自杀、丈夫出轨的双重打击，悲痛欲绝之下她逃往国外生下女儿乐乐，没想到乐乐竟被查出患有白血病，要想救孩子只有一个办法，那就是跟孩子亲生父亲再生一个利用脐带血移植治疗。为了救女儿，苏意晚不顾自己脑子有恶性肿瘤，毅然决然带着孩子回国，以离婚为条件要求薄靳言跟自己同房。三年后再重逢，俩人都朝对方露出獠牙，可针芒相对之下爱意汹涌翻滚，两人这才发现原来当年的种种龃龉，都是误会…… \",\"second_cate\":\"女频豪门总裁\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480316,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1BunWyuYJtNOJFaDgFXb5aQ?pwd=acb6\",\"online_time\":\"2023-11-24 00:00:00\",\"time\":1700755200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"夫人离婚后，疯批总裁他慌了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"夫人离婚后，疯批总裁他慌了\",\"description\":\"夏惜与顾夜霆是一对恩爱至深的恋人，夏惜莫名被绑架，顾夜霆不顾自身安危前往救人，自己却惨遭毒打，醒来后，两人就完成了结婚仪式。但结婚当天，顾夜霆却在别的男人床上发现了夏惜，还被人指认之前的绑架都是夏惜的做戏，顾夜霆一怒之下，将夏惜关到了顾家五年，而新的变化，就从夏惜的闺蜜，着急嫁入顾家开始。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"\",\"update_time\":1720477666,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1x_b5wXd0LAu2f99cBIP0jA?pwd=y5u6复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-15 00:00:00\",\"time\":1692028800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"夫人，全球都在等你离婚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"夫人，全球都在等你离婚\",\"description\":\"本剧讲述了聪明坚韧的女主苏楠为了解脱受尽压迫的糟心生活、实现自己的人生价值一直在与对自己的不公待遇作斗争，尽管这一路频频被恶毒女配婉柔刁难，被男主傅邺川误会，但经过重重纠葛傅邺川终于及时醒悟，最终两人幸福走到一起的故事。\",\"second_cate\":\"女频大女主逆袭\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479776,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1NS4DyAlyGFBGPMEZfkB-nw?pwd=dysm\",\"online_time\":\"2023-11-09 00:00:00\",\"time\":1699459200,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"夫妻马甲掉完双双把家还\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"夫妻马甲掉完双双把家还\",\"description\":\"本剧讲述了时沫为父查清真凶路上遇到真爱傅厉锦，最终与真爱一起查明真相，并相守一生的故事。幼年时遭逢巨大变故的时沫并没有长成一副怨天尤人心里满是仇恨的样子，反而出落得落落大方、积极开朗，虽然心中立志为父亲报仇，可是从没想过用极端的手段去报复他人，她心中所思所想都是查明当年的真相，找出当年的罪证，是非对错自有公判，而面对包办婚姻她也是极力反对，时沫的这一观念与男主傅厉锦不谋而合，两人在相处中日渐被对方所吸引，男女主两人相互藏多重马，一直在掉马的边缘拉扯，看得观众也捏一把汗，两人极其喜欢扮猪吃老虎，引发一系列沙雕搞笑的剧情，直到最后一刻才暴露两人真正的身份，狠狠打脸一波反派，最终查明了所有真相，拿回了属于自己的一切，过上了幸福的生活。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484036,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1hGufjg2amGpdhgK7UAXfWg?pwd=kk25\",\"online_time\":\"2024-04-02 00:00:00\",\"time\":1711987200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"头号宠婚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"头号宠婚\",\"description\":\"遭遇家族破产，父亲又突发心脏病病危入院，亲戚漠视，最终林云溪只能以出卖尊严的方式换取父亲医疗费用，在大伯一家的陷害下，为了自保和傅斯尘定下合同婚约成为‘假夫妻’，在与傅斯尘相处过程中慢慢喜欢上他，而在傅斯尘想要对她真正表白那晚，林云溪提出了离婚，傅斯尘赌气答应，直到傅斯尘母亲与林云溪见面解开误会，傅斯尘又重新追回了林云溪。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479006,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1b_UdvxDjSNs9W-gHgp1n2w?pwd=m4tu\",\"online_time\":\"2023-10-06 00:00:00\",\"time\":1696521600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"奈何盛世要宠我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"奈何盛世要宠我\",\"description\":\"喻唯一的父母被舅舅陷害，双双而亡，长大后，她与豪门公子盛世联姻，二人联手，对抗榕城几大家族，过程中二人深深爱上了对方。\",\"second_cate\":\"女频甜宠/都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483316,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1rzhnyOo-6K_fTeOC2tsd1Q?pwd=27ry\",\"online_time\":\"2024-03-14 00:00:00\",\"time\":1710345600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"奉旨追妃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"奉旨追妃\",\"description\":\"一个在客栈当跑堂的，居然是皇室唯一残存的血脉!男主刘斗本是人皇血脉，但因为太废了，只能御最低级的神而被皇室抛弃。但突然一天，周公公找到了男主，要男主奉旨生娃，给刘家续种，并给了男主一个可以调动神都金钱的令牌，从此屌丝翻身被美人倒追。但男主心中的白月光不为金钱所动，而倒贴的曹梦婷又不忍伤害。男主唯有挑战管家任务，去追神都女神孙瑜，与豪门一同竞争。男主最后能不能获得白月光的爱意?在追女神孙瑜中如何觉醒御神等级?知道日久生情的曹梦婷居然是世仇将如何面对?所有的故事，跟随着一个扶不起的阿斗，手中那个神都令牌说起...\",\"second_cate\":\"男频古装剧\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478216,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1cR5q3waGjgceGmGuj3GYoQ?pwd=pa7y\",\"online_time\":\"2023-09-07 00:00:00\",\"time\":1694016000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女主偷听我心声人设崩塌了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女主偷听我心声人设崩塌了\",\"description\":\"唐瑜熬夜看短剧猝死，穿越到熟知的短剧剧情中。竟成了剧中的大反派 。为了摆脱被原著龙王男主叶晨一脚踢死的命运，唐瑜决定顺水推舟，苟活到最后，没想到剧中的女主们竟然能偷听到唐瑜的心声，这下完蛋了！\",\"second_cate\":\"男频穿越/都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483196,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1RTyPI7xBs6xHGKcgQ2NQkA?pwd=95aj\",\"online_time\":\"2024-03-11 00:00:00\",\"time\":1710086400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女儿与我同归于尽\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女儿与我同归于尽\",\"description\":\"金融大佬陈勇得知自己身患绝症，想要临死前获得女儿的原谅。却不想，女儿竟要和他同归于尽。原来，年轻时，陈勇滥赌、酗酒，害的妻子早亡，女儿终身残疾。造化弄人，就在两人都要葬身火海的时候，陈勇拼死救了女儿。怀揣着满腔愧疚和懊悔，他意外获得了重生一次的机会。\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481686,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1FUkLhhOJbmVuUqUF4pd2qQ?pwd=j6m5\",\"online_time\":\"2024-01-19 00:00:00\",\"time\":1705593600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女儿再爱我一次\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女儿再爱我一次\",\"description\":\"陆贝儿六岁时被拐，成了顾家养女顾雪儿。十二年后，为了给养母换肾，顾雪儿成了陆家车祸变傻养子的冲喜新娘。面对她的，是无尽的折磨和虐待。亲母亲、假千金、恶毒堂哥，轮番上阵，顾雪儿心灰意冷，越过窗户一纵而下。当知道自己才是陆家千金，顾雪儿又该何去何从？\",\"second_cate\":\"女频大女主\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483206,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1PegDYwDLPXUUSi1OgbfjDA?pwd=erjv\",\"online_time\":\"2024-03-11 00:00:00\",\"time\":1710086400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女儿对不起\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女儿对不起\",\"description\":\"因为一场车祸，妈妈顾向晚在儿子和女儿之间选择了儿子，女儿黎浅便走丢了，寻找多年无果，几年后，在黎氏集团的实习生中发现了身影。\",\"second_cate\":\"女频亲情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487776,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1sji86gTn7oIntz6fOvuDeA?pwd=mbrw\",\"online_time\":\"2024-06-18 00:00:00\",\"time\":1718640000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女儿带我软饭硬吃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女儿带我软饭硬吃\",\"description\":\"秦枫本是大帝转世却因历经红尘封印大帝记忆，巧合救女神王林若仙，林若仙为让秦枫守护大夏与其一同出席秦老爷子生日宴，发现秦枫从小被秦家人排挤，秦家人连女神王信物都不放眼里，林若仙为秦枫打脸那些人。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487916,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1KE4mcZwzkWJG1G11inqxZg?pwd=qrws\",\"online_time\":\"2024-06-20 00:00:00\",\"time\":1718812800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女儿拔了我的氧气管\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女儿拔了我的氧气管\",\"description\":\"首富林川在ICU里，被痛恨自己的女儿拔掉了氧气管，竟然在死后重生到90年代。重生后的他发誓，要改变妻儿自杀的命运，改过自新，戒掉赌瘾，用家里仅剩的十块钱重新发家致富，让妻儿们过上幸福生活，让女儿原谅自己。\",\"second_cate\":\"男频重生年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478526,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1YfR6SnLsZmCBeS69CqqyYA?pwd=5m86\",\"online_time\":\"2023-09-15 00:00:00\",\"time\":1694707200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女儿身暴露，王爷他沦陷了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女儿身暴露，王爷他沦陷了\",\"description\":\"因不满指婚老侯爷，任知恩女扮男装逃出任府，意外成为声名狼藉的九王爷的教书先生，不料各种挑战接踵而至...太子慕容皓的谋害，任知思母亲身世之谜，九王爷慕容烨母妃之死...各种真相纷纷揭开...\",\"second_cate\":\"女频古代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484696,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1ppYORix49dv8zvNLmhtA2Q?pwd=fvzs\",\"online_time\":\"2024-04-25 00:00:00\",\"time\":1713974400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女将军娶个乞丐当王妃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女将军娶个乞丐当王妃\",\"description\":\"女主红豆身为付将军之女幼时被屠家，少女时期被义父觊觎后逃入古墓与守墓人斗志斗勇学得一身江湖本领后，被反派利用小乞丐生命逼迫嫁入荆王府中，得知实情暗中帮助长安恢复武功和病情中产生感情爱恨纠缠中不断升华，后联络旧部奔赴疆场。在战场两人并肩作战默契配合，感情加重，功伟绩获得封号百姓赞称“女将军”后继续分赴疆场。男主牺牲！悲痛万分从书中穿回。\",\"second_cate\":\"女频古装、战争\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483676,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1bmLpIvDqfFQVLeOFZXO1VQ?pwd=3yii\",\"online_time\":\"2024-03-22 00:00:00\",\"time\":1711036800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女将军现代虐渣攻略\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女将军现代虐渣攻略\",\"description\":\"前世是大夏国女战神，现代是善良懦弱的叶家大小姐，奈何父母去世后，被姑母一家强夺家产，堂妹非但抢夺未婚夫，还凌辱叶倾城致死，待叶轻城穿来，开启虐渣打脸的复仇之路。\",\"second_cate\":\"女频古穿今重生复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478816,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1r_CYbnlTroRyMTKFcv9Vcg?pwd=ty3p\",\"online_time\":\"2023-09-28 00:00:00\",\"time\":1695830400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女帝\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女帝\",\"description\":\"东洋人横行，想要入侵大夏，他想请李秋水出山，去对付东洋人！李秋水拒绝了，她现在只想跟女儿过普通人的生活，可是李秋水不知道是，她的女儿此时正在学校受尽欺辱。\",\"second_cate\":\"女频战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487046,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1ZOf5jsvQv4jNbS6SbUlamg?pwd=33tq\",\"online_time\":\"2024-06-06 00:00:00\",\"time\":1717603200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女帝的绝品假太监\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女帝的绝品假太监\",\"description\":\"秦云穿越到武国成了小太监，正在被公主欺负，恰逢北凉公主携带使团挑衅，武国朝堂无人敢应战，秦云战胜北凉使团，无意中发现皇帝意是女儿身，又被皇帝威胁安抚后宫。秦云查出武侯意图勾结北凉造反，趁机拿下北凉公主，于是帮助女帝平息叛乱。\",\"second_cate\":\"男频穿越历史\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720477856,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1_L4yuQTvoPLRnhgZVgXMeQ?pwd=3wtq复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-18 00:00:00\",\"time\":1692288000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女帝要选妃我誓不做男宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女帝要选妃我誓不做男宠\",\"description\":\"武瑶意外当上女帝，发现父王死的十分蹊跷，但因朝堂毫无根基，故装作昏君暗中调查；宰贤陈逸飞误会女帝誓死参谏，被悄悄册封为皇后。女帝又纳书生陆卿烟，武将金俊焕，侠客叶青等成为强大智囊团，整治朝堂。\",\"second_cate\":\"女频古装/权谋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486806,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1YiitpnV64JRtND-VByA24g?pwd=qx8b\",\"online_time\":\"2024-06-01 00:00:00\",\"time\":1717171200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女总裁的换身奇遇记\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女总裁的换身奇遇记\",\"description\":\"蛮横霸道林氏集团总裁、林家二小姐林傲雪，因意外点开游戏链接后和她公司刚入职耍宝男职员温亦安灵魂互换。林傲雪想换回身份，温亦安抢手机删除链接，阻断林傲雪换回身份的途径。初期两人矛盾频频，时常斗嘴吵闹。\",\"second_cate\":\"通用奇幻\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486486,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1uptteE9TlJQnaEU_2cpRMg?pwd=85f8\",\"online_time\":\"2024-05-13 00:00:00\",\"time\":1715529600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女总裁还乡又美又飒\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女总裁还乡又美又飒\",\"description\":\"赵希楠被逼嫁换彩礼钱，在侄女沈欢帮助下逃到云城。因缘际会下救了帝尊集团总裁关虹，被收为义女。此时赵希楠已离家六年，想回报家乡，对小渔村进行新农村建设。拆迁过程中村民坐地起价闹事，赵希楠回村处理事务、探亲，不想遭遇观念愚昧的父母等人羞辱。于是赵希楠与众人周旋，这过程还怒甩渣男友，打脸下头同学和表亲们等。赵希楠对小渔村的改造建设很成功，最后获得村民们的认可和感恩。\",\"second_cate\":\"女频乡土、逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482286,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1RSoW3PH2Z7dJTjOd1vCDlg?pwd=gi7b\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女明星的贴身阴阳师\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女明星的贴身阴阳师\",\"description\":\"身为风水师高家独子兼花圈店老板的高赫，为了赚钱给妈妈治病误入娱乐圈，通过明星经纪人王悦心一路为女明星，网红和主持人清除邪祟，并不断被日本风水师山口挑战斗法的故事。这不仅是一场正与邪，善与恶的较量!更是一场中日荣誉之战!\",\"second_cate\":\"男频灵异\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478266,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/13tlLYVnVCRMw0Um_xFy_vA?pwd=jv9a\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女王嫁给我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女王嫁给我\",\"description\":\"结婚三年，琳琅因得不到丈夫柳楠的爱，一气之下离婚。另一边，因为柳楠和白月光明星乔亚的绯闻，柳氏集团股票跌底。琳琅临危受命成为柳氏总裁，一路披荆斩棘力挽狂澜。而柳楠发现自己早已爱上琳琅，开启追妻之路。\",\"second_cate\":\"女频豪门、虐渣\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488846,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1ZWghAYUvHu2tkxa1Y8GUxg?pwd=ua1f\",\"online_time\":\"2024-07-05 00:00:00\",\"time\":1720108800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女王本色\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女王本色\",\"description\":\"平定外乱的森罗殿主沈凤来荣归大夏，想要给女儿沈璃一份盛世嫁妆，却发现女儿一直被女婿徐洋等人虐待，沈凤来一怒之下血洗婚礼。又发现他们背后有大靠山青云侯支持，于是沈凤来带着森罗殿众将士开始对付内乱。\",\"second_cate\":\"女频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487626,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1GGx3whYrdpampgYUgSrDHA?pwd=4jfn\",\"online_time\":\"2024-06-15 00:00:00\",\"time\":1718380800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"女王驾到前夫悔断肠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"女王驾到前夫悔断肠\",\"description\":\"索罗岛女王江紫溪权势滔天，旗下的索罗财团掌控全世界80%的资源。作为女王，她是众多小国元首争相拉拢的对象，是各国首富跪舔攀关系的无上存在。五年前，妹妹江紫冰觊觎姐姐江紫溪的权势地位，设局将其坑杀，所幸，江紫溪掉入深海，被宋君则爷爷宋振国所救。苏醒之后，江紫溪丧失记忆，在宋振国的安排下跟宋君则成婚，成为了一名家庭主妇。\",\"second_cate\":\"女频大女主\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483426,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1-i0ido1FQ4Sv-cpnnvFszw?pwd=ambi\",\"online_time\":\"2024-03-18 00:00:00\",\"time\":1710691200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"她从深渊中走来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"她从深渊中走来\",\"description\":\"女明星眼看着自己一路扶植上位的男友终于站上了梦想的舞台，男友曾允诺的求婚却没实现！取而代之的是她大尺度的床照被公映在屏幕上。女主被网暴致死的时，才做了一回明白鬼，原来这一切都是她最亲的人们设下的陷阱，重活一世，女主势要让曾经那些亲手推她下地狱的人，尝尝绝望的滋味......\",\"second_cate\":\"女频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485276,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/13J7I1SmvOUNtGsmZ2jczLw?pwd=a7g2\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"她在灯火阑珊处\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"她在灯火阑珊处\",\"description\":\"15年前，洛大山出轨被三个孩子撞破，小女儿雪珊被打晕扔下山崖，江丽看透洛大山本性，带着孩子离开。15年后，江丽已是集团总裁，每天抱着小女儿发黄的照片流泪，但雪珊其实一直都在身边。\",\"second_cate\":\"通用/寻亲\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488306,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1l2Bl9sWUYg4xAeU9KbUA5A?pwd=9rs2\",\"online_time\":\"2024-06-26 00:00:00\",\"time\":1719331200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"她在现代追驸马\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"她在现代追驸马\",\"description\":\"长公主李沐雪魂穿到现代李沐雪身上，过五关斩六将之后，终于成功追到了驸马顾以诚，正当两人要开启甜甜的恋爱时，被卷入到了一场惊天阴谋中……\",\"second_cate\":\"女频古装/现穿言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483156,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1_F0PMhx29PVuIFDnWx5fAg?pwd=fuak\",\"online_time\":\"2024-03-09 00:00:00\",\"time\":1709913600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"她是谁\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"她是谁\",\"description\":\"毕业回国前，高悦约室友沈氏千金大小姐沈岚溪外出露营，沈岚溪欣然答应，却被高悦推下悬崖害死，高悦伪装成沈岚溪回国准备继承沈氏集团。不料很快被深爱沈岚溪的男友冯天翊和闺蜜吴霏霏识破，二人决定一同演一场大戏找出高悦谋害沈岚溪的证据，冯天翊和吴霏霏找到暗恋沈岚溪多年的初中同学叶彦辰，叶彦辰心痛不已，决定帮助吴霏霏。三人配合，在沈氏集团董事长接任仪式上让假的沈岚溪绳之以法。\",\"second_cate\":\"女频悬疑\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482616,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1zIM_CZdrcwX1o_XdpCJy_g?pwd=bhkz\",\"online_time\":\"2024-02-18 00:00:00\",\"time\":1708185600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"她死后，薄爷跪在墓碑前哭成狗\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"她死后，薄爷跪在墓碑前哭成狗\",\"description\":\"六年前——乔予是双手不沾阳春水的豪门千金，娇纵任性；薄寒时是穿着廉价白衬衫的寒门才子，清贫孤冷。\\n六年后——乔予是挣扎在温饱边缘的单亲妈妈，卑微孤苦；薄寒时是屹立于全球福布斯富豪榜的风云人物，矜贵无双。\",\"second_cate\":\"女频现代，追妻火葬场，微虐，宝宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481496,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1YMASXfJvs33EpqWSlF6nXw?pwd=349w\",\"online_time\":\"2024-01-08 00:00:00\",\"time\":1704643200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"她的反击\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"她的反击\",\"description\":\"唐氏千金唐茵梦，因郑薇插足致使家庭破碎，家业被占。十五年后化名绮梦，成为丁家女仆，开始了她的反击。发现自己深爱的男人是仇人的儿子，这让她的复仇计划陷入了矛盾和挣扎。\",\"second_cate\":\"女频大女主/复仇/白切黑\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484856,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1hAd40lZx3T9rzo3O0fMS1w?pwd=penr\",\"online_time\":\"2024-04-29 00:00:00\",\"time\":1714320000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"如果爱有来生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"如果爱有来生\",\"description\":\"本剧讲述了上辈子识人不清，被渣男和渣妹联手陷害致死的慕初言一朝重生，这次她发誓再也不会放过这对贱人。强势来袭的她打脸复仇虐渣，被男主厉司寒宠上了天，她放火，他浇油。她虐渣，他护航。两人就此展开一段缠绵缱绻的甜宠爱情故事。\",\"second_cate\":\"女频重生甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479746,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1GCKE7z3Q2tVuQugFx97Hng?pwd=4rn8\",\"online_time\":\"2023-11-09 00:00:00\",\"time\":1699459200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"如果眼泪记得你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"如果眼泪记得你\",\"description\":\"临近毕业，唐璐的母亲因被追债导致车祸，她不得已要带着母亲出过治疗，庞大的压力下她不想拖累男友封煜，假装出轨分手，殊不知，封煜本就是集团继承人，他发誓要报复这个嫌贫爱富的女人。五年后，他设计唐璐入职，但真正面对唐璐的时候，封煜却发现，他只想唐璐回到自己身边。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478626,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1e-OiCYKRFz42I43MyddHbQ?pwd=gaj3\",\"online_time\":\"2023-09-25 00:00:00\",\"time\":1695571200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"如果还能遇见你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"如果还能遇见你\",\"description\":\"温情为救陆晏时答应父亲联姻，陆宴时成首富却恨透抛弃他的温情，得知陆宴时已订婚，温情决定独守秘密带大两人孩子，陆宴时在报复后因不忍心而收手，真相浮出水面，温情也即将离世，陆宴时宁与天下为敌也要护她周全。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484376,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1ukSvaG3GFvNcHjecNmaDYQ?pwd=1tvm\",\"online_time\":\"2024-04-12 00:00:00\",\"time\":1712851200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"如果重回到1991\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"如果重回到1991\",\"description\":\"一个年轻时一念之差害死老婆、孩子害好兄弟家破人亡的浪子，被当年辜负的兄弟杀死后回到90年代从头再来终得圆满的故事。\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485766,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1eOqniD-lQEca-r0xqFkpDw?pwd=4379\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"妄念\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"妄念\",\"description\":\"女主幼年时家人惨遭迫害，化名季柠嫁给仇人，重新以夫人身份回家，游走在这对貌合神离的父子之间，她发现原来墨然的真实身份并不是墨谨言的亲生儿子。同处一个屋檐下的假继母和假儿子争锋相对又爱欲交织……\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483506,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1WCqkqI9qfZ48kzLDsN5-Nw?pwd=wmxk\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"妈妈出车祸后我重生了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"妈妈出车祸后我重生了\",\"description\":\"贺晴天为了救母，答应成为苏大强的女朋友，却在为其产下一女后被抛弃。在强逼利诱之下，苏家得到了苏青的抚养权。李紫嫉妒贺晴天，找到李铁柱拿小苏青哄骗贺晴天，却意外造成了车祸，贺晴天被撞成为疯子，错过了小苏青相见。小苏青却眼睁睁的看着母亲受到迫害，一颗仇恨的种子从那一刻种在了心底。\",\"second_cate\":\"女频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484806,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1YMjOO9eWQMcl4UiYrKIrCQ?pwd=p265\",\"online_time\":\"2024-04-27 00:00:00\",\"time\":1714147200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"妈妈别哭\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"妈妈别哭\",\"description\":\"母子二人相依为命，历尽千辛万苦，最终成为彼此所能依靠的参天大树，凡是过往，皆为序章。\",\"second_cate\":\"女频家庭伦理\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485826,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1txsG_6EpBokTNYq87q7UqA?pwd=u1z2\",\"online_time\":\"2024-05-25 00:00:00\",\"time\":1716566400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"妈妈我是女儿啊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"妈妈我是女儿啊\",\"description\":\"沈知意幼时在集市上和家人走丢，十八年后就在林家人即将认回她的时候被林思媛冒领身份，林家人更是纵容假千金林思媛对沈知意处处刁难和羞辱，好在傅明熙护着她，最终真相大白，林家人后悔不已，寻求沈知意原谅。\",\"second_cate\":\"女频苦情/亲情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487766,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1e3H2CjWaO3oV-NyMbMICjQ?pwd=e5i7\",\"online_time\":\"2024-06-18 00:00:00\",\"time\":1718640000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"妈妈请爱我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"妈妈请爱我\",\"description\":\"苏凝原是苏家丢失多年的千金，却意外在孤儿院以养女身份被领养至苏家。苏父去世后留下抑郁疯癫的苏母，与此同时也是孤儿院出身的苏倩，利用苏凝丢失的玉佩，假冒千金获得苏母的信任，苏凝为了保护苏父的产业找回真千金身份，一场真假千金的争夺战开始。\",\"second_cate\":\"女频亲情、母女、恋爱\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484776,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1QNh-XJb9xX1L2cHDT827Iw?pwd=mvvn\",\"online_time\":\"2024-04-27 00:00:00\",\"time\":1714147200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"妈我给您复仇了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"妈我给您复仇了\",\"description\":\"故事讲述了女主黄欣瑶，为寻找二十年前母亲被骗至山村的真相，潜伏村庄内，一步步揭露村内人民的人心黑暗，在潜伏中，黄欣瑶利用聪明才智对抗邪恶势力，让反派自食恶果，最终遭受法律制裁，之后，黄欣瑶回到将母亲骗至山村来的林珊身边，同样智取得到林珊全家的犯罪证据，将其一举歼灭，终于，黄欣瑶亲手将曾经伤害过自己母亲和自己的人都送进了监狱，也成功收获爱情，拥有美好结局。\",\"second_cate\":\"女频乡村复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482746,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1mc7Q50xN8L--d0o372yZ7g?pwd=wciy\",\"online_time\":\"2024-02-26 00:00:00\",\"time\":1708876800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"妖狐送我 金光宝眼\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"妖狐送我 金光宝眼\",\"description\":\"古玩店小职员梦中遇到美女叫他恩公，转眼却被美女变狐妖给吓醒，醒来后却依旧遇到噩梦一般的现实，老婆不光给他戴了绿帽还卷走了他的存款，妹妹急需医药费他却被打得头破血流，当他在最低谷的时候才发现，原来，狐妖真的来报恩了。\",\"second_cate\":\"男频都市鉴宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478126,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/120oUGO7mt-2NAYOjU33rng?pwd=2h9u复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-31 00:00:00\",\"time\":1693411200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"妻子再原谅我一次\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"妻子再原谅我一次\",\"description\":\"叶鼎天，全球首富，他的老婆却靠捡垃圾为生，女儿还被人拐卖掏心挖肺！女儿去世是叶鼎天一生的痛！他遗憾死去，没想到，一睁眼回到了二十年前，那是女儿被拐卖的那一天！\",\"second_cate\":\"男频重生\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482216,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1efUW_yuU7vNqwcgX0ZHw1A?pwd=xhc7\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"妻子归来的秘密\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"妻子归来的秘密\",\"description\":\"本故事讲述了富家千金夏西，上一世眼盲心瞎，被渣男和坏心闺蜜欺骗陷害，不仅父母被害，更被渣男闺蜜残忍虐打，最终蒙冤惨死。重活一世，夏西发誓要手撕那对狗男女，更重要的，是补偿上辈子那个明明只手遮天却为救自己而甘愿赴死的男人。\",\"second_cate\":\"女频逆袭、复仇、甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482486,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1OW5yPYaGOnXpOECh9QAP8g?pwd=29pf\",\"online_time\":\"2024-02-15 00:00:00\",\"time\":1707926400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"妻子的绝境反击\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"妻子的绝境反击\",\"description\":\"周玫原以为她是这个世界上最幸福的女人，可接二连三的意外，让她意识到所有的幸福都是假象。有人要杀她！在寻找凶手的过程里，也让周玫看到了枕边人的真实模样。在一次次的较量中，看谁才是赢家。\",\"second_cate\":\"女频悬疑、言情、复仇、爽剧\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486186,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1Pb_WYupHe5xno8nVpgBc5w?pwd=zc2g\",\"online_time\":\"2024-05-31 00:00:00\",\"time\":1717084800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"娇娇王妃她脸红心跳\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"娇娇王妃她脸红心跳\",\"description\":\"水洛蓝因医学实验失败后机缘巧合穿越回古代成为钰王府的王妃，冷钰遭人陷害瘫痪在床三年也人之将死，在水洛兰的治愈和陪伴下，两人互生情愫，并将王爷多年腿疾治好，两人也找到当年的真相，洗清冤屈，报仇雪恨。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484136,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1HNZv1u9eoDWRaHv2ZXgVcA?pwd=9wcj\",\"online_time\":\"2024-04-04 00:00:00\",\"time\":1712160000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"娘娘出征寸草不生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"娘娘出征寸草不生\",\"description\":\"女将军江雪位扶心爱之人李清玄登上皇位。而后因为撞破李清玄与亲妹江荧的丑事，被赐死，死前发誓报仇。一直钦慕江雪的小温侯沈渊杀上金銮殿，与李清玄决一死战，两人同归于尽。此后，江雪与沈渊双双重生。\",\"second_cate\":\"女频穿越、重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485436,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1D8aJlB4tm71toFSS3tgKGA?pwd=gg6u\",\"online_time\":\"2024-05-19 00:00:00\",\"time\":1716048000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"娱乐天王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"娱乐天王\",\"description\":\"十年无私付出，在坠落高楼时，萧玄才看清楚心上人林薇薇的丑陋面目。当再次睁开眼，重回十年前放弃成为歌手的节目中，这一次他不再相信林薇薇编织的爱情陷阱，重拾音乐，用十年的积累，打造属于自己的神话。\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485056,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1fHXNlUmbcrGTaFad0vzBLg?pwd=usci\",\"online_time\":\"2024-05-04 00:00:00\",\"time\":1714752000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"婚后强宠，总裁大人超给力\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"婚后强宠，总裁大人超给力\",\"description\":\"遭遇家族破产，父亲又突发心脏病病危入院，亲戚漠视，最终林云溪只能以出卖尊严的方式换取父亲医疗费用，在大伯一家的陷害下，为了自保和傅斯尘定下合同婚约成为‘假夫妻’，在与傅斯尘相处过程中慢慢喜欢上他，而在傅斯尘想要对她真正表白那晚，林云溪提出了离婚，傅斯尘赌气答应，直到傅斯尘母亲与林云溪见面解开误会，傅斯尘又重新追回了林云溪。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479016,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1fn6eEuXTW8pc29BK04tDZQ?pwd=hghi\",\"online_time\":\"2023-10-06 00:00:00\",\"time\":1696521600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"媳妇每天都想陷害我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"媳妇每天都想陷害我\",\"description\":\"纨绔子弟叶天与苏芸一家有着杀母之仇，每次见到苏芸，都会当街调戏，苏芸愤怒不已。后叶家破产叶父将叶天抵押给了苏芸家当赘婿，两人成欢喜冤家。最终叶天报仇雪恨，与苏芸修成正果。\",\"second_cate\":\"男频豪门/赘婿\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488746,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"链接：https://pan.baidu.com/s/1Z04DzR4BXmvWgLyFDfnxUg?pwd=41vi\\n提取码：41vi\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"2024-07-03 00:00:00\",\"time\":1719936000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"子规声声\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"子规声声\",\"description\":\"抚养桑雨的爷爷意外死亡，线索指向杜家！在查凶过程中，桑雨发现，当年竟被亲生父亲和小姨子一起当死胎丢弃！二人还育有一女，在杜家鸠占鹊巢。后来，生母也被几人逼疯毒哑，桑雨黑化复仇。\",\"second_cate\":\"女频复仇/亲情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487906,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/15pla-mtO6akjym6sumJfCQ?pwd=kqiy\",\"online_time\":\"2024-06-20 00:00:00\",\"time\":1718812800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"季总他怎么可能喜欢我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"季总他怎么可能喜欢我\",\"description\":\"总裁因无子出国治疗，飞机上竟看到缩小版自己，他怒吼：你妈妈呢！\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477736,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1bVDXvLCBHHiwJIYINXQnOA?pwd=42fa复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-15 00:00:00\",\"time\":1692028800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"孤独又灿烂的我们\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"孤独又灿烂的我们\",\"description\":\"陈荨是远近闻名的“扫把精”，只要靠近她的男生都会莫名其妙的倒霉、受伤，甚至意外死亡。陈荨因此被视为不祥，被所有人疏远欺辱。殊不知这一切，都源于一场千年前的誓言。此时，誓言中的另外一位重要人物，战功赫赫的异种将军楚殇，醒了。他要来找他的妻子，陈荨……\",\"second_cate\":\"女频奇幻爱情 轻喜 甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483776,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1XfYEuS2TV9pPMh7Naj4q5Q?pwd=svuu\",\"online_time\":\"2024-03-25 00:00:00\",\"time\":1711296000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"孽徒住手\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"孽徒住手\",\"description\":\"叶擎苍一家三年前被人屠灭满门后被妖姬救下收为徒弟，三年之期已到，叶擎苍功法大成，便下山报仇，最重大仇得报，还收获了爱情。\",\"second_cate\":\"男频高手下山、复仇\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486716,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1lL072b9t96x10PGaORY3TQ?pwd=spdj\",\"online_time\":\"2024-05-31 00:00:00\",\"time\":1717084800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"它喵的，我才不要做女一\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"它喵的，我才不要做女一\",\"description\":\"当红顶流女明星宁宛看剧本时，意外穿成了书中的恶毒女配钟舒宁，并正巧赶上了钟舒宁即将给原书男主谢运宸下药，逼迫他娶自己的狗血桥段。知晓全文剧情的钟舒宁，对谢运宸的渣男行径厌恶至极，果断逃离谢运宸，和反派大佬穆廷深闪婚。原本钟舒宁只是想利用他摆脱谢运宸，谁知穆霆深同她一起来参加恋综，在两人相爱相杀的相处过程中，穆廷深对她产生好悉，不仅三番两次拒绝了她离婚的请求，还开始了霸气护妻模式。就连谢运宸，在看到钟舒宁的转变后，也转变了对她的态度。\\n原书女主纪雅静妒火中烧，不断陷害钟舒宁，并捏造事实让钟舒宁陷入千夫所指的境地。为了避免自己走向原著的悲惨结局，钟舒宁霸气还击，揭穿了白莲花伪善的真面目，完成了从黑莲花到大女主的身份逆袭。\",\"second_cate\":\"女频都市闪婚\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479366,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/136yZhgVbw5mX66nb_IMxhg?pwd=446f\",\"online_time\":\"2023-10-19 00:00:00\",\"time\":1697644800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"守护你直至云开月明\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"守护你直至云开月明\",\"description\":\"付时宜被继母卖给京都首富白家，与植物人白景霆结婚，白景霆曾对付时宜有救命之恩，付时宜心甘情愿，悉心照料。付时宜被前男友白津祎欺压，白津祎想要和付时宜联手害死白景霆被拒，因此处处针对付时宜，在付时宜被羞辱被责罚的时刻，白景霆醒了过来……\",\"second_cate\":\"女频甜宠/植物人\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482066,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1gat8CUZ5pRWPKiIcD25TRA?pwd=4nfr\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"完蛋！我被房客包围了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"完蛋！我被房客包围了\",\"description\":\"西北兵王秦风退役归来，因醉酒与白锦曦发生一夜情，被其记恨。但秦风退役后所继承的别墅里，白锦曦竟是那里的房客，同住的还有她的三个性格各异的好姐妹，啼笑皆非的合租生活也因此拉开序幕...\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486386,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1ApWsEZhneKJKQk9jej_XCA?pwd=gs1f\",\"online_time\":\"2024-04-30 00:00:00\",\"time\":1714406400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"宝宝来自六年后\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"宝宝来自六年后\",\"description\":\"男女主相亲时交恶，来自六年后的儿子出现使他们不得不产生联系。许小乔向父亲状告妹妹未婚先孕，周清鹤救场，两人感情升温。小朋友回六年后见到爸爸妈妈。男女主:现在知道爸爸妈妈为什么结婚了吗?小朋友:因为我！\",\"second_cate\":\"女频/霸总/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488266,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1m5ck28A8FKnqx9d2aWLC_A?pwd=r2es\",\"online_time\":\"2024-06-26 00:00:00\",\"time\":1719331200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"宠婚来袭\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"宠婚来袭\",\"description\":\"宋安乔醒来，发现自己身处豪宅手脚被缚，被威胁五日之内必须解除婚约。原来母亲背着宋安乔收了楚家两千万，私自给宋安乔领了结婚证！宋母一直对儿子格外偏爱，为给儿子治病，居然把宋安乔给“卖了”！无奈之下，宋安乔只得去找楚非远商议“离婚”。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484446,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/10ivjHrnEB7HJVr88wOH25g?pwd=3ube\",\"online_time\":\"2024-04-16 00:00:00\",\"time\":1713196800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"宠爱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"宠爱\",\"description\":\"对女人过敏的大佬墨冷渊捡回来个女孩后将她宠翻天！ “她手疼不疼？还不多派几个人帮她！”“我夫人是乡下来的，谁都别欺负她。” 大叔霸宠小可爱，小可爱洛樱也治好了大叔瘫痪的腿。众人一层层扒小姑娘的马甲，发现她是玄门大佬，医学圣手，众人瑟瑟发抖：这谁敢惹？只好看着浓情蜜意的二人日日磕糖。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480976,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1kgdgCQW8q6-7FD-z1GZl2g?pwd=7mvn\",\"online_time\":\"2023-12-21 00:00:00\",\"time\":1703088000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"审判\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"审判\",\"description\":\"杀死敌国首领神主宙斯，捣毁灭世组织，救大夏亿万百姓于水火之中的民族英雄，战神秦天，却被当做叛国贼缉拿回国。女儿秦木兰亲手抓捕秦天，并带着大夏亿万百姓，抽取秦天的记忆，公开直播，要审判秦天的罪恶。随着记忆的抽取，曾经抛妻弃女，害死妻子，杀害恩师镇国候，坑杀大夏十万龙卫，出卖国家，投敌叛国的真相逐渐被揭露。最终秦天为保护国家而死，全民痛苦不已。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482236,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Rxfc3gd-b9uftgtnVhs-PA?pwd=yync\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"宫先生你家四宝抄家了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"宫先生你家四宝抄家了\",\"description\":\"大婚前夜遭遇双重背叛，冷惜月酒吧买醉误将总裁当服务员把他睡了。六年后冷惜月带四宝回归，发现孩子们父亲是宫氏集团总裁宫心逸。宫老太太得知冷惜月诞下四女喜不自胜，宫心逸也趁机求婚，一家人在一起幸福生活。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485076,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1crJM3m55b_0bChtCNm9QeQ?pwd=2ftn\",\"online_time\":\"2024-05-06 00:00:00\",\"time\":1714924800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"寒天尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"寒天尊\",\"description\":\"叶峰母亲惨遭陷害成为叛国贼，叶峰含恨远走海外积攒实力为母澄清，归来时母亲却已去世。叶峰一方面启动世纪葬礼为母安葬，另一方面，他誓要查出真相，为母报仇!\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477886,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1JsspAtKtTVHnEcuof6N7kw?pwd=xgdg\",\"online_time\":\"2023-08-19 00:00:00\",\"time\":1692374400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"寒门贵女\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"寒门贵女\",\"description\":\"十五年前，王喜乐被生父贩卖，中途逃走遇王富贵收养，五年时间王喜乐逆袭成为了金融女王，再次回归时，竟遇到养父王富贵被同村恶霸欺辱，一起的起因竟是王喜乐被谣传国外卖身，讥笑时，王喜乐带着豪车衣锦还乡。\",\"second_cate\":\"女频现代/亲情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487236,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":24,\"material\":\"https://pan.baidu.com/s/1Zl34Qe7ExQ6hioVet2ojuw?pwd=eann\",\"online_time\":\"2024-06-08 00:00:00\",\"time\":1717776000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"对不起姐就是豪门\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"对不起姐就是豪门\",\"description\":\"千金大小姐楚柠为爱隐姓埋名。谁料凤凰男为和豪门千金联姻把她多年付出贬的一文不值。楚柠认清真相华丽回归。渣男一家讨好！楚柠：姐这豪门与凤凰男无缘。与楚柠有婚约的男人出现：我是世界首富，嫁我，门当户对。\",\"second_cate\":\"女频/霸总\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488706,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1B9cdYlB62Kw8_q4HFZXr8g?pwd=b1b3\",\"online_time\":\"2024-07-02 00:00:00\",\"time\":1719849600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"对不起请让我再次爱你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"对不起请让我再次爱你\",\"description\":\"山村刁妇张翠娥进城时，偶然撞见了环卫工人沈忆及其女儿沈知念，见知念年纪虽小却很勤劳，于是将知念拐回山里成了自家童养媳，十五年后，已成首富的沈忆不忘找女，并意外在购买土地时选中了知念被拐的山村。\",\"second_cate\":\"通用寻亲逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486116,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1G1H7V146W8y6jpjSaUTZsw?pwd=23ci\",\"online_time\":\"2024-05-30 00:00:00\",\"time\":1716998400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"寻子追凶\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"寻子追凶\",\"description\":\"雷婷和雷万钧本是对普通夫妻，不料因高三女儿雷雅被大人物抓走，而卷入一起拐卖人口，贩卖器官的恶性组织中，原是大人物需要雷雅的肾脏骨髓救助自己小儿子。虽历经险难，但也从未放弃，直到得知大人物原来是世人眼中的大善人首富，誓要救回女儿，向世人揭穿首富的真面目，雷婷万钧要如何救出女儿？女儿还活着吗？首富恶行，到底能否昭告天下？\",\"second_cate\":\"通用亲情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487796,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1VK0RzGf_w7ToCoXtkDgJEw?pwd=qd3v\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"将军大人饶命啊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"将军大人饶命啊\",\"description\":\"四好青年苏云璃追剧时意外穿越，成了剧中荒淫无道的祸国公主，并在自己的榻上被男主萧逸寒一箭穿心。再次睁眼后苏云璃没有回到21世纪，反而重生在了这部剧的第一集。为了避免未来被萧逸寒杀掉的命运，她决定助力萧逸寒成为大将军，并且成全他和官配白璎璎，可是故事并没有按苏云璃的美好期望发展，她不知道其实萧逸寒也重生了。前世萧逸寒虽然杀了女魔头苏云璃，但是自己也毒发而亡，重活一次，他决定趁早下手，成为离苏云璃最近的人，然后找机会杀了她……\",\"second_cate\":\"女频古代言情穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483366,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1qMJwK1m2ZWR5sw8BnDjtYw?pwd=2fq4\",\"online_time\":\"2024-03-15 00:00:00\",\"time\":1710432000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"将军夫人不好惹\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"将军夫人不好惹\",\"description\":\"本剧的主人公沈娇前世是个英姿飒爽，巾帼不让须眉的女将军，却因嫁错了人，最终被打了败仗的丈夫坑杀于阵前，其麾下上万精锐士兵也纷纷丧命。含恨而亡的沈娇没想到上天再给了她一个机会，让她再次回到了一切尚未发生的时机，这一世，沈娇发誓要改变命运，挽救为她而死的所有人的生命和国家的命运，正所谓宝剑锋从磨砺出，梅花香自苦寒来，最终沈娇以一己之力改变了悲剧，并在此过程中收获一段甜蜜的爱情。\",\"second_cate\":\"女频古言重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479716,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1E5wdVCTVZuIwQlg2MqUFiw?pwd=cbcp\",\"online_time\":\"2023-11-09 00:00:00\",\"time\":1699459200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"尊龙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"尊龙\",\"description\":\"男主江凡身怀绝顶医术，结婚后主动做家庭煮夫,然在前妻心里不值一文反被当成无法依靠的男人，坚持离婚，这时女主请江凡出手救爷爷，并愿意以身相许，神药培元丹出世成功救人，却被前妻秘书抢走，前妻献药给江城大佬却差点害死夏老，江凡及时救人仍被前妻误会是阴谋……\",\"second_cate\":\"男频都市神医\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482576,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1KKvKK8W8bFBepdeSBMDJ9g?pwd=bi9j\",\"online_time\":\"2024-02-18 00:00:00\",\"time\":1708185600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"小乔的烦恼\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"小乔的烦恼\",\"description\":\"打工人小乔遭遇车祸，穿越成了乔家大小姐乔倚楣，乔大小姐为了嫁给游式总裁使出了百般花招，却把自己作死了。小乔一朝穿越成大小姐，立马展开享乐模式，却被游总抓到把柄，威胁她帮助自己，真正解除婚约……\",\"second_cate\":\"女频甜宠 轻喜\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481476,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/15OBQRnK62fVnDRvk0aab0Q?pwd=usce\",\"online_time\":\"2024-01-08 00:00:00\",\"time\":1704643200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"小屋醉暖风\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"小屋醉暖风\",\"description\":\"惊！被打压的卑微实习生竟是首富夫人——首富夫人要做独立女性，化身卑微实习生被处处霸凌，儿子为给妈妈撑腰，用零花钱买下公司后竟被他人顶替身份耀武扬威，来看真夫人如何打脸虐渣冒牌货。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486136,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1RIaebaOQGF-jWNd7MY4FzQ?pwd=xhwq\",\"online_time\":\"2024-05-30 00:00:00\",\"time\":1716998400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"少帅夫人茶又媚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"少帅夫人茶又媚\",\"description\":\"现代影后慕清予穿越成为民国富商慕家二小姐，因外公曾帮过大帅，自幼与少帅订下娃娃亲，长相甜美，性格机敏、果敢、善于伪装演戏。慕清予穿越过来陷入被继母和妹妹迫害的困境，卖傻装瞎机智化解眼前麻烦，并和隐瞒身份的未婚夫少帅纠缠上，两人共同经历许多困难和生死考验后终于幸福地在一起。\",\"second_cate\":\"女频民国 甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483326,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1g--pwuWZWZlSC78cSiIbww?pwd=ngn2\",\"online_time\":\"2024-03-14 00:00:00\",\"time\":1710345600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"少帅强宠：倒贴上门妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"少帅强宠：倒贴上门妻\",\"description\":\"陆帅府与温家联姻，没想到温家小姐温言婚前和李府公子李聿青私奔，成婚当日，陆鸣铮抬着棺材去接亲，迎回了年少时心心念念要娶的姑娘，可分别多年，他以为心上人早已背弃他，恨意的种子瞬间蹿升长大。他双目通红，将她锁进那口棺材里。“言言，既然你的心不属于本帅，那你的人归本帅，陪本帅一起死吧！” \",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479136,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/15ja540gIW9KsRzEeLID-bg?pwd=9ph5\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"少帅的心尖宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"少帅的心尖宠\",\"description\":\"江城富商千金楼心月遭未婚夫赵澜与庶妹楼依依背叛，被推下高楼重生。她利用前世记忆，巧妙反击赵澜和庶妹，并与江城少帅沈夜达成契约婚姻，二人历经诸般险阻后心意相通，终得幸福。\",\"second_cate\":\"女频民国背景(非穿越、重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487266,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1bDglohVMMxqdV4SQwzXA2w?pwd=499d\",\"online_time\":\"2024-06-08 00:00:00\",\"time\":1717776000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"崛起之我妈是首富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"崛起之我妈是首富\",\"description\":\"易瑶一直以为自己是被抛弃的孤儿，在未来婆婆家受尽欺辱无力还击。其实易瑶的亲生母亲慕容曦月，是全球顶级财团的霸道总裁。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478086,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/15Y22lvjVm4PiCoVdX_tm3g?pwd=nksh复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-29 00:00:00\",\"time\":1693238400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"崛起从卖大力丸开始\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"崛起从卖大力丸开始\",\"description\":\"叶星辰机缘巧合下成为沈家赘婿。一直以来用大力丸为自己天生废脉的老婆洗筋伐髓，让沈玉瑶成为了荒古圣体。三年后叶星辰恢复修为，准备以书院夫子的名义收沈玉瑶为徒，不料沈玉瑶决定与叶星辰离婚。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485586,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1yCJj7WZU91aqC2g11Z2ujg?pwd=j7pi\",\"online_time\":\"2024-05-22 00:00:00\",\"time\":1716307200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"崛起从回村开始\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"崛起从回村开始\",\"description\":\"赵出息在外兢兢业业工作十年，却怀才不遇，依然是普通人一个。而他的同学们已经各个非富即贵，尤其是班长张贺，一向看不起赵出息，甚至在回村过年时各种羞辱赵出息。饱受欺压的赵出息机缘巧合之下获得了财神系统，富可敌国！在再次遭遇张贺的挑衅、媒婆的轻视、同学的嘲讽时，决心奋起反击，用财神系统狠狠打脸张贺等人，并在此过程中结识了柳倩倩、沈如玉等志同道合的朋友。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482656,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1I3sVE6AAgxUMnaeX0ipD-Q?pwd=atj9\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"崛起从工厂开始\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"崛起从工厂开始\",\"description\":\"林飞在工厂兢兢业业工作十年，却屡遭上司赵腾打压，更因为得罪赵腾的心腹唐金燕而面临开除的命运。与此同时，林飞的前妻张艳洁也带着新欢来到林飞面前炫耀，人生走到低谷的林飞忍无可忍，决心不再窝囊，奋起反抗。一步步化解了赵腾的明枪暗箭，并在此过程中结识了柳雨菲、温晓曼等志同道合的朋友，一起找到了赵腾及其帮凶的罪证，将其绳之以法。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482326,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1nwZjxU3c_PTUp7K4G88KMA?pwd=8hef\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"崛起从掌控时间开始\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"崛起从掌控时间开始\",\"description\":\"普通快递员李墨的目标是凑齐买房首付和彩礼迎娶宁如月，在偏僻城郊正赶上长生殿主渡雷劫，帮助老殿主顺利渡过雷劫，李墨因此被老殿主收为关门弟子，传授长生殿功法，继承长生殿主之位并安排师姐青鸾尽全力辅佐李墨。\",\"second_cate\":\"男频都市、奇幻\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488426,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1beqjlO6Ri40Tq9faSBKprA?pwd=y47i\",\"online_time\":\"2024-06-28 00:00:00\",\"time\":1719504000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"工业大摸底我上交了超级芯片\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"工业大摸底我上交了超级芯片\",\"description\":\"苏辰凭借自己努力获得的保送名额，却被别人轻易顶替，父亲辛苦研究出来的隐形涂料技术也被人窃取，两代人的恩怨，在一次工业大摸底中拉开帷幕，看重活一世的苏辰会如何反击，又怎么拿回属于自己的东西！\",\"second_cate\":\"男频穿越、重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485266,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1NRCy_QNvxM9faxT7OQKtWQ?pwd=anwu\",\"online_time\":\"2024-05-15 00:00:00\",\"time\":1715702400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"巨富：从退婚开始\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"巨富：从退婚开始\",\"description\":\"蝉联三年福布斯富豪榜第一的林万国，遭遇车祸出国治疗回归，无子的他得知自己还有个私生子——林宇，当即下令让管家兼秘书的赵楠去将林宇带回继承家产。林宇在短短几天之内，历经了解除婚约、母亲重病去世、得知私生子身世、女神被逼婚，入赘女神等人生大事，决定秘密继承家族，利用赘婿身份隐藏自己，帮助女神老婆渡过一次次危机，也一步步将因继承权多年来一直暗害他们父子的林家大伯送入监狱。\",\"second_cate\":\"男频神豪\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479486,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1-gJhtZdutA4l-zpfNxdIbg?pwd=wwb6\",\"online_time\":\"2023-10-27 00:00:00\",\"time\":1698336000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"帅哥你好丑\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"帅哥你好丑\",\"description\":\"男主是一只修炼了千年的白鹤，也是天族里最美的男子。哥哥嫉妒他美貌和才华，故意藏匿灵珠，须知仙人弄丢灵珠，会被处以重刑，还会失去千年的修为。哥哥故意将其错降到以丑为美的罗刹国，女主招亲擂台上，又误打误撞拔出了她的青云剑，成了甄如烟的准新郎。男女主开始了契约婚姻。殊不知男主竟是女主念念不忘的救命恩人，两人欢喜冤家，调笑打闹，男女主也渐生情愫。男主因此被罗刹国重兵在握的“第一美男”赵明，视为眼中钉，被抢未婚妻，他明里暗里使绊子，甚至联合哥哥置男主于死。\",\"second_cate\":\"女频喜剧 古装 仙侠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480636,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1BHQWFbN6Ave1Ybp-_mZjUw?pwd=up5u\",\"online_time\":\"2023-12-12 00:00:00\",\"time\":1702310400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"师祖归来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"师祖归来\",\"description\":\"乾坤师祖林风为守护苍生，提前出关大败气噬月教，走火入魔，成为傻子回到家中。这三年苏雨菲对林风细心照顾。但因苏家出现变故，苏雨菲和林风的女儿林梦瑶慎重绝命寒蛊，苏雨菲只能嫁大武尊陈立峰才能为女儿续命。\",\"second_cate\":\"男频现代、武尊\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488926,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/13s-J2vkzloniDgmPkQE3Iw?pwd=8t7n\",\"online_time\":\"2024-07-06 00:00:00\",\"time\":1720195200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"带娃二婚禁欲裴总爱争宠\\u0026\\n裴总夫人偷偷给你生了两个娃\\u0026\\n总裁夫人带崽炸翻全场\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"带娃二婚禁欲裴总爱争宠\\u0026\\n裴总夫人偷偷给你生了两个娃\\u0026\\n总裁夫人带崽炸翻全场\",\"description\":\"六年前许知夏被前男友陷害，与裴淮舟意外发生关系，并生下生龙凤胎，但二人却没见到彼此的样貌。六年后许知夏与裴淮舟重逢并结婚，裴淮舟隐瞒身份，但在萌宝的助攻下两人关系逐渐升温，最终认出彼此和孩子。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488196,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1iOkP1m-QOXtZ3PqHmz_S3A?pwd=9qvd\",\"online_time\":\"2024-06-24 00:00:00\",\"time\":1719158400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"带娃离婚年下总裁要娶我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"带娃离婚年下总裁要娶我\",\"description\":\"结婚6年来，顾暖带着女儿生活在渣男老公一家算计中，贪得无厌的渣男老公却要对自己的宝贝女儿动手，顾暖决定奋起反抗，在离婚当天，在恶婆婆贬低嘲讽，一个西装笔挺的男人出现，让顾暖摆脱了命运束缚。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"\",\"update_time\":1720487286,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1w7iRwDWLn7YJnlyiED_6jg?pwd=34i5\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"带崽离婚首富千金的身份藏不住了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"带崽离婚首富千金的身份藏不住了\",\"description\":\"夏之晴是清洁工，这天她照常去接孩子，结果被老同学欺辱，路上一排豪车驶来，曾经抛弃了自己和母亲的爸爸成了首富，夏之晴不信，夏之晴父亲给了张黑卡离开，夏之晴带孩子去高级饭店，被池倩欺辱，夏之晴拿出黑卡却刷不出来，池倩让她舔鞋，夏之晴为了孩子只能照做，这时夏之晴爸爸的部下赶来打脸，夏之晴这才知道自己真是首富的女儿，开展了一系列的打脸之路。\",\"second_cate\":\"女频大女主复仇\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480266,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1q1QE5zUm_R8RC08xi_5T6Q?pwd=ripf\",\"online_time\":\"2023-11-22 00:00:00\",\"time\":1700582400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"带球跑后我成男神白月光\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"带球跑后我成男神白月光\",\"description\":\"时吟爱上老板顾寒迟。一场宴会遭受顾家人刁难耻闹后，时吟选择继承家业。三年后时吟成为博兴集团的CEO。顾寒迟求得时吟原谅，两人情感极具升温。突然顾寒迟发现母亲杨初竟是当年害死时吟兄长的凶手。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487676,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1UfCBiw3eTopF3RH2M-iEaA?pwd=m723\",\"online_time\":\"2024-06-16 00:00:00\",\"time\":1718467200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"带着孩子嫁入豪门\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"带着孩子嫁入豪门\",\"description\":\"多年前男女主被人下药发生关系。七年后，女主为解决女儿户口问题和男主在民政局相遇，二人决定拼婚。男主帮女主解决了工作的问题，女主也为男主家庭的纠纷做了努力。几经波折后二人带着女儿开始了新的幸福生活。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720484266,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1GGajXMbvLAauX7bw_r_2wA?pwd=3w3s\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"年下弟弟太撩人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"年下弟弟太撩人\",\"description\":\"女总裁苏楠一次酒醉后，不小心潜了特助傅星，原以为花钱就能打发的小奶狗，实际上却是大佬，而苏楠竟还跟他闪婚领证了！说好的合作关系也在小奶狗的步步紧逼中逐渐变了味。苏楠：你到底想干嘛？！傅星：你。\",\"second_cate\":\"女频现代言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484086,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Xzymp8SRzEtclbF6FAYASA?pwd=qsnw\",\"online_time\":\"2024-04-03 00:00:00\",\"time\":1712073600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"年下总裁太会撩\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"年下总裁太会撩\",\"description\":\"设计师苏晚惨遭男友婚前背叛。酒后偶遇的服务员，真实身份竟是商业巨子陆某，志在做陆夫人的丽娜被激发，启动攻击。对诬陷打压苏晚坚强应对；但发现陆的身份并不那么简单时，倍感羞辱。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486516,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1pzq4D11VCQ-Euq0pBge3bg?pwd=gjwe\",\"online_time\":\"2024-05-16 00:00:00\",\"time\":1715788800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"幸好还有你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"幸好还有你\",\"description\":\"苏清清终于找到了自己的双胞胎妹妹苏曼，但是妹妹已经被人凌辱至死，她拿到了妹妹的日记本后才得知，这次，她要代替妹妹归来，让所有欺负妹妹的人，付出代价！\",\"second_cate\":\"女频甜宠 女强\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481416,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1vZUGyR0HG9lhgB5qOtaVrA?pwd=b4k1\",\"online_time\":\"2024-01-05 00:00:00\",\"time\":1704384000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"幸孕宠妻战爷晚安\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"幸孕宠妻战爷晚安\",\"description\":\"燕城四大家族之一的严家长女严铮翎，刚和寰亚集团总裁战寒爵订婚就出了车祸，并重生到洛家弃女洛诗涵身上。因担心战寒爵不相信重生的说法，她用洛诗涵的身份嫁给了战寒爵，却遭战寒爵嫌弃，她一气之下向战寒爵借精生子，没想到竟生出一胎三宝，洛诗涵将大宝留给战寒爵后，将二宝三宝拐走跑路，惹得战寒爵全城通缉。五年后，洛诗涵带着两宝回国，竟然在机场就碰到了战寒爵……\",\"second_cate\":\"女频总裁\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482706,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1oXdyi8Tk-Hs3QpgZuwYF8g?pwd=q7kd\",\"online_time\":\"2024-02-24 00:00:00\",\"time\":1708704000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"延迟告白\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"延迟告白\",\"description\":\"亲爹漠视，继母迫害，池音音走投无路，上门逼婚江城权贵顾西程！新婚当天被丈夫发现婚前失贞，认定她私生活混乱。怀胎十月，池音音生下孩子，签字离婚净身出户。经年后，池音音带着孩子回到了江城。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485606,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/19Dl8mJz8uJF3_K1cd3nSLQ?pwd=2krv\",\"online_time\":\"2024-05-23 00:00:00\",\"time\":1716393600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"开局一身无敌大招\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"开局一身无敌大招\",\"description\":\"边北村山神庙镇守家族罗家的大少爷，万年难见的荒古圣体，因荒古圣体成长过程中会遭到天妒，容易中途夭折，所以被父亲罗峰从小欺骗没有修炼天赋。但实际上，修行一日千里，早就达红尘真仙，就差最后一道红尘历练，化凡为仙。罗峰借着蓝秀儿来找罗天退婚的机会，骗罗天下山历练，因担心罗天借实力乱来，达不到历练的效果，依然隐瞒，这导致罗天下山之后，一直以遵纪守法的小山民的定位处事，造成了许多反差。\",\"second_cate\":\"男频逆袭 \",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482366,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/18_OwW51rF7oOEsF-YWLnZQ?pwd=uxsx\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"开局三个崽，我在豪门当后妈\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"开局三个崽，我在豪门当后妈\",\"description\":\"沈暖暖和付云霆发生一夜情，并生下孩子，沈寒雪从中作梗抢了沈暖暖的三胞胎。六年后，沈暖暖和付云霆因意外再次相遇并闪婚，付云霆隐瞒身份，女主真诚相待。经过一系列困难，两人最终走到一起。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484866,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1X-nkKB6vCtxwtEIBcFjB6g?pwd=exqf\",\"online_time\":\"2024-04-29 00:00:00\",\"time\":1714320000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"开局九个仙女师傅\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"开局九个仙女师傅\",\"description\":\"大师傅，琉璃女帝，二师傅，九尾天狐，这样的美女师傅有九个！\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481876,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1UtojM1bVveEK5QRJR_EZiw?pwd=93f5\",\"online_time\":\"2024-01-26 00:00:00\",\"time\":1706198400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"开局修炼十万年我在人间已无敌\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"开局修炼十万年我在人间已无敌\",\"description\":\"十万年前，道祖林逸与师尊叶轻舞被困天劫杀阵结为道侣，叶轻舞为救林逸身死道消，十万年后叶轻舞重生人间，林逸下山踏上寻找叶轻舞的路途。\",\"second_cate\":\"男频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487436,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1N1BvllwsHTtYFppLZnrygQ?pwd=jcxe\",\"online_time\":\"2024-06-13 00:00:00\",\"time\":1718208000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"开局先杀霸总\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"开局先杀霸总\",\"description\":\"顾昭昭，江湖第一杀手，被算计谋害后穿越到现代，需要杀死霸总裴观才能回到原来的世界。顾昭昭认为小菜一碟，但她万万没想到这个霸总挺难杀啊。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485166,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1Lu0B6gzvaStbDEtsTg2qcw?pwd=e1gi\",\"online_time\":\"2024-05-11 00:00:00\",\"time\":1715356800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"开局官府发媳妇\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"开局官府发媳妇\",\"description\":\"突然穿越到了古代，饭都吃不饱怎么办？什么，男人快被打完了，官府发了个漂亮老婆，明年必须生孩子？什么！这是什么鬼设定！没关系，学好数理化，走遍天下都不怕！\",\"second_cate\":\"男频古装穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482926,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1V7V8BWmtHJYmOPVXQtWIvw?pwd=sz8g\",\"online_time\":\"2024-03-02 00:00:00\",\"time\":1709308800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"开局秒杀世界首富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"开局秒杀世界首富\",\"description\":\"小人物叶欢，参加相亲却遇见饭托被宰，主观意识觉醒，激活了意愿秒杀系统，开局就能秒超跑，狠狠打脸饭托女，本以为自此可以走上幸福高光的叶欢，却因为老同学洛语嫣的倾慕，遭到反派杜鹏的嫉恨，杜鹏千方百计，试图全方位羞辱叶欢，而拥有秒杀系统的叶欢，却无往不利，纵享都市，不仅抱得美人归，甚至还逐渐揭开了自己的身世之谜……\",\"second_cate\":\"男频神豪 系统 逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482676,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1JRaIklyXkk2__ToSjWeFFA?pwd=iej4\",\"online_time\":\"2024-02-24 00:00:00\",\"time\":1708704000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"开局逃婚少奶奶要翻天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"开局逃婚少奶奶要翻天\",\"description\":\"顾夕月为了查明自己父亲死亡的真相，被同父异母的姐姐顾若算计，嫁给了变成“活死人”的季司晏为妻。然而，洞房花烛，顾夕月竟意外发现了躺在床上的活死人新郎竟然是她的救命恩人。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486316,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1kqkq0OsNuP0c9XiEWwjuPg?pwd=2pee\",\"online_time\":\"2024-04-26 00:00:00\",\"time\":1714060800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"弃妃要休夫\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"弃妃要休夫\",\"description\":\"顾相思是一个温柔而善良的女性，与她共度三年婚姻生活的是一位战斗力强大的皇子萧潜。本来他们应该过上恩爱的生活，但因为权力斗争的纷扰，产生了诸多误会。有为了争夺皇位而不顾一切的皇弟，有出卖女儿以博取上司欢心的丞相顾瞻，甚至因为嫡庶之间的争斗使得庶妹顾怜月心理扭曲，恶意陷害自己的亲姐姐。最终，两人解除误会，放下利益选择了隐居，实现了美满的结局。\",\"second_cate\":\"女频古风\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478546,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1gIQSiamtLikErncatNF0Tw?pwd=8ajx\",\"online_time\":\"2023-09-15 00:00:00\",\"time\":1694707200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"张大人现在是2024年\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"张大人现在是2024年\",\"description\":\"陈国户部侍郎张镜辞，因拒绝迎娶公主遭奸人陷害，穿越到现代同名姓的傻子身上，被邻居洛晚晚寻到。没想到原本呆傻的张镜辞大变样，琴棋书画样样精通，甚至依靠手腕数次帮洛晚晚解决危机，救张家于水火，两人也在接触中互相倾心。随着回古代的时间临近，张镜辞能否会正视自己的心意，留在现代呢？\",\"second_cate\":\"女频古穿今\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483076,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1g9ffL8DQsx1qLi0nT-BNTQ?pwd=yi55\",\"online_time\":\"2024-03-08 00:00:00\",\"time\":1709827200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"弹指遮天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"弹指遮天\",\"description\":\"修罗统帅陆景退伍后，应母亲要求相亲，途中遇变故，出手并救下江城首富玉镇国。为报恩情，玉镇国欲将孙女玉朝青许配给陆景，此事遭到玉朝青激烈反对，拉了一个陌生人领证结婚以表达不满，殊不知，此人正是陆景。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486046,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1BFYoJKb-pzE1iL5QnLhJRA?pwd=ucm9\",\"online_time\":\"2024-05-29 00:00:00\",\"time\":1716912000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"当世子拥有了读心术\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"当世子拥有了读心术\",\"description\":\"他一觉醒来躺在陌生的床上，他心想这是哪里，正在这时听到外面的女人说想娶她，那简直是癞蛤蟆想吃天鹅肉，等她一会就跟他一决高下。\",\"second_cate\":\"男频逆袭古装\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478256,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1J9q6pUFYT9dUJOpitRghzg?pwd=c9qb\",\"online_time\":\"2023-09-08 00:00:00\",\"time\":1694102400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"当富贵来敲门\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"当富贵来敲门\",\"description\":\"保安鲍富突然继承了来自二叔的一大笔遗产，但继承遗产必须经过二叔的考验，负责考察鲍富的是二叔的心腹马总管，但马总管却在暗中针对鲍富，想要让鲍富的继承计划流产……\",\"second_cate\":\"男频神豪\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481446,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/15m02XCBT55Y4_xi-H7WuNw?pwd=6ckt\",\"online_time\":\"2024-01-08 00:00:00\",\"time\":1704643200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"当悲伤没有眼泪\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"当悲伤没有眼泪\",\"description\":\"她是夕紫，男友死亡，孩子被父亲谎称夭折，坚守爱情见证，成了风情万种的酒吧老板娘；八年前，双胞胎兄弟两人走上了不同的人生；也爱上了相同的女人；八年后的重逢，哥哥亦或者弟弟，再次和夕紫命中注定。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486146,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1e0kfDYlqXMhXLJBTRLP9cA?pwd=wttf\",\"online_time\":\"2024-05-30 00:00:00\",\"time\":1716998400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"当皇后穿成了豪门弃妇\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"当皇后穿成了豪门弃妇\",\"description\":\"费尽心机登上皇后宝座的许知微，竟穿越到现代变成了豪门弃妇结婚多年，时郁舟竟从未正眼瞧过许知微，郁舟开始慢慢接受并爱上许知微，却在结婚当天遭人枪杀。许知微该如何替深爱的男人报仇。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484576,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1Wjk4BRRqq9WSfnx4wYEM6Q?pwd=sjgs\",\"online_time\":\"2024-04-19 00:00:00\",\"time\":1713456000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"当穿越女遇上重生太子妃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"当穿越女遇上重生太子妃\",\"description\":\"\\\"相府嫡女苏如是倾慕太子萧则，好不容易如愿嫁入太子府，没想到遇到了同样喜欢萧则，却从千年以后的现代社会穿越而来的庶女慕容月，苏如是技不如人，最后被慕容月害死，没想到一朝重生，两人划开了新的篇章。\\n重生后的苏如是决心找慕容月报仇，将当初属于自己的一切统统夺回来，可重生一次，慕容月仍旧有萧则的偏宠，还有她难以想象的现代先进科学知识的武装。\\n苏如是一次次失败之下发现自己拥有多次重生的能力，而这一次，她势必要把输过的都赢回来！\\\"\",\"second_cate\":\"女频古代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479126,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1KV1EOiTH-i_9ApeL5E6yiA?pwd=px45\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"当草根遇见进化系统\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"当草根遇见进化系统\",\"description\":\"男主在偶然一天，他救下险被货车撞倒的女孩，自己却不慎落下终身残疾。与此同时，父亲去世，母亲住进医院，张望海无奈高中辍学。男主因为一时善意救下的女孩时空旅行者为报恩，为他绑定“人类进化系统”重启人生。\",\"second_cate\":\"男频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484906,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1ly2ZR1Qbi87YKA7x5gRKEw?pwd=1rgg\",\"online_time\":\"2024-04-29 00:00:00\",\"time\":1714320000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"彩礼谈崩后我闪婚了豪门老公\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"彩礼谈崩后我闪婚了豪门老公\",\"description\":\"因为彩礼问题，江然与谈了两年的男友魏明在餐厅争吵，与此同时，秦衍因“没房没车”被相亲对象羞辱，两人因此不小心撞到一起结下梁子。另外因为隔壁秦奶奶的撮合下，两人阴差阳错在一起。因为买房问题想秦衍借款，以“彩礼”卖给秦衍，加深了秦衍的误会。一次偶然的误会，让江然误以为秦衍为了自己得罪了大人物，在明知道是鸿门宴的情况下毅然赴约，秦衍的身份居然是隐藏的大佬……\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482476,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1jHJGqOSSSOeKgBkL_6r4Tw?pwd=71ec\",\"online_time\":\"2024-02-15 00:00:00\",\"time\":1707926400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"彪悍媳妇的八零年代\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"彪悍媳妇的八零年代\",\"description\":\"一场意外，沈伊伊穿越成为八零年代被娘家吸血的小可怜沈伊伊，当机立断和娘家划清关系，同时，在千里之外的科研基地里秦烈回归。两人相认后，沈伊伊说服秦烈支持自己做茶叶蛋生意，一起发家致富奔小康。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485996,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1NBbscHJcCs-pmxwzbl9hSA?pwd=kavh\",\"online_time\":\"2024-05-28 00:00:00\",\"time\":1716825600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"影后归来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"影后归来\",\"description\":\"知名影后江心妍被替身演员沈玫设计陷害，坠崖毁容流落国外。随后又得知丈夫病亡、女儿失踪，坠崖也不是意外！五年后江心妍改头换面，以纪以宁的身份回国，接近沈玫儿子沈清泽，开启了复仇之路。\",\"second_cate\":\"女频复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487926,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1kANB0gO0CkH9Q3FMFf6qXw?pwd=2jty\",\"online_time\":\"2024-06-20 00:00:00\",\"time\":1718812800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"影后重生顾大编剧你别跑\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"影后重生顾大编剧你别跑\",\"description\":\"金凤奖影后杨奕沫，对戏被泼了硫酸导致毁容，也连累了正在商场上与对手生死对局的父亲。走投无路的她，只能黯然走上天台，结束了年轻的一生。没想到跳楼后，她重生到了毁容前，成功晋升顶流。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486086,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Bd_FfGBqCTjVFHC8sxJiTQ?pwd=4qbv\",\"online_time\":\"2024-05-30 00:00:00\",\"time\":1716998400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"律师女王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"律师女王\",\"description\":\"年幼时，女主父母因为大桥坍塌事件被诬陷自杀，从此女主立志当一名律师，为所有不公之事发声，同时想尽办法为父母翻案，后续遇到种种艰难。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484896,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1xuRbnyN8IzpL58I4S8HCfw?pwd=kwnt\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"心劫\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"心劫\",\"description\":\"冷烟为报恩嫁给男明星华云飞，还为他捐了自己的一颗肾，导致眼盲，却因撞破华云飞跟经纪人叶璇偷情，被二人杀人灭口。意外重生后，冷烟回到三个月前给华云飞的换肾手术现场，这一次，她决定改变命运，并得到前男友隐藏富豪萧城帮助。原来萧城上一世得知冷烟死讯，悲伤殉情后，竟然也重生归来，这一对重生情侣联手合作，上演了一场完美复仇，并最终收获甜蜜爱情。\",\"second_cate\":\"女频重生/家庭伦理/复仇\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483706,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1v2lRBIGyFWjK5jvd_XLv6g?pwd=nmr4\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"心死后怀上他孩子\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"心死后怀上他孩子\",\"description\":\"从小缺爱以及眼下缺钱的秦怡不顾母亲反对嫁入顾家，不料噩梦才刚刚开始。顾墨城同外面的女人黎晓哓生下私生子，并查出患有白血病。顾墨城想利用秦怡为孩子配型。这时秦怡发现自己竟怀孕了。\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485486,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1SNGCWbQ4P3fTTnZjOe2prQ?pwd=x6s7\",\"online_time\":\"2024-05-20 00:00:00\",\"time\":1716134400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"忠犬与野蔷薇\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"忠犬与野蔷薇\",\"description\":\"沈家继承人沉云岚与顾舟携手应对沉虎一家，数次在阴谋中逃生，二人互相帮助，沉云岚顺利继承家业，调查出父母死亡真相并一起揭开了沉虎和背后杀手组织的阴谋，两个孤独的人互相依靠，成为了互相的后盾。\",\"second_cate\":\"女频商战/悬疑/霸总/双强\",\"episode\":0,\"platform\":\"\",\"update_time\":1720486986,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/12n1RpOfCcgJWIYriXs8pfA?pwd=vm5e\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"快穿之反派太宠太撩人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"快穿之反派太宠太撩人\",\"description\":\"盛暖因一次意外被穿书系统选中，成为小说里的炮灰女配，穿越到各个小世界里去拯救反派，却没想到每个世界里的反派，无论是阴郁的贫困生，还是禁欲的豪门掌权人，竟都与她原世界的未婚夫裴澈长得一模一样。\",\"second_cate\":\"女频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486266,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1ZFzhPtjYXpm7MmZAtm3rYQ?pwd=7q8a\",\"online_time\":\"2024-04-19 00:00:00\",\"time\":1713456000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"快穿之病娇男主好难撩\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"快穿之病娇男主好难撩\",\"description\":\"曲嫣作为快穿世界的任务执行者，代替原主执行任务从未失败。这次手撕渣男渣女后，却迟迟攻略不下霸总莫北霆，可她却不知莫北霆早已沦陷，莫北霆为保护曲嫣死在她怀中，两人的宿命拉扯才刚刚开始。\",\"second_cate\":\"女频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487416,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":16,\"material\":\"https://pan.baidu.com/s/1IKjMGRtVROHEQZZe6qbnMA?pwd=am43\",\"online_time\":\"2024-06-12 00:00:00\",\"time\":1718121600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"快穿： 病娇男主他又吃醋了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"快穿： 病娇男主他又吃醋了\",\"description\":\"接到新任务的女主这回穿成了一个叫曲嫣的弃妇，此次她的任务，除了报复渣男渣女，就是要撩到那个最难撩到男人！谁知这次的女主，竟然与这个男人，有了一段三生三世的缘分。\",\"second_cate\":\"女频甜宠快穿\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479266,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1mlT1fUUhodqJxp-UUKvVmQ?pwd=skny\",\"online_time\":\"2023-10-14 00:00:00\",\"time\":1697212800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"念念不忘终有时\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"念念不忘终有时\",\"description\":\"沈念念和叶谨言小时候遭遇绑架，沈念念被绑匪虐待至哑，命悬一线，意外被穷苦人家孙桂芳一家救下，取名张年年，从此流落在外二十载。长大后的张年年凭借一块玉佩，几次差点与哥哥和叶谨言相认，最终都没相认成功，阴差阳错下，张家大女儿拿到女主的玉佩，冒领了沈氏千金的身份，并对念念暗下杀手，女主被亲哥哥和养姐百般欺辱，而叶谨言却觉得眼前的女孩似曾相识。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486276,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1Z5q8x9HVarwoyM91xpLrdA?pwd=bsh2\",\"online_time\":\"2024-04-19 00:00:00\",\"time\":1713456000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"怒火狂飙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"怒火狂飙\",\"description\":\"—南荒将王林少杰，林家废弃嫡长子，携众将士低调回顾，一边协助自己未婚妻振兴家族，一边打压林家势力，亲人的不理解，爱人的担心，虎视眈眈的林家家族，将王一步一步完成大计，为自己正名，终抱得美人归。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482696,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1Ip3mVBCDmZi25BsYxXYh_g?pwd=62y1\",\"online_time\":\"2024-02-24 00:00:00\",\"time\":1708704000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"怪力甜心惹不起\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"怪力甜心惹不起\",\"description\":\"傅家新一代家主傅景同经常收到死亡威胁，“女杀手”乔叶菲的天生神力，唤起了傅景同的回忆，两人经历种种误会与趣事，将幕后黑手绳之以法。傅景同也发现了爱人就是自己的救命恩人，有情人终成眷属。\",\"second_cate\":\"女频/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488046,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"链接：https://pan.baidu.com/s/1AsJfz7ue2enEo1rgeOa3dg?pwd=ugwe\\n提取码：ugwe\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"2024-06-21 00:00:00\",\"time\":1718899200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"总裁你想和谁谈恋爱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"总裁你想和谁谈恋爱\",\"description\":\"本剧讲述了主角李想创业失败后，被表叔慧眼识珠，在他的支持下东山再起，成为了一家传媒公司的老板。经过一番努力奋斗，事业和爱情双丰收的故事。\",\"second_cate\":\"男频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487116,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/10lqDKI6ZnbdM-GYg8K_7kQ?pwd=vg87\",\"online_time\":\"2024-06-07 00:00:00\",\"time\":1717689600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"总裁大人的暖婚娇妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"总裁大人的暖婚娇妻\",\"description\":\"柳南因醉心科研不管生活被奶奶逼迫去公司上班，遇见平凡但正义感爆棚的陶乐乐，两人协议结婚排除万难后最终走在一起。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478376,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1oPDJY_SJmgec4h7LCXDjEQ?pwd=51w4\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"总裁夫人竟是全能大佬\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"总裁夫人竟是全能大佬\",\"description\":\"池元元怀了孩子与汪雨逃婚私奔，网络天才白月夕夺取对家机密，为躲避对家伤害故意扮丑隐藏身份顶替池元元嫁入传说长相丑陋身患重病的元城最有权有势的凌氏大少凌辰风。\",\"second_cate\":\"女频逆袭言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479056,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1tzyDhh9tPy0kd5E2DDhdcQ?pwd=wwg5\",\"online_time\":\"2023-10-11 00:00:00\",\"time\":1696953600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"总裁夫人，请穿上你的马甲\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"总裁夫人，请穿上你的马甲\",\"description\":\"苏可心为了调查内鬼偷偷潜入自家公司，一同入职的实习生付婧竟然假冒总裁夫人，随着苏可心身份的揭露，内鬼也渐渐的浮现出来，苏可心惊奇的发现，这件事的背后居然是自己的亲生父亲苏国立指示的，在亲情与爱情的抉择中，苏可心该如何选择？而总裁夫人的身份，究竟是苏可心的救赎还是枷锁？\",\"second_cate\":\"女频/霸总\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488696,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/18hp8CThHfXyLBWLaz-MMaQ?pwd=bcxr\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"总裁对我下手了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"总裁对我下手了\",\"description\":\"秦烈和叶汐是大学同学，两人互相喜欢多年。因二人家境相差悬殊，叶汐一直逃避这段感情。秦烈家里安排订婚，秦烈没有答应，秦母用叶汐妈妈来威胁她离开，叶汐不得已同意，却在提交辞呈时和秦烈一起摔了一跤互换身体。\",\"second_cate\":\"女频霸总、欢喜冤家\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488586,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1SvF7evPanRP3a787wykk2w?pwd=em7e\",\"online_time\":\"2024-06-29 00:00:00\",\"time\":1719590400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"总裁爸爸你跪下，宝宝求你点事\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"总裁爸爸你跪下，宝宝求你点事\",\"description\":\"不堪催婚相亲的骚扰，安然和霍司川闪婚了。她绝不会想到，这个自称是总裁保镖的霍大勇，就是霍氏集团总裁霍司川。而他的孩子霍年年和霍岁岁，就是她五年前误以为夭折的龙凤胎。误以为安然是拜金女，霍司川刻意装穷测试安然的心意。可经过一段时间的相处后，他发现安然是个善良乐观的好女孩。正要坦白时，却意外得知他的前妻假借他的名义诬陷安然抄袭...\",\"second_cate\":\"女频霸总/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487896,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/12c5exN6NtYSfNPzs3MV-0g?pwd=sejx\",\"online_time\":\"2024-06-20 00:00:00\",\"time\":1718812800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"总裁的契约女友\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"总裁的契约女友\",\"description\":\"食品公司的员工车小小，代替闺蜜去故意破坏相亲，没想到相亲对象竟然是自己的老板楚浩轩。虽然几次和老板的会面都被自己机智躲过，但是车小小在公司每天都战战兢兢。楚浩轩对车小小的业务能力非常认可，慢慢也对这个小员工产生了兴趣，但是意外的发现，车小小就是冒充的相亲对象。楚浩轩非常生气，开始用各种方法折磨车小小。但在这个过程中，楚浩轩慢慢发现自己喜欢上了车小小，于是用契约女友的方式开始了追妻之路...\",\"second_cate\":\"女频、都市甜宠、总裁\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480606,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1avHeHIQzk6PC5QIKdEa8gA?pwd=q8ge\",\"online_time\":\"2023-12-07 00:00:00\",\"time\":1701878400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"总裁镇不住少奶奶\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"总裁镇不住少奶奶\",\"description\":\"楚眠被流放到风岛立誓要对迫害她的楚家复仇。为此，在A国财阀厉天阙将她带回家中时，她选择装疯潜伏了下来。厉天阙也因为童年缺失，放手纵容了女孩。故事就在二人的互相救赎与复仇大计中，逐渐展开。\",\"second_cate\":\"女频霸总/复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485706,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1nA-ufRv2dFtZCR5grhcaHg?pwd=kq3a\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"恋曲1980\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"恋曲1980\",\"description\":\"方晓婧意外穿越回八零年，成为大队队长江磊性格恶劣的妻子，被大院众人厌恶，利用自己现代专业造型美发技术，在八零年发光发热，扭转江磊和大院众人的看法，克服种种困难开了属于自己的美发店，发家致富，和江磊解除误会，重归于好。\",\"second_cate\":\"女频穿越/年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485596,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1zy4AO2VWMa1WcBBjG99CJg?pwd=3dtq\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"恋糖时光\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"恋糖时光\",\"description\":\"本片讲述了女主苏糖在娱乐圈几经风雨，最后成功和金融大鳄秦淮在一起，获得事业爱情双丰收的故事。\",\"second_cate\":\"女频霸总、甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480486,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1b5uT98QsiwcE3LXIuufJCA?pwd=6kqf\",\"online_time\":\"2023-12-05 00:00:00\",\"time\":1701705600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"恨君不似凉州月\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"恨君不似凉州月\",\"description\":\"凉州公主阿离远嫁盛朝和亲，却发现新婚的太子是曾出现在梦里的爱人，她追寻太子许久，却发现，她和太子之间的渊源，不止是梦中的那场婚礼，这个皇宫，从来容不下她这个和亲公主。\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477776,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1O7Z68UBSqvFVRHUmtFcrBA?pwd=tedx复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-11 00:00:00\",\"time\":1691683200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"恰似一道暖阳光\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"恰似一道暖阳光\",\"description\":\"因被表姐墨雨婷陷害，千金大小姐夏天受尽屈辱，一夜之间失去所有。为了拿回所得一切，夏天走上复仇之路，幸得儿时竹马沈君临暗中帮助，夏天从此一路崛起，拿回本属于自己的一切，且和沈君临拥有完美爱情。主要剧情，围绕着夏天和陷害她的人，来回产生矛盾冲突，装逼打脸，纯新媒体风，快节奏爽文短剧。\",\"second_cate\":\"女频都市甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482986,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1XNUgdvwg8AUOInK7qy6nfQ?pwd=j9rt\",\"online_time\":\"2024-03-06 00:00:00\",\"time\":1709654400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"恰似寒冰遇骄阳\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"恰似寒冰遇骄阳\",\"description\":\"传闻他权势遮天却偏偏对她一见钟情，宠妻无下限，捧在手心怕化了\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477936,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1dHSSzaaWC9V8Fdwnzyk61A?pwd=4i2r\",\"online_time\":\"2023-08-19 00:00:00\",\"time\":1692374400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"恰好你爱我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"恰好你爱我\",\"description\":\"初见时，他是小乞丐，她是富家女孩儿，一个简单的施舍，让他牢记十年！再见时，他是高高在上的集团总裁，她是身份低微的瘸子员工，一场替嫁，筑起一段妙不可言的缘！可他没发现一直苦苦寻找的人就在枕边……她不知道一直讨厌，嫌弃自己的人，就是那个少年！直到风水轮转，他得知真相想要挽回的时候，一场意外再次让两个人分开……是缘还是孽！\",\"second_cate\":\"女频现代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483686,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1rKCxCsgBbkvwCUIw-nAeeQ?pwd=r3f6\",\"online_time\":\"2024-03-23 00:00:00\",\"time\":1711123200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"恰逢承书听雨时\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"恰逢承书听雨时\",\"description\":\"被老板拖欠工资下药，宁潇雨跟游泳教练闪婚要债，从此开启逆袭人生。不但拿了设计比赛一等奖，还顺利成为著名的MP珠宝设计师。本以为这是努力和好运的原因，没想到是因为老公根本不是游泳教练，而是MP总裁。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485566,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1KCs8MrdZu9admWqt6IwEOw?pwd=udmz\",\"online_time\":\"2024-05-22 00:00:00\",\"time\":1716307200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"恶魔天使\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"恶魔天使\",\"description\":\"大难不死的陆晚柠化身著名画家艾利老师，十年蛰伏如今回归被霸占的陆家，展开一场天使的救赎。\",\"second_cate\":\"女频复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487396,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1AMQ5AS8_xglF8_N4mwD1pw?pwd=ttcs\",\"online_time\":\"2024-06-12 00:00:00\",\"time\":1718121600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"悬崖下的女人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"悬崖下的女人\",\"description\":\"富家千金李楚晴不顾父亲的反对，嫁给了凤凰男王大铭，而这段婚姻让王大铭倍感压抑。他恨岳父对他的轻视，也恨妻子对钱不屑一顾的样子。在闺蜜乔小贝的勾引下，两人密谋把李楚晴扫地出门，夺取企业。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487406,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1pPsQiJaqaUS3so1OW47QeQ?pwd=nb1u\",\"online_time\":\"2024-06-12 00:00:00\",\"time\":1718121600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"情深不知所起\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"情深不知所起\",\"description\":\"孤儿院内,女主依依和男主石头青梅竹马，相依为命。多年后，二人先后被人领养，石头成为顾氏总裁顾北辰，依依则被普通人家收养，改名江欣雅，成为杂工。与此同时，依依的亲生母亲（第一世族秦家的新一代家主）已经得知依依的下落，想要将依依寻回。作为依依养父的江父贪慕融化富贵，便让亲生女生江新蓉顶替了江欣雅的“秦家遗女”的身份。并与毫不知情的顾北辰达成婚约。得知内情的江欣雅想要说出真相，但每一次都被继妹的男人姜浩阻止并破坏。直到秦家养子查验继承人“秦依依”的真实身份，并确定江欣雅才是真正的秦氏继承人时，顾北辰才幡然醒悟，自己苦苦寻找的人，是江欣雅，而非江欣蓉。\",\"second_cate\":\"女频霸总/都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488736,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"链接：https://pan.baidu.com/s/15L8tEsNVvCowAdUF1U0Etw?pwd=wwkz\\n提取码：wwkz\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"情深似景\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"情深似景\",\"description\":\"唐婉清曾和周景深青梅竹马定下婚约，两年前亲眼见到周进雄害了唐家的所有人，遂装失忆嫁给周进雄，伺机查清周家害人真相，收集害人证据以及唐家秘宝地图。周景深归来，发现心爱之人嫁给自己父亲，愤怒下二人不断误会争执，后帮助唐婉清查清唐家被害真相，唐婉清报仇雪恨，二人和解。\",\"second_cate\":\"女频民国言情\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482196,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1JJS83qGXZNK8HrTmBduz_A?pwd=2vcq\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"情深可抵岁月长\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"情深可抵岁月长\",\"description\":\"姜宁与霍辞的婚礼当天，霍辞大庭广众之下带着姜宁同母异父的妹妹张以沫，并声称要退婚。气愤无奈之下，姜宁只得让步答应解除婚约，却在离场时遇到了霍辞的小叔......\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485156,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1ghVUKWAt4gvHDGQDREdEWA?pwd=nddu\",\"online_time\":\"2024-05-11 00:00:00\",\"time\":1715356800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"情深深泪濛濛\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"情深深泪濛濛\",\"description\":\"苏瑜和傅斯年结婚三年，彼此相爱。然而，苏瑜的姐姐苏辞遭到设计，在与未婚夫许慕的大婚之日遭遇多人侵犯，后逃出发生车祸导致意外流产，一系列事件对苏辞造成重大创伤，精神出现问题。苏夏因爱慕傅斯年，嫉妒苏瑜，将大姐苏辞的遭遇嫁祸给苏瑜，并且一直借用大姐苏辞挑拨苏瑜与傅斯年两人感情，让两人误会不断加深，苏瑜身心俱疲，在生下孩子后，却被告知孩子已被出现精神问题的苏辞害死，得知孩子身死的苏瑜彻底爆发，不相信姐姐苏辞会做出恶毒的事情，决心查找真相，揪出幕后真凶。而此前姐姐苏辞也在经历治疗和陪伴后，精神慢慢恢复，怀疑伤害自己的真凶不是苏瑜，但考虑到各种因素，苏辞决定先继续装疯调查真相。苏瑜在姐姐苏辞暗地里的帮助下，才知道原来一切都是苏夏的设计，苏辞把孩子还给苏瑜，两人联手查找苏夏作恶的证据，揪出幕后真凶苏夏，让真相大白于众，傅斯年得知真相后悔不已，向苏瑜不断道歉，寻求苏瑜原谅，追妻火葬场。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478776,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1-RyPufPDAigDeTRf7vjwEg?pwd=33ix\",\"online_time\":\"2023-09-27 00:00:00\",\"time\":1695744000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"情靡\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"情靡\",\"description\":\"因意外被下药 ，纪璇和宋昭礼不期而遇，打破了纪璇原本平静的生活。所有人都以为是纪璇攀高枝，只有宋昭礼知道这是他的蓄谋已久。纪璇也在不断拉扯中揭开谜题。 两人展开了一段极度拉扯双向救赎的爱情\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485016,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"链接：https://pan.baidu.com/s/1sYYFhOzwbgNG5w-FkjE06Q?pwd=1j5j\\n提取码：1j5j\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-03 00:00:00\",\"time\":1714665600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"慕少的读心娇妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"慕少的读心娇妻\",\"description\":\"甄甜本是万人瞩目的影后，不料被渣男觊觎上亿财产害死，重生到了18线小明星身上。自此甄甜变成了田真儿，还获得了能够听到他人心声的能力。通过读心术，步步为营最终让渣男自己承认了一切。但其实真凶却另有其人。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485866,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"链接：https://pan.baidu.com/s/1oICAh_5PzCnuP6xy9yR8MA?pwd=f97h\\n提取码：f97h\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-26 00:00:00\",\"time\":1716652800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"成为恶毒女配之后拿下男主\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"成为恶毒女配之后拿下男主\",\"description\":\"女主魂穿到自己读的小说中，和收养女主的哥哥之间的情感纠葛。\",\"second_cate\":\"女频现代都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480096,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1r0x4zaOcTe0yZse4dt2Taw?pwd=3ew4\",\"online_time\":\"2023-11-17 00:00:00\",\"time\":1700150400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我三万娶的老公竟是亿万总裁\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我三万娶的老公竟是亿万总裁\",\"description\":\"崔情宜婚礼上得知未婚夫出轨当场开价一个月三万高薪聘请新郎，与戚成风领证结婚。崔情宜一直认为戚成风是事业无成的家庭煮夫，却不想竟是千亿总裁。随着戚成风的掉马，崔情宜发觉丈夫并不是一个普通男人。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484406,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1OfxbssYKwB8VEQC-iOE62A?pwd=626h\",\"online_time\":\"2024-04-13 00:00:00\",\"time\":1712937600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我不是神仙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我不是神仙\",\"description\":\"沈仙本是京州医科大学毕业生，从小被天师观隐退的国师张山峰收养，梦中成仙，但自己并不知晓，因为答应了女将军楚筱的退婚，而得罪了王家大少王昊辰，被迫下山向苏家家主苏染求亲，为天师观寻找靠山，机缘巧合下与苏染有了一夜情缘，之后被苏染拉着参加寿宴，打败武安王府的护卫，得到苏家的认可，又被苏染要求参加招夫考验，在霸王擂上力压群雄，打败武安王世子白飞殊，拿下霸王头衔，之后又救下京州守备林百岁的女儿林宝宝，得到京州经略使的位置，武安王府勾结外敌绑架苏染，沈仙大发神威打败外敌救下苏染，在二人的婚礼上，武安王白重阳造反，沈仙联合大师父张山峰打败武安王，最后得知了自己的身世，在天池水潭，为人间独抗天劫。\",\"second_cate\":\"男频高手下山玄幻\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482646,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1tTw609DjuDYsQITnzTzzgg?pwd=6nq1\",\"online_time\":\"2024-02-22 00:00:00\",\"time\":1708531200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我从工厂崛起，纵横四海\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我从工厂崛起，纵横四海\",\"description\":\"工厂临时工赵明，偶然救下了工厂区丧偶女领导杨皎月，杨皎月随手施恩，赵明抓住机会，一路急速高升，逆袭打脸那些看不起自己的人，甚至于还让那些人变成了自己的追随者。杨皎月对其越发看重，甚至想要把妹妹文雯嫁给他，一切看似美满的生活，却因为当年灭了赵氏家族的仇人的到来而打破.....\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"\",\"update_time\":1720477676,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/19OyhsvXXTLuU-Raeyng2Rw?pwd=2cpd复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-15 00:00:00\",\"time\":1692028800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我们爱过又忘记\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我们爱过又忘记\",\"description\":\"南枫做了桑胤衡三年秘书，把他伺候的妥妥帖帖。 她知道，他们俩不可能有将来。 门不当户不对的。 她一个没权没势的，犯不着跟权贵斗。 可是，哎，桑总，你追过来干什么？ 你不是要娶和你门当户对的大小姐么？\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481766,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1nrmasbs5QfZ8EFy4D6JynA?pwd=562k\",\"online_time\":\"2024-01-22 00:00:00\",\"time\":1705852800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我再也不想恋爱了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我再也不想恋爱了\",\"description\":\"舔一个女神，你就是舔苟。舔一百个女神，一百个女神就是你的舔苟。陈远，一个普通的大三学生，开局被甩，觉醒终极舔苟系统，获得舔苟金九千万亿。九千万亿什么概念？大小马首富，他们总资产加起来怕也不到我的万分之一。然而坑爹的是，舔苟金只有舔女神才能消费。一条终极舔王的故事，由此展开·····\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481736,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1IKjhswRNX3zoHjRYz_U8-w?pwd=e2uq\",\"online_time\":\"2024-01-19 00:00:00\",\"time\":1705593600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我和总裁相了个亲\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我和总裁相了个亲\",\"description\":\"女主鹿悠悠在替闺蜜乔一相亲时，与男主顾湛星相遇。鹿悠悠本来打算把顾湛星恶心跑没想到竟被男主拆穿反将一军。更巧的是没想到男主竟然是女主的老板。二人发生了一系列让人忍俊不禁的乌龙事件。之后男主为了敷衍爷爷邀请女主成了契约女友。二人磕磕绊绊，最终修成正果。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485176,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1s5llQYRz6QJk1fmCoxKVXw?pwd=z9m4\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我在三界直播带货\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我在三界直播带货\",\"description\":\"一个普通的带货直播间无意间与三界信号串联，许海城的生活从此天翻地覆。斗恶人、辨古董、收美人… 通过与三界众人交换而来的技能成为一方霸主。为龙国铲除外来势力，最终成为万人敬仰的“龙神”。\",\"second_cate\":\"男频逆袭轻玄幻\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480056,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/10tU80UNmPilVcz1UjdMWaw?pwd=e4ag\",\"online_time\":\"2023-11-16 00:00:00\",\"time\":1700064000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我在人间当财神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我在人间当财神\",\"description\":\"江防十世为穷人，为了让天下黎民过上好日子，不惜赌上自己的转世气运，最后封锁在天庭，期间受到玉帝的青睐，随后准备前往第十一世生活，并且获得了财神的仙位传承，需要完成任务才能开启仙位，而这个任务就是：散财……最后，江防获得十世财运加持，发现了财神的真谛，最终放弃仙位，幸福生活在了都市。\",\"second_cate\":\"男频都市、奇幻\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482446,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1KzHj_KV5XeGo1bK4GaBqOg?pwd=prxi\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我在人间当阎罗\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我在人间当阎罗\",\"description\":\"地府之主阎罗王入人间转世，一入轮回三千年，地府也因此停摆三千年，六案功曹各路鬼差陷入沉睡。阎罗王最后一世轮回，是以送外卖为生的阎非，家境贫意，母亲重病，阎非拼命赚钱给母亲治病。这天遇到了一位刁蛮任性的顾客，不分青红皂白让阎非下跪道歉后，仍给了差评，阎非急怒攻心，心脏病复发，危在旦夕，此时又听闻母亲病危，需要一小时内缴50万医疗费才能开始手术救人，听闻噩耗，阎非心脏再也支撑不住，倒地身亡。阎非死后被牛头马面，黑白无常带至地府，阎非心系病重母亲下脆求饶，不曾想四位鬼差竟然也跟着下跪磕头，直言阎非就是地府之主阎罗王，只要他坐上阎罗王宝座，自可阴阳穿梭。阎非将信将疑坐上宝座，瞬间神格归位...\",\"second_cate\":\"男频异能\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479646,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ptBdMqNRY8HiAYXegE4zQg?pwd=dvy3\",\"online_time\":\"2023-11-03 00:00:00\",\"time\":1698940800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我在仇人家做女佣\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我在仇人家做女佣\",\"description\":\"何穆的父亲是一名教师，因制止了校园暴力，被施暴的富家千金凌羽诬陷强奸，名声尽毁，于家中上吊自杀。何穆的母亲也被凌羽诓骗坠楼，何穆退学。十年后，何穆化名成蝶，展开了一场预谋已久的复仇。\",\"second_cate\":\"女频复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487216,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1raECXvOOEpAm_ACakmH5-A?pwd=36tz\",\"online_time\":\"2024-06-08 00:00:00\",\"time\":1717776000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我在古今当首富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我在古今当首富\",\"description\":\"外卖员杜霖惨遭女友背叛，上演羞辱戏码，气愤中骑着电动车穿越时空，误打误撞杀死流寇头目，被朝廷册封为大将军，到京城受封时，利用计算机打败倭国神算大师，方便面硬刚生鱼片，电动车跑败千里马，然后回到现代，变卖皇帝的赏赐发财，回古代迎娶英武女将军周允儿。\\n他掌握时空穿梭技能，在古今穿梭，互通有无，把古代名人字画、珍玩玉器，带回现代来拍卖，回程时又把化品、小家电等带到古代作为奢侈品卖给有钱人，甚至连薯条薯片汉堡的技术都传到古代，开起加盟店，赚取高额利润，积攒泼天富贵，走上人生巅峰。更因粗通历史而未卜先知，赢得众人青睐。他把曾经欺负、鄙视他的冷漠无情的亲友、咬牙切齿的仇人、趋炎附势的同学都一一打险，让曾经骑在他头上的经理转而成为他的马前卒，对他唯命是从。让曾经给他戴绿帽子的富二代赵龙倾家荡产，饱受摧残，不敢再得瑟。之前无耻给杜霖戴绿帽的水性杨花的前女友秦露，又反过来对杜霖死缠烂打，哭着喊着要复合，让杜霖不厌其烦。杜霖在现代大杀四方后，又回到古代惩治卖官鬻爵的大太监刘忠贤。流民作乱，周允儿甘愿成为人质，杜霖为营救美娇妻，也为黎民苍生，斥巨资从现代采购粮米油盐，拯救十万挣扎在死亡线上的流民，让他们安居乐业，各有所养。\",\"second_cate\":\"男频古代神豪\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479456,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1PB5tUgRwYSUJ234Q2QOdbQ?pwd=b7bs\",\"online_time\":\"2023-10-27 00:00:00\",\"time\":1698336000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我在无人处寻你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我在无人处寻你\",\"description\":\"5岁的陆暖暖为了保护弟弟而跌落山崖失去记忆。15年后，被捡垃圾的养父收养的江小雪在陆氏酒店上班，却被亲生母亲和弟弟各种欺负和羞辱。身份曝光后，在母亲和弟弟的愧疚忏悔中，最后大团圆结局。\",\"second_cate\":\"女频豪门、寻亲\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488896,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1N3AREC7TO457q54di8bGNQ?pwd=k4it\",\"online_time\":\"2024-07-06 00:00:00\",\"time\":1720195200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我在未来等你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我在未来等你\",\"description\":\"哥哥林朝暮被误会成凶手逃了七年。到了2031年，林朝暮放弃时意外通过手机打破时空界限联系到2024年的林夕佳。两人确认彼此身份后，2031年的林朝暮通过林夕佳的日记本帮助2024年的林夕佳定位凶手。\",\"second_cate\":\"通用悬疑 甜宠 时空对话\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486126,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/106RaI8CuCfjkrcucHVfn6g?pwd=ux46\",\"online_time\":\"2024-05-30 00:00:00\",\"time\":1716998400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我在缅北九死一生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我在缅北九死一生\",\"description\":\"高志强与妻子在东南亚旅游时被绑入缅北诈骗园区，这里是人间地狱，从事电信诈骗器官交易色情等犯罪活动。高志强与黑玫瑰及其手下四大天王斗智斗勇，终于揪出幕后真凶，九死一生逃出园区，但妻子却下落不明。\",\"second_cate\":\"通用\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486646,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1VhItFmMJTfMbJ9sw0S-yXg?pwd=4k9m\",\"online_time\":\"2024-05-25 00:00:00\",\"time\":1716566400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我在荒岛当岛主\\u0026荒岛夺命之龙卷风\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我在荒岛当岛主\\u0026荒岛夺命之龙卷风\",\"description\":\"陈阳是一个公司的小职员，为了庆祝公司上市，公司老总带着公司员工坐飞机旅游团建，结果遇到了龙卷风，飞机出事，漂到了一个岛上，最后陈阳被自己老板顾天河与女朋友林瑶害死在了岛上。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487576,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1yMf6llKDINsDNKcNVHGLAA?pwd=amrt\",\"online_time\":\"2024-06-14 00:00:00\",\"time\":1718294400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我家超市能穿越\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我家超市能穿越\",\"description\":\"因为一块欢迎光临的牌子，桑以安买下的超市意外成为了在晚上联通不同时空的神奇空间，就在她以为自己爱情事业双丰收时，她的某些不当行为导致了历史发生些许变化，她也将迎来自己的惩罚，成为无限倒霉体质。\",\"second_cate\":\"女频奇幻/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484306,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1MdsEjHZK0CTzct-593CT-Q?pwd=28ds\",\"online_time\":\"2024-04-11 00:00:00\",\"time\":1712764800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我居然闪婚了禁欲男神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我居然闪婚了禁欲男神\",\"description\":\"意外失去五年记忆的苏梨一觉醒来，跟暗恋多年学生时代的男神结婚了！可18岁的苏梨连男人手都没摸过，现在居然有了老公还是男神！陆景川发现老婆要抛弃自己，又开始了误会、求和、吃醋等追妻火葬场的行为，最后两人经历重重磨难让苏梨恢复记忆并且回心转意！\",\"second_cate\":\"女频都市言情甜宠 \",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483306,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1VOKPxBrqUotanePAydJH7A?pwd=d8r4\",\"online_time\":\"2024-03-13 00:00:00\",\"time\":1710259200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我帮财神渡情劫\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我帮财神渡情劫\",\"description\":\"实习财神禄无为下凡渡劫后就能飞升转正，另一名实习财神商仄追下凡间破坏禄渡劫抢转正名额。禄无为在凡间被童颜收留，发现童颜的弟弟罗尧就是自己前世恩人，于是留下来报恩，不停的当僚机促成罗尧的婚事。禄无为在凡间经历了商仄追杀、帮童颜摆脱坏发小陷害，忽然被月老的线牵到了童颜手上，开始了自己的坎坷心碎的渡劫历程，在调皮月老的帮助下，成功飞升。\",\"second_cate\":\"女频甜宠、轻喜\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479246,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1m6oAZNdm-7fuShbULZyDYQ?pwd=ye5z\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我开锁匠开局见义勇为（老剧）\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我开锁匠开局见义勇为（老剧）\",\"description\":\"开锁匠林陌接妹妹下班遇蒙面劫匪，主动成为人质，意外激发开锁异能，能破解世上所有锁。林陌凭借异能制服劫匪，和幕后黑手林科结怨。自称是林陌女儿星星的小女孩出现，向他揭开了未来神秘面纱的一角。\",\"second_cate\":\"男频战神、屌丝逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484636,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1hszBZOOSHjxSe90OkUm6Dw?pwd=829c\",\"online_time\":\"2024-04-20 00:00:00\",\"time\":1713542400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我成了失忆霸总的心尖宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我成了失忆霸总的心尖宠\",\"description\":\"简若彤送水途中意外救了苏舟辰，离开却被追杀，许诺简若彤金钱让简若彤救了自己，但苏舟辰再次醒来，却失去了记忆。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478426,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1fqiaD7SBdCtTuhjrcksk-A?pwd=6h2f\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我曾爱你如沧海\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我曾爱你如沧海\",\"description\":\"姜莱出身富贵，因意外被一个小男孩救过后想要报恩。长大隐藏身份嫁给厉景深，却差点被厉家人还有小三岳姗姗害死。之后姜莱恢复身份，跟傅惊尘一起打脸前夫一家，发现他是自己的救命恩人后在一起。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486846,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1mQXrSFvlU47SDmHm-wl5Xw?pwd=g83x\",\"online_time\":\"2024-06-04 00:00:00\",\"time\":1717430400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我有一只神笔\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我有一只神笔\",\"description\":\"赵平家境贫穷，娶不上媳妇，时常被人耻笑偶然情况下得到一支美女为真身的上古神笔，所画东西都能变真。\",\"second_cate\":\"男频神豪，小人物逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482266,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/188ramzV6wOhTuSjOF2kN1w?pwd=k7hu\",\"online_time\":\"2024-02-08 00:00:00\",\"time\":1707321600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我有三个哥哥超宠我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我有三个哥哥超宠我\",\"description\":\"路浅浅突然发现自己不是亲生的，原生家庭竟然是南城最大世家，被领回家后被各种人刁难威胁，三个哥哥齐齐上阵妹控打脸奇葩人物。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"\",\"update_time\":1720478676,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1PpdjDbxx7eDezPOTFXad0A?pwd=ch97\",\"online_time\":\"2023-09-25 00:00:00\",\"time\":1695571200,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我有三个妹妹绝世无双\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我有三个妹妹绝世无双\",\"description\":\"无\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478736,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1JghYxPdSdSLqVcL5ivGBlg?pwd=9ye6\",\"online_time\":\"2023-09-25 00:00:00\",\"time\":1695571200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我有三爹，可翻江\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我有三爹，可翻江\",\"description\":\"徐峰因不小心得罪了孙家大少孙志，被当成狗侮辱，甚至被拴在酒店门口，后惹怒李光被酒店赶了出去。 失去工作的徐峰成了流浪汉，任人欺辱，就在此时，有三位神秘富豪找上门来，竟然都说自己是徐峰的爹。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482426,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1TP_y6vmUQZO97erSVdviRQ?pwd=dcix\",\"online_time\":\"2024-02-11 00:00:00\",\"time\":1707580800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我有五个大佬崽崽\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我有五个大佬崽崽\",\"description\":\"林家千金林茉如跟相恋多年的程骁凡一夜春风后，程骁凡离奇失踪，林茉如继母林雪月却带着其父前来捉奸，表示已经将林茉如许配人家，将其赶出林家。误会自己被骗的林茉如返回乡下，跟着医神逍遥子学习医术，发现自己怀孕，最后竟然生下四男一女五胞胎！时隔六年，林茉如带着孩子们返回国内，这五个宝贝却一心想要找回爸爸。\",\"second_cate\":\"女频/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487966,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1SFGEfjpANlhBF-vGyMwERQ?pwd=kdk9提取码:kdk9复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我本不凡\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我本不凡\",\"description\":\"叶凡意外发现同学聚会上，老婆和高中时期的班长出轨了。他一怒之下决定离婚，却在这时惊讶地发现，自己竟然是全球首富的继承人，本想从此平亿近人，却不料总有人不相信，于是走上了一条继承家产，顺便打脸的道路。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487556,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1Hf-Gl6_jKv5dvwePAUz44A?pwd=qixr\",\"online_time\":\"2024-06-14 00:00:00\",\"time\":1718294400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我爸竟有万亿资产\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我爸竟有万亿资产\",\"description\":\"夏正豪本是当年横扫美国商界的天才企业家，后因遭到五大隐世家族的迫害，隐姓埋名回到国内，选择成为一名代驾，暗中却留下手下替自己打理美国的资产。二十年后，夏正豪的死敌仲东河得知，夏正豪的儿子夏博云也成为了天才企业家，暗中作梗，意图毁掉夏博云，夏正豪为了拯救儿子的公司，重整旗鼓，毅然选择重新对抗仲东河及他身后的五大隐世家族。\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484836,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1cYq1NqLqOw8KV8ZCi72Myg?pwd=buhk\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我用读心术狠狠拿捏王爷\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我用读心术狠狠拿捏王爷\",\"description\":\"现代女神医穿回古代成为腹黑残疾王爷的弃妃，听到王爷的心声要杀了自己这个没用之人，为了保命于是大展身手，之后更是利用医术一次又一次脱险，同时也跟王爷建立了感情，最终在一起。\",\"second_cate\":\"女频古代言情 穿越 甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482996,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1PvrhkqTge_mJTqvQ5cckgA?pwd=tegd\",\"online_time\":\"2024-03-06 00:00:00\",\"time\":1709654400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的25岁白富美老婆\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的25岁白富美老婆\",\"description\":\"苍龙殿殿主宁尘因妻子意外去世，心灰意冷之下选择做一名保安，过平凡的日子来照顾女儿，却阴差阳错和妻子的妹妹孟晚意闪婚成为夫妻，两人在互不知情的情况下互相帮助，感情升温，并且最终携手找到了害死宁尘妻子的元凶，将其绳之以法。\",\"second_cate\":\"男频闪婚、兵王\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480986,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1dlkBvwxsQ0MwJTlSdVAyeQ?pwd=fhm3\",\"online_time\":\"2023-12-21 00:00:00\",\"time\":1703088000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的AI能具现\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的AI能具现\",\"description\":\"男主程潇是一个醉心研究AI的穷小伙，他的AI突然能够使实物变现，女友嫌他穷攀上了富豪廖其昌，他用这一功能打脸拜金女友，开启了疯狂的逆袭之旅。这时，科学怪人彼岸花盯上了他。\",\"second_cate\":\"男频都市、系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488436,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1cXdJIAAdzQCBITo5pF_oPA?pwd=3fu6\",\"online_time\":\"2024-06-28 00:00:00\",\"time\":1719504000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的万人迷总裁老婆\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的万人迷总裁老婆\",\"description\":\"秦婉清对外招婿许以重利，徐家因秦婉清对外传言他一点都不好，不愿让徐不凡入赘，便以妹妹威胁，让身为保安的陆北辰代替徐不凡成为了上门赘婿。\",\"second_cate\":\"男频逆袭精选\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478436,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1E2J3S2nuNVFqEt7y-r8bzA?pwd=pzzb\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的九个姐姐都是大佬\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的九个姐姐都是大佬\",\"description\":\"李平的老爸傍上女首富，李平不但多了一个首富后妈,还有九个独宠他的美女姐姐。继承千亿家产后的李平一路披荆斩棘,摇身一变成了比后妈和九个姐姐还厉害的主。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488716,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1--VC1yQVTz-mPpjv5ifWBw?pwd=gack\",\"online_time\":\"2024-07-02 00:00:00\",\"time\":1719849600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的傻白甜老婆\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的傻白甜老婆\",\"description\":\"女总裁醉酒进错房，隔天醒来拽着床上小保安：你必须娶\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478716,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1RwkgV9ghs5OIdjY4QO4E0A?pwd=xfrj\",\"online_time\":\"2023-09-25 00:00:00\",\"time\":1695571200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的六个姐姐风华绝代\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的六个姐姐风华绝代\",\"description\":\"楚辰，居住玉鼎山，世人尊称显圣真君，本是孤儿院的一名弃婴，七岁时被玉鼎真仙沈素琼收养教导，二十五岁时泰师命下山，寻找自己在孤儿院相认的六个姐姐，楚辰运用自己的武力，医术，个人魅力，辗转在众女和东海各大家族中，解决了姐姐们与各家族之间的思怨情仇，楚辰在收服各家族时，知晓了自己是第一豪强楚家遗失在民间的长子，也知晓了自己背负的血海深仇，楚辰与自己的姐姐们一起掀翻楚家，并找到了一切事件的幕后黑手，向他报仇雪恨。\",\"second_cate\":\"男频高手下山\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482556,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1uR6XOgejJjTnPCOgfmU0BA?pwd=sit7\",\"online_time\":\"2024-02-18 00:00:00\",\"time\":1708185600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的千金大小姐老婆\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的千金大小姐老婆\",\"description\":\"安若欢是家族斗争受害者，流落他乡多年，拒绝原谅挑起事端的奶奶。奶奶渴望和解，派管家寻她，希望她回归家族。安若欢嫁入墨家受尽冷眼，身份恢复后，她以万贯家财逆袭，打脸势利眼。\",\"second_cate\":\"女频都市、豪门\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488956,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/138Iw3AHHgWjU-kCTp3G_jA?pwd=jgay\",\"online_time\":\"2024-07-07 00:00:00\",\"time\":1720281600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的右眼是神级计算机\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的右眼是神级计算机\",\"description\":\"计算机系高材生刘弟因见义勇为重伤，右眼失明。虽挚友张天甲竭力帮衬，但在病痛折磨下苦熬三年，刘弟的伤情仍恶化到无可挽回。刘弟以为死亡终于来临之际，却意外和自未来穿越而来的超级计算机“魔瞳”融合共生。\",\"second_cate\":\"男频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484986,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1346fyJCwqgX1cyX8GHg3ng?pwd=jma7\",\"online_time\":\"2024-05-02 00:00:00\",\"time\":1714579200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的失忆小奶狗\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的失忆小奶狗\",\"description\":\"秦苒隐姓埋名与白氏集团总裁白景州契约婚姻三年因流言误会白景州心有白月光秦苒对这段婚姻不抱期望。白景州提出离婚她干脆选择放手。领离婚证路上白景州发生车祸失去记忆在医院醒来认定秦苒就是他的爱人。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487096,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1eC3bro2RYbWQApqSGHOOjQ?pwd=3n2u\",\"online_time\":\"2024-06-07 00:00:00\",\"time\":1717689600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的女友一千岁\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的女友一千岁\",\"description\":\"千年前的将军转世之后与柳如烟相恋，却遭其嫌弃最后两人离婚。后与女帝姬月瑶相认之后，觉醒了各种的技能，医术，功法，等等，逐渐展现自己的实力，打脸那些瞧不起他的人，最后让柳如烟后悔莫及，与女帝相知相爱。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488466,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1mW86mgz-JvC0X_5D2RGFvg?pwd=yp78\",\"online_time\":\"2024-06-28 00:00:00\",\"time\":1719504000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的女友居然是猫\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的女友居然是猫\",\"description\":\"顾知夏是最普通的一名社畜，然而命运的捉弄让她每到晚上12点就会变为一只小猫咪。她一边忙于工作生活，一边找寻恢复正常的方法，却发现唯一可以治疗她这个毛病的方法，居然是她顶头上司的亲吻。\",\"second_cate\":\"女频霸总、奇幻\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488756,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1M_XljaLKnNidL_TW6hIn_A?pwd=6vj2\",\"online_time\":\"2024-07-04 00:00:00\",\"time\":1720022400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的总裁老公豪又帅\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的总裁老公豪又帅\",\"description\":\"女主因一次意外和男主闪婚，婚后女主发现男主竟是豪门总裁！此后女主便过上了纸醉金迷养尊处优的生活。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478346,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/19FjUWAsyGZsNuNO7P7DnKA?pwd=k46v\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的手机连天界\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的手机连天界\",\"description\":\"本是一个平平无奇公司小保安的徐涛勤勤恳恳，任劳任怨，受气是常有的事情， 被同事戏弄也是家常便饭。就因为他和陈煦瑶说了一句话，就被小混混盯上，一顿胖揍，打 得半死。没想到却因此得到了意想不到的奇遇，激活了手机上的神秘系统。只要完成系统的 目标，就能得到相应的奖励。什么?你问奖励什么?那可就多了去了!今天可能是蟠桃仙丹， 明天可能是火眼金睛。而且随着奖励的累积，他甚至可以直接上天界，成为真神!这可把徐 涛乐坏了。从那一刻开始，他的人生就像开了挂一样。付出一分，收获百万，稍微努力一下， 就能拥有七十二变的能力。哎呀，暂定一个小目标，要逆天!是真的逆天!\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483036,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1nGEZivbZPy9oRa07oZg2Wg?pwd=m6sp\",\"online_time\":\"2024-03-07 00:00:00\",\"time\":1709740800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的机器人女友\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的机器人女友\",\"description\":\"江辰三年前遭遇了家族灭门，成为林家的赘婿，备受欺辱，在失去利用价值的时候被一脚踹开。林家准备杀人灭口，江辰却因为未来科技云烟的帮助，死里逃生，开始了对林家和陈家的复仇，并振兴家族。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487746,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1wL2-T-Wq1e8pPq_sjHEi1w?pwd=g785\",\"online_time\":\"2024-06-18 00:00:00\",\"time\":1718640000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的民国娇妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的民国娇妻\",\"description\":\"民国当红花旦穿越百年到现代顶流小鲜肉身边发生的故事\",\"second_cate\":\"女频穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480696,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/10KR9ui3o5DTJz6fgb93O3w?pwd=3mgn\",\"online_time\":\"2023-12-12 00:00:00\",\"time\":1702310400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的相亲对象是机器人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的相亲对象是机器人\",\"description\":\"智能机器人安全管理服务集团得知机器人顾特（编号89757）突破了软件升级限制，产生了人类感情，必须秘密销毁。顾特一边躲避追捕，一边和女主林娜娜之间发生了一场又甜又虐的爱情故事。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484936,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"链接：https://pan.baidu.com/s/1AMYCvFGpdpCwObPPqyr4VA?pwd=95xk\\n提取码：95xk\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-01 00:00:00\",\"time\":1714492800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的绝品废材老公\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的绝品废材老公\",\"description\":\"刘天阳原本是鄂省首富刘少军之子，却在出生后被亲生父母因为未婚先孕、家族争斗的原因送至小山村刘老汉家生养，初中毕业后刘天阳参军，后来他在一次任务中为顾及大局忍痛亲手打死了被毒贩劫持的女友，被判三年监牢。出狱后的刘天阳万念俱灰，加之家中刘老汉生病去世，无奈之下担负起抚养妹妹刘芊芊的责任，带着妹妹来到荆城生活，经人介绍，与荆城大家族林家达成协议，与林家耀之女林婉溪结为名义夫妻，入赘林家耀一家，以帮助他们顺利取得家族遗产。\",\"second_cate\":\"男频逆袭爽文、废柴流、都市反转\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482126,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1nIgK6xaqeYOiEkoAoNBNPQ?pwd=h5y9\",\"online_time\":\"2024-02-05 00:00:00\",\"time\":1707062400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的绝美师姐太宠了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的绝美师姐太宠了\",\"description\":\"叶天从小在山上被美女师父养大，这二十年叶天青出于蓝，武道医术等都到达顶峰，这些年更是被各种高能美女师姐众星捧月般宠爱。没想到，这一天，他竟被绝色大师姐赶下山做上门女婿，别的上门女婿唯唯诺诺，叶天却重拳出击，谁让他有七个师姐撑腰呢！\",\"second_cate\":\"男频高手下山\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477826,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Hp-UqMj0Vd3TLm2hhllAPw?pwd=mktc\",\"online_time\":\"2023-08-15 00:00:00\",\"time\":1692028800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的网恋男友是大佬\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的网恋男友是大佬\",\"description\":\"温家千金温安瑶终于要和网恋五年的男友奔现了，只是不巧，她在男友的认知里是个服务员，更不巧的是，她那个据说工地搬砖的男友，也是司家集团的总裁……\",\"second_cate\":\"女频甜宠、轻喜\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483946,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1gASCn7OSCxMGJ3iTbLwPFw?pwd=uk59\",\"online_time\":\"2024-03-29 00:00:00\",\"time\":1711641600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的美女战神老婆\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的美女战神老婆\",\"description\":\"陈苏苏成为女战神，见到大战神男主（方啸小号），崇拜爱慕。回家，为了家族就打算离婚，嫌弃方啸一点忙帮不上，方啸只能无奈离开。之后不久发现陈苏苏被人图谋不轨，上去营救，却反被陈苏苏误会……\",\"second_cate\":\"男频战神/赘婿\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481146,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1Jd4-fpMzhwfFpNmT4tsIWA?pwd=ha7y\",\"online_time\":\"2023-12-25 00:00:00\",\"time\":1703433600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我的霸总上司太耀眼\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我的霸总上司太耀眼\",\"description\":\"谢沉舟和舒宁心是未婚夫妻关系，门当户对，舒宁心被家里派去谢沉舟公司和谢沉舟培养感情，也是锻炼舒宁心能力。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478236,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Vl6OQG7NTswsfCco67idAA?pwd=t62g\",\"online_time\":\"2023-09-08 00:00:00\",\"time\":1694102400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我竟然是财阀的小儿子\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我竟然是财阀的小儿子\",\"description\":\"故事围绕着神秘男主林风展开，他是全球千亿身家黑客之子，却在30年生活中一直被隐藏身份，过着屈辱的生活。当意外得知自己身世后，开始走上人生巅峰。他不仅要面对背叛他的前妻苏梦婷，还要应对情敌张明的讥讽和周围市侩小人的嘲笑。与此同时，林风还与苏梦婷、李雨晴等女性角色产生了深厚的感情纠葛。他们的命运交织在一起，共同经历了爱情、亲情的考验。最终，林风凭借智慧和勇气，在惊心动魄的商战中成功击败了张明，携佳人共度辉煌。\",\"second_cate\":\"男频神豪\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480086,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/12cT2L6guG67Flpsmv9W4HQ?pwd=irtb\",\"online_time\":\"2023-11-17 00:00:00\",\"time\":1700150400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我竟被困在同一天一万年\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我竟被困在同一天一万年\",\"description\":\"苏铭被困在六月一日一万年，了解临城所有人和事情，直到他解救第一女秘书许幽兰时打破被困一万年魔咒，也因此得罪了陈耀光等人，苏铭联合众人，成功解决幕后黑手楚天奇。\",\"second_cate\":\"男频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"\",\"update_time\":1720486756,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Q-HcidVZyyiMoIJSO3SmZA?pwd=g2eg\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我能看到万物价值\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我能看到万物价值\",\"description\":\"陆远一心为了治好女儿的病奔波，终于得知妻子的骨髓能救女儿，不惜下跪哀求，没想到这个出轨渣女为了保险金准备让女儿病死，还狠狠侮辱陆远。意外之下，陆远觉醒神眼，能看到万物价值，并以这个能力开始逆袭人生。\",\"second_cate\":\"男频都市奇幻/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480626,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1aKoezbKEvmcaAO_VLMR4Hw?pwd=dek3\",\"online_time\":\"2023-12-08 00:00:00\",\"time\":1701964800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我被总裁骗了婚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我被总裁骗了婚\",\"description\":\"十五年前，沈枝意救下了商时予，商家因为商时予被暗害一事将人送出国，而在商时予回国的那天，阴谋再次到来，机缘巧合之下又是被沈枝意救下，而十五年前了无音讯，让沈枝意对商时予有了怨气，商时予只能假装失忆留在沈枝意身边……\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481656,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1esyn2U8IjcskFeHBF_ZPdQ?pwd=5cr8\",\"online_time\":\"2024-01-16 00:00:00\",\"time\":1705334400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我被豪门继承人包围了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我被豪门继承人包围了\",\"description\":\"蒋佳怡作为蒋氏千金，为了嫁给穷小子徐安，不惜与蒋家切断一切联系，全心全意做徐安的太太，不料徐安却出轨蒋娜。蒋佳怡来医院照顾植物人婆婆，碰巧在医院的妇产科门诊撞破了徐安和蒋娜的奸情。受到委屈的蒋佳怡决定回到蒋家，父亲蒋天雄决定为她举办一场盛大的回归宴.....\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484236,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1go3VkF0O90oYHJImCEnGmw?pwd=7a5k\",\"online_time\":\"2024-04-09 00:00:00\",\"time\":1712592000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"我靠拯救男主走上人生巅峰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"我靠拯救男主走上人生巅峰\",\"description\":\"姜悦然车祸身亡，死后绑定系统穿书，拯救黑化男主。成为人人唾弃的未婚先孕女知青，姜悦然脚踹渣男，掌掴黑心闺蜜，一手男主一手儿子，甜甜蜜蜜把家还。\",\"second_cate\":\"女频年代、系统、甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483986,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1Z74rV9tptUOhRgJc0JH95A?pwd=85xs\",\"online_time\":\"2024-03-30 00:00:00\",\"time\":1711728000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"战神王爷手撕白莲花\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"战神王爷手撕白莲花\",\"description\":\"战神王爷夜湛，一不小心中了毒箭，醒来后成发现自己跟京城第一美女江穗宁换了身体，不得不开始应付庶妹的挑衅、渣男的算计、绿茶的阴谋，并跟使用自己身体的江穗宁在交换信息、共同对敌的情况下产生感情。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484716,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1tVQRwvUy7Ub7L-gsMyZg8w?pwd=xfig\",\"online_time\":\"2024-04-26 00:00:00\",\"time\":1714060800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"手握八百纵横四海\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"手握八百纵横四海\",\"description\":\"叶飞是炎帝后代，因被毒打觉醒了炎帝神魂，世界被贬值亿倍，叶飞成为资产唯一不被贬值的人，开启了一段传奇人生的旅程……\",\"second_cate\":\"男频神豪\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481506,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1wGS5_sFRTEw5wgp5HR-FsA?pwd=5js2\",\"online_time\":\"2024-01-08 00:00:00\",\"time\":1704643200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"打工人的最强身份\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"打工人的最强身份\",\"description\":\"李峰是一个退伍军人，一次偶然救下赵梦雪的爷爷，被赠星辰酒店。只可惜，却被雷经理和丁玲陷害，幸好得到赵梦雪的帮助。李峰决定退掉酒店，赵老欣赏他的决心，牵线李峰与赵梦雪结婚。成为赵家女婿后，李峰坚守本心，为赵梦雪解决度假村问题。二人克服困难，相互了解，最终结婚。\",\"second_cate\":\"男频都市 神豪 逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482606,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/154bBBLA3MNrRnVUzVL-x8w?pwd=gta8\",\"online_time\":\"2024-02-18 00:00:00\",\"time\":1708185600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"护国女将星\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"护国女将星\",\"description\":\"太子骆云显遭到三皇子骆云城的陷害被皇帝赐死，护国女将军阮软以赴死的决心去营救骆云显，结果遭到敌人暗算，古穿今到现代横店拍摄现场；醒来后发现自己竟穿越懂啊现代成为了戏子的替身，还在现代遇到了太子骆云显和三皇子骆云城.....\",\"second_cate\":\"女频穿越 都市爱情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481036,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1bEJrq4Vv0vZF6nTrL5Vhdw?pwd=2nnj\",\"online_time\":\"2023-12-22 00:00:00\",\"time\":1703174400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"护龙天师\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"护龙天师\",\"description\":\"大夏龙脉被破坏，陈平安为修复龙脉下山寻找五方令。\",\"second_cate\":\"男频鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720484066,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1no6M3y2kMQGQTsgV2MUqZg?pwd=4p9c\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"报告侯爷，夫人她又跑路了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"报告侯爷，夫人她又跑路了\",\"description\":\"致力于锄奸扶恶的怪侠姜云韶阴差阳错嫁给死对头孟星河，发现本该意气风发的少年将军孟星河如今变成病秧子，不得不生活在一起的二人，发生了一系列啼笑皆非的故事，天降姻缘带来了危机同时也带来了救赎。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483246,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1sZsUDTMYCJ8iho-zMPwZUA?pwd=ybsw\",\"online_time\":\"2024-03-12 00:00:00\",\"time\":1710172800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"报告总裁您找错夫人了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"报告总裁您找错夫人了\",\"description\":\"盛北爵隐藏身份跟楚星晚谈恋爱，正准备公开身份的时候，遭遇到车祸失忆。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485066,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"链接：https://pan.baidu.com/s/1WJSibdXJeEcqNBnvzq2fqA?pwd=83t3\\n提取码：83t3\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-05 00:00:00\",\"time\":1714838400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"报复渣男后，我转身嫁给他小叔\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"报复渣男后，我转身嫁给他小叔\",\"description\":\"被渣男背叛，却意外和总裁闪婚，婚后总裁一句话渣男瞬间破产！\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480306,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/19VdAy5GgwKnq_pVskxWtGQ?pwd=p9nd\",\"online_time\":\"2023-11-23 00:00:00\",\"time\":1700668800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"披荆斩棘的婚姻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"披荆斩棘的婚姻\",\"description\":\"首富千金隐藏身份扶持娱乐圈男友出道成巨星，却惨遭渣男嫌弃而离婚，为了报复渣男，随便拉来一个男人闪婚，结果闪婚老公是娱乐集团沈氏大佬，强强联合，手撕渣男，打脸绿茶。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484386,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1svejcqBAwixH-ieV1Ptneg?pwd=uufb\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"拒不悔婚：傅总别想逃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"拒不悔婚：傅总别想逃\",\"description\":\"苏清颜前世被陆宁远利用，害死了最爱自己的傅司夜，家人也被陆宁远跟苏云瑶联手害死，只为谋夺苏家财产。重活一世苏清颜决定让渣男贱女付出代价，守护家人，更重要的是好好爱傅司夜，弥补自己对他的亏欠。\\n苏清颜重生在自己割腕自杀逼傅司夜把制药厂项目交给陆宁远的节骨眼上，苏清颜知道制药厂项目看着肉少实则利润巨大，前世陆宁远正是凭借这一项目有了跟傅司夜抗衡的资本，而傅司夜手上投入十几个亿的新型药品却是无底洞会拖垮傅氏。苏清颜冒着被傅司夜误会的风险问傅司夜要了那批新型药品交给陆宁远，傅司夜虽然失望，但还是毫无保留的相信了苏清颜，交出星河湾。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481486,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/19yVQ0E2bOxvvB0yXHY7N3g?pwd=irc8\",\"online_time\":\"2024-01-08 00:00:00\",\"time\":1704643200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"拿什么拯救你我的爱人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"拿什么拯救你我的爱人\",\"description\":\"特工周奇因意外穿越到了小说里，并和小说人物“李依伊”相遇。李依伊因为长相和周奇的亡妻一模一样，被周奇保护。两人虽有各自误会，但在周奇的努力下，打败了反派，两人最终走到了一起。\",\"second_cate\":\"通用穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485796,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":7,\"material\":\"https://pan.baidu.com/s/13pIP7rGOSsA3XJMnIwm4wg?pwd=rxbv\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"拿错化验单后夫人开始反抗了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"拿错化验单后夫人开始反抗了\",\"description\":\"苏雅在医院误诊后，经历了一段精神崩溃的时期，但最终在家人、朋友和医生的关爱与治疗下，逐渐恢复了理智，找到了内心的平静，实现了自我救赎。\",\"second_cate\":\"女频/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488256,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1hBbs7ijC2adWhHW9wKV2Ww?pwd=gmxn\",\"online_time\":\"2024-06-26 00:00:00\",\"time\":1719331200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"捡个公主当保姆\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"捡个公主当保姆\",\"description\":\"外卖小哥变身霸道总裁，开始开挂人生，同时收留落魄公主争夺家产，环环相扣的剧情爽点以及相互试探的千层套路。\",\"second_cate\":\"男频都市甜宠爱情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482346,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1IIC9trH2c8E1YCT45eAk5Q?pwd=b6pg\",\"online_time\":\"2024-02-11 00:00:00\",\"time\":1707580800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"捡个老公当总裁\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"捡个老公当总裁\",\"description\":\"搞笑屌丝男乔思聪，霉运连连被逼至跳楼之际，却被发现相貌酷似集团总裁甄梓恒，为钱甘当总裁替身，成为大boss副总的傀儡。成为替身后，乔思聪一面沉迷于总裁式生活得意忘形，一面沉醉于夫人美色不可自拔，百般献媚却屡受敲打后，认清副总妄图侵占公司的野心和自己对夫人的真爱。最终与夫人联手夺回公司，赢得夫人芳心，逆袭成为真正的总裁。\",\"second_cate\":\"女频现代 爱情 喜剧 霸总\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483256,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1BmxaBqhCdIZXZIHN4euJnw?pwd=8359\",\"online_time\":\"2024-03-12 00:00:00\",\"time\":1710172800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"换个灵魂来选美\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"换个灵魂来选美\",\"description\":\"林清与黄嘉玲在一场盛大选美比赛中意外交换灵魂，自此顶着对方身体生活并体验完全不同圈层家庭。从看不惯对方至放下矛盾妥协互助晋级比赛，一起捣破比赛背后不道德阴谋，斩获不一样人生感悟，情谊亦日益深厚。\",\"second_cate\":\"女频现代 奇幻轻喜剧 爱情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486206,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1Hhj_oT62srw9cclDD9accw?pwd=umam\",\"online_time\":\"2024-05-31 00:00:00\",\"time\":1717084800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"揉碎温柔\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"揉碎温柔\",\"description\":\"为了肚子里的孩子，落魄的千金小姐鹿之绫被迫嫁给疯批残暴大佬薄妄，为了保命她开始攻略薄妄，让从小就缺乏关爱的残暴大佬感受到了温暖，两人渐渐靠近了彼此。面对薄妄家族里的争斗和商场上的尔虞我诈，鹿之绫有头脑有胆识，总能够帮助薄妄一一化解，最后男主和女主相互救赎赢得真爱。\",\"second_cate\":\"女频复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480936,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1ypbYkNdf_QErNYH3KsoXoQ?pwd=4u5w\",\"online_time\":\"2023-12-19 00:00:00\",\"time\":1702915200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"撑腰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"撑腰\",\"description\":\"苏倾容是千年前的战王府正妃，因被人下毒陷害容貌尽毁，被战王萧宸风误会并厌恶，大婚当日就将她关至偏院，五年后，她被萧宸风侧妃一杯毒酒害死。再次睁眼，苏倾容穿越到了现代，成了帝京豪门萧宸风的太太，这一世，苏倾容不愿再做被困囚笼里的金丝雀......\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486066,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1SJVdUQ3JPRKN13da_xfb5w?pwd=fb47\",\"online_time\":\"2024-05-29 00:00:00\",\"time\":1716912000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"救命契约霸总太粘人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"救命契约霸总太粘人\",\"description\":\"在两个家庭中长大的谢晚凝，20年前亲眼目睹父亲和宋姨伤害母亲并抛尸，而让她努力活下来的原因，不仅是因为被陆家人所救，最重要的是要亲手为自己的母亲报仇，再为母亲报仇的过程中，她遇到了自己的命中注定，而且这个命中注定还是自己的婚约老公，后来两人相知相识相爱，并育下三子，互相守护一生。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484246,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1ti8QN-DfZpJOogt4ga-Atw?pwd=ie3f\",\"online_time\":\"2024-04-10 00:00:00\",\"time\":1712678400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"救命影帝主动撩上门要结婚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"救命影帝主动撩上门要结婚\",\"description\":\"乔岁岁为避免被家人卖掉发朋友圈闪婚，竟闪婚到了百亿影帝！而影帝终于娶到暗恋多年的女生，即将开启漫漫宠妻之路！\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479696,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Cgc8W5MJWhAfJU3Zp0A7YA?pwd=rmbf\",\"online_time\":\"2023-11-08 00:00:00\",\"time\":1699372800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"救命！我被魔尊大人宠上天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"救命！我被魔尊大人宠上天\",\"description\":\"网文作家李蕙娇在许愿时意外召唤出了自己书中的大反派“赤弦魔尊”厉苍云，厉苍云为回到书中决定为李蕙娇实现愿望：帮她追求她暗恋已久的霸总涂梓浩。然而当霸总真的爱上自己时，李蕙娇才发现自己喜欢的人是厉苍云。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484436,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/15ZyvzM6JwqrG3TCHXsURvw?pwd=zjv9\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"救命，女儿亲爹是国王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"救命，女儿亲爹是国王\",\"description\":\"6年前，温柔和国王孟坤霆意外发生关系，温柔只得生下一女。6年后，女儿温小暖不小心闯进了由孟家姻亲陆家牵头举办的重要宴会上，女儿更是直接抱上了国王孟坤霆的大腿喊他爸爸。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484326,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1QuVBw6A1DDjKG_aftVepEw?pwd=wpdd\",\"online_time\":\"2024-04-11 00:00:00\",\"time\":1712764800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"救救我老板\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"救救我老板\",\"description\":\"一个老板被关在手机里，找了个被生活所迫要自杀的年轻人来顶替他到公司寻找真相。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482826,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1BkwKMrPzJvODksH9acnoyw?pwd=67un\",\"online_time\":\"2024-02-28 00:00:00\",\"time\":1709049600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"教官心上欢，小妖精致命又凶残\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"教官心上欢，小妖精致命又凶残\",\"description\":\"娱乐圈三线小明星颜初倾被家人背叛掉入海中，被教官傅砚所救，颜初倾对傅砚一见钟情，决定追夫，当部队的高岭之花终于被颜初倾摘下时，她却发现傅砚是帝都豪门傅家二少，而自己父亲的死同傅家有莫大的关联。在这个过程中自己的身世，好友的算计，家族的阴谋一一将颜初倾裹挟，但好在她和傅砚始终相互信任，携手找出了当年的真相，有情人终成眷属\",\"second_cate\":\"女频总裁甜宠豪门\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477976,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1-Hw7DsfBRa4OUyYRiRTeJw?pwd=8egf复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-24 00:00:00\",\"time\":1692806400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"斩神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"斩神\",\"description\":\"他是一代帝师，他身背剑匣，行走天下，却意外卷入一场巨大的阴谋之中。他从一个大排档的意外冲突开始，逐渐揭开了一个涉及财阀家族、权力斗争和深层秘密的复杂谜团。身处权力和欲望的漩涡，白玉京必须运用他的智慧和武力，对抗来自各方的威胁和背叛。一部关于背叛、阴谋和正义的都市传奇，将带你走进一个充满悬念和惊喜的世界。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480346,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/12RuUA_vL2eiJMh91ByO77w?pwd=quw4\",\"online_time\":\"2023-11-24 00:00:00\",\"time\":1700755200,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"新婚夜，总裁逼我给白月光下跪\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"新婚夜，总裁逼我给白月光下跪\",\"description\":\"沈言嫁给傅星寒三年，身心俱疲，换来的，只是一纸离婚协议及无穷的羞辱与不信任，为什么，她明明把所有的事实都摆在面前，那个男人，却始终不相信她.....\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478476,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/19DerVC6zZNiDXN8yHzWufA?pwd=e8fw\",\"online_time\":\"2023-09-14 00:00:00\",\"time\":1694620800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"新婚夜，我被少帅哄一整晚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"新婚夜，我被少帅哄一整晚\",\"description\":\"武力值爆表的医生秦晚晚意外穿成了民国少帅府的傻夫人，一边装傻一边替女主报仇，教训那些对她心怀不轨的人。相处的过程中，她才发现，这个少帅，可比她想象中的要好玩多了~\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477876,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1s3P_HcFcnAoE3qicrbun5A?pwd=2eb9复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-19 00:00:00\",\"time\":1692374400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"新婚夜：植物人老公被我撩醒了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"新婚夜：植物人老公被我撩醒了\",\"description\":\"付时宜被继母卖给京都首富白家，与植物人白景霆结婚，白景霆曾对付时宜有救命之恩，付时宜心甘情愿，悉心照料。付时宜被前男友白津祎欺压，白津祎想要和付时宜联手害死白景霆被拒，因此处处针对付时宜，在付时宜被羞辱被责罚的时刻，白景霆醒了过来……\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479816,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1_vm46w2sBlZMG3BVWgoF_Q?pwd=dn4x\",\"online_time\":\"2023-11-10 00:00:00\",\"time\":1699545600,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无上修罗\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无上修罗\",\"description\":\"北境龙帅、修罗神殿代理殿主修罗林霄，因滨州江家江老爷子的遗愿，回到滨州与江氏集团总裁江若雪来履行婚约......\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481226,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1CfP_-4jWR1D9stC3YxgPFw?pwd=ky5x\",\"online_time\":\"2023-12-29 00:00:00\",\"time\":1703779200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无以为家\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无以为家\",\"description\":\"梁思凡和凌彬彬的父母是当年插队的上海知青，为回到上海抛弃了他们。15年后两人拿到奖学金并将出国深造，离开前决定到上海寻亲。没想到亲生父母只想拿到更多的钱，有了一次次的背叛、欺骗和伤害。\",\"second_cate\":\"女频年代/亲情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487666,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/19jjA6-pnY_LajPq2jtW8CA?pwd=77sy\",\"online_time\":\"2024-06-16 00:00:00\",\"time\":1718467200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无双傻婿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无双傻婿\",\"description\":\"华夏第一家族少主，天下第一奇门传人，竟然意外封印了自己的双魂五魄，当了五年的傻子上门女婿！五年来受尽欺凌，一朝觉醒，天下震动。\",\"second_cate\":\"男频赘婿\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483496,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Qn7KKTmRWdRV1H_Z4L4m5A?pwd=uz76\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无双败家子\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无双败家子\",\"description\":\"身患绝症又无钱治疗的沈三多，虽然是个孤儿，可是因行善积德重生成了首富之子，需要在三个月的期限内败光百亿家产，才能重获新生，在不断败家续命的过程中，沈三多并没有迷失本性，最终成为抱得美人归。\",\"second_cate\":\"男频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478636,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1PzjnzAsXhhB-HYVNOlnj8g?pwd=zb2h\",\"online_time\":\"2023-09-25 00:00:00\",\"time\":1695571200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无双龙尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无双龙尊\",\"description\":\"叶天龙调查暗魔王，发现其逃走。得知家人受害，他率天龙军回海城救援，低调搜查暗魔王踪迹，并保护自己的家人不受伤害。\",\"second_cate\":\"男频都市、赘婿\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488576,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1RTkRb1zo7Eh1VmlI0sn_jg?pwd=5zgn\",\"online_time\":\"2024-06-29 00:00:00\",\"time\":1719590400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无敌\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无敌\",\"description\":\"韩雨轩为妻子林清雪，退婚大夏第一女战神，放弃武安君的身份，甘愿隐身于小小郑城，隐藏身份筹谋三年，让大夏王族承认林清雪王妃的身份，就在册封大典的前一天，收到了林清雪的离婚协议书。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480656,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1EfauJ1ioVh213Jt4kbm47Q?pwd=3cmx\",\"online_time\":\"2023-12-12 00:00:00\",\"time\":1702310400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无敌从下山开始\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无敌从下山开始\",\"description\":\"男主秦浩川带着通天修为和六封婚书出山，不料刚下山就遇到了被人下药的女主纪雨萱，本好意救纪雨萱却意外发生的一夜情，随着一夜情对象实际是秦浩川未婚妻真相的揭开，纪雨萱也因此打开了心结，决定重新给秦浩川一次机会。但其余5位婚约对象却纷纷登门要求提亲。面对5位提亲家族的“诱惑”，秦浩川虽然拒绝了5个家族，亲手撕毁了婚约，这也为以后惹来了祸根。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480366,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1WRPgzxGSZBXLn76HZMrddw?pwd=5bif\",\"online_time\":\"2023-11-25 00:00:00\",\"time\":1700841600,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无敌双宝，总裁爹地好神秘\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无敌双宝，总裁爹地好神秘\",\"description\":\"司夏在订婚前夕，被继妹林染雪陷害，导致跟盛朔发生关系，同时意外怀孕。四年后，带着一双儿女回国，进入盛朔所在的公司，夜晚在酒吧认出的带面具的盛朔是孩子的亲生父亲，却不知道他是自己的顶头上司。司夏不断周璇在两个关系中，对公司总裁老板的男主有了好感，也对误会在夜总会上班的盛朔有了好感。一切从盛朔邀请司夏假扮自己的女朋友开始有了转机，期间两个萌宝以司夏弟弟妹妹的方式不断助攻，最后误会解开，一家四口幸福的生活在一起。\",\"second_cate\":\"女频现言萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478896,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1nX7am6E9cEpBk9oEnrmr8Q?pwd=nbgs\",\"online_time\":\"2023-09-30 00:00:00\",\"time\":1696003200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无敌双宝：爸爸去哪儿了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无敌双宝：爸爸去哪儿了\",\"description\":\"司夏在订婚前夕，被继妹林染雪陷害，导致跟盛朔发生关系，同时意外怀孕。四年后，带着一双儿女回国，进入盛朔所在的公司，夜晚在酒吧认出的带面具的盛朔是孩子的亲生父亲，却不知道他是自己的顶头上司。司夏不断周璇在两个关系中，对公司总裁老板的男主有了好感，也对误会在夜总会上班的盛朔有了好感。一切从盛朔邀请司夏假扮自己的女朋友开始有了转机，期间两个萌宝以司夏弟弟妹妹的方式不断助攻，最后误会解开，一家四口幸福的生活在一起。\",\"second_cate\":\"女频现言萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478906,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/10smDXPleNpuInZFBAXKqVA?pwd=juyg\",\"online_time\":\"2023-09-03 00:00:00\",\"time\":1693670400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无敌神之手\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无敌神之手\",\"description\":\"在混混武康前来逼债时，张立意外的觉醒了神之手的异能。张立用异能赶走混混后，又遇夏美书母女二人的羞辱，张立不得不出手教训。而在此时，医院要求张立立刻交出医药费。可张立在去往医院的路上又撞上了女友出轨，在愤怒中张立拿着钱前往医院。在去往医院的路上，张立教训康帅，并救下美女医生华医生。以致后来在张立遇到护士欺辱时，华医生出手相助。\\n而与此同时，因为张立赶走了混混。并没有还钱。在医院缴费中，道遇了混混夏海带头的报复。可是，区区夏海又怎么会是拥有神之手的张立的对手，最终，夏海认栽，并赔偿给张立一百万的医疗费。张立从医院回家的途中救下了乔家三小姐乔予。可也因为此事，导致张立和周霖枫积怨加深，并导致乔易误会张立，从而让二人一直有矛盾误会。张立回到家后，花了几天时间研究神之手，并在此期间升级了不少的神奇物品。\\n张立利用这些神奇物品在古董街淘宝，并在此结识了朱明。朱明也在此邀请涨立参加万宝会。张立用夏海的医疗费和古董街淘宝赚的钱，与乔予一同前往交易所。在交易所门口遭遇大堂经理的刁难，好在当时乔予在场，才让张立能够在接下来的期货市场大展神威，并在此狠狠羞辱了周霖枫。\\n张立带着姝妹和乔子去吃饭时，再度遇到夏海和康帅二人，张立再次教厦夏海，这也让夏海心中仇怨极深，从而导致最后夏海与周霖枫合伙绑架乔予和张兰事件的发生。万宝会上，张立大战赵大师，为自己正名，为朱明挣面。可也在此时，收到了妹妹和乔予被绑架的消息。张立怒极，利用神器物品快速救出妹妹。而此时，他的异能被不少人看到，他的期货之神的名号也被人传开。最终，张立和张兰隐于市。\",\"second_cate\":\"男频异能\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479386,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1mK8ErbMVUZ9taehAzYRzUw?pwd=csq1\",\"online_time\":\"2023-10-21 00:00:00\",\"time\":1697817600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无敌龙婿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无敌龙婿\",\"description\":\"天师高阳，因缘际会，嫁入苏家当了三年上门女婿。三年假象，一朝梦醒。自此开始，高阳开启了不一样的人生，他一眼能断吉凶，武道能镇压无敌。一念，我可可以把你高高捧起，成为人上人。一念，我可以把你踩在地上，卑微如蝼蚁。世界之巅，有我足矣!\",\"second_cate\":\"男频赘婿\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477926,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1-OQAi-40qO2sNKb63LO7EA?pwd=7bet复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-19 00:00:00\",\"time\":1692374400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无极天尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无极天尊\",\"description\":\"霍铮一生为国征战，国主却听信小人谗言，派人除掉他以免“功高震 主 ” 。 身负重伤失去记忆的他功力被封印，靠送外卖解决一家人的温饱，儿子的一场大病拖垮了他，无意间更是发现了老婆出轨，儿子也非亲生。霍铮本已放弃生的希望，一场车祸不但让他恢复了记忆与功力，还碰见多年前一见钟情的女人…… 名誉，权力，财富，他会夺回曾失去的一切，携两大至宝和幕后隐藏的黑手抗衡，他 就是天地共主 —— 霍铮！\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483646,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":23,\"material\":\"https://pan.baidu.com/s/1HPitMJuXMyw-qMZSAppIzg?pwd=8si7\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无毒不女人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无毒不女人\",\"description\":\"安澜撞见丈夫和闺蜜偷情还被丈夫扫地出门，被季氏总裁季凉川撞伤失忆。季凉羽暗中操作她整容成季凉川初恋模样，与季凉川陷入情爱纠葛。安澜逐渐恢复记忆，发觉身边人都在欺骗利用她，于是决定向所有人复仇!\",\"second_cate\":\"女频复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485756,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1pf3xcXzlHfW9fgfVPk-cVA?pwd=wdkw\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"无法抗拒的她\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"无法抗拒的她\",\"description\":\"唐箐箐女扮男装伪装成保镖，结果意外之下救下遇到危险的萧氏董事长萧逸，萧总聘请唐箐箐做自己的贴身保镖。成为萧逸的贴身保镖。在进入公司之后，唐箐箐发现萧逸的身上有过和自己同样的命运。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484566,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1CQ-lKUS1EhH0ugxGDji0RA?pwd=5e9j\",\"online_time\":\"2024-04-19 00:00:00\",\"time\":1713456000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"日结巨富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"日结巨富\",\"description\":\"叶凡原本是海城第一世家叶家的唯一继承人，为了爱情脱离家族，每天送外卖为生，差点被害死，并发现这是他深爱的女人的阴谋。男主决定回归家族，获得继承人的身份，打脸前女友和恶少，认回孩子，走向人生巅峰。\",\"second_cate\":\"男频神豪\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480426,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1PQGodfeeouHsfvdBVX1wkw?pwd=56pp\",\"online_time\":\"2023-11-27 00:00:00\",\"time\":1701014400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"日行一善\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"日行一善\",\"description\":\"因研究出了新型芯片，苏知梦被境外势力一路追杀到苏氏集团，偶遇此时只是集团的保安队长江寒，江寒出手将追杀的杀手击退。在得救之后，苏知梦觉得江寒身份非同一般，开始从自己的渠道展开调查····\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486466,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":19,\"material\":\"https://pan.baidu.com/s/1aH3OptTk8EviJnyCyOKNzA?pwd=vawh\",\"online_time\":\"2024-05-12 00:00:00\",\"time\":1715443200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"时先生，换我来爱你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"时先生，换我来爱你\",\"description\":\"盛千意为帝都盛氏集团千金，因爸妈离奇失踪，由舅舅一家抚养，谁知被渣男贱女欺骗惨死。一次意外，盛千意醒悟后开始悄悄复仇，还爆出了三个马甲，她也最终找回了真实记忆，夺回一切，与男主甜蜜相守。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485456,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/16Y0us5ytOCmunGwku67z_w?pwd=dg48\",\"online_time\":\"2024-05-19 00:00:00\",\"time\":1716048000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"时光不敌我爱你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"时光不敌我爱你\",\"description\":\"陆佳佳车祸后穿进一本年代文成跪舔知青周文清的极品女配。为避免像原主一样凄惨而死，陆佳佳第一时间跟周文清拉开距离。薛彦不喜欢原主却被穿书而来的陆佳佳吸引，陆佳佳也没想到补偿最后把自己给赔了。\",\"second_cate\":\"女频年代、穿书\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488626,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1VBQzab48sZy-PYQoOagGJQ?pwd=iunh\",\"online_time\":\"2024-06-30 00:00:00\",\"time\":1719676800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"昆仑\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"昆仑\",\"description\":\"在神界，萧阳乃六界至尊，一朝回到人界，他却成为痴傻稚儿，被一个女人养了五年。一次闭关，走火入魔，萧阳神魂被困神界百年，成为六界至尊后踏破虚空回到人界，人界肉身因为失魂痴傻五年，被锦盛集团总裁叶诗语收养，在萧阳神魂回归之后，为报恩留在叶诗语身边，意外发现龙戒，得知寻找十年的小女孩正是叶诗语，两人修成正果。\",\"second_cate\":\"男频都市玄幻\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479826,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1RxKC7nkceSuwQGzY_FWzEA?pwd=9dfx\",\"online_time\":\"2023-11-10 00:00:00\",\"time\":1699545600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"昆仑殿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"昆仑殿\",\"description\":\"名震四方的昆仑殿主叶昆仑归来，低调的他拒绝了多位名媛千金示爱，只求守护对自己有恩的冯家，并报仇血恨，手刃为难欺凌冯家的仇敌\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479336,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1joDV4XNiWBdQNkHjWe6G6g?pwd=mq2v\",\"online_time\":\"2023-10-17 00:00:00\",\"time\":1697472000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"昆仑殿主\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"昆仑殿主\",\"description\":\"名震四方的昆仑殿主叶昆仑归来，低调的他拒绝了多位名媛千金示爱，只求守护对自己有恩的冯家，并报仇血恨，手刃为难欺凌冯家的仇敌\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479276,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1geZn-2gV60PidQywv1E8Og?pwd=uhff\",\"online_time\":\"2023-10-14 00:00:00\",\"time\":1697212800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"昆山九缘\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"昆山九缘\",\"description\":\"十年前，叶家乃九州第一大家，经神秘组织陷害后在一夜间被灭门，作为叶家唯一幸存者叶辰被母亲挚友接到昆仑山，至此拜师学艺整整十年。十年之期已到，叶辰拜别师父后下山，拿着早年间叶家给他订下的三门婚书，决定退掉婚约，了却尘世恩怨，寻找十年前的真相，且重振叶家。叶辰拿着第一张婚书来到云家……\",\"second_cate\":\"男频复仇/高手下山/战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482726,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1MtscMZqZ6edJKdFx1qlp6g?pwd=pj8t\",\"online_time\":\"2024-02-26 00:00:00\",\"time\":1708876800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"星光陷阱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"星光陷阱\",\"description\":\"影后甄甜被未婚夫影帝颜承亦害死后重生到十八线明星田真儿身上，并意外获得读心术。正当她决心复仇时，却发现原主竟是慕氏总裁慕御风的隐婚妻子，并和颜承亦有着难以言说的关系。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487506,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1o6Eonhuq-_midUmK0t9GEg?pwd=sr76\",\"online_time\":\"2024-06-14 00:00:00\",\"time\":1718294400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"星河帝国\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"星河帝国\",\"description\":\"保安林星河玩的一款游戏意外成真，他在游戏中创建的星河帝国降临在蓝星之外，他成至高无上的星河帝国元首陈软。林星河遇到了苏清雪，为追求她，前往苏清雪父亲的寿宴，寿宴上处处被贬低，但他元首身份即将曝光。\",\"second_cate\":\"男频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488516,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1pYGQgR6SP_4XPsb0TJb3QQ?pwd=yhyi\",\"online_time\":\"2024-06-29 00:00:00\",\"time\":1719590400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"春棠欲醉\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"春棠欲醉\",\"description\":\"前世，宋棠宁是全盛京最娇贵的女郎，却因一个庶女，死在了至亲兄长和青梅竹马的未婚夫手上。 他们夺走她的一切，毁了她的人生，踩着她的尸骨捧着庶女成为耀眼的骄阳，而她却毁容断腿，被囚于废院多年活活遭人勒死。 重生后，棠宁再也不要当那踏脚石。 冷漠偏心的兄长，她不要。 爱慕白莲的表哥，她断亲。 三心二意的未婚夫，她退婚。 等撕开庶女嘴脸，兄长们和未婚夫跪在面前求她原谅。 宋棠宁冷漠：原谅？呵，烧死了灰扬了才好。 她已经有阿兄了，虽然新找的阿兄是个太监，名声不好，冷戾狠辣，远远唤声督主就能吓的小儿啼哭。 可他唤她“小海棠”时，温柔极了。 …… 萧厌最初与棠宁独处时，被人说于礼不合：“本督是个太监，有什么礼？” 后来满室暖香，萧厌抱着醉红了眼的小姑娘：“小海棠，阿兄疼你。”\",\"second_cate\":\"女频/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488326,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1YaDrdxVOdVDePALMu_zv1A?pwd=jpac\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"昨夜思念如风\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"昨夜思念如风\",\"description\":\"女主一朝醒来，发现自己穿成了年代文被抱错的假千金主角司念，此时的司念面临要嫁给一个带着三个孩子的养猪场老板，熟知剧情的她，二话不说，直接嫁人，就此开启了一场欢欢喜喜乡村甜宠带娃日常~\",\"second_cate\":\"女频年代、穿书、轻喜甜宠日常流\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480466,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ZMNSmchIxvrf5FkLoETqaw?pwd=ba43\",\"online_time\":\"2023-12-04 00:00:00\",\"time\":1701619200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"昨夜星辰恰似你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"昨夜星辰恰似你\",\"description\":\"女主一家人一夜之间全部“意外”身亡，女儿的丈夫顺利继承了首富家产。早年丢失的女主终于找到父母，却得知父母已全部身亡，姐夫继承了遗产，女主决定复仇姐夫，却意外发现真正害死父母的竟是姐姐。\",\"second_cate\":\"女频亲情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486026,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/13hnxd3jqgNiM0BNUumAWLQ?pwd=u559\",\"online_time\":\"2024-05-28 00:00:00\",\"time\":1716825600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"是他先动心\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"是他先动心\",\"description\":\"姜栀把江祁年从一个小透明捧成大明星，却没想到江祁年站上领奖台时，当众背弃侮辱姜栀，既然你说我一文不值，那我就随便找个人将他捧上你的位置，但没想到，姜栀随手一抓的路人，却是公司新上任的总裁，更没想到的是，这个路人对她蓄谋已久……\",\"second_cate\":\"女频现言\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484226,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1olHGZKvpo_hJ3gxmOqxrQw?pwd=1w5v\",\"online_time\":\"2024-04-09 00:00:00\",\"time\":1712592000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"是妈妈是女儿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"是妈妈是女儿\",\"description\":\"唐欣欣幼年帮助母亲逃离控制欲强的父亲，却与母亲失散。成年后，她为赚钱治病成为弟弟家教，与母亲误会加深。唐欣欣因遗传病生命垂危，选择隐瞒真相，与他人共编善意谎言，避免母亲再次承受失去女儿的痛苦。\",\"second_cate\":\"女频亲情/寻亲\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487546,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1ndGhpDlcYMtXY3bPLyg9ig?pwd=jnbk\",\"online_time\":\"2024-06-14 00:00:00\",\"time\":1718294400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"是风动了我的心\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"是风动了我的心\",\"description\":\"颜采薇为了救出被未婚夫宁北凡和闺蜜江娇陷害入狱的父亲，委身于宁家掌权人宁归风。宁归风暗中出手，救出颜采薇父亲。众人都十分好奇，颜采薇的靠山到底是谁？宁北凡和江娇贼心不死，还想要颜采薇的命，危难之际，宁归风及时出现，救她逃离了魔爪，打脸众人。而和宁归风纠缠期间，她暗动芳心，本以为会无疾而终，但宁归风对她事事顺从，让她生了欢喜之心，她开始以为两人是两情相悦，宁归风未婚妻沈雪儿的回来却打破了现在的平衡，也让她知道了宁归风的秘密……\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483486,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1TKVJnhOKIQf8NwjUld4hCA?pwd=mndj\",\"online_time\":\"2024-03-20 00:00:00\",\"time\":1710864000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"景少帅你搞错心上人了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"景少帅你搞错心上人了\",\"description\":\"颜心前世被枕边人一家所害，丈夫和儿子合谋用颜家药铺卖官鬻爵，一朝重生后颜心决定向丈夫一家复仇。重活一世复仇途中却意外和少帅景元钊发生一场巧取豪夺的爱恨纠葛，颜心该如何在霸道少帅的爱情陷阱和前世仇恨中游刃有余？\",\"second_cate\":\"女频民国/重生/宅斗\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483536,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1XftlNMWXH_dim_r1ILNdjg?pwd=ikp2\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"景少的在逃娇妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"景少的在逃娇妻\",\"description\":\"原本心有所属的顾念因破产缺钱被迫嫁给景容，两人先婚后爱，再因某些人、事产生隔阂，感情拉扯，最后兜兜转转彼此敞开心扉，成为最幸福的一对。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479886,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1MT8mBJEL9MGlOYCaQISLnQ?pwd=i4nc\",\"online_time\":\"2023-11-14 00:00:00\",\"time\":1699891200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"暴富后前女友后悔了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"暴富后前女友后悔了\",\"description\":\"实习医生林炎发现未婚妻高倩倩出轨，却遭到羞辱。林炎被打伤丢出医院后，遇到了来让自己继承家业的父亲，从此成为富豪之子，他立马带着上官初雪离开了医院。拥有神医之术的林炎离开之时，碰巧治好了冯大小姐。\\n林淼为了争夺家族继承权，想祸害吞并冯家，击垮林炎。来回争斗中，林炎彻底击溃了林淼，最终继承林氏，和上官初雪在一起过上了美好生活\",\"second_cate\":\"男频神豪神医\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479656,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1NF1GP7wEIaswOhUT6evM6A?pwd=wcxn\",\"online_time\":\"2023-11-06 00:00:00\",\"time\":1699200000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"替嫁千金除三害\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"替嫁千金除三害\",\"description\":\"苏音与哥哥年幼时被卖进豪门君家，二人受尽欺辱惨死。重生后，再次面临代替君家亲女儿嫁给残废男主墨辰的抉择，苏音决定嫁入墨家，对君家展开复仇，找回了亲生哥哥，与墨辰先婚后爱迎来甜蜜生活。\",\"second_cate\":\"女频大女主/复仇/白切黑\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486326,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1fpeWu3NQRheue_0SLFKXaQ?pwd=enrn\",\"online_time\":\"2024-04-27 00:00:00\",\"time\":1714147200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"替嫁娇妻99次出逃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"替嫁娇妻99次出逃\",\"description\":\"萧云霆被苏嫣然所救，却因为黑夜误以为是苏嫣然的姐姐，苏忆楠救了自己。恰好苏爸爸债台高筑，萧云霆便趁机要求苏忆楠嫁过来，免清债务。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478336,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1eDEVMgNVRdNuT6nC-xKE8A?pwd=mhys\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"替嫁当晚，植物人老公睁眼了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"替嫁当晚，植物人老公睁眼了\",\"description\":\"本剧讲述了女主顾云汐在一场家庭设计的阴谋下，替嫁给发生车祸变成植物人的男主凌氏集团总裁凌千夜。新婚当晚，植物人老公凌千夜被她一针扎醒。醒来后的他狠厉孤傲，甚至一再向她提出离婚......经过一段时间的重重纠葛，他竟又屁颠颠的跟在顾云汐的身后？“救命之恩当以身相许，你得对我负责到底！\",\"second_cate\":\"女频都市甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479766,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1zOC3PCTp99vLB_2Ty54CdQ?pwd=edym\",\"online_time\":\"2023-11-09 00:00:00\",\"time\":1699459200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"替嫁甜婚：霍总宠妻花样多\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"替嫁甜婚：霍总宠妻花样多\",\"description\":\"李悠悠是叶家养女，叶家大小姐叶夕颜不愿嫁给身体不好的霍龙章，逼李悠悠替嫁进霍家。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479066,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1IJtA7vgSNPIrt8HScH1BxA?pwd=dwky\",\"online_time\":\"2023-10-11 00:00:00\",\"time\":1696953600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"替身龙主\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"替身龙主\",\"description\":\"升龙殿世代守护大夏。三年前，升龙殿龙主被手下贪狼背刺，重伤失踪。龙主失踪后，贪狼趁机勾结首辅之子萧天赐和倭国势力，意图夺升龙殿龙主大权并颠覆大夏。危机四伏之际，升龙殿摇光女战神找到失忆的云泽，发现其和龙主长得一模一样，于是摇光软硬兼施，逼云泽为龙主替身应对各种危机。\",\"second_cate\":\"男频战神、失忆、身份悬疑、爱情、打脸\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482876,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1gB9iIumoe4ysM6GaeOXh-Q?pwd=uip9\",\"online_time\":\"2024-03-01 00:00:00\",\"time\":1709222400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"替闺蜜相亲总裁赖上我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"替闺蜜相亲总裁赖上我\",\"description\":\"女主是自立自强各种做兼职替家里还债的校花，男主是父母离异有过童年阴影的霸道总裁。女主为了拿到10万块替富二代闺蜜相亲，不料相亲对象却是自己的老板。女主使劲浑身解数为闺蜜搞砸家里安排的相亲，不聊男主却一眼认定、非她不娶。于是，一场猫与老鼠、你追我逐的恋爱游戏开始了。剧情伴随女主与闺蜜二人不同的感情线交叉推进展开，是一部治愈甜蜜、能上头又下饭的短剧神作。\",\"second_cate\":\"女频霸总、甜宠、现代都市、闺蜜、搞笑\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483066,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1YAISMhnzSB4GA5qZSn70Wg?pwd=myga\",\"online_time\":\"2024-03-08 00:00:00\",\"time\":1709827200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"最强·王者归来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"最强·王者归来\",\"description\":\"繁天，沙场上不可一世的御天大将军，血统高贵的海城大公子，如今却隐姓埋名于凡俗，为爱甘愿过起了平凡生活。不料妻子徐盈盈攀炎附势，为徐家重回昔日巅峰，背叛丈夫，委身海城四大世家之一的陈氏三太子陈硕。海城权贵割据，民不聊生，帝都欲弃之，特派京都圣姑前来行祭祀大典。繁天为保百姓安危重新卷入乱世。陈硕一众屡屡越界，跋扈挑衅，繁天当仁不让，依次清洗，海城终得太平，圣姑钦佩其风范，并因预和天命的能力算出繁天乃自己命中克星，需与其生下一子，方可破除诅咒，，圣姑强求繁天与自己行云雨之事，然而海城新的危机亦在俏然氤氲......\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481086,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1J83S4iIIWcjIrkd8hVlu1w?pwd=4j5i\",\"online_time\":\"2023-12-25 00:00:00\",\"time\":1703433600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"最灿烂的她\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"最灿烂的她\",\"description\":\"钟意5岁生日母亲赠予玉佩项链，二婶以灾星罪名把钟意驱逐出家门，钟意被猪肉摊的小贩钟强林娟捡到。钟意不断被何家人欺辱，何家人得知钟意真实身份后愧疚自责，最终钟意回到何家揭穿了二婶阴谋。\",\"second_cate\":\"女频寻亲\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486656,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"链接：https://pan.baidu.com/s/1Fr1u0HWDkh60VAHXsenu_g?pwd=anwb\\n提取码：anwb\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-26 00:00:00\",\"time\":1716652800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"月子期和渣男离婚后\\u0026月子期和渣男离婚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"月子期和渣男离婚后\\u0026月子期和渣男离婚\",\"description\":\"欧阳倩八岁的时候被收破烂的张春菊捡到改名为张子萱。十五年后，张子萱嫁给了老公李博文，李博文却在张子萱坐月子期间出轨孙艺，张子萱受尽侮辱后与李博文离婚。离婚后，张子萱与三个哥哥相认，华丽变身归来。\",\"second_cate\":\"女频逆袭/团宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487496,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/11g6OJVqjGvGTXb3jHbiq1w?pwd=h2ut\",\"online_time\":\"2024-06-14 00:00:00\",\"time\":1718294400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"有女成凤\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"有女成凤\",\"description\":\"姐弟同时考上大学，父亲撕毁女儿的通知书，并打算将其嫁给村长的傻儿子，女儿连夜逃跑。十年后功成名就归来，想起父亲和族长的迫害，在看到母亲的惨状后，盼娣决定在宗谱大典上揭示他们的虚伪面目。\",\"second_cate\":\"女频亲情、女强\",\"episode\":0,\"platform\":\"tikTok\",\"update_time\":1720489016,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1bUlk7IyrpylOR676mgHMTw?pwd=yxhj\",\"online_time\":\"2024-07-09 00:00:00\",\"time\":1720454400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"服了她满级你惹她干嘛\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"服了她满级你惹她干嘛\",\"description\":\"超级女杀手重生在了丑女乔影身上，在洞悉了主身身世后。决定替乔影出口恶气，阴差阳错的救了帝都第一权贵秦时言。秦时言对这个外表奇特却极具个性的女孩产生了极大的兴趣。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486926,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1zNhrw0R6k349J2irbRk0rA?pwd=vhux\",\"online_time\":\"2024-06-05 00:00:00\",\"time\":1717516800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"朝来寒雨晚来风\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"朝来寒雨晚来风\",\"description\":\"二十年前，林红为救女儿与洛家千金调换身份，为了见到女儿去洛家当保姆，不想不断被女儿洛雪晴欺辱直到去世，林红养女真千金林念念得知真相，决定为养母报仇，回到洛家历经艰难揭开身世谜团，为养母讨回公道。\",\"second_cate\":\"女频亲情、复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485256,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1BHirRAQtti94skpwiB5OyA?pwd=nurf\",\"online_time\":\"2024-05-14 00:00:00\",\"time\":1715616000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"未婚夫帮我吊打绿茶\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"未婚夫帮我吊打绿茶\",\"description\":\"陈若曦是龙国首富陈家的千金小姐，小时候被人贩子拐走，被清洁工王翠芬捡到，王翠芬拼尽全力将陈若曦养大，后来陈若曦嫁给章天德，陈若曦选择到工地上做苦力来帮助章天德，谁曾想章天德为了走捷径背叛了陈若曦。\",\"second_cate\":\"通用现代/团宠\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486726,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1I4YOS-ZxCwPKBIhaQzgKAw?pwd=nt8t\",\"online_time\":\"2024-06-01 00:00:00\",\"time\":1717171200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"末日游戏\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"末日游戏\",\"description\":\"前世，主人公赵宇在未世来临时依旧选择善待别人，但他的善意却被以贺向明为主的恶人利用而最终导致自己和好友身死。临死前，赵宇意外地重生到了末世来临的一天前并保留了之前的记忆，重生后，为了在未世中生存下去，赵宇利用参加游戏活动对包括贺向明在内的恶人们的复仇。\",\"second_cate\":\"男频复仇/重生末世\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483886,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1QgoALyht3URbgx-3HMjKVg?pwd=ej4c\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"末日重生之嫁给渣男死对头\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"末日重生之嫁给渣男死对头\",\"description\":\"大灾难来临，女主许知意被肖梁欺骗找男主沈瑜南要食物，男主为了保护女主交出食物，惨遭反水，刺杀身亡。女主殉情后意外重生到大灾难之前，与男主打造安全屋，抵御寒冬和外敌，共度末日的故事。\",\"second_cate\":\"女频穿越、重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484616,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/11C31Ywt_sXBdCPVTXZjLCg?pwd=9nu8\",\"online_time\":\"2024-04-20 00:00:00\",\"time\":1713542400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"末日：求生之路\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"末日：求生之路\",\"description\":\"公元2072年，岛国核污水引发末日狂潮，病毒肆虐，感染者失控暴行。江凡重生至病毒爆发前，集结旧部携手王欣怡与张佳佳历经茶山避难营、伊甸园等险境，成功研发抗病毒血清粉碎岛国阴谋，拯救人类于末日危机。\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486376,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1eHcmBvxFT7AmiS9H4MCBTA?pwd=atup\",\"online_time\":\"2024-04-30 00:00:00\",\"time\":1714406400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"来不及爱你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"来不及爱你\",\"description\":\"女主被拐卖多年后被富豪沈家认回，但等待她的不是温暖的家人，而是一场场冰冷的交易，原本以为能够借助沈家给自己的养母治病，结果迎接她的确实一场场的虐待。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486346,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/15T_Uha54wB8rqfF4G2WU8w?pwd=p4tv\",\"online_time\":\"2024-04-29 00:00:00\",\"time\":1714320000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"来时有归途\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"来时有归途\",\"description\":\"叶溪在三年前为了秦砚放弃家族继承人的身份，在背后默默支持秦砚的事业，在秦砚取得与叶氏集团签约S级订单的机会当天，被秦砚的母亲加秦砚的小三齐臻臻等人扫地出门，女主就此展开惩治渣男计划\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485366,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1tBVtKiUzVKdagiGoaxo9mg?pwd=bwa9\",\"online_time\":\"2024-05-18 00:00:00\",\"time\":1715961600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"来自星星的4个哥哥都宠我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"来自星星的4个哥哥都宠我\",\"description\":\"n3星女将前往地球“历劫”，变成普通人简浅，记忆全失，遭到继母和同父异母姐姐欺辱，又被旧仆背刺，外星哥哥们得到信息后来到地球各种帮助。历经劫难，最终和对她不离不弃的厉尘有情人终成眷属。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484756,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1wEl8HEtRMJVkBIjhvqoEEw?pwd=vdym\",\"online_time\":\"2024-04-26 00:00:00\",\"time\":1714060800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"极品外卖员降服绝世风华三姐妹\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"极品外卖员降服绝世风华三姐妹\",\"description\":\"陈远辛苦送外卖赚钱，却没想到其女友姚澜澜出轨富家公子方冲天，并设计夺取了陈远父亲留下的唯一遗产。殊不知，陈远其实是天洲首富陈家失散多年的独子，陈远对那些曾经欺辱他的人展开了复仇计划。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487426,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1G7gHGjkNNM61MHYfaGD82Q?pwd=gp75\",\"online_time\":\"2024-06-12 00:00:00\",\"time\":1718121600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"极品辣妈不好惹\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"极品辣妈不好惹\",\"description\":\"为了给自己的两个双胞胎孩子找个父亲，江暖相亲相到了云城首富盛临渊。江暖以为是哪里搞错了，就拒绝了盛临渊，但没想到盛临渊却死皮赖脸缠了上来。盛临渊：没办法，孩子让我签了追妻协议，我只能把你追到手。江暖：签了追妻协议是吧？那就再签一份婚前协议吧。\",\"second_cate\":\"女频萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483926,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1W7VCzXqhqlg0a92ueLskdg?pwd=se9n\",\"online_time\":\"2024-03-29 00:00:00\",\"time\":1711641600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"极品逍遥皇太子\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"极品逍遥皇太子\",\"description\":\"开局穿越成了大夏太子爷，何奈已经被废。也好，叶洵也志向不大，只愿做一个声色犬马，醉卧美人膝的逍遥王爷 。然，事与愿违。本无意再起波澜的叶洵，被硬生生推到了漩涡中，乱世将起，谁主沉浮。且看叶洵如何笑傲大夏，搅弄风云。\",\"second_cate\":\"男频古装穿越\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479496,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1RCda7CmUFL4RUIGeirHSZQ?pwd=7x3i\",\"online_time\":\"2023-10-27 00:00:00\",\"time\":1698336000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"极致体验：我的老婆是美人鱼\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"极致体验：我的老婆是美人鱼\",\"description\":\"安氏集团少爷安憬琛被人算计下药，意外与人春风一度，殊不知那人竟是来暗杀的人鱼公主虞浅浅。原来安氏集团涉嫌利用人鱼族提炼药物，人鱼公主正是因此来复仇的。但是意外发生，虞浅浅竟失忆了，安憬琛不得不肩负起照顾这个傻妻子的责任，只是这个傻妻子却另有目的！\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479626,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Nf_RyutycyeRZyh4uvj7vw?pwd=ypg8\",\"online_time\":\"2023-11-03 00:00:00\",\"time\":1698940800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"极限营救\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"极限营救\",\"description\":\"24岁的普通女孩江心月重病后，获得了看到死亡倒计时的能力，还发现自己与沈氏集团总裁沈秋白绑定，两人每救一个人，她就能多获得一天寿命。自此与沈秋白一起，踏上了极限营救的旅途。\",\"second_cate\":\"女频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485816,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/11h8h7tHJcoH9AhJBqn66Vw?pwd=89d6\",\"online_time\":\"2024-05-25 00:00:00\",\"time\":1716566400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"染指\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"染指\",\"description\":\"商业帝国掌舵人林染在退婚当日受创失忆，从此落入阴谋的漩涡之中，谁说忘记是新的开始，只要故人仍在，一切都是命运的安排……\",\"second_cate\":\"女频现言\",\"episode\":0,\"platform\":\"\",\"update_time\":1720483446,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/109bdLOvJZcA52Mn5iKw_WQ?pwd=ti98\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"桑总别虐了，夫人她要嫁人了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"桑总别虐了，夫人她要嫁人了\",\"description\":\"南枫做了桑总五年的地下情人，最终也只旱换来桑总订婚的消息,伤心之余却接连遭逢打击，自己怀孕，继父欠债，所有压力来袭的时候,南枫却再也不想求助于那个人。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477686,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ls-RvKDVqF5UIbQMQwTQoA?pwd=fbd3复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-16 00:00:00\",\"time\":1692115200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"梧桐叶里思星辰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"梧桐叶里思星辰\",\"description\":\"顾桐被姐姐陷害，无意中跟夜司宸露水相逢后，被迫代替姐姐嫁给夜司宸。在跟顾桐的逐渐相处中，夜司宸逐渐爱上性格率真的顾桐，理解顾桐的难处，帮她扫平前方的一切道路，最后步入婚姻的殿堂。\",\"second_cate\":\"女频甜宠/都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483386,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1Hh5Wo0xi9gQHixsaZZWQ_A?pwd=tdx4\",\"online_time\":\"2024-03-16 00:00:00\",\"time\":1710518400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"植物人被老婆弃在医院，睁眼即巅峰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"植物人被老婆弃在医院，睁眼即巅峰\",\"description\":\"大佬意外成为植物人，在乡下医院自生自灭五年，竟是被发妻抛弃，签下离婚协议书。当主角韩雨轩睁开眼，即风云归来…\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480736,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":7,\"material\":\"https://pan.baidu.com/s/1xM407HpvGYwufjss1_csXw?pwd=xppm\",\"online_time\":\"2023-12-13 00:00:00\",\"time\":1702396800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"歌手2024之闪耀歌坛\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"歌手2024之闪耀歌坛\",\"description\":\"陈晓莹在遭受背叛和身体伤害后，通过努力重新站起来追求自己成为歌手的梦想。在面对曾经的背叛者和新挑战时，她不断成长，最终在歌唱比赛中获得认可，赢得了尊重和爱情。\",\"second_cate\":\"女频娱乐圈/虐渣\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488886,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1uZPdV48cSw3QpurDSpzc5A?pwd=q3sy\",\"online_time\":\"2024-07-05 00:00:00\",\"time\":1720108800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"此意绵绵\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"此意绵绵\",\"description\":\"林施生前被丈夫姜来背叛，被第三者王钰侮辱，连自己唯一的希望——六岁的女儿果果也在王钰的陷害之下死亡。林施为了报复这对狗男女，于是整容变成了王钰继女——陈玲。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720484076,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1WiKOHzFax_oCZEi9iSd5oA?pwd=kmin\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"步步攻心\\u0026步步夺心\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"步步攻心\\u0026步步夺心\",\"description\":\"从小被人贩子拐走的女主长大后历尽千辛万苦终于找到亲生父母，就在相认的那一刻，父母被车撞死，痛苦欲绝的女主这一切的阴谋全部都是养女盛开所谓，男主发现女主并且救了她，二人开始了复仇之路。\",\"second_cate\":\"女频复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487956,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1qb9dAXQHvwfz-cRwsrUX8Q?pwd=at4m\",\"online_time\":\"2024-06-21 00:00:00\",\"time\":1718899200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"武安\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"武安\",\"description\":\"大夏武安君秦武安在新婚之夜被结义兄弟沈枭下毒，打下悬崖失去记忆，被苏蔷薇所救。苏蔷薇被逼婚，秦武安的未婚妻江晚意也在苦苦抵挡沈枭。登基大典在即，秦武安终于恢复记忆，誓要夺回自己的一切。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488036,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"链接：https://pan.baidu.com/s/1033qtQmTPk7Q53Qu2WW5xQ?pwd=layv\\n提取码：layv\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"2024-06-21 00:00:00\",\"time\":1718899200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"死对头他千娇百媚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"死对头他千娇百媚\",\"description\":\"女主在婚礼当天意外和来找茬的死对头交换身体，两人不得不假扮对方生活，在发现女主未婚夫是女主弟弟找来的渣男后两人决定联合起来收拾反派，最终女主踹掉渣男惩治反派，和男主一起迎来幸福结局。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484816,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1VCEmkBJw00ZXj1a_J-AFow?pwd=dek7\",\"online_time\":\"2024-04-28 00:00:00\",\"time\":1714233600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"残疾大佬掐腰吻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"残疾大佬掐腰吻\",\"description\":\"订婚前夜家族破产，未婚夫退婚！虞声晚成了整个上流社会的笑话......为了满足奶奶遗愿，她鼓足勇气攀上了没人敢惹的短命鬼！虞声晚说：只要你娶我，什么条件我都能答应你！陆北穆笑了：什么条件都能答应？从此他食髓知味，夜夜贪欢！说好的短命鬼呢？说好的继承遗产呢？怎么感觉他身强体壮力气大......\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480716,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1jZrP1G2HFjJfgqenmAbi7A?pwd=4nb8\",\"online_time\":\"2023-12-13 00:00:00\",\"time\":1702396800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"池总他不按套路出牌\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"池总他不按套路出牌\",\"description\":\"宋娜受池明旭的雇佣，意图暗杀池骁。最后关头，宋娜心软，被池骁反制，头部受伤陷入昏迷。此时池骁查出宋娜身为顶级杀手的底细，正想除掉宋娜，醒来的宋娜却忘了自己是杀手。得知打伤自己的人是池骁后，撒泼打滚要求池骁负责。池骁为了更好的控制宋娜，让宋娜进入池家，当自己的贴身保镖。两人在相处的过程中，逐渐发现彼此就是自己寻找多年的孤儿院同伴，两个互为救赎的人再次走到了一起……\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482766,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1CNz8oGtQeQ_C8a2_qbgmjw?pwd=yyw7\",\"online_time\":\"2024-02-26 00:00:00\",\"time\":1708876800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"池总太太要和你离婚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"池总太太要和你离婚\",\"description\":\"本剧讲述了造型设计师季悠然和霸总丈夫池墨深因为一个误会决定离婚，然而池墨深对季悠然情深依旧，用各种手段阻挠对方离开自己，二人在啼笑皆非的种种误会中，逐渐理解彼此，并发现彼此的感情，最后两人重归于好。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481716,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1MI6yPA82Kqdcx5qz14XjSg?pwd=b13i\",\"online_time\":\"2024-01-19 00:00:00\",\"time\":1705593600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"沈先生为何要这样对我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"沈先生为何要这样对我\",\"description\":\"沈家老先生去世，沈家少爷终于回国，并在灵堂上见到了当年的家庭教师，沐雪。此时的沐雪已经是沈老先生的秘书，还是他传闻中的情人，沈老先生的遗产甚至都有沐雪的一部分。面对这样的沐雪，沈家少爷却始终无法忘记，沐雪当年对他的背叛……\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481926,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1pv1q_btHZqTV_2K0yVTctA?pwd=n8tp\",\"online_time\":\"2024-01-29 00:00:00\",\"time\":1706457600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"沉没（全29集）\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"沉没（全29集）\",\"description\":\"朴惠为富不仁，致使林晓晓一家沉陷海难。危难之际，王兰选择救儿子而抛弃女儿。林晓晓巧合被朴惠救下，更名朴晓晓。朴晓晓得知朴惠就是当年制造海难的罪魁祸首。朴晓晓弃暗投明，和生母相认，报警将养母绳之于法。\",\"second_cate\":\"女频亲情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487326,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":7,\"material\":\"https://pan.baidu.com/s/1CmhgoCGyjFHV0vyX27KVsw?pwd=qhu4\",\"online_time\":\"2024-06-09 00:00:00\",\"time\":1717862400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"没关系，是爱情啊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"没关系，是爱情啊\",\"description\":\"失忆毁容的“孤儿”江念在被前夫顾霆修背叛抛弃，遭遇车祸，恢复记忆，回到江家成为掌权人后，为了报复已经认不出自己的前夫，让顾霆修成为自己贴身仆人，却发现两人之间有种种误会的故事。\",\"second_cate\":\"通用背叛/萌宝/失忆/双胞胎/复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484966,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"链接：https://pan.baidu.com/s/1-go1CyttsPaWp2evrw2p3Q?pwd=4os4\\n提取码：4os4\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-02 00:00:00\",\"time\":1714579200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"泰山府君\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"泰山府君\",\"description\":\"陈子凡年幼时期和父亲逃亡被追杀，逃亡到泰山时，机缘巧合成为泰山府君，在泰山苦修三千年，成为至尊境高手后下山，下山后的陈子凡决定找救过自己的萧采薇母亲报恩，但萧采薇却对陈子凡不假辞色，而陈子凡除了回来报恩外，同时还想查明父亲死因，为父报仇，随着陈子凡的调查，当年的真相，也逐渐浮出水面……\",\"second_cate\":\"男频战神、都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482496,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1Dpy8n6NJdndxZlhcGzYo7A?pwd=d2ga\",\"online_time\":\"2024-02-15 00:00:00\",\"time\":1707926400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"泼天富贵\\u0026家财万贯\\u0026先敬罗衣再敬人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"泼天富贵\\u0026家财万贯\\u0026先敬罗衣再敬人\",\"description\":\"叶天泽放弃更好的发展辛苦跑外卖六年只为供女友考编上岸，却被女友上岸第一剑先斩意中人。偶遇大嫂姜韵，才知哥哥竟是市值万亿的浩泽集团掌门人，但哥哥意外死亡需叶天泽去冒名顶替才可稳住万亿市值。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486876,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1Ypjp91W__as_9D_8G0QHEg?pwd=sa5p\",\"online_time\":\"2024-06-05 00:00:00\",\"time\":1717516800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"浴火重生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"浴火重生\",\"description\":\"末世来临，顾倩提前囤积了物资，却被渣男带着亲人侵占，导致她变异，悲惨离世。再一睁眼，居然回到了末世来临之前，这一次，她要让渣男自取灭亡！\",\"second_cate\":\"女频复仇、爽文\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481616,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1fTd7I5IZdlqYeU6whSbM9A?pwd=atpu\",\"online_time\":\"2024-01-15 00:00:00\",\"time\":1705248000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"消失的他回来了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"消失的他回来了\",\"description\":\"多年前，柳家动手清洗风家，夺取风家资产，并将罪名全都推到风岚身上，柳润天顾及舆论，并想利用风家，留下了风家的小儿子和女儿。风家大少爷风岚受到柳家追杀多年，在一次被柳家追杀的过程中，得知自己的妹妹风雅要被献给金家家主，决心回国查明当年的所有真相，并为自己的家人复仇。回到南市，风岚宣布召开大会，并亲自找上柳家的门,却撞上柳家和金家正在密谋将风家的宅基地献给主帅，风岚出手整治二人，却遇上组织左使，但组织左使并不认识风岚，风岚废掉左使后，朱雀出场，告诉柳金两家，交出家主令和半数股份，才能饶其不死，两人退下后，朱雀告知风岚，金家己经准备强拆风家宅基地。风岚半痴呆的奶奶为了孙子回家能找到路，誓死保护老宅子，却被金家的喽啰羞辱殴打，赶来的风雅也险遭侮辱，关键时刻，风岚赶到，及时解围，却被金家放信号弹招来的人围住。风岚处理掉一众喽啰后，希望和味妹解释清楚，但妹妹仍旧以为当年的事情就是自己的哥哥做的。就在风岚准备清理这一切时，柳家却突遭变故，柳家的小儿子得知自己其实是风家人，于是处理掉了柳家家主，自己坐上柳家家主的位置，并开始和自己的哥哥，进行生死较量。然而这一切。只不过是刚刚开始\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479116,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/11dqCKnyCFlitucJwNJ9IUQ?pwd=k4en\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"消失的她之面具之下\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"消失的她之面具之下\",\"description\":\"外表单纯可爱的周彤突然失踪，周彤的男友刘波也在一场车祸中昏迷不醒，长居国外的周青踏上了寻找妹妹周彤旅程，用自己的心理学专业技巧穿越破朔迷离的真相，惩戒真凶，完成复仇。\",\"second_cate\":\"通用悬疑、复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488646,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1m6k29aUQCJO92cwQtmxeMQ?pwd=61mk\",\"online_time\":\"2024-07-01 00:00:00\",\"time\":1719763200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"淘气小亲亲\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"淘气小亲亲\",\"description\":\"颜茸茸意外怀孕。司伯珩得知后将颜茸茸接回家中，两人在接触中渐生爱意。女明星陈诗婉不甘心自己喜欢的男人爱上颜茸茸，设计伤害颜茸茸。司伯珩帮颜茸茸解决了网爆和家庭带来的伤害，同时封杀了陈诗婉。司家人发现，颜茸茸与李毓舟去世的夫人长相相似。而陈诗婉也因相貌相似，被李家误认为李毓舟失踪的女儿。在司伯珩的帮助下，颜茸茸躲过了李家的内部斗争，成功认祖归宗，并惩治了为难颜茸茸的人。两人终成眷属。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480806,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1Wj-n9Jw-1tbUlS0yN6UCrQ?pwd=68hq\",\"online_time\":\"2023-12-16 00:00:00\",\"time\":1702656000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"深情女主人设崩了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"深情女主人设崩了\",\"description\":\"剧中白夏青与女主白夏青对视，羁绊交织，机缘巧合之下你成为了女主白夏青。婚宴手撕渣男，打脸绿茶。白夏青佛系开启豪门生活，误打误撞遇到大boss傅砚辞。白夏青的到来让整个剧本世界发生重大变化，顾景琛也逐渐被白夏青所吸引开启倒追，而殷妙柔却无法接受巨大改变露出绿茶本性针对白夏青。有着傅砚辞的助攻，白夏青重新被白家接纳，且将以前失去的亲情、名声和金钱都夺了回来，并与傅砚辞开始漫长感情拉扯。最终，白夏青为救傅砚辞被殷妙柔刺死，回归现实。在现实生活中，偶遇长相跟傅砚辞一样的男人，而那个人，确实是傅砚辞在白夏青死后，穿到现实与她相遇。\",\"second_cate\":\"女频穿书/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481296,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1qt-SegiKnkztbaAn2Z2bwQ?pwd=6ndx\",\"online_time\":\"2024-01-02 00:00:00\",\"time\":1704124800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"深情诱引\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"深情诱引\",\"description\":\"林语熙六岁父母被害，流落福利院，因父母之死与周家有关，为了平息舆论她被周家收养，之后嫁给了周家二公子周晏京。和周晏京经历重重误会和阻碍最终走到相爱的故事。\",\"second_cate\":\"女频豪门、都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488876,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":6,\"material\":\"https://pan.baidu.com/s/1P-OOZY0X0GXfB340yqYZjw?pwd=vw88\",\"online_time\":\"2024-07-05 00:00:00\",\"time\":1720108800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"深深吻，浅浅缠\\n（爆款老剧）\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"深深吻，浅浅缠\\n（爆款老剧）\",\"description\":\"丈夫出轨了。为了报复，她在离婚之前，招惹了一个她招惹不起的男人。原以为只是一晌贪欢，男人却缠上了她，逼着她夜夜沉沦……\",\"second_cate\":\"女频现代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488906,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1vGA5L7gvSKMPmAOazMEdQg?pwd=x87c\",\"online_time\":\"2024-07-06 00:00:00\",\"time\":1720195200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"深爱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"深爱\",\"description\":\"一场意外将姐弟俩压在同一石板下，母亲迫于无奈只能先救弟弟，叶雅丽就此与白夏青失散。回国后叶雅丽一直寻找女儿的下落却杳无音讯，她坚信自己的女孩白夏青还活着。另一边，沈爱与养母沈爱娟过着艰苦拮据的生活......\",\"second_cate\":\"女频/亲情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488136,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Y2qzMO_sAgUP7qy-_kWzIA?pwd=hcxj\",\"online_time\":\"2024-06-23 00:00:00\",\"time\":1719072000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"混世医圣\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"混世医圣\",\"description\":\"楚凡，当代医圣，幼年时家族剧变，被迫逃离至滁州，后被秦文瑶父亲所救，保下小命，之后随上一代医圣学医，多年后学有所成，重归滁州隐姓埋名入赘秦家，既是报恩也是为了隐藏身份查清当年家族覆灭真相，多年来拒绝无数人的追随，心甘情愿留在秦家，而秦文瑶为了保护父亲留下的公司，无奈和楚凡离婚，得知秦文瑶内心想法，楚凡主动放手，离开秦文瑶，只不过，在后来追查家族覆灭真相时，次次和秦文瑶发生接触，了解到秦文瑶的难处，之后在楚凡追查凶手的时候，和秦文瑶有过多次接触，甚至还被背叛一次，彻底对秦文瑶失望，但在最后解决凶手的紧要关头，秦文瑶舍身相救，楚凡也终于明白秦文瑶的内心想法，最后两人终于重新走到了一起。\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479636,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1AGnq4Uc34Cd73wiLEpgJSA?pwd=nnza\",\"online_time\":\"2023-11-03 00:00:00\",\"time\":1698940800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"渣爹总想 和我抢妈咪\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"渣爹总想 和我抢妈咪\",\"description\":\"夏晚晴怀胎之际，被家里收养的妹妹夏晚艺陷害，被未婚夫霍谨笙误会为撞断他妹妹双腿的元凶。无法解释的夏晚晴独自生子，生下一对双胞胎，她本想带着孩子销声匿迹，无奈女儿病弱，她只好留给霍谨笙照顾。三年后，夏晚晴回国，并意外地再次与霍谨笙产生交集……\",\"second_cate\":\"女频都市萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478356,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1knngkyDet2m-eyVrbQIfeQ?pwd=597p\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"游龙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"游龙\",\"description\":\"订婚当天居然发现对象竟是杀死自己姐姐的仇人？林峰被林家家主说破了身份，苏轻雪悲当场撕毁结婚协议与之割裂。苏轻雪也终于恢复了记忆，原来她就是苏轻柔。贵为龙主的林峰又将如何保护和弥补妻子和孩子？\",\"second_cate\":\"男频兵王/战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485406,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1mkoradhla-lK7HlsBsrzUw?pwd=ipbd\",\"online_time\":\"2024-05-19 00:00:00\",\"time\":1716048000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"滚滚红尘1988\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"滚滚红尘1988\",\"description\":\"穿书后，苏晓敏拳打后母，脚踢黑心妹，与倒爷林家俊合作，从摆地摊开始创业致富。然而，林家俊的身世，将苏晓敏卷入豪门争产的恩怨是非之中。商场、情场，步步惊心。在时代的大浪潮中，苏晓敏开启逆袭人生。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484726,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1kfe0yxDSGKhhSYER8yreaQ?pwd=1wa6\",\"online_time\":\"2024-04-26 00:00:00\",\"time\":1714060800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"滚蛋吧！我的垃圾人生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"滚蛋吧！我的垃圾人生\",\"description\":\"女主被渣男老公和闺蜜害死，魂穿到三年前，为摆脱渣男老公对自己的家暴，和绿茶闺蜜对自己的利用，女主通过一步一步的设计，把绿茶闺蜜转嫁给了自己的渣男老公，让绿茶闺蜜，过上了自己上辈子水生火热的生活！\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487176,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":19,\"material\":\"https://pan.baidu.com/s/17Hu_ozQrzFNHaFQQtugbnQ?pwd=fewf\",\"online_time\":\"2024-06-08 00:00:00\",\"time\":1717776000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"漂亮后妈甜翻全家\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"漂亮后妈甜翻全家\",\"description\":\"盛沐沐穿剧了，居然要给 17 岁豪门少爷当恶毒后妈，还下场凄惨？为了扭转地狱开局，盛沐沐誓要做个好后妈，面对叛逆继子和腹黑老公，盛沐沐主打一个关怀备至，夫唱妇随，却不想偏执的豪门千金曲慧，誓要破坏两人感情，继子为她撑腰，老公宠她无度，更意外得知自己竟然也是世家千金！开局一手烂牌只想自救的盛沐沐，一不小心成了人生赢家！\",\"second_cate\":\"女频甜宠/豪门\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483856,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1PWYwihmIGm3zuDQ9zUWqEA?pwd=m53p\",\"online_time\":\"2024-03-27 00:00:00\",\"time\":1711468800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"漫天星辰不及你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"漫天星辰不及你\",\"description\":\"海归天才珠宝设计师谢晚星，为了完成奶奶遗愿，找出杀害爷爷、夺走遗世珍宝“失落之心”的凶手，隐瞒身份回到国内，阴差阳错之下，将珠宝大亨陆浩辰误认为是自己闺蜜男友，一时冲动上前，搅黄了对方的相亲，却意外得知，陆浩辰为陆氏珠宝员工，为了弥补过失，也为了获取更多关于“失落之心”的消息，谢晚星与陆浩辰领了证，开始了同居生活。这时双方互不了解，互有戒心，双双藏皮，一个对外是高奢品牌珠宝大亨，对内是朝九晚五时常出差的社畜，一个对外是从不露面的神秘海归天才珠宝设计师，对内是时常被催稿的公司画手，二人带着各自的心思开始了同居生活。\",\"second_cate\":\"女频现代、甜宠、轻喜\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481286,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1N2Czyux9gBWmeYFV-HfhWA?pwd=cpus\",\"online_time\":\"2024-01-02 00:00:00\",\"time\":1704124800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"漫过思念的河流\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"漫过思念的河流\",\"description\":\"好友婚礼上，沈溪跟陈川意外结识。陈川因家庭不近女色，两人意外一夜情，互有好感但没表明。沈溪相亲了多个奇葩男，陈川提出闪婚，沈溪同意。两人欢喜冤家，却又感情升温，共同迎接新的美好生活。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487366,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1S9o4RZ2A7IDgHpgyGiVfDg?pwd=exdr\",\"online_time\":\"2024-06-11 00:00:00\",\"time\":1718035200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"潜龙出渊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"潜龙出渊\",\"description\":\"大周镇国神王姜龙，因绞杀倭寇，身负重伤失忆，成为江北城叶家次女叶如梦的老公。国主为震慑各国，树立一个假神王，巡游天下，来到江北城。江北城四大家族之一的赵家，为假神王举办接风宴。赵家少爷赵泰，是叶如梦姐姐叶媚儿的准老公。赵泰要把叶如梦献给假神王。姜龙被胡桂兰和叶如梦逼离婚，打脑袋，姜龙因祸得福，恢复记忆。姜龙前往神王接风宴，救回叶如梦。国主得知姜龙复出，遂让假神王在江北城举办三军誓师会，想让姜龙出山，带军去打仗，为大周开疆拓土。而假神王，想除掉姜龙，自己真正取而代之。用三军将士的命威胁姜龙，让他去赴会，想在誓师会上杀掉他。真假神王，终迎来当面对峙，姜龙，又该如何破局。\",\"second_cate\":\"男频战神、都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483376,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/11DVqeJzyT_am9ClG-yV9Vw?pwd=9vcr\",\"online_time\":\"2024-03-15 00:00:00\",\"time\":1710432000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"激荡1988开局成为女装大佬\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"激荡1988开局成为女装大佬\",\"description\":\"周晓治年轻时沉迷赌博，导致妻儿惨死。此后他奋发图强，终于成为亿万富豪。一次意外，周晓治重回妻子艾海兰难产的这一天。重活一世，周晓治发誓要将数十年的忏悔化作万千宠爱，让妻儿成为世界上最幸福的人。面对家徒四壁的现状，凭借对市场发展的熟知，周晓治抢先推出风靡全国的健美裤，开始发家致富。经商路上，结发之妻艾海兰、亦敌亦友的楚英红、误落风尘的李晓丹、海归女学生涂安妮等一众美女与他爱恨纠缠。而另一面，商业大亨涂金财在商场上对他步步紧逼，欲置他于死地。在这风云激荡的1988，乘着改革开放的浪潮，周晓治扬帆起航，再创致富传奇。\",\"second_cate\":\"男频重生\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482016,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1K0paUags59eNF1dpygDzFQ?pwd=pf8w\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"炮灰后妈终于洗白了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"炮灰后妈终于洗白了\",\"description\":\"沉迷于小说《八零军婚有双宝》的大学生秦小乔，在一次国际英语演讲比赛中不慎被吊灯砸中，却意外穿越到了小说中恶毒女二的身上，变成了小说中男主陆封烈的妻子和两个儿子大宝小宝的妈妈。\",\"second_cate\":\"女频穿越、重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485336,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1Kks62WQu3AI-CNNJcVCUWg?pwd=msgd\",\"online_time\":\"2024-05-17 00:00:00\",\"time\":1715875200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"炼气百万层\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"炼气百万层\",\"description\":\"在山上跟着三个高手师傅修行的叶凌风身怀无敌修为，被欧阳家退婚后，为救苏绫儿的爷爷而下山，意外碰到当年灭了自己全家的幕后真凶，为拯救女主护佑天下，变得更加坚强，最后打败boss，拯救女主，拯救天下。\",\"second_cate\":\"男频高手下山\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485536,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1gnNabHN98OrQE8ZAbxtIDg?pwd=ik6z\",\"online_time\":\"2024-05-21 00:00:00\",\"time\":1716220800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"烈爱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"烈爱\",\"description\":\"穿越后的曲嫣一改过去逆来顺受黄脸婆的形象，变美虐渣打脸一个不落，更是在宴会上一眼相中了江城首富薄家掌舵人的儿子，薄司宴。曲嫣要为原主找到真正的爱情，于是开始了主动攻略薄司宴的一系列行动...\",\"second_cate\":\"女频穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484466,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1HuXlH2YKczY-NUnfMjn0fQ?pwd=qedc\",\"online_time\":\"2024-04-16 00:00:00\",\"time\":1713196800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"热血狂医\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"热血狂医\",\"description\":\"护工陆凡面对女友的出轨，好兄弟的背叛，参悟医术。在得知多年前相救自己的不是女友，而另有他人时，他决心复仇，让曾经背叛过和伤害过自己的人，付出惨痛的代价。\",\"second_cate\":\"男频神医\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478996,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ttXcSSiV3ltcjHGjQ8p06g?pwd=fkk4\",\"online_time\":\"2023-10-06 00:00:00\",\"time\":1696521600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"热辣滚烫之丑女翻身\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"热辣滚烫之丑女翻身\",\"description\":\"拥有天籁声音的江清歌因容貌不佳自卑，连登台的机会都被貌美爱豆抢去。见面会当日，江清歌不慎摔出后台，受到全场嘲讽羞辱，只有纪船挺身相护。当她以为纪船真的欣赏自己时，却发现纪船真实目的......\",\"second_cate\":\"女频逆袭/娱乐圈/励志/减肥\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484766,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1VkiLIWE2B6g4CIL3391RzA?pwd=hpfy\",\"online_time\":\"2024-04-26 00:00:00\",\"time\":1714060800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"焚心之战\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"焚心之战\",\"description\":\"雷龙战神联手兄弟周辰，研发新型远程作战芯片焚心。没想到周辰被奸人挑唆，将矛头指向了叶言，从此兄弟反目，不死不休，同时，陆安瑶逐渐走进了叶言的心，牵起她的手，这天下，无人能伤她半分。\",\"second_cate\":\"男频兵王/战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485316,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":7,\"material\":\"https://pan.baidu.com/s/1mYg9_lJsomXhpvYII1c9cQ?pwd=9m36\",\"online_time\":\"2024-05-17 00:00:00\",\"time\":1715875200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"照亮我温暖我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"照亮我温暖我\",\"description\":\"沈念从小有一个幸福的家庭，但是在除夕夜那晚，一场大火，妈妈陆芸为了救她和她一起进了手术室。首富外婆陆桦赶到，把陆芸带走......\",\"second_cate\":\"女频亲情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485986,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1Co0Qh4b1sbIAxgKgmphfmg?pwd=5abe\",\"online_time\":\"2024-05-28 00:00:00\",\"time\":1716825600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"燃宫\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"燃宫\",\"description\":\"云蕖被挚爱楚景恒背叛家破人亡，在楚景恒和新宠沈清荷大婚之夜被赐毒酒而死，重生醒来后决定扭转命运，第一步就是拒绝嫁给二皇子，拉拢六皇叔，利用前世记忆扭转乾坤，主动出击谋划两次大计，自此楚毓和云蕖达成利益伙伴，最终云蕖帮助楚毓登上皇位，迎娶云蕖为后......\",\"second_cate\":\"女频古装权谋爱情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483766,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1V3By-HXYs1Y7cc6zHNNwCQ?pwd=5mkj\",\"online_time\":\"2024-03-25 00:00:00\",\"time\":1711296000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"燃烧吧镇国神君\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"燃烧吧镇国神君\",\"description\":\"大夏前神帅军第一统帅沈风，风神君为陪伴妻子林雪儿退隐，却因徒弟云溪被迫重出江湖最终毁灭扰乱大夏的暗影组织，重归大夏第一统帅风神君之位。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483556,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1GlzjpS4GXvpQKrDSL958Uw?pwd=istt\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"燃烧的玫瑰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"燃烧的玫瑰\",\"description\":\"沈知音假扮司机在车上发现老公江越出轨女佣陆佳慧，两人害死了她的父亲和女儿，沈知音计划利用小三的私生子陆景复仇。她假装被混混追杀闯进陆景洗澡的浴室，上演湿身诱惑；在KTV自残引陆景跟陆佳慧翻脸。在复仇过程中陆景多次救她，沈知音也爱上了被她利用的陆景，最后为救他而死，陆佳慧也被江越害死，江越被抓，大结局在海边陆景与沈知音长得一摸一样的女子重逢。\",\"second_cate\":\"女频大女主 复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482836,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1m_8h6V8wIVjbGvrF32fmDg?pwd=khvd\",\"online_time\":\"2024-02-28 00:00:00\",\"time\":1709049600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱你不能言\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱你不能言\",\"description\":\"结婚六年，江姝如同傅津言的保姆，任劳任怨，失去自我。傅津言因漫音要回来赶江姝，江姝选择离婚。再见面时，江姝已是谈判桌上谈笑自如的女强人。而傅氏总裁傅津言，早已不配站在江姝的身边。\",\"second_cate\":\"女频霸总、虐渣\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488916,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1JK610IOW9pIblAlPJ_d8aA?pwd=tmjg\",\"online_time\":\"2024-07-06 00:00:00\",\"time\":1720195200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱你情出于蓝\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱你情出于蓝\",\"description\":\"她从小暗恋他，终于订婚。在一场地震中，同父异母的妹妹代替她成了他的救命恩人。从两小无猜到貌合神离，当她为了孩子想重新开始时，父亲谋夺生母的遗产，妹妹也极力挑拨关系，这段婚姻能否维持？\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486166,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1NYfQQWIUV8Hbw_FPRW2rcw?pwd=di82\",\"online_time\":\"2024-05-31 00:00:00\",\"time\":1717084800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱你是我的秘密\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱你是我的秘密\",\"description\":\"蓝雨与霍执霆邂逅，却因男友张宇正意外撞死霍妹而替其顶罪入狱。蓝雨在狱中怀孕生女霍多多，却被张鑫抱走。霍多多寻母，张鑫冒充蓝雨，并隐瞒真相。最终，霍多多救母，霍执霆床前表白蓝雨。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486236,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1OFlK9anya9LwhOxeAyO91A?pwd=kq7j\",\"online_time\":\"2024-05-31 00:00:00\",\"time\":1717084800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱入山海\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱入山海\",\"description\":\"替嫁，商业联姻\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483216,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1dtFAuXoJmWShURetbSQgLg?pwd=cwy8\",\"online_time\":\"2024-03-12 00:00:00\",\"time\":1710172800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱在凤归时\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱在凤归时\",\"description\":\"被乞丐收养长大的月牙，为了和养父生存下去，拼尽努力，不畏困难。面对各种困境，她从不屈服，迎难而上，凭借自己的努力，最终不但找回了自己的亲人，还治好了养父的病，又收获了爱人和孩子。\",\"second_cate\":\"女频/民国\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488396,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1pVR3kztpRzjWzQ0AOUyxQQ?pwd=ytca\",\"online_time\":\"2024-06-27 00:00:00\",\"time\":1719417600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱在悬崖上\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱在悬崖上\",\"description\":\"女主韩法因肥胖被丈夫和儿子嫌弃，丈夫更是出轨自己闺蜜，后被两人设计陷害死里逃生，于是决心减肥换脸开启新的人生华丽归来。\",\"second_cate\":\"女频换脸、复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488616,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1CCcWzvLLtEynm9yD-gwViQ?pwd=mvra\",\"online_time\":\"2024-06-30 00:00:00\",\"time\":1719676800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱在黎明前降落\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱在黎明前降落\",\"description\":\"【情绪稳定温柔克制女航医×前期傲娇狗后期疯狗男机长】 沈瑶初和高禹川的开始就是一个错误。 他只是喜欢她的身，她却妄想得到他的心。 因为意外来的孩子，他把她娶回了家，把一个小错误变成了大错误，两个人的羁绊越来越深，也牵扯出了儿时的旧事。或许，他们相爱相恨，都是命中注定。\",\"second_cate\":\"女频职场情感\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483106,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1ktnMQP_pDX-BiZlUbzsbYg?pwd=ctf8\",\"online_time\":\"2024-03-08 00:00:00\",\"time\":1709827200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱已无可救药\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱已无可救药\",\"description\":\"腹黑总裁厉寒骁有先天性心疾，偶然发现特殊体质的女外卖员姜灵，竟能通过亲密接触的方式治疗他的心疾，但姜灵会因此气血衰弱而死。厉寒骁为治心疾，霸道地娶姜灵为妻，明明该要她的命，却不知不觉动了心…… \",\"second_cate\":\"女频现言\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484826,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1VtEWxPECtgpXK76w-7IstQ?pwd=sygh\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱恨无可救药\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱恨无可救药\",\"description\":\"许言言父母入狱，她艰辛半工半读。成为沈庭昱康复师后，两人情感渐深，却受误会与仇恨困扰。历经陷害、误解与生死考验，他们终敞开心扉，揭露郑泽天罪行，战胜一切阻碍，携手共度余生。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488726,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"链接：https://pan.baidu.com/s/18XqbFRUvOHviusBuQLhc5Q?pwd=vh13\\n提取码：vh13\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"2024-07-03 00:00:00\",\"time\":1719936000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱意深藏\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱意深藏\",\"description\":\"江笙因为父亲使计，被迫与总裁厉廷衍闪婚，约定两年后自动离婚，期间从未见面。两年后厉廷衍回国，意外与江笙发生关系，阴错阳差错认成江笙闺蜜林晓晓，一心只想和江笙快速离婚，好对林晓晓负责。江笙在厉廷衍公司任职，因为平时故意打扮朴素土气，被厉廷衍选为贴身秘书，两人朝夕相处，渐渐产生感情。但厉廷衍一直没有认出秘书就是妻子，一面对妻子身份的江笙满是嫌弃，一面又对秘书身份的厉廷衍动心。直到厉廷衍终于发现他嫌弃的老婆正是他心动的秘书，并且也知道和他发生关系的是江笙，惩罚了林晓晓后，开启了追妻之路。在厉廷衍的坚持不懈下，两人最终消除误会，带着孩子，幸福生活在一起。\",\"second_cate\":\"女频甜宠破镜重圆\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481306,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1n53-Sod2-Je_z-fCECELpw?pwd=t4pq\",\"online_time\":\"2024-01-02 00:00:00\",\"time\":1704124800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱意迟迟归\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱意迟迟归\",\"description\":\"二十年前女儿童童出生。温舒撑着力气把长命锁挂在女儿脖子上，婆婆闯进来抢走婴儿，哥哥温云深追了出去，发誓找到妹妹。养母在大雪地里捡到女婴。二十年后，忍冬与母亲和哥哥遇见，却见面不相识。\",\"second_cate\":\"通用寻亲\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487596,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/19rSMIr5nWktkCqBgFGkYJw?pwd=rhdy\",\"online_time\":\"2024-06-15 00:00:00\",\"time\":1718380800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱是一场在劫难逃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱是一场在劫难逃\",\"description\":\"楚家有一块传家的无价之宝玉佩，米粮垄断商人余家决定借才进城的沈时修沈司令的手夺取玉佩，他们借沈司令的人以走私大烟的罪名害死楚父，但余家人没想到沈司令无意中看到了被关押的楚母，在楚母决定献身沈司令成为二姨太时，余兰（沈司令的大太太）找人轮奸了楚母，诬陷楚母和人通奸，沈司令愤怒下掐死了楚母，这一切都被衣柜里躲着的楚纤看到。\",\"second_cate\":\"女频民国/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485666,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1qW5BSfPrP-0jZYyE7ADI6w?pwd=7rjj\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱火灼心\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱火灼心\",\"description\":\"沈念6岁时父母被白薇害死，哥哥成傻子。为照顾哥哥，学一身本事。沈念有能力养哥哥后，开始调查白薇，以理疗师季瑶的身份成白薇的助理，挑拨白薇和丈夫之间关系，搜集白薇出轨证据，各种打脸白薇，终为父母报仇。\",\"second_cate\":\"女频复仇/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487246,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1xIv6vlH1fc4f7G9QNP2JWQ?pwd=f85e\",\"online_time\":\"2024-06-08 00:00:00\",\"time\":1717776000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱的契约锦衣卫\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱的契约锦衣卫\",\"description\":\"纨绔千金叶凌雪救下穿越而来的锦衣卫沈墨，叶凌雪和沈墨妻子长相一样，阴差阳错下两人原地闪婚。叶家主昏迷，他们携手抗敌，叶凌雪尽显纨绔公主本性，与沈墨一主一仆，日常撒糖，在困境中渐生情愫。\",\"second_cate\":\"女频穿越/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485216,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/14ovXMznwHsJkuToiY6-fRg?pwd=u8sx\",\"online_time\":\"2024-05-12 00:00:00\",\"time\":1715443200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爱的时差\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爱的时差\",\"description\":\"温家大小姐嫁给时慕白几年，就忍受了几年冷暴力，时慕白漠视身边之人对于她的欺辱，让温言备受委屈。这一世回来，她要离开这个男人，拿回自己温家大小姐的尊严！\",\"second_cate\":\"女频甜宠 女强\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481126,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1nUz7jji8bgNAKoEf9obLEQ?pwd=ukj2\",\"online_time\":\"2023-12-25 00:00:00\",\"time\":1703433600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"父亲真实身份曝光全家泪崩\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"父亲真实身份曝光全家泪崩\",\"description\":\"全球首富李安，低调的去做了名清洁工。他的二儿子与赵家之女订婚，首富李阿城前来道喜，称李安为大哥，赵志远不信李安的真实身份，三番四次的去找事，最终在儿子的婚礼上有头有脸的人物都到场，打了所有人的脸。\",\"second_cate\":\"男频逆袭/打脸\",\"episode\":0,\"platform\":\"\",\"update_time\":1720487616,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/18qFo33aA3fpo6WoE75-ung?pwd=jn77\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爸临天下\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爸临天下\",\"description\":\"一代战神秦昊天被掩埋在土里多年，却无意间被遭遇霸凌的女孩沈果果挖了出来。沈夜雪决定让秦昊天做沈果果的契约父亲。而也就在这个时候，沈家面临被收购的危险。关键时刻，秦昊天得到消息，沈果果就是他亲生女儿。\",\"second_cate\":\"男频/赘婿/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488216,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1Y0e9e1GBsNT9AgKzX1hDMw?pwd=egem\",\"online_time\":\"2024-06-24 00:00:00\",\"time\":1719158400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"爹地，妈咪她想去父留子\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"爹地，妈咪她想去父留子\",\"description\":\"傅寒和白楚曦发生一夜情生下一对双胞胎，白楚曦被妹妹算计告知弟弟（傅钰）是死胎，在傅寒继母算计下傅钰被带回傅家，男女主各自带着自己的孩子因为一次相亲再次相遇，由于一次意外两个孩子被互相抱错。\",\"second_cate\":\"女频萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485136,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1kJpojAzQRQXcQ2jnDIN8Bg?pwd=3dck\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"物价贬值花掉一块钱真的好难\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"物价贬值花掉一块钱真的好难\",\"description\":\"出身普通的穷逼青年陈升经历失败人生后意外身亡，进入了物价贬值的世界。怀揣两万巨资的陈升瞬间成为隐形富豪，打脸前任、投资产业、获得女神青睐，与嚣张富商对峙一步步建立自己的商业图景，凭一己之力引领乾城商界。\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482806,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1dfnbJ_9jeZsGOTVGl_gPBw?pwd=a4fm\",\"online_time\":\"2024-02-28 00:00:00\",\"time\":1709049600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"犯了规\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"犯了规\",\"description\":\"从小流落在外，五年前意外与庄御发生关系后怀孕生子，但孩子刚生下就被人抱走不知所踪。三年前刚被亲生家庭姜家找到，就代替死去的姐姐嫁入庄家。三年后的现在，姜尤是御池集团执行总裁，掌管整个庄家生意。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486826,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1c7p77c9KiKbzEWeS7_zJvA?pwd=niyk\",\"online_time\":\"2024-06-04 00:00:00\",\"time\":1717430400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"狂少风云\\u0026房东先生别逃\\u0026房东攻略\\u0026我被美女房客包围了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"狂少风云\\u0026房东先生别逃\\u0026房东攻略\\u0026我被美女房客包围了\",\"description\":\"亿万总裁江辰隐藏身份，当上一名房东。事实上，江辰是要找出害死父亲的幕后主使，所以江辰才将计就计当上房东。尽管如此，当这些房客各自遇上困难时，他还是会暗中帮忙解决。\",\"second_cate\":\"男频富豪隐藏身份复仇\",\"episode\":0,\"platform\":\"\",\"update_time\":1720487816,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1YhL1vgorfJnI4xPhWt2BWw?pwd=94j7\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"狂飙之傻婿觉醒\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"狂飙之傻婿觉醒\",\"description\":\"叶玄本是掌握世界一半武器财富的狂龙组织的首领，因为一次意外，叶玄变成了只有八岁孩子智力的傻子，被手下秦无炎秘密带回中海，和自己的孙女。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479856,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1r5h217QWPMa1pTLIx6LE_A?pwd=8haf\",\"online_time\":\"2023-11-14 00:00:00\",\"time\":1699891200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"狂飙之风再起时\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"狂飙之风再起时\",\"description\":\"善良的卖鱼佬王强为了妻子张芬委屈求全，可妻子还是出轨背叛了他，王强怒不可遏，却被有势力的菜霸奸夫毒打。生命垂危之际，他再次看到了自己时常接济的老乞丐，获得了助他逆袭的金光宝眼（参透未来）超能力……\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720478186,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1d_EPK_im7iYohacYOcTisQ?pwd=xg27复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-09-04 00:00:00\",\"time\":1693756800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"狂龙下山\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"狂龙下山\",\"description\":\"叶家弃子叶星辰在灭门惨案中侥幸脱身，又被世外高人老鬼相救并且传他无上神功，叶星辰为了报恩替老鬼守狱三年，三年后老鬼回到天堂岛，叶星辰趁机辞别老鬼下山去履行自己与江海陈氏集团之女陈思思的婚约，临别前老鬼给了他一把名叫弑魂短刺。赴约途中，叶星辰无意中救下以为被杀手劫持的女子，而这个女人正是江海第一家族萧家的大小姐萧清月。这也为他引来了一系列来自暗网组织的麻烦......\",\"second_cate\":\"男频复仇/高手下山/战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482936,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1gK3a9zcsZH3yt3RkcPDy4Q?pwd=6c73\",\"online_time\":\"2024-03-04 00:00:00\",\"time\":1709481600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"狂龙觉醒\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"狂龙觉醒\",\"description\":\"一介布衣叶凌天，历经磨难终成大器，封战天王，护国之战被叛徒算计，失忆多年，狂龙终会觉醒…\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478946,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/111uS28N-4Mceyy6SfONXcQ?pwd=gj35\",\"online_time\":\"2023-10-01 00:00:00\",\"time\":1696089600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"狱锁狂龙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"狱锁狂龙\",\"description\":\"本片讲述了身为龙神的萧辰，跌宕离奇的一生。萧辰在一次斩杀了东岛贼首之后，为了避免两国战争，自请入狱五年。在监狱里的萧辰却遭到了乌鸦等岛国叛徒的侮辱，并且对方拿出了他女儿的影像，萧辰竟然都不知道几年前的一次意外，让林清音有了孩子，并生了下来。现在孩子遭到了别人的欺凌，林清音也被林家欺负，甚至要将她献给豪绅。萧辰哪有不出手的道理。\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477986,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1F3i4RNOl00ECSACo6ihHfg?pwd=b4ae\",\"online_time\":\"2023-08-24 00:00:00\",\"time\":1692806400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"玄门之主\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"玄门之主\",\"description\":\"穷小子初次下山被退婚，谁知他有三重身份，神医，战神，首富！\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479576,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ZeIYgLUwg6BrRX9sMbDanw?pwd=r43x\",\"online_time\":\"2023-11-03 00:00:00\",\"time\":1698940800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"王妃今天休夫了吗\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"王妃今天休夫了吗\",\"description\":\"温锦一朝穿越，就从军医变成了王爷的冷宫王妃，更惨的是，还带了个娃。又没钱又没人的温锦，只能先从赚钱养娃开始……\",\"second_cate\":\"女频古装、穿越、马甲、甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482596,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1W5vOyGfCjZQM6D6o8wYakA?pwd=7ast\",\"online_time\":\"2024-02-18 00:00:00\",\"time\":1708185600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"王妃她又美又飒\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"王妃她又美又飒\",\"description\":\"从勾栏女到摄政王妃，这是江秋叶未曾设想的道路，她只想做无情的赚钱机器，摆脱控制自在高飞，奈何克死五个老婆的废皇子陆秉昭非要强娶，被迫替嫁的江秋叶一夕之间被卷入皇权争夺的漩涡。既如此，那就不要怪我江秋叶去夫留财，与你相爱相杀，不不不，我才没有爱上你。\",\"second_cate\":\"女频古装复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483976,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1C0apQbmAOuTjnqyF9uD2Xw?pwd=kb6i\",\"online_time\":\"2024-03-30 00:00:00\",\"time\":1711728000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"王府一等家丁\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"王府一等家丁\",\"description\":\"郁郁不得志的IT男王灿穿越到古代，利用现代知识帮助男扮女装的梁王解决府内和朝廷的重重危机，凭借一身才华和正义感获得各路美女青睐，最后带着娇妻美妾归隐山林。\",\"second_cate\":\"男频穿越、重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484676,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1K0_w0vyRouJ4KIK_3Wua4w?pwd=j1zt\",\"online_time\":\"2024-04-24 00:00:00\",\"time\":1713888000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"王爷别来无恙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"王爷别来无恙\",\"description\":\"珠宝设计师宋以棠，在经历亲情事业双重打击后濒临崩溃，打算跳楼自尽却意外偶遇穿越而来昏迷的古代王爷温予卿，宋以棠无奈放弃自杀将温予卿带回了家，两人由此展开一段穿越古今的奇幻爱情故事。\",\"second_cate\":\"女频穿越、重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484646,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/18u-IM6Q2r64k2dSJkBgzyA?pwd=hbd8\",\"online_time\":\"2024-04-21 00:00:00\",\"time\":1713628800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"王爷要升职\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"王爷要升职\",\"description\":\"楚暮意外穿越成了月国的一个废柴王爷。虽贵为王爷却被太子坑害的生活不能自理。楚暮为了自救，运用现代信息差，重拳出击开启了一段传奇逆袭之旅。\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478076,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ZQR1Q7KtliuElvFZFKNtuw?pwd=fm5v复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-29 00:00:00\",\"time\":1693238400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"玩火娇妻你别跑\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"玩火娇妻你别跑\",\"description\":\"吕家陷入困境，吕父吕丰国无奈之下决定让吕秋雨商业联姻。吕秋雨明白这种婚姻的后果就是一辈子相夫教子，可惜推脱无果，于是订婚宴前亲自雇狗仔，在酒吧拍自己与随便抓的酒保的亲密照。没想到婚约没解成，订婚宴上棒球帽男闯入，低声称姐姐撩了人就跑，劫走吕秋雨。他说服吕秋雨与自己结婚，生米煮成熟饭，好摆脱一辈子只能做大佬背后女人的命运。吕秋雨知道这是唯一的办法，于是答应了签订为期三年的契约婚姻合同。二人结婚后，池安一副指定把家照料好的小奶狗模样，白天做家务夜里去酒吧上班，实际上池安是海归商业巨头不断暗中协助吕秋雨重振家业，两人在经历了重重阻挠和误会后认定了彼此，最终爱情事业双丰收。\",\"second_cate\":\"女频甜宠/姐弟恋/双强\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481726,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/17IWUPlf7EGUggH-wwW0lcg?pwd=atb3\",\"online_time\":\"2024-01-19 00:00:00\",\"time\":1705593600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"玩脱了忠犬总裁不请自来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"玩脱了忠犬总裁不请自来\",\"description\":\"孤儿歌手姜时月，为揭胞姐遇害之谜，踏入娱乐圈，偶遇归国富少，二人闪婚以避联姻。姜时月借顾太身份暗查线索，却陷顾家纷争与兄弟情网，逐步逼近真相\",\"second_cate\":\"女频霸总、甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488976,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"链接：https://pan.baidu.com/s/1Zs39u41bDZAnH2nP7FXLgQ?pwd=9261\\n提取码：9261\\n--来自百度网盘超级会员V10的分享\",\"online_time\":\"2024-07-08 00:00:00\",\"time\":1720368000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"玫瑰冠冕\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"玫瑰冠冕\",\"description\":\"徐家养女楼阮，一直喜欢着青梅竹马的周越添，她追着她跑了十年，却只落得，养女，不配嫁入周家的回复。殊不知，就在她追着别人跑的十年中，也有人，在默默的看着她的背影。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480776,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1nY6P6ktZJ5NXahT5H2X3vg?pwd=qg67\",\"online_time\":\"2023-12-15 00:00:00\",\"time\":1702569600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"玫瑰的真相\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"玫瑰的真相\",\"description\":\"苏白原名苏凤鸣，多年对家庭的付出并没有换来丈夫江寒的忠诚。苏凤鸣遭背叛离婚，失去孩子和家庭。十年后，整容换脸的苏白归来，获得江氏股份，揭露江父和江寒种种罪行，让他们绳之以法。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486246,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1Sn9EC9l0-K1BzBV5ElCTkw?pwd=ba4a\",\"online_time\":\"2024-05-31 00:00:00\",\"time\":1717084800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"玫瑰轻颤时\\n（玫瑰冠冕2）\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"玫瑰轻颤时\\n（玫瑰冠冕2）\",\"description\":\"徐家养女楼阮，一直喜欢青梅竹马的周越天，追了十年，却只落得一句，养女不配嫁入周家的回复，孰不知她追别人拍的十年中，也有人，在默默的看着她的背影。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485086,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1SkV5nyp2j0zYJD-a28LbTQ?pwd=mzvw\",\"online_time\":\"2024-05-09 00:00:00\",\"time\":1715184000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"电竞之我和世界冠军五五开\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"电竞之我和世界冠军五五开\",\"description\":\"叮！恭喜宿主激活MVP系统！中路对狙胜利就能获得美女游戏解说奖励哟！\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481406,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1rUONdZsJIDUKemdx5xvSJA?pwd=gjqk\",\"online_time\":\"2024-01-03 00:00:00\",\"time\":1704211200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"画皮王妃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"画皮王妃\",\"description\":\"卿月被妹妹卿云瑶夺走了外貌和身份，被迫取代她成为曾经好友煜王的王妃，二哥被卿云瑶所伤，心爱之人也被卿云瑶夺走，她发誓要拿回身份，揭穿这个恶毒的女人！\",\"second_cate\":\"女频古装甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479146,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1pJW_R_ppSK2I7vtGXOaqeQ?pwd=ixpw\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"畏罪夫人的99次出逃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"畏罪夫人的99次出逃\",\"description\":\"林氏破产、父亲冤死，弟弟生病急需用钱，林念迫不得已进入夜魅当陪酒女，却意外遇到仇人顾以铭，林念不敢得罪顾以铭，只想努力赚钱，顾以铭以为林念贪慕虚荣、故意接近自己，命方巡调查林念身份，发现林念是仇人之女，用林子昂为筹码要挟林念，反复折磨，林念不明白顾以铭的恨来自何处，直到顾以铭亲口说出那些陈年往事，林念才知道自己的父亲是杀人凶手，心甘情愿替父赎罪。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479876,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Sh21vld3ayGBC1J20VSclw?pwd=u5tu\",\"online_time\":\"2023-11-14 00:00:00\",\"time\":1699891200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"病娇反派攻略计划\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"病娇反派攻略计划\",\"description\":\"阮幺幺进入了自己创作的小说，只要她让书中反派萧祈之爱上她并为她去死，她就能完成任务回家。阮幺幺自信满满接下攻略任务，开启了攻略反派的旅程，却不料自己写的反派就是个小变态，不但温暖不了，还天天刀她。阮幺幺在系统的帮助下不断变换身份攻略萧祈之，功夫不负有心人，在死了几次之后，疯批反派好像终于动心了。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481276,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1NrZhH8iWK81VfWMBUyE53g?pwd=knej\",\"online_time\":\"2023-12-29 00:00:00\",\"time\":1703779200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"病态占有：偏执陆总视她如命\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"病态占有：偏执陆总视她如命\",\"description\":\"苏清颜死后，看到传闻中冷酷的总裁陆霆琛竟然杀了害她的那对狗男女，用血淋淋的双手跪在墓前，捧吻着她的身体……重回年少，她一边狂虐渣男贱女，一边好奇调查陆霆琛，不想，刚一靠近，就被偏执阴郁的男人压在了墙角。 “颜儿，明明知道我喜欢你喜欢地快疯了，还敢来招惹我！” \",\"second_cate\":\"女频都市重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479916,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1OlsYmXihrHj69HLiHzRmsQ?pwd=7qh6\",\"online_time\":\"2023-11-15 00:00:00\",\"time\":1699977600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"痴傻千金三叔宠我入骨\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"痴傻千金三叔宠我入骨\",\"description\":\"苏家大小姐，商业奇才苏暖因同父异母妹妹苏珊珊争夺苏家继承权，遭毒手致失忆痴傻下嫁顾少廷。顾家欺压霸凌甚至夺走苏暖公司！只有霍慕寒暗中照顾苏暖。苏暖恢复记忆，她能否开启华丽复仇风暴？与霍慕寒又会怎样？\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485226,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1SrE5eQ2rrxyoJZ9VC9TgGw?pwd=tpxt\",\"online_time\":\"2024-05-13 00:00:00\",\"time\":1715529600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"痴傻神婿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"痴傻神婿\",\"description\":\"叶辰散尽修为回到十年前，倒转时空重来一次，只为护妻周全。痴傻五年的叶辰一朝清醒，一次炒股比试被世人尊称为“南省股神”。凭借预知未来，成为众豪门大佬竞相追捧的真人“白龙王”。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485636,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1fQLfMSCWvJ2u9ME39o5p0A?pwd=qgix\",\"online_time\":\"2024-05-23 00:00:00\",\"time\":1716393600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"痴傻老爸竟是仙人\\u0026风云再起\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"痴傻老爸竟是仙人\\u0026风云再起\",\"description\":\"孙涛之女孙瑶遭遇车祸，孙涛解开封印二十三年的修为，抱着孙瑶逆天改命，代价是全身修为和痴傻三年。孙涛身体愈发虚弱，孙瑶为让消失三年的母亲救孙涛，带着孙涛冲到母亲百亿豪宴上对着高台喊出了一声妈妈。\",\"second_cate\":\"男频都市、修仙\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488946,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1hOrfLUrXZi2HGqVUG1skaw?pwd=9enh\",\"online_time\":\"2024-07-07 00:00:00\",\"time\":1720281600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"白云深处有卿卿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"白云深处有卿卿\",\"description\":\"后妈为让私生子出国留学劝沈云初退学嫁人，把嫁妆拿给弟弟读书。沈云初不愿放弃自己人生，努力做各种兼职。有天救了一位老奶奶，阴差阳错和她孙子结婚。沈云初发现他竟是总裁却装成普通打工人！沈云初便配合他表演！\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487456,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1ZeYWd6BcBzOFxC8BZng-4Q?pwd=6e77\",\"online_time\":\"2024-06-13 00:00:00\",\"time\":1718208000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"白富美前妻跪求复合\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"白富美前妻跪求复合\",\"description\":\"世界首富萧阳，为了报恩入赘苏家，担心老婆自卑隐瞒身份，暗中帮老婆功成名，老婆在男主表明身份之前要求离婚，转投富二代的怀抱，男主重新接管产业，却被老婆质疑身份。\",\"second_cate\":\"男频都市/神豪+离婚后\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480826,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1GQcBSChnbyjoAnnqagB3VQ?pwd=ei7b\",\"online_time\":\"2023-12-16 00:00:00\",\"time\":1702656000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"白日偷欢，总裁又野又欲\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"白日偷欢，总裁又野又欲\",\"description\":\"\\\"小时候的一场意外，季司辰被绑架，结果错把绑匪的一双儿女认成了救命恩人。其中绑匪儿子因为季司辰意外死亡，于是季司辰承担起了照顾绑匪女儿——付瑶。之后季司辰为了给付瑶换肾，与夏瑾薇契约结婚，两人先婚后爱，发生了一系列的悲虐故事。\\\"思想:都市女性成长剧，讲述女主人公夏瑾薇在如愿嫁给了季司辰后，在契约婚姻的成长蜕变。\",\"second_cate\":\"女频复仇虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478276,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/12v2VA-j8Hehtb3UdtW75Ow?pwd=q3x6\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"百亿新娘\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"百亿新娘\",\"description\":\"谢听晚为查出母亲死因，周旋在顾氏三兄弟间，这让男主顾时宴越发不甘，谢听晚凭借处变不惊的能力逐渐查明真相，却也让她与三兄弟的感情纠葛越发难以收拾，关键时刻男主多次相救，让她明辨真心，与之携手共度余生。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484186,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1_QZDvfh1ak-yoiBwHG_10w?pwd=yang\",\"online_time\":\"2024-04-06 00:00:00\",\"time\":1712332800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"皇子入赘到我家\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"皇子入赘到我家\",\"description\":\"姚七七是身价千万的女富豪，意外穿越到了大凉国的逼婚现场，按规矩年满18岁的女子若未婚配就要承受酷刑，姚七七无奈与一位名叫韩澈的少年定下了婚约，并当场夺走了其初吻。姚七七本以为成婚就是走个形式，两人终将相忘于江湖，谁知少年恋爱脑上头，势要让姚七七爱上自己。姚七七爱财不爱色，各种刁难想要少年知难而退，却没想到少年是当朝四皇子，软硬兼施，势要将姚七七掳进宫中做王妃…\",\"second_cate\":\"女频古装权谋爱情\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483956,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":7,\"material\":\"https://pan.baidu.com/s/1dV_vP7T70zf8RnPlt_9N-Q?pwd=jrrr\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"盖世无双\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"盖世无双\",\"description\":\"战神归来娶妻，遭遇庸俗之辈诋毁，手下长老背叛，凭借一己之力力挽狂澜稳定局势。终于如愿向未婚妻提亲，不了平庸之辈难以教化，战神终于明白未婚妻一家是贪得无厌的小人，甩手离去与小心守护他的姑娘双宿双栖。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484356,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1Kv-0tHJuFDd7GTLpEnWKGw?pwd=ramx\",\"online_time\":\"2024-04-12 00:00:00\",\"time\":1712851200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"目中有神\\u0026花都神眼\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"目中有神\\u0026花都神眼\",\"description\":\"刘弟因见义勇为被打伤右眼，幸得楚河相救植入一只假眼。三后年后，假眼内人工智能终和刘弟脑神经融合，开始崛起。燕卿纹找到刘弟，想给钱报答。刘弟看出燕家暗潮涌动留下保护燕卿纹。在魔瞳帮助下将坏人一网打尽。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487726,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1BwRuxS11awjo2saeJZno5Q?pwd=75ac\",\"online_time\":\"2024-06-18 00:00:00\",\"time\":1718640000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"盲女千金\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"盲女千金\",\"description\":\"为救长孙，重男轻女的顾奶奶牺牲孙女，将其戳瞎双眼抛弃，被清洁工救起后抚养长大。成年后，盲女方梨因意外得罪顾家养女，遭遇顾家人百般羞辱，但随着双方不断产生摩擦，方梨是顾家女的身世逐渐浮出水面。\",\"second_cate\":\"女频亲情/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486936,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1GAqZYb13pX_8dp5NUV7Ebg?pwd=ihtq\",\"online_time\":\"2024-06-06 00:00:00\",\"time\":1717603200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"盲神\\u0026瞎子战神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"盲神\\u0026瞎子战神\",\"description\":\"穆青击败北荒四大战神，斩断北荒龙脉后遭遇天谴，瞎了双眼，在家被妻子看不起离婚，最终隐忍良久，终于找到了天谴的源头，恢复了视力，也斩断了幕后黑手。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480956,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1xFE7wWxBFgSacKJAKcyF4A?pwd=abbs\",\"online_time\":\"2023-12-20 00:00:00\",\"time\":1703001600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"相亲女神拉我去领证\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"相亲女神拉我去领证\",\"description\":\"李峰五年前惨遭小人陷害，一家上下殒命当场，无一幸免！唯有他，恰遇女神仙天降，与其进行合体双休，保全性命，之后随仙在深山中苦修五年，学成通世修为。归来都市后，在一次相亲中，遇到洛雪静以及自己的孩子。五年前究竟发生了什么？男主又将怎样查明陷害家人的真凶呢？\",\"second_cate\":\"男频神医\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478936,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1O2QNmp6Dkj-7PypPoJo49w?pwd=btzs\",\"online_time\":\"2023-10-01 00:00:00\",\"time\":1696089600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"相亲对象是总裁\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"相亲对象是总裁\",\"description\":\"盛和集团小职员替闺蜜相亲，却发现相亲对象居然是公司新来的魔鬼总裁，她该何去何从？\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482026,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1t-eJFjSNYpezeesT6J4UCQ?pwd=79tb\",\"online_time\":\"2024-02-02 00:00:00\",\"time\":1706803200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"相亲开局震惊村花\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"相亲开局震惊村花\",\"description\":\"普通人出身的赵出息，多年来时常被人看不起，所以赵出息一心想要成为有钱人，打脸看不起自己的人。谁知这一日，赵出息美梦成真，财神显灵，张贺再次跳到面前炫富，这次赵出息决定不再忍气吞声，狠狠教训了张贺。在财神能力的帮助下，赵出息逐渐迷失了自己，直到噩耗逐渐降临，赵出息才明白，钱并不是万能的，衷心悔过之后，赵出息获得了重来一次的机会，迎来了自己的新的人生。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482536,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/10ImaMEJPFfaqvKFP5NNJcA?pwd=3fnp\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"相亲相到大boss\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"相亲相到大boss\",\"description\":\"因一字之差，林岚跑错了相亲的酒店，却阴差阳错和韩亦辰邂逅。为了让母亲不留遗憾，林岚主动提出契约婚姻。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484606,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1eWFF5EvwSmCmLbH340aHRA?pwd=6a51\",\"online_time\":\"2024-04-20 00:00:00\",\"time\":1713542400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"相思不似相逢\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"相思不似相逢\",\"description\":\"暮小晚平静的生活被一个萌娃“碰瓷”给打破，被迫在总裁的邀请下成为了萌娃的“临时妈妈”，殊不知，这萌娃正是暮小晚5年前和总裁生下的孩子。在萌娃的疯狂助攻下，小晚终于认清了自己男友的渣男本质，也找到了自己的真爱王子，收获了幸福美满的三口之家。\",\"second_cate\":\"女频萌宝/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481166,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1XvNV851C7jCA3iuaA3bR1g?pwd=uaqv\",\"online_time\":\"2023-12-25 00:00:00\",\"time\":1703433600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"相思相见知何日\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"相思相见知何日\",\"description\":\"盛相思嫁给了傅家二少傅寒江，傅寒江喜欢的却是自己大哥的未婚妻姚乐怡。不久后，傅家大少傅寒川因车祸成为植物人。姚乐怡从楼梯摔下流产，诬陷是盛相思推了她。傅寒江将盛相思送去国外自生自灭。\",\"second_cate\":\"女频现代/都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487226,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/12ti1s6WfBIla65n3iojLJA?pwd=u1u7\",\"online_time\":\"2024-06-08 00:00:00\",\"time\":1717776000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"真假双龙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"真假双龙\",\"description\":\"水浒传武松杀嫂现代版。孪生兄弟被认错，弟弟为哥哥复仇，同时用哥哥身份打脸众人，为哥哥出气，也赢得大家的尊重。故事线吸引人，打脸爽感十足，弟弟和嫂子暧昧线引人遐想…\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484116,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":6,\"material\":\"https://pan.baidu.com/s/1xqpdMsbK94PuYdqd4_3AdQ?pwd=ns9e\",\"online_time\":\"2024-04-03 00:00:00\",\"time\":1712073600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"真假妈妈战总别虐夫人了\\u0026战总你找错夫人了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"真假妈妈战总别虐夫人了\\u0026战总你找错夫人了\",\"description\":\"姜语嫣跟男主意外怀孕，离家出走遭车祸，结果孩子被丢弃，自己残疾。五年后回国，继妹拆穿其瘸腿身份，遭羞辱。战时宴出面霸气护妻，为了儿子两人闪婚。继妹嫉妒姜语嫣，于是冒充孩子母亲，引发真假妈妈争议。\",\"second_cate\":\"女频霸总、萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488656,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1CthRdT-Irj9JMLHsSBewmw?pwd=yyzb\",\"online_time\":\"2024-07-01 00:00:00\",\"time\":1719763200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"真千金在职场叱咤风云\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"真千金在职场叱咤风云\",\"description\":\"顾云汐隐瞒首富女儿身份入职华贸地产，遭陈雪冒充并陷害。陈雪盗方案、散播谣言、勾引经理求转正。最终顾云汐揭露真相，陈雪和经理被打脸。\",\"second_cate\":\"女频/职场\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488026,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"链接：https://pan.baidu.com/s/1jQw5iQFkl-HlpAYFmSMJwA?pwd=x2af\\n提取码：x2af\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"2024-06-21 00:00:00\",\"time\":1718899200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"真千金智斗拜金女\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"真千金智斗拜金女\",\"description\":\"盛怀瑾的父亲让女主继承家业，女主执意来到新收购的公司实习。没想到刚进公司遇见假冒自己的假千金林瑶。林瑶在设计比赛、宣传片拍摄、谈项目时为难盛怀瑾，盛怀瑾一一打脸林瑶。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479086,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1l1FJltaXmm6kAlx964GG4w?pwd=id1n\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"真千金炸翻同学会\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"真千金炸翻同学会\",\"description\":\"女主是豪门千金，隐瞒身份嫁给男主，和男主一起参加同学会，谁料在同学会上男女主被各种瞧不起，更有女二冒充女主的身份声称自己才是豪门千金，对此，女主利用自身的知识与背景一一打脸。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720478036,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1h3wgvwNTrD7fcsso5rP7WA?pwd=cpk8复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-27 00:00:00\",\"time\":1693065600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"真千金艰难求生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"真千金艰难求生\",\"description\":\"顾耀辉烂赌欠债逃跑中被人贩子拐走孙女顾宁安。后顾宁安改名叶念堂，女儿查出白血病晚期。骨髓匹配度最高竟是丈夫秘书夏云儿。顾耀辉老年痴呆发作只记得给孙女的平安扣吊坠。夏云儿凭借吊坠成功冒充顾家孙女的身份。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488186,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1vBM51sh_Mw2bejogAukMnQ?pwd=q4r2\",\"online_time\":\"2024-06-23 00:00:00\",\"time\":1719072000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"真的很想你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"真的很想你\",\"description\":\"十八年前沈若云放弃豪门千金身份，嫁给贫苦丈夫并生下女儿秦小贝，不料丈夫早亡，自己被带回家当接班人。十八年后沈若云当权沈家主母，为了获得秦小贝的原谅，以前嚣张跋扈的她开始变得温柔细心了起来...\",\"second_cate\":\"女频亲情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485206,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1Gmw21N2uAHfGxLTAKTwH8A?pwd=8hf4\",\"online_time\":\"2024-05-12 00:00:00\",\"time\":1715443200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"真香警告：我被渣男小舅宠上天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"真香警告：我被渣男小舅宠上天\",\"description\":\" 喻岁被自己‘好姐妹’恶意灌醉，差点失身的她，被蓄谋已久的时宴知给截胡了。一觉醒来，看见身边躺着的陌生男人，喻岁第一反应就是甩银行卡封口，结果一个转身，男人成了自己未婚夫的舅舅。吓得她连他外甥都要踹了，结果他却像狗皮膏药一样贴了上来。喻岁不知道，时宴知对她一见生情，偷偷暗恋她十年，回国第一时间，就是要摘了她这朵娇花，装进自家花瓶。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"\",\"update_time\":1720478766,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1zmZcqzWP-p-W4h6f0RnN-A?pwd=avi5\",\"online_time\":\"2023-09-27 00:00:00\",\"time\":1695744000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"真龙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"真龙\",\"description\":\"龙门门主韩雨轩为妻子当了五年保安，却意外撞见妻子和别的男人在酒店点私会。妻子一家人，在寿宴上对韩雨轩百般指责要两人离婚，小姨子却以千亿总裁的身份登场来接韩雨轩回家。随着最终韩雨轩龙门门主的身份揭开，五年前韩雨轩被小姨子所救的事实也被揭秘，妻子一家人后悔不已，韩雨轩和小姨子两人终成眷属！\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481106,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1BQTWDHAYmih5zHool-F4Tw?pwd=p7ii\",\"online_time\":\"2023-12-25 00:00:00\",\"time\":1703433600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"眼泪女皇\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"眼泪女皇\",\"description\":\"裴之之在一次意外中，受伤失明，成为孤儿，伯伯家想要裴之之父母留下的遗产，故收养裴之之，在得知裴之之也不清楚遗产在哪里之后，直接为了高昂彩礼，将失明的裴之之嫁给了一个重病将亡想要冲喜的富商。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484666,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1CGeuGoMmpLgav1x_VOQHug?pwd=7th8\",\"online_time\":\"2024-04-22 00:00:00\",\"time\":1713715200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"督军夫人重生虐渣\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"督军夫人重生虐渣\",\"description\":\"唐紫尘前世嫁给陆辰，在其登上督军之位后被赐死重生归来，督军副将顾临渊对唐紫尘一见钟情，在唐紫尘死后为她报仇，被乱枪射死，随后也重生了。两人在报仇中爱上对方，陆辰登上督军被乱枪射死。紫尘终于大仇得报。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486796,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1pQS3Bpmx3PY8t8x0YYA3UA?pwd=6qcd\",\"online_time\":\"2024-06-01 00:00:00\",\"time\":1717171200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"砂锅粥与费南雪\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"砂锅粥与费南雪\",\"description\":\"时知味因不愿贿赂经理被鼎食大酒店开除，散心时遇到手持费南雪的帅气男模即鼎食幕后大老板。两人巧合结为夫妻，时知味是程宴救命恩人，因时知味的误会程宴不敢与她相认。时知味得食神大赛榜首，找到母亲死亡真相。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485976,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1UDiQTdMX9T1HXWYwMwVnBg?pwd=2juq\",\"online_time\":\"2024-05-28 00:00:00\",\"time\":1716825600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"破产后我成了死对头的秘书\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"破产后我成了死对头的秘书\",\"description\":\"桓曜集团董事长宋盛龙因看不惯儿子宋辰玉太过咸鱼，高薪聘请儿子从小到大的死对头傅晋肠演戏，假装集团破产背债，宋辰玉为还钱不得不给傅晋旸当秘书，实则通过这种方式激励、教育宋辰玉发奋图强。两人在共同的工作生活中发生许多无厘头的搞笑事件，宋辰玉阴差阳错地拿下了知名品牌L集团的亚洲总代理权，没想到惹来傅晋旸父亲和异母弟弟的注意，为和他们竞争下作手段频出。最终凭借着自己的聪明机智，两人挫败了傅氏父子的阴谋，宋辰玉做回总裁，傅晋旸一手搞垮傅氏集团完成夙愿后，回到桓曜给宋辰玉做了秘书。\",\"second_cate\":\"女频双男主\",\"episode\":0,\"platform\":\"\",\"update_time\":1720478916,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1H9FiR-KNW0PONV5mTuLtRg?pwd=3tte\",\"online_time\":\"2023-09-30 00:00:00\",\"time\":1696003200,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"破局\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"破局\",\"description\":\"反诈人员洛鸿宁和同事前往缅北执行寻回任务，期间遭到当地村民袭击，洛鸿宁被村民打晕后卖到了江湖园区。初到园区的洛鸿宁并不信邪，一边被“收拾”，一边和欧若然策划逃跑，可当身为园区二把手的黄宇一次次的用酷刑把他逼到死亡边缘，一次次的让他见证园区同胞被残害致死，于是洛鸿宁决定假意加入，暗自发力，在洛鸿宁一步步的努力下，他得到了园区老大江湖的赏识，这让本就嫉妒他的黄宇更加憎恨他······\",\"second_cate\":\"男频缅北反诈\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480046,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1-7g58yMD885H1VH2r5v8GQ?pwd=4mqg\",\"online_time\":\"2023-11-16 00:00:00\",\"time\":1700064000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"破烂老爸俏后妈\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"破烂老爸俏后妈\",\"description\":\"一个是遭人嫌弃的养女，一个是被人看不起的个体户，众人本以为他们会是一对贫贱夫妻，等着笑话。却不想关馨不仅与杨震相敬如宾，更是利用自己的现代思维在事业上给杨震很大帮助，二人事业蒸蒸日上，家庭和睦美满。\",\"second_cate\":\"女频/重生/穿越/年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488446,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/12nfvutiIKFOswaf4zos7fQ?pwd=8nyb\",\"online_time\":\"2024-06-28 00:00:00\",\"time\":1719504000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"神凰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"神凰\",\"description\":\"陆无双出于对女儿的亏欠，决定退隐并寻故人之子王小虎，但错眼识婿。女儿被家暴到流产，即将被送给几大家族的恶少，王⼩⻁⿎⾜勇⽓向陆⽆双说明情况，陆⽆双⼤怒想去救⼥⼉，却因倭贼⼊侵徒弟重伤，导致女儿被霸凌。\",\"second_cate\":\"女频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485576,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1HTvjDO8J97IKvXW7-4ztNg?pwd=65aa\",\"online_time\":\"2024-05-22 00:00:00\",\"time\":1716307200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"神医下山开局被豪门女神求娶\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"神医下山开局被豪门女神求娶\",\"description\":\"斩神院谷主与世长辞，他的徒弟萧傲天下山，回家迎娶白富美老婆，却被丈母娘和小姨子百般嫌弃，丈母娘和小姨子合伙设计萧傲天猥亵小姨子被老婆楚离歌看见，楚离歌的公司遭受打击，回家还要处理家务事，对萧傲天失望至极，要和他离婚，这时张赫赶来，萧傲天和他比拼医术，萧傲天断言丈母娘五步身亡，真被他说中了，萧傲天也渐渐恢复身份重新获得老婆的爱慕。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480906,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/14waVQYs_B6u4Cz4P6BpdZw?pwd=efby\",\"online_time\":\"2023-12-19 00:00:00\",\"time\":1702915200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"神医毒妃很轻狂\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"神医毒妃很轻狂\",\"description\":\"顾云儿本是21世纪赫赫有名的鬼手天医，却因被人追杀到山野中，乱战时被木棍打到脑袋意外打开了穿越时空的大门，来到了古代，灵魂附身在凌湘君身上，成为新的凌湘君。凌湘惊讶发现慕云止竟然与当年为救自己惨死的初恋男友叶沐辰长得一模一样，为了弥补对叶沐辰的遗憾，凌湘君将感情寄托在慕云止身上，疯狂爱上了慕云止，面对慕云止的处处刁难，凌湘君从未退缩，用自己最大的热忱回报慕云止........\",\"second_cate\":\"女频穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478116,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1e5EpWUv7eo6s0PdwaVydGw?pwd=kfk8复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-29 00:00:00\",\"time\":1693238400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"神医狂妃战神王爷乖乖受宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"神医狂妃战神王爷乖乖受宠\",\"description\":\"女主穿越古代，为了解毒强了男主，两人结下梁子。一纸婚书，她成了他的妻，从此王府鸡飞狗跳。女主意外得知自己是玉族族长，玉族千年来深受血咒折磨，代代相传。想要破除诅咒，必须集齐七颗龙珠。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486336,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Fv-j1LckDAHP0iOHDSlvYA?pwd=df5t\",\"online_time\":\"2024-04-28 00:00:00\",\"time\":1714233600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"神售\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"神售\",\"description\":\"西省首富意图让儿子继承家业，但他想创造价值，于是去房产公司做销售。期间的困难都被他化解，但心仪的女孩发现他的身世后开始疏远他。为挽回女孩，报复那些同事，他动用了父亲的关系，却被认为是在演戏。\",\"second_cate\":\"男频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484596,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/10mfbxDxGbSgJ_Kr5Zjhe0A?pwd=hja8\",\"online_time\":\"2024-04-19 00:00:00\",\"time\":1713456000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"神武天尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"神武天尊\",\"description\":\"神武君叶辰被叛徒暗害坠崖失忆，被女主意外救下当了保安，却被女主闺蜜陷害发生一夜情，女主气愤男主恩将仇报，却不知道男主就是她六年前的救命恩人，将其赶走后意外恢复记忆，找叛徒报仇，偿还女主救命之恩。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480536,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1mHyinaHFLgQMjQ5J6GTWGg?pwd=5fkh\",\"online_time\":\"2023-12-06 00:00:00\",\"time\":1701792000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"神王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"神王\",\"description\":\"五年前，帝都楚家弃子被逐出家门，遭仇家追杀遇到义父秦天昊与未婚妻秦雪瑶的相助，得以逃脱进混乱领避难。秦雪瑶为救男主被大火烧伤毁容，从此不复中海第一美人，秦天昊也被中海各大家族针对，最终郁郁而终。楚无道在知义父去世，秦雪瑶即将嫁人的消息时，决定出世。一为娶秦雪瑶为妻，二为义父报仇雪恨！回中州后，得知秦家老太君寿宴，楚无道携天山雪莲作贺礼出席，却不想被秦家老太君以及秦风羞辱。郑家少爷郑秋带礼物来提亲，目的是得到秦雪瑶，以报当年被拒之恨。郑家凭关系成了神王宴的承办方，拥有神王宴请帖，大肆羞辱楚无道。楚无道找葛玄机为秦雪瑶医治，并令萧天策送上神王宴请帖…\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479376,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1G4OHYb9KAwa61uFH42V3LQ?pwd=rwdn\",\"online_time\":\"2023-10-19 00:00:00\",\"time\":1697644800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"神豪农民工\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"神豪农民工\",\"description\":\"世界顶级企业秦氏集团的未来接班人秦风，因家族往事被赶出秦家，被迫在工地搬砖当一个农民工，他误打误撞入赘沈家，与沈家千金沈婉晴结为夫妻。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478686,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1BWeMXw__on5t_SgA47aM6A?pwd=zmi8\",\"online_time\":\"2023-09-25 00:00:00\",\"time\":1695571200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"神豪送货工\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"神豪送货工\",\"description\":\"物流送货工郑毅辛辛苦苦送货，一边被工友压榨，一边被女朋友抛弃，好容易想要吃顿烧烤安慰下自己，却被黑心烧烤老板宰客，还被路过的混混拿烙铁烫了个伤伤疤，连累了平时关系好的李瑶一起被打。就在极度落魄凄惨之时，他才被人告知，他竟是首富的儿子!\",\"second_cate\":\"男频都市神豪\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478136,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ZIt5Xf4e3FWz0pFRkWQ9lA?pwd=sk5i复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-09-02 00:00:00\",\"time\":1693584000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"神豪：从一元秒杀顶级别墅开始\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"神豪：从一元秒杀顶级别墅开始\",\"description\":\"世界首富陈总终于找到了失踪多年的儿子陈放，为了弥补离开儿子这么久的愧疚，陈总特意为儿子开发了一款秒杀app，无论是价值八亿的檀宫别墅，上亿的酒店股份，统统只需要陈放一元秒杀！一条神奇的打脸之路开始了\",\"second_cate\":\"男频神豪、都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480146,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/14WtjdWbqhxBlCitEl2lcfQ?pwd=kqxt\",\"online_time\":\"2023-11-19 00:00:00\",\"time\":1700323200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"祭司夫人飒爆全球\\u0026大祭司妈咪不好惹\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"祭司夫人飒爆全球\\u0026大祭司妈咪不好惹\",\"description\":\"凤黎带儿子小九下山参加弟弟婚礼，却意外与儿子生父重逢，卷入外域侵夺龙国傅家产业的阴谋。凤黎和小九揭露外域阴谋，解除傅清泽蛊毒，保护傅家，最终父子相认，小九接任大祭司，让父母幸福生活。\",\"second_cate\":\"女频萌宝、奇幻\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488986,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"链接：https://pan.baidu.com/s/1_xfKJ5BFOpZm3_bmD7SuhA?pwd=h3ot\\n提取码：h3ot\\n--来自百度网盘超级会员V10的分享\",\"online_time\":\"2024-07-08 00:00:00\",\"time\":1720368000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"禁欲男神狠狠宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"禁欲男神狠狠宠\",\"description\":\"傅玄屹是京都傅家太子爷，是京都人人皆知的狠厉佛子。魏语娴独自一人来到京都上学，却被母亲转走了所有积蓄，走投无路之际，只能另辟蹊径。 那一夜，他说他绝嗣，她信了，当被查出怀孕后，她慌不择路......\",\"second_cate\":\"女频都市、霸总\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488786,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/121L2zXXIylA2a1g6EupDPg?pwd=6ugp\",\"online_time\":\"2024-07-04 00:00:00\",\"time\":1720022400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚三十六计\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚三十六计\",\"description\":\"唐剑因离婚案胜诉率高居不下一度成为宣城风云人物。唐剑事业上非常成功但个人生活却遭人非议，唐剑本人早已习惯这种除了打离婚官司再无其他的生活，就在她以为这辈子就这样的时候，刚毕业的张柏然突然闯进了她的生活.....\",\"second_cate\":\"女频律政/爱情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485186,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1uLW83HYJAk5YLvM3zxuFYQ?pwd=iwaw\",\"online_time\":\"2024-05-12 00:00:00\",\"time\":1715443200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚三十天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚三十天\",\"description\":\"苏冷烟和许如安曾因相爱摒除万难结婚，却被生活的柴米油盐磨灭热情急于离婚。可当两人车祸双双失忆，被迫重新结合踏上寻找记忆之路。苏冷烟和许如安经历了许多啼笑皆非的故事，解开了误会，在磨难中体谅，在厌恶后相爱，共同找回相爱的初心。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483406,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1-rf5EAoF5eq4V0_cjFEOiA?pwd=2b44\",\"online_time\":\"2024-03-18 00:00:00\",\"time\":1710691200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚前夜，顾夫人重振妻纲\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚前夜，顾夫人重振妻纲\",\"description\":\"闪婚两年老公没露过面，每月十万生活费准时到账。林念：这是什么神仙故事！眼看合约即将到期，离婚前夕，顾先生顾太太突然圆房了。林念：这是什么狗血事故！再然后顾先生在离与不离之间反复横跳，顾太太在逃与不逃当中反复纠结。再再然后顾先生发现他的小娇妻不但藏了许多小马甲还藏着一个最最重要的秘密。“所以宝贝儿，那天晚上，其实是你……嗯？”\",\"second_cate\":\"女频现代女强\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480476,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1l20E1MYP3O8GBJsxDKyDMw?pwd=2m6f\",\"online_time\":\"2023-12-05 00:00:00\",\"time\":1701705600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚千金美又飒\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚千金美又飒\",\"description\":\"阮乔为报恩隐瞒身份嫁给薄司寒，心机女却冒领救命之恩跟在薄司寒身边，面对曾经的救命恩人，和颇有心机隐藏真相的齐诗诗，薄司寒又该如何选择？\",\"second_cate\":\"女频豪门\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482896,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/18akvGMx2wa_Mh5fd-r2kXQ?pwd=7gkz\",\"online_time\":\"2024-03-01 00:00:00\",\"time\":1709222400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后三个绝美姐姐找上门\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后三个绝美姐姐找上门\",\"description\":\"前妻一家因江辰送外卖的身份逼他离婚，殊不知，他却是江家少主，并有三个绝美大佬姐姐给其撑腰打脸前妻一家……\",\"second_cate\":\"男频小人物\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481916,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1RcNR9cONybUJ2T-170eHWg?pwd=ca5d\",\"online_time\":\"2024-01-29 00:00:00\",\"time\":1706457600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后公布亿万身价\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后公布亿万身价\",\"description\":\"秦天和艾潇潇结婚，过起了家庭煮夫的平凡生活。不料秦天的真心最终也抵不过金钱和地位。因为他穷，因为他窝囊，因为他平凡如尘埃！可当秦天签下离婚协议的一刹那，这个世界的王，他回来了！\",\"second_cate\":\"男频小人物逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478866,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1UezulG9LgmkHjvFb9LtxWA?pwd=rz27\",\"online_time\":\"2023-09-29 00:00:00\",\"time\":1695916800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后再恋爱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后再恋爱\",\"description\":\"女主温言因爱慕男主时慕白，借着自己的外祖父跟时慕白的祖父定下的婚约，强行嫁给时慕白，却遭到时慕白的百般厌恶，即便濒临死亡，时慕白也不曾来看过她一眼。认清现实后的温言跟时慕白提出了离婚，离婚后，时慕白才逐渐意识到自己已经爱上了温言，心里追悔莫及，用尽各种手段努力追妻，求妻子回头的故事。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480856,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1IL1WLTsll-oWeVaq0czYYg?pwd=mfe4\",\"online_time\":\"2023-12-18 00:00:00\",\"time\":1702828800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后再说一次我爱你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后再说一次我爱你\",\"description\":\"三年前，江怀月和季景洲领证结婚，然而季景洲却意外见到江怀月和一个老男人相处亲昵，季景洲误以为江怀月背叛了自己，提出离婚。不明所以的江怀月被逼着签下离婚协议后，伤心出国。三年后，两人再次相见。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487806,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1ZGW9HhcvIJTcariNs8my1Q?pwd=rzji\",\"online_time\":\"2024-06-19 00:00:00\",\"time\":1718726400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后前夫总想纠缠我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后前夫总想纠缠我\",\"description\":\"乔言因丈夫的忽视冷漠导致流产后，心死如灰决定离婚，恢复自己与丈夫的兄妹关系，并在离婚后收到了新的追求，没想到，前夫却总是不满足，只作为哥哥的身份……\",\"second_cate\":\"女频甜虐\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477806,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1thNsDClL0o7tKQO28fggRw?pwd=c7ik复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-11 00:00:00\",\"time\":1691683200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后前妻她美又飒\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后前妻她美又飒\",\"description\":\"苏桃本为苏家千金，小时候遭遇绑架，被陆寒川救赎，为了报恩嫁给陆氏集团总裁陆寒川。陆寒川也一直在寻找小时候许下婚约的女孩，却错认成她人，逼着苏桃离婚。恢复身份后，苏桃打脸前夫一家。\",\"second_cate\":\"女频现言\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482376,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1hwemqDMD_qPJFRnb0SWG5w?pwd=ejq1\",\"online_time\":\"2024-02-11 00:00:00\",\"time\":1707580800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后司少追妻火葬场\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后司少追妻火葬场\",\"description\":\"儿时的沐宁宁与司墨寒定下婚约。十八年后,司墨寒成了傻子,沐宁宁依旧嫁给他。一场意外,司墨寒恢复记忆,得知杀害他父母的仇人正是沐宁宁的养父!清醒后的靳司寒,将怒火发泄在沐宁宁身上。而这时,沐宁宁的真实身份,也正式揭开!\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487516,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1GaOxkuqI1IkIqnsL2vilPA?pwd=e2vq\",\"online_time\":\"2024-06-14 00:00:00\",\"time\":1718294400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后大明星老婆后悔了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后大明星老婆后悔了\",\"description\":\"徐天，表面是一个搬砖的工人，与追求事业的江沐寒婚姻生活充满了矛盾和冲突。江沐寒在事业达到巅峰时，决定与徐天离婚，寻求更自由的生活。但随着剧情发展，她开始意识到名利与个人幸福的真正意义，并逐渐后悔当初的决定……\",\"second_cate\":\"男频都市/战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481746,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1rh2DFuEj-Nh6biKZE1OHeA?pwd=jpjc\",\"online_time\":\"2024-01-22 00:00:00\",\"time\":1705852800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后天降三个大佬哥哥\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后天降三个大佬哥哥\",\"description\":\"沈柒柒跟渣男陆淮之离婚后，被大哥二哥三哥和未婚夫男主慕少离宠上天。前夫一直不相信沈柒柒是沈家千金，在打脸过程中，陆淮之得到应有惩罚，沈柒柒和慕少离过上了幸福生活，醒来，发现竟是自己做的梦。\",\"second_cate\":\"女频豪门/复仇/爽剧\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486456,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1PcBpQL4Bb-0XpuPcUb9Grw?pwd=c8mm\",\"online_time\":\"2024-05-12 00:00:00\",\"time\":1715443200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后带崽嫁给千亿霸总\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后带崽嫁给千亿霸总\",\"description\":\"江映月本少江家大小姐一场车祸意外失忆失踪，被陆衍之所救，嫁入陆家。但结婚后发现意外怀孕被认为出轨不检点，不受陆家待见，多年后陆衍之青梅竹马回国，江映月地位再次受到排挤，被羞辱失望的江映月带孩子离开陆家，却意外遇到孩子的亲生父亲多年前自己救的那个人，在萌娃助攻下江映月逐渐敞开心扉，这过程中陆衍之也认清内心追妻火葬场。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478646,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1bChNlK7nzz7yFyG0JyElMw?pwd=wvyj\",\"online_time\":\"2023-09-25 00:00:00\",\"time\":1695571200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后成为祁少的心尖宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后成为祁少的心尖宠\",\"description\":\"因母亲改嫁，姜幼宁成了祁斯峤名义上的妹妹，从此沦为病娇哥哥的“玩物”。祁斯峤曾扬言，在姜幼宁爱上他那瞬间，她对自己就失去了吸引力。殊不知，柔弱被欺的形象是姜幼宁编织的网，用来捕获他这个猎物——她故意以柔弱姿态让他在一次次霸凌中爱上她。无奈两人终被祁父拆散！如今，她终等到‘猎物’回来，祁斯峤对她嫁人嫉妒到发狂，姜幼宁甘之如饴，顺势离婚，从此两人相爱相杀…\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482316,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1gjt_loSi5faXClbhkCSt0A?pwd=9m7b\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后成了世界首富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后成了世界首富\",\"description\":\"秦震为爱和首富母亲打赌，只要以普通人的身份和苏倩雪结婚三年，即可通过考验，秦震就能带苏倩雪回家。三年之期已到，秦震满心欢喜带着万亿礼物去向苏倩雪坦白身份，却收到一纸离婚协议书。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480496,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1bHZcond_1RwI0OtiDhNJoA?pwd=xbnn\",\"online_time\":\"2023-12-05 00:00:00\",\"time\":1701705600,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后我带三宝惊艳全球\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后我带三宝惊艳全球\",\"description\":\"洛颖雪本是神都洛家千金，被人偷袭受伤失忆流落民间嫁入杨家，却被当成生育机器，但五年三胎全是女儿，被杨家无情抛弃，还派人要伤害她。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478326,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1WC4KN3iWk18Dq8FOkVwUQw?pwd=m2kc\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后我拿下小舅子未婚妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后我拿下小舅子未婚妻\",\"description\":\"孤儿秦宇被秦月告知，自己并不是孤儿，而是超级神豪秦海生的独子，在家族内斗中意外流落在外，孤儿瞬间变身为亿万富豪的秦宇从此开启了打脸逆袭之路。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485946,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"链接：https://pan.baidu.com/s/171gml3kfC2Z363lQa0CqPQ?pwd=l3n3\\n提取码：l3n3\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-27 00:00:00\",\"time\":1716739200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后我的崽打上门来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后我的崽打上门来\",\"description\":\"七年前，林霜生产当晚，被妹妹林雪所害，母女分离，林霜被卖到国外，女儿则被扔进垃圾堆，七年后，林霜成长为一代战神，她得知自己的女儿则奇迹般的生还，林霜的归来将带来怎么的改变呢？\",\"second_cate\":\"女频兵王/战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485326,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1zljEguL6j3KLTtEt3E8Wzg?pwd=15bz\",\"online_time\":\"2024-05-17 00:00:00\",\"time\":1715875200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后我让渣男倾家荡产\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后我让渣男倾家荡产\",\"description\":\"本剧以女主沈唯一为中心，讲述了跟渣男顾景琛离婚后，被大哥沈初衍、二哥沈初礼、三哥沈初泽和未婚夫男主慕云庭宠上天，在此期间，前夫一直不相信女主沈唯一就是沈家千金，在一次次的打脸过程中，顾景琛最终倾家荡产，得到了应有的惩罚，沈唯一和慕云庭过上了幸福的生活。\",\"second_cate\":\"女频豪门/复仇/爽剧\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484096,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":17,\"material\":\"https://pan.baidu.com/s/11-S7vJO0j2x5CADGB1yRFg?pwd=28sq\",\"online_time\":\"2024-04-03 00:00:00\",\"time\":1712073600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后我让渣男牢底坐穿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后我让渣男牢底坐穿\",\"description\":\"沈倩倩本是职场精英，原是职场女强人的她，却在怀孕后选择为孩子退隐做起了全职妈妈，可没想到，女儿的一次意外，让沈倩倩看清了老公的嘴脸。迫于无奈之下，沈倩倩只能联合“小三”，让渣男老公净身出户。\",\"second_cate\":\"女频/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487986,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"链接：https://pan.baidu.com/s/1d49IHc2LrrA6UwudfUR0pw?pwd=4c0b\\n提取码：4c0b\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"2024-06-21 00:00:00\",\"time\":1718899200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后渣男前夫后悔了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后渣男前夫后悔了\",\"description\":\"江城首富之女沈初棠竟为了渣男顾淮之隐姓埋名默默付出三年，成立顾氏集团，就在沈初棠准备坦白自己千金身份的时候，却得到了顾淮之的一纸离婚书。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485616,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1nSJyZiR7udAmWWaNbKtBdw?pwd=imur\",\"online_time\":\"2024-05-23 00:00:00\",\"time\":1716393600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后继承亿万财产\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后继承亿万财产\",\"description\":\"阔太太林梦凡本来养尊处优，生活幸福，每天要做的事情就是和太太圈的姐妹购物喝下午茶，本以为这样的生活会一直到老，没想到会遭到顾子辰的背叛。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479036,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1THMYp7vM5P34DF2O7GzD4w?pwd=79td\",\"online_time\":\"2023-10-11 00:00:00\",\"time\":1696953600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后美女总裁倒追我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后美女总裁倒追我\",\"description\":\"镇北王失忆，以普通人身份和妻子结婚，做外卖员养家糊口，不料妻子出轨，一番争执后镇北王恢复记忆，重登巅峰，将他受到的屈辱千百倍地还回去。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481796,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1sNyn7IKM5QwV7VSIhaaR8Q?pwd=vru3\",\"online_time\":\"2024-01-22 00:00:00\",\"time\":1705852800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后被大佬疯狂追求\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后被大佬疯狂追求\",\"description\":\"国内第一豪门苏家的大小姐苏婉宁被厉景深所救，报恩结婚。为了不让厉景深有压力，苏婉宁一直隐藏身份和厉景深相处，如今厉景深在她的帮助下总算声名鹊起，就在苏婉宁准备坦白身份的时候，厉景深却出轨背叛了她，苏婉宁看清厉景深的真面目后，收回送给厉景深的一切，恢复单身身份，受到各方大佬的疯狂追求。\",\"second_cate\":\"女频离婚/打脸\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482116,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1j4e6swT_LKbilHgnKlrGaQ?pwd=rm3h\",\"online_time\":\"2024-02-05 00:00:00\",\"time\":1707062400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后豪门千金杀疯了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后豪门千金杀疯了\",\"description\":\"盛世集团的董事长盛眠，因为一次误会，隐瞒身份嫁给了渣男厉少诚五年。直到离婚那天，才意外得知当年救自己的，是孟家弃子孟宴臣。最后在两人的努力下，盛眠坐稳盛世集团的位置，并和孟宴臣成功在一起。\",\"second_cate\":\"通用大女主\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485506,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1KTKWQBr6YPmVFDsBlvW3jA?pwd=r9x8\",\"online_time\":\"2024-05-20 00:00:00\",\"time\":1716134400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后重归巅峰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后重归巅峰\",\"description\":\"秦天和艾潇潇结婚，过起了家庭煮夫的平凡生活。不料秦天的真心最终也抵不过金钱和地位。因为他穷，因为他窝囊，因为他平凡如尘埃！可当秦天签下离婚协议的一刹那，这个世界的王，他回来了！\",\"second_cate\":\"男频小人物逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478856,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ubs75qGZdU0PPsz5EREsVw?pwd=fk6i\",\"online_time\":\"2023-09-29 00:00:00\",\"time\":1695916800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后高傲前妻悔恨终生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后高傲前妻悔恨终生\",\"description\":\"中夏第一财团，萧家继承人萧天策，为了不让妻子有压力，一直隐藏身份和老婆相处，如今妻子在他的帮助下总算声名鹊起，就在萧天策准备坦白身份的时候，妻子却出轨背叛了他，萧天策看清妻子的真面目后，决定坦白身份，收回送给妻子的一切，而知道真相的妻子，悔不当初。\",\"second_cate\":\"男频退婚、身份曝光\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482056,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1_gkMWLnbdl8E-W3h23qhdA?pwd=vjxr\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后！她转身收到六胎孕检单\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后！她转身收到六胎孕检单\",\"description\":\"该剧讲述了隐瞒“江湖神医”身份的乡下女孩沈一一，与看似不能生育的豪门公子霍庭君相爱相杀的故事。第一首富霍三爷因为交通意外成了瘫痪在床的活死人！沈一一来冲喜，新婚第一夜霍三爷居然睁眼了！虐妻一时爽，追妻火葬场!骄傲地霍家公子遇见了一个比他更骄傲地沈一一，逗趣爱情随即上演!\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481636,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1xxRcMiHQ2I-U3O5oK2Lrkg?pwd=mwyj\",\"online_time\":\"2024-01-16 00:00:00\",\"time\":1705334400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后，三个大佬都要娶我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后，三个大佬都要娶我\",\"description\":\"她是身价亿万的财团大小姐！为报救命之恩，她隐藏身份嫁给一位穷小子多年！谁知，她亲手扶持老公公司成为千万财团后，公司上市前夕，老公就将她扫地出门，迎娶首富侄女回家！！离婚后，她身份曝光！打脸渣男贱女，前夫后悔不已，可惜已经晚了，她被三个大佬未婚夫宠野了............\",\"second_cate\":\"女频大女主\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481856,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":16,\"material\":\"https://pan.baidu.com/s/14zX2o8h-Z-U-MVNJsL2xGg?pwd=ij9h\",\"online_time\":\"2024-01-26 00:00:00\",\"time\":1706198400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后，前妻她带球跑了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后，前妻她带球跑了\",\"description\":\"苏云汐嫁给萧南承两年，没有怀上孩子，婆婆对其心生不满，设计陷害苏云汐，最终逼得苏云汐签下离婚协议，远走他国。六年后，苏云汐带着女儿沐沐回国。而萧南承也将与林依依结婚，萧南承和林依依来到DL公司选订婚礼服，作为DL集团高级设计师的苏云汐，接待了他们。这次意外相遇，让萧南承和苏云汐再次纠缠上，过往的误会也逐渐解开。\",\"second_cate\":\"女频现言\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478156,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1IAReCLIc1q_UJa6IPshozw?pwd=42wi复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-09-02 00:00:00\",\"time\":1693584000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后，前妻曝光了她的豪门身份！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后，前妻曝光了她的豪门身份！\",\"description\":\"\\\"离婚后，前妻曝光了她的豪门身份：陆乾阳和林乐瑶是青梅竹马的情侣，林乐瑶一直默默支持陆乾阳的事业，陆乾阳创业时遭到对手报复，林乐瑶舍身相救，功劳却被白菲儿冒领。林乐瑶因为当初舍命救陆乾阳留下后遗症，眼睛逐渐失明，行动不便。白菲儿以为计划得逞，陆乾阳却还是娶了林乐瑶，于是白菲儿开始通过陆乾阳妈妈来接近陆乾阳，同时根据陆乾阳妈妈嫌贫爱富的心理，联合逼迫林乐瑶离开陆乾阳，逼林乐瑶打掉孩子，虐待林乐瑶，虐待孩子诬陷给林乐瑶。白菲儿害死了陆乾阳母亲嫁祸给林乐瑶，这才让陆乾阳彻底对林乐瑶死心。\\n林乐瑶被逼走，白菲儿安排人半路开车撞伤林乐瑶，林乐瑶被亲生父亲救下，成为真正的富家千金回归，调查真相，复仇白菲儿\\\"\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478046,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1zWOPrkJQHEScHGHSOqlLeA?pwd=mgte复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-27 00:00:00\",\"time\":1693065600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后，总裁前夫想撩我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后，总裁前夫想撩我\",\"description\":\"乔言作为顾家流落在外的大小姐，幼年才被找回。此时的顾家，已经有了一位养子，顾夜霆。乔言暗恋顾夜霆多年，甚至甘愿做了他十年的隐婚妻子，但这一切，都被顾夜霆的儿时同伴，打破了。乔言决意离婚，二人的关系，居然在离婚后有了新的变化。\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478806,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Tomrp6Rox5sksti6Qd2e3g?pwd=3yj4\",\"online_time\":\"2023-09-27 00:00:00\",\"time\":1695744000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后，我首富身份曝光了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后，我首富身份曝光了\",\"description\":\"龙门财团之主林霄三年前遭人暗算，被楚悠然所救。为了报恩，林霄隐姓埋名成外卖员，与楚悠然结婚，默默帮楚悠然创业，甚至暗中将龙门财团的千亿订单送给楚悠然，谁知林霄此举被楚悠然误会不求上进，惨遭离婚。林霄百般解释自己的身份都得不到楚悠然的信任，只能选择离婚。婚后楚家一蹶不振，林霄在和楚悠然的几次接触中身份彻底揭晓，楚悠然这才知道自己错过了林霄，追悔莫及。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478886,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1aIprZcG7jhFSeABCYgqW2Q?pwd=jfpn复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-09-30 00:00:00\",\"time\":1696003200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后，白富美总裁后悔了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后，白富美总裁后悔了\",\"description\":\"隐龙殿主，暗助妻子成为商业女王，却被妻子逼迫离婚。如今他显露真身，打脸前妻，惩戒宵小，又得世家小姐青睐。我的权势，你们无法想象!\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"\",\"update_time\":1720478106,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/12T_KEGc76MWu93exfekQkg?pwd=2jqw复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-29 00:00:00\",\"time\":1693238400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚后，被三个大佬哥哥宠上天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚后，被三个大佬哥哥宠上天\",\"description\":\"江城首富沈家大小姐沈唯一为了男友，隐姓埋名帮助丈夫开公司赚钱，谁知丈夫身家过亿后的第一件事就是带着小三上门，要与沈唯一离婚，沈唯一愤怒之下，直接叫来了三个大佬哥哥，她势必要让顾家看看，什么才叫高攀不起。\",\"second_cate\":\"女频甜宠 团宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479206,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1OyJd0V7AnmDGjVFRhCtWDA?pwd=8uv7\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚吧！真当我是癞蛤蟆\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚吧！真当我是癞蛤蟆\",\"description\":\"楚宇轩是楚门门主流落在外的私生子，成为暗网首领后，一直隐藏身份寻找母亲的下落。大明星老婆嫌弃他是滴滴司机出轨白月光后，被父亲以他母亲下落为要挟，让他和江城第一美女赵雅楠结婚，回归楚门帮他抢夺家产。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486576,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1K2GusyDq00VnrcnT9cJAzg?pwd=btgs\",\"online_time\":\"2024-05-20 00:00:00\",\"time\":1716134400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚妈妈竟是霸总白月光\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚妈妈竟是霸总白月光\",\"description\":\"温知暖和顾延之本过着甜蜜生活，顾母强硬去母留子，女儿糯米跟随顾延之生活。三年后，温知暖改名换姓带一儿子高调回归，进入顾氏争抢糯米抚养权，顾延之追妻火葬场，历经磨难和温知暖修成正果。\",\"second_cate\":\"女频萌宝/情感虐恋/真假千金/女王归来\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486446,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1mDtSWGgI4gqOZPLOa4cyXQ?pwd=hme4\",\"online_time\":\"2024-05-09 00:00:00\",\"time\":1715184000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚当天被五位爸爸认回豪门\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚当天被五位爸爸认回豪门\",\"description\":\"只因她是孤女，婆婆欺她，老公辱她，渣男出轨离婚算计她净身出户。突降五位父亲，地产大亨！影视巨星！医学泰斗！科研学术大佬！海外霸主雇佣兵战神！谁是真正的父亲？重要的是几位父亲疼她宠她，让她从此一路开挂！\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484146,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1itjtnY_l811UGTR-IBwPpg?pwd=vqde\",\"online_time\":\"2024-04-04 00:00:00\",\"time\":1712160000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"离婚当日绝美女总裁求我娶她\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"离婚当日绝美女总裁求我娶她\",\"description\":\"林云遭遇妻子出轨，离婚当天绝美女总裁倒追求娶，两人闪婚打脸前妻。林云却因此陷入豪门争夺继承权的漩涡。\",\"second_cate\":\"男频都市、修仙\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488456,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1WJVULB1sb50Z3EwVoHkWIw?pwd=1ddv\",\"online_time\":\"2024-06-28 00:00:00\",\"time\":1719504000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"秋起长歌梦里欢\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"秋起长歌梦里欢\",\"description\":\"余笙是个资深摄影师，因为家里破产，父亲自杀，导致严重的心理创伤，摄影作品没有性张力，外界传闻江郎才尽。为了解决问题，余笙尝试着接触异性，偶遇了一个大胆的模特新人秦浩东，不小心落入秦浩东的追爱“陷阱”，在秦浩东粘着她的时候起了怜悯和恻隐之心。两人在工作和生活中不断产生剪不断的牵连。最终走到一起。\",\"second_cate\":\"女频甜宠/职场/姐弟恋\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480926,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1mbAcUmvMeurBw_6QhjxWWw?pwd=qp1g\",\"online_time\":\"2023-12-19 00:00:00\",\"time\":1702915200,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"租个男友过大年\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"租个男友过大年\",\"description\":\"为了应付过年催婚，大龄单身女叶汐不得不临时租个男友交差。不想阴差阳错把霸总顾离当成了约定的保安“男友”带回了乡下。顾离利用钞能力成功帮叶汐打脸爱攀比的亲戚同学，出尽风头。回城后顾离遭遇爷爷催婚，不得不续租叶汐做女友，两人日久生情。在此期间，叶汐的奶奶和顾离的爷爷也网恋奔现，最后亲上加亲四个人一起举办了婚礼。\",\"second_cate\":\"女频现代言情/都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482466,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1do6PSSnz4X96MgcJeEfDCQ?pwd=eznv\",\"online_time\":\"2024-02-15 00:00:00\",\"time\":1707926400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"秦总别装了，夫人已嫁到\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"秦总别装了，夫人已嫁到\",\"description\":\"豪门千金妈死爹不爱！却被亲爸逼着代替后妈女儿嫁给一个植物人！后妈继妹百般羞辱她，却没想，那个植物人老公他，突然睁开眼了！\",\"second_cate\":\"女频霸道总裁\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479196,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1fLmUloEXxRtE_HRulNCo5A?pwd=jwey\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"秦总，您的戏精老婆又作妖了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"秦总，您的戏精老婆又作妖了\",\"description\":\"纪舒颜意外穿越到豪门总裁文中，成了男主秦明礼的妻子。穿过去时，促成这段婚事的秦老太太的葬礼结束，秦明礼提出离婚…\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482796,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/17DGPgN59ZU_lJIH0ES5o7g?pwd=9rni\",\"online_time\":\"2024-02-27 00:00:00\",\"time\":1708963200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"程总您认错白月光了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"程总您认错白月光了\",\"description\":\"江柠是待在程淮川身边时间最长的女人，整个帝都的人都以为她是程家三少的掌心娇，不可亵渎分毫。然而只有江柠自己知道，她不过是男人白月光的替身。在他终于找到白月光的那天，他弃她如敝履。江柠心灰意冷，带着腹中的孩子选择远走高飞。然而男人却疯了，他怎么也没想到，他找了十几年的白月光，其实就是他的枕边人......\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483346,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Ep73pco9rQ2xYrwEn8rcfQ?pwd=y3rv\",\"online_time\":\"2024-03-15 00:00:00\",\"time\":1710432000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"空降三个哥哥：我开启了狂飙人生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"空降三个哥哥：我开启了狂飙人生\",\"description\":\"林暖身份是沐家千金，却因为从小惨遭灭门，因此和三个哥哥被迫分离，被林家领养后改名林暖，长大后的林暖和陆天赐恋爱准备结婚，林暖来到陆家却看到陈家千金陈菲菲和陆母相谈甚欢，陆母中意有钱有家世的陈菲菲，对林暖挑三拣四，动辄打骂。婚礼上，更是安排陈菲菲抢婚，让林暖当着宾客的面丢人，关键时刻，林暖的三个哥哥赶到，分别是四海商会创始人世界首富沐明晨，圣医玄手当代医仙沐乾阳，修罗殿玉面修罗沐寒夜。众人震惊行礼，三个哥哥接走林暖，众人猜测关系。林暖故意放出假消息，陈菲菲和陆天赐各种作妖挑衅，最后被林暖和哥哥们打脸。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478016,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1m-UM7ilXe_YrBp4PL5i8bQ?pwd=trg9复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-24 00:00:00\",\"time\":1692806400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"穿书后反派都喊我妈\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"穿书后反派都喊我妈\",\"description\":\"万万没想到她竟意外穿越到正在追的漫画里，成了里面迷倒万千少女的豪门霸总的老婆江瑾，而这个江瑾却是个被渣男哄骗背叛丈夫，丧心病狂虐待亲生孩子，最后遭报复惨死街头的恶毒女人，知道江瑾最后结局的她暗自决定，一定要改变她和厉云霆还有三个孩子的命运......\",\"second_cate\":\"女频幻想言情（穿书）\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483046,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1BqTk6JaoHJMCxiwdLhAduA?pwd=8nqs\",\"online_time\":\"2024-03-07 00:00:00\",\"time\":1709740800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"穿书后我成了顶级强少\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"穿书后我成了顶级强少\",\"description\":\"男主苏夜穿越电视剧成女神柳青妃舔狗，从此拒绝当舔狗并开始打脸女神柳青妃的故事。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484926,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"链接：https://pan.baidu.com/s/18XixScTVVZka8d0MDRR0nw?pwd=xf5c\\n提取码：xf5c\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-01 00:00:00\",\"time\":1714492800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"穿书后，我成了腹黑男主的心尖宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"穿书后，我成了腹黑男主的心尖宠\",\"description\":\"社畜女孩意外穿书成恶毒女配，不想惨死的她，本想改变剧情走向，帮助腹黑男主攻略小说女主。怎料越努力越心酸，男主对性格大变的女主产生了浓厚兴趣………\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481396,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1o7dOdihK6m4vlvGHskU3Nw?pwd=c3he\",\"online_time\":\"2024-01-03 00:00:00\",\"time\":1704211200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"穿成炮灰女配后我靠医术征服司少\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"穿成炮灰女配后我靠医术征服司少\",\"description\":\"不孕不育专家叶婉欣猝死后穿成书中叶氏集团流落在外20年真千金。被家人逼迫嫁给传闻中不能生育的司夜寒。叶婉欣霸气反击为自己谋取利益后前往司家，打脸女配，收拾家人，最后成功生下3胞胎，拿到300亿奖励。\",\"second_cate\":\"女频穿书/逆袭/霸总/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486096,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1CwgsepGZexayY9IWHbiOpA?pwd=tkc2\",\"online_time\":\"2024-05-30 00:00:00\",\"time\":1716998400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"穿越之飒姐换夫\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"穿越之飒姐换夫\",\"description\":\"沈抒绮意外穿入电视剧，从原剧本的悲情女配逆袭为掌控命运的女王。面对陆砚晟的绝情和沈初眠的算计，沈抒绮凭借预知剧情，智斗渣男，潇洒离职，更与商业大亨祁煜携手，不仅在商战中大展拳脚，更谱写了浪漫新篇章。\",\"second_cate\":\"女频/穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488686,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1NP72YzMv1rKsaMfpGqFe5w?pwd=jkqp\",\"online_time\":\"2024-07-02 00:00:00\",\"time\":1719849600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"穿越古代当股神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"穿越古代当股神\",\"description\":\"纵横“股海”多年的金融男陈决，因为一场意外的“加仓”让自己赔的倾家荡产，接受不了现实打击的他陷入晕厥，想不到再次睁眼，自己却在金銮殿上被五花大绑！大量记忆涌入陈决的头脑，让他意识到自己竟然穿越到了古代，而即将身首异处的他决定用过人的商业头脑拯救自己！带着皇上开股市，带着皇后开直播，带着公主穿黑丝。。。展开了一场啼笑皆非的异世之旅！\",\"second_cate\":\"男频穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483616,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1g4U1LbUi0PY0NWNgAy8dug?pwd=fanq\",\"online_time\":\"2024-03-22 00:00:00\",\"time\":1711036800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"穿越后，错撩女反派\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"穿越后，错撩女反派\",\"description\":\"一个爱追剧的普通女孩意外穿越到剧中发现自己成为了剧中反派！在险象环生的环境中，她勇敢地面对挑战，展现出坚强和智慧，赢得他人的信任和支持，也成功的将原剧中男女一号变为反派，最终成为这个世界的主角并收获爱情。\",\"second_cate\":\"女频穿越现代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479316,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1A8pp8C-pC2TNCzHjDulqCQ?pwd=ndhu\",\"online_time\":\"2023-10-17 00:00:00\",\"time\":1697472000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"穿越平行世界当明星\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"穿越平行世界当明星\",\"description\":\"一部娱乐圈男频爽文短剧，以娱乐圈为创新元素，为观众呈现了一段轻松幽默的故事。\",\"second_cate\":\"男频都市穿越\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480026,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1W0HsTuIJOMo20OexD2-beQ?pwd=h989\",\"online_time\":\"2023-11-16 00:00:00\",\"time\":1700064000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"立地成神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"立地成神\",\"description\":\"十年前，林家灭门，侥幸逃脱的林凡跟随师傅上山修行。在深山修炼十年的林凡，尘缘未了导致修为卡在瓶颈，奉师命下山游历。\\n林凡带着通天修为回到天都，势要手刃仇人，为父报仇。刚下山就遇到十年前的恩人叶婉儿，叶凡测算出叶婉儿陷入生命危机之中，为报恩潜伏在她身边保护。\",\"second_cate\":\"男频都市修真\",\"episode\":0,\"platform\":\"\",\"update_time\":1720478846,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1D8jYypBgdKkYJ8wxCVXL3Q?pwd=gntj\",\"online_time\":\"2023-09-29 00:00:00\",\"time\":1695916800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"第一万次重生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"第一万次重生\",\"description\":\"多次重生后都会回到距离自己生命结束还有3个月的陈洛对所有人的秘密了然于心，新一次的重生中意外得知自己之前喜欢的女人顾清欢自杀身亡其实是被人所逼，遂开始调查真相，在多次重生中找到了真凶。\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485926,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1bZVHLT-1awZm2k7Gj7HkGw?pwd=984s\",\"online_time\":\"2024-05-27 00:00:00\",\"time\":1716739200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"紫龙传奇\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"紫龙传奇\",\"description\":\"林凡原本是一名纨绔公子，因为好赌被未婚妻和苏幕设计失去了家产并被杀，林凡意外获得了神功，成为了紫龙神尊，重活一世林凡决定亲手把自己失去的拿回来。\",\"second_cate\":\"男频/赘婿/战神/逆袭\",\"episode\":0,\"platform\":\"\",\"update_time\":1720488016,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":17,\"material\":\"链接：https://pan.baidu.com/s/1qk_rh555WNN_COsbhUzOvg?pwd=pey4\\n提取码：pey4\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"繁花似锦\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"繁花似锦\",\"description\":\"男女主怀着各自目的闪婚，男主要找寻神医黑玫瑰为弟弟治病，殊不知他眼前的就是黑玫瑰，而女主这边有暗杀男主的任务，却不知不觉爱上了男主，双方各怀心事，却又撒糖不断。\",\"second_cate\":\"女频魂穿/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483116,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1fJMRXSJxDpCFlF6499JK3g?pwd=c13u\",\"online_time\":\"2024-03-09 00:00:00\",\"time\":1709913600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"繁花初见不知迟\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"繁花初见不知迟\",\"description\":\"急于结婚，乔然随便拉了个\\\"破产\\\"的小老板领了证，本是打算与他平平淡淡的过下去。谁知婚后：她想买辆国产比亚迪代步，抽个奖却能中一辆免费的保时捷。\\n她想贷款买套小楼盘的两居室，抽个奖又意外中了一套大别墅。她每次遇到困境的时候，他也总是临危不乱易如反掌间帮她迎刃以解。直到某一天，有人阿谀奉承地来到她的面前，叫她一声：首富太太。她才知道，原来她嫁了一个身家千亿的财团大老板。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481696,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1rMtW1--5VBq4Aru4ldAJBw?pwd=weqz\",\"online_time\":\"2024-01-19 00:00:00\",\"time\":1705593600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"繁花年代\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"繁花年代\",\"description\":\"龙城首富韩阳因心脏病突发，被紧急送往医院途中，不料被亲生女儿韩晓婉截走并将他送往火葬场，让他为三十年前贩卖女儿、逼死妻子的罪行付出代价。弥留之际，韩阳痛心疾首地忏悔，愿用毕生财富换人生重活一次。\",\"second_cate\":\"男频年代 重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483186,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/14ONAX80KcDqjXBlN4mv1lg?pwd=481y\",\"online_time\":\"2024-03-10 00:00:00\",\"time\":1710000000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"红毯女士\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"红毯女士\",\"description\":\"江岚为养渣男，一天打两份工，却惨遭羞辱背叛，失魂落魄被车撞却意外与双胞胎影后姐姐苏若雪相认。苏若雪为救江岚意外车祸脸部受伤无法完成影视拍摄，赔偿金高达一亿，为挽救姐姐的影后事业，二人决定交换身份。\\n江岚因为记不住台词的随口一句话却引来各种追捧，影后光环下演戏好像并没有那么难，影帝张逸龙竟主动求炒cp？\\n苏若雪则化身小人物进入江岚公司，各种打脸杂碎，为妹妹出头，暖男同事顾情深似乎有点深情，让人完全招架不住。\\n且看两个性格完全不同的姐妹花在交换生活中如何过关斩将，各自抱得美男归！\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487936,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1BhQl5QVVaPXbLHg1rfzVmQ?pwd=xey9\",\"online_time\":\"2024-06-20 00:00:00\",\"time\":1718812800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"纪总的闪婚夫人美又飒\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"纪总的闪婚夫人美又飒\",\"description\":\"童婳和纪宴礼小时候一起遭遇绑架，被救下后童婳给纪宴礼输血，纪宴礼因此对童婳许下娶她的承诺。二十年后，长大后的童婳和纪宴礼却各自认错了人，并且因为认错的人而针锋相对，发生了一系列故事。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486856,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1gkUOgqFhYCwmhh0E_xgK3g?pwd=s18q\",\"online_time\":\"2024-06-04 00:00:00\",\"time\":1717430400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"纪画的计划\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"纪画的计划\",\"description\":\"一夜之间，纪画家破人亡，她展开了长达十年的复仇计划，就在她即将复仇成功时，却爱上的仇人的弟弟……\",\"second_cate\":\"女频豪门总裁\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483026,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1cOsIuwz1IvPIDQJh7KGR_g?pwd=3nzk\",\"online_time\":\"2024-03-07 00:00:00\",\"time\":1709740800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"纯情苏老师休想逃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"纯情苏老师休想逃\",\"description\":\"苏沐云为救弟弟成为沈嘉年家教，两人相爱。误会后她态度大变，选择留在沈父身边。沈嘉年出国，五年后回国再见苏沐云，误会加深。苏沐云默默承受苦衷，沈嘉年不知真相。\",\"second_cate\":\"女频豪门、虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488776,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1XmS8DlLCfqS_ibB1mJl-8w?pwd=6tvf\",\"online_time\":\"2024-07-04 00:00:00\",\"time\":1720022400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"纵横\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"纵横\",\"description\":\"顾峰被叫岳父沈青山到天台停机坪上，沈家为了让沈洛心能顺利嫁入陈家，逼迫顾峰跳楼自杀，顾峰下令，招标宴会上，送一份订单给沈珞心，并嘱咐苏梦妍不要向宁雪妃暴露他的行踪，沈珞心提出异议，顾峰将这些年帮助她的事情，一一说出，沈珞心嘴硬不信，认为顾峰除了宋万三的尊重外，一无所有，顾峰亮出东君身份，众人震惊，四家家主走进酒店，以为子女们得罪的是宋万三，后得知顾峰的东君身后提出质疑，认为宋万三是让顾峰假冒东君，借此来问罪打压他们。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483836,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1UFTWD0VbxLu-qrGlV84b7g?pwd=jmm8\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"给前夫的白月光让位后\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"给前夫的白月光让位后\",\"description\":\"女主沈时好错认男配苏屿恒为救她的人，与其成亲后发现他喜欢的是自己的妹妹，于是毅然和离。之后她遇到周序川，得知他才是救自己的人，两人历经磨难后终成眷属。期间霓虹郡主多次阻挠，甚至对沈时好下药陷害，最终被周序川反击而身败名裂。后来周序川在与北狄三皇子一战中失踪，被传战亡，面对心爱人的失踪，沈时好该何去何从？\",\"second_cate\":\"女频古装/甜宠/宅斗\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483876,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1_4rVwDLRrinrjn3O6fIfww?pwd=t7xk\",\"online_time\":\"2024-03-28 00:00:00\",\"time\":1711555200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绝世医妃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绝世医妃\",\"description\":\"著名男科大夫虞心柔因被患者骚扰意外下穿成了古代后宫中一个妃子，而这个妃子竟被当做是皇帝生病的元凶即将打入冷宫，危急之下虞心柔允诺为皇帝治病，为此还成了所谓的宠妃！就看现代男科医生如何在宫斗中脱颖而出！\",\"second_cate\":\"女频古装甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479536,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/11c6xYdW7Gh0STHtTzjFqZQ?pwd=pp68\",\"online_time\":\"2023-10-28 00:00:00\",\"time\":1698422400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绝世医皇\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绝世医皇\",\"description\":\"凌云龙五年前因凌家灭亡逃入深山，练就一身绝世医术，成为天门医皇，有引领众生百年一次开天门，一窥长生三百年的资格，未婚妻袁玲却不识人间真龙，直接退婚。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480196,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1zQAh0cGbd_zeJ8tfriz9Eg?pwd=w6bz\",\"online_time\":\"2023-11-20 00:00:00\",\"time\":1700409600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绝世医神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绝世医神\",\"description\":\"医圣叶青，隐藏身份娶了南省第一美女沈若霜，并暗中帮助沈家崛起。就当叶青要在为沈若霜准备的南省宴会上表明身份，让沈若霜成为南省最有权势的人前一夜，沈若霜却向叶青提出了离婚。宴会上，沈若霜得知叶青真实身份，无比后悔，想要复婚……\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480786,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1ooBe9Atvhkr-0mI_rw9A7A?pwd=efup\",\"online_time\":\"2023-12-15 00:00:00\",\"time\":1702569600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绝世帝君\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绝世帝君\",\"description\":\"神尊阁少主，新任帝君张伟一场大战中受伤被被妻子萧若云所救，张伟顺势隐匿身份，成为一名外卖员。夜王与其子叶天三番五次挑衅，在大师姐和小师妹帮助下，张伟探查出当年父亲受害真相并击杀通敌卖国的拜日尊者。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486696,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1GngApll3JE6uDV0CghfItA?pwd=bi7n\",\"online_time\":\"2024-05-30 00:00:00\",\"time\":1716998400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绝世强医\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绝世强医\",\"description\":\"大夏仙师陈锋隐居山林，被厉君瑜请下山救治其家人，遵从师命手持两份婚书下山。在阴差阳错之中，却被厉君瑜退婚，与另一位婚约人苏明月相识相知。并助苏家脱离陈鹏飞设计的圈套，但苏家除了苏明月对其信任外，其他人都十分看不起陈锋。在其弟子为陈锋举办的谢师宴中，苏家落入深渊，厉君瑜追悔莫及，陈鹏飞被惩治。最终陈锋与苏明月终成眷属。\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483416,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1weo2vhaipoNCyljhfA8VFA?pwd=h6kj\",\"online_time\":\"2024-03-18 00:00:00\",\"time\":1710691200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绝世武神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绝世武神\",\"description\":\"武胜为给妹妹凑医疗费，去地下黑市打黑拳赚钱，练成了绝世武功，武胜申请打出笼战，众人震惊。武胜一路过关斩将，杀出成为，直面象主和狮虎豹三王，象主利用武神戒召出剑姬剑圣剑豪剑魔来对付武胜。武胜轻描淡写战胜四人，被四人奉为武神殿武神，接管武神殿成为地下世界之王。\\n武胜的妹妹武墨被林家手下发现并抓回林家准备给林东作为练功炉鼎，而林东发现武墨姿色极佳，决定占有武墨，千钧一发之际，武胜赶到，救下武墨，打败林东。林家家主仗势欺人，派出四大高手实则剑姬弟子对付武胜，武胜出手，教训了四大高手，剑痴出场，对付武胜，武胜废掉剑痴。剑姬赶到,拦下四人，道出武胜武神的身份，林家震惊...\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479476,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1pST1UoEH5ht2PhNu5F05uA?pwd=afaf\",\"online_time\":\"2023-10-27 00:00:00\",\"time\":1698336000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绝世神豪\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绝世神豪\",\"description\":\"苏秦被女友背叛，觉醒神豪打赏系统，一路开挂逆袭，年度之夜大败神豪五斗米一战封神，四大当红主播纷纷前来投靠，对他爱慕有加，他却不知该如何抉择。\",\"second_cate\":\"男频系统、逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488796,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/12O04U5EmPHQ--RReOpwnIg?pwd=49vu\",\"online_time\":\"2024-07-04 00:00:00\",\"time\":1720022400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绝世萧门\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绝世萧门\",\"description\":\"萧凡从北境归来，正巧五年龙熄令解除，宋启安率萧门众人前来青州恭迎萧凡回归，为了能让唐家在青州立足，萧凡特例让出龙鼎集团三成股份，然而，唐家却对他百般误解，唐雅柔甚至提出了离婚，萧凡心灰意冷，不再对青州留有念想。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482336,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1D0FeO1GNvhg_7iqV6W_Ghg?pwd=brxf\",\"online_time\":\"2024-02-09 00:00:00\",\"time\":1707408000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绝代佳人欠我赊刀债\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绝代佳人欠我赊刀债\",\"description\":\"王遁一应爷爷王四九遗命下山收九家帝皇后裔嫡女配婚的赊刀债，以期完成九凤朝龙仪式，破赊刀一脉天缺地弊命运，让爷爷入土为安。游历金市、山城、京都等地，结识美女，发生许多啼笑皆非的故事，堪称现代版鹿鼎记。\",\"second_cate\":\"男频高手下山\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486916,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1q2OWiRSlMK8VZiy33VMrvw?pwd=d9n3\",\"online_time\":\"2024-06-05 00:00:00\",\"time\":1717516800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绝命婚姻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绝命婚姻\",\"description\":\"七年前苏月和丈夫陈明在职场相识相知，两人从竞争对手到倾心恋人，在同一个升迁机会面前，陈明向苏月求了婚并许诺会养苏月一辈子，苏月被陈明的真诚打动。为了婚姻幸福，苏月选择回归家庭，做一个全职主妇。婚后两年苏月便成功诞下一女，丈夫陈明也在职场愈发出色。苏月自认为家庭幸福美满，可意外发生于苏月在丈夫的衣服上发现一根不属于自己的头发开始。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485346,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1-m7SbWKm4y2oFEaKsrbGdA?pwd=yuc4\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绝望主妇的霸气逆袭\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绝望主妇的霸气逆袭\",\"description\":\"女主毕业后因老公一句承诺甘心成为全职太太并天真以为只要留住美貌就能留住老公的心。然老公却出轨。女主选择离婚。女主整日以泪洗面探望儿子不成反被羞辱。女主不断成长蜕变，打脸渣男前夫。渣男前夫追妻火葬场。\",\"second_cate\":\"女频婚姻/爱情/亲子/事业\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485416,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/19XQT8VcwER83uxPjKlKeLg?pwd=rn93\",\"online_time\":\"2024-05-19 00:00:00\",\"time\":1716048000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绝症后谭小姐疯狂了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绝症后谭小姐疯狂了\",\"description\":\"谭心雨患上绝症只有三个月寿命后，当即决定为自己而活。自此开始肆无忌惮的任性妄为。当她在酒吧任性狂野的撒钱后，引起富二代任嘉铭的注意。谭心雨与他是第一次，和表现出来的放荡完全不同，于是对她更加好奇。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487146,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/15z-wNTQNcxmWtlq95xPwXg?pwd=eyx6\",\"online_time\":\"2024-06-07 00:00:00\",\"time\":1717689600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绝色未婚妻宠我上天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绝色未婚妻宠我上天\",\"description\":\"普通外卖员刘浩在家求姻缘，遇到财神爷现身给姻缘，接着被相亲对象徐若遥羞辱，不过每到关键时刻，财神爷能出手救助，化解各种危机。在与未来的老婆接触中，周氏集团遇到债务危机，刘浩豪掷百亿救回周氏集团，让周雨烟震惊，同时，周雨烟被吴家少爷看上，指明要周雨烟嫁给他，不然就灭了周家，周雨烟父亲迫于压力要同意，只有爷爷反抗，危急时刻，刘浩爆出真实身价，打脸众人，赢得周雨烟芳心。\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479586,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1RiFj8kifaa9TZZPs8zKm6A?pwd=9jfc\",\"online_time\":\"2023-11-03 00:00:00\",\"time\":1698940800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"继承人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"继承人\",\"description\":\"上一世，他被财阀崔世泽抢了婚妻，又被无情的践踏，在经历了背叛和死亡的极致痛苦后，意外重生回到十年前，变身成为仇人崔世泽的弟弟——家族显赫的财阀家族二公子！这一世，他决心利用这个意外的机遇，站到世界的顶点，惩治那些恶人。\",\"second_cate\":\"男频小人物逆袭\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480706,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1uQn9gBcvKanFAkKb8XtMEg?pwd=h4tf\",\"online_time\":\"2023-12-12 00:00:00\",\"time\":1702310400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"继承者\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"继承者\",\"description\":\"秦震为爱和首富母亲打赌，只要以普通人的身份和苏倩雪结婚三年，即可通过考验，秦震就能带苏倩雪回家。三年之期已到，秦震满心欢喜带着万亿礼物去向苏倩雪坦白身份，却收到一纸离婚协议书。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479506,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1KqhyrjAkoDTgv3x0YGvqAw?pwd=cd1u\",\"online_time\":\"2023-10-27 00:00:00\",\"time\":1698336000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"绯闻计划\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"绯闻计划\",\"description\":\"一对性格截然不同的男女，在一次意外中互相交换了灵魂，无奈之下两人只得扮演对方，替对方生活，解决工作上遇到的问题。正因如此，两人从不同的角度重新认识了对方，他不是这般不近人情，她也并非这般没心没肺。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482036,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1UAZ06i-Sl33f_Fd5oErdoQ?pwd=ibj3\",\"online_time\":\"2024-02-04 00:00:00\",\"time\":1706976000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"缅北反诈江湖情\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"缅北反诈江湖情\",\"description\":\"浩南、火鸡、七妹、小算盘是几个出生入死的好兄弟，对以老鹰为首的缅北犯罪团伙深恶痛绝。在与诈骗园区的斗争中，浩南杀死了老鹰情人黑玫瑰，老鹰誓要报仇。双方水火不容，浩南惨遭陷害堕入绝境。\",\"second_cate\":\"男频兵王/战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487006,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1YXbpgyvtH36Pdt-_QjbwJA?pwd=edpr\",\"online_time\":\"2024-06-06 00:00:00\",\"time\":1717603200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"缅北反诈终极之战\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"缅北反诈终极之战\",\"description\":\"为了探寻妻子下落，高志强卧底进入缅北最大诈骗园区，在浩南、瘦猴、肥仔、阿泰等好友帮助下，历尽艰难找出园区犯罪证据揭开黑幕，一举捣毁诈骗园区，揪出幕后真凶，与妻子团圆。\",\"second_cate\":\"通用\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488276,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":16,\"material\":\"https://pan.baidu.com/s/1T473hkitMtltXcoJzknECg?pwd=rut3\",\"online_time\":\"2024-06-26 00:00:00\",\"time\":1719331200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"美女总裁欠我赊刀债\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"美女总裁欠我赊刀债\",\"description\":\"通阴阳，晓命理！鬼谷传人王遁一携滔天本领入世，开启一段传奇人生……\",\"second_cate\":\"男频都市修仙\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479836,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1OyllcydGV6faeFz57V5CgQ?pwd=58jf\",\"online_time\":\"2023-11-10 00:00:00\",\"time\":1699545600,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"美女时刻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"美女时刻\",\"description\":\"陈霄有一项超能力。能够看到将死之人头顶的数字倒计时，数字预示着剩余寿命。在一次乘坐飞机时，陈霄惊恐发现飞机上所有人头顶都有倒计时数字0。陈霄猜测飞机即将发生空难，只有王诗雨与他一起离开。结果飞机真的出事了，王诗雨决定与陈霄一起拯救那些头顶出现倒计时的人。在尝试多次拯救他人后，却屡屡失败。两人分别之际，陈霄突然发现王诗雨的头顶也出现了死亡倒计时！\",\"second_cate\":\"男频悬疑推理\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483866,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1bGnUxoxS-6YyjkmSRZ2yHg?pwd=8xs8\",\"online_time\":\"2024-03-28 00:00:00\",\"time\":1711555200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"羽翼天下\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"羽翼天下\",\"description\":\"叶城功高盖世被封翼王，却解甲归田想过普通人的生活，与方倾颜结婚三年处处忍让，却被暗中扶持的方家看不起，认为他是个扶不上墙的烂泥。方家封爵，叶城为了给兄弟讨回公道，大闹封爵大典，镇权贵，惩罪恶，褫夺爵位，立兄弟之女为候。一连串的误会解除之后，方倾颜才认识到方家人的恶劣，才知道她一直看不上的老公是羽翼天下的翼王，后悔不已。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481236,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1-VxhGo-Wp_-Y_iaHjALCew?pwd=tsj4\",\"online_time\":\"2023-12-29 00:00:00\",\"time\":1703779200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"翻转人生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"翻转人生\",\"description\":\"垂垂老矣的首富叶辰，终其一生，都在寻找他失散多年的女儿。但当他终于找到之时，女儿却被叶辰的妻子挟持，最终牵扯出了一个长达数十年的阴谋。叶辰眼看着他的女儿被人残害，自己也最终惨死。当他再次张开眼时，竟然重生到2008年。重生后的他发誓，要改变妻儿自杀的命运，改过自新，戒掉赌瘾，他要发家致富，让妻儿们过上幸福生活。\",\"second_cate\":\"男频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481056,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1PDb5WTJjgjND6ZHg-ZINMA?pwd=j4kt\",\"online_time\":\"2023-12-25 00:00:00\",\"time\":1703433600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"老公我掉进了闺蜜的陷阱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"老公我掉进了闺蜜的陷阱\",\"description\":\"叛离月门的苏明珠为夺取月神玉，派遣儿女潜入顾家，夺取长生不老之力。月门弟子高寻奉命追踪，与顾家后人顾苏结缘。暗杀计划意外使月神玉与顾苏融为一体，一场关于权力和爱情的斗争悄然拉开序幕。\",\"second_cate\":\"通用/异能/都市/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488416,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1IKT81LYcMEfLoczFVXp98g?pwd=yiiv\",\"online_time\":\"2024-06-27 00:00:00\",\"time\":1719417600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"老公来自外太空\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"老公来自外太空\",\"description\":\" 千予初是来自哈克尔星球的探查员，因与地球人楚玉儿相爱，被身为本星球的执法者的哥哥千思奇追杀，楚玉儿为救千予初而亡。500年后，千予初找到转世后的穆晓曼。为了更快亲近心爱之人，腹黑的千予初英雄救美时，装作被混混打伤，加之私人医生的配合，自称命不久矣。而穆晓曼因与千予初贴身接触，让她脑海里经常出现的模糊男子逐渐清晰，为了弄清真相，于是便答应千予初成为他的契约女友，在有生之年陪伴左右。就在穆晓曼多次遇到危险，遇到各种不同的人刁难侮辱时，千予初总能在第一时间出面保护。但千予初内心也暗暗自责，因为穆晓曼有些委屈，皆因他而起，所以千予初对穆晓曼的宠爱更加肆无忌惮。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479686,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ZnyvcKKRP26nlvnRcLVVPw?pwd=7xbu\",\"online_time\":\"2023-11-08 00:00:00\",\"time\":1699372800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"老公的金丝雀怀孕后\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"老公的金丝雀怀孕后\",\"description\":\"一场车祸，一名孕妇，掀开了安檀婚姻的真相，原来，表面上的二十四孝好老公不仅婚内出轨，与别人珠胎暗结，还背地里转移财产，甚至当年的孩子也是他害死的，而小三小四也是被容宴西欺骗的可怜人，当安檀查清一切，决定联合小三小四，将失去的一切都拿回来！\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482966,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1vqFyozWUCc5NSYdqIqcP2A?pwd=uye7\",\"online_time\":\"2024-03-05 00:00:00\",\"time\":1709568000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"老婆不许我低调\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"老婆不许我低调\",\"description\":\"萧然一手缔造了萧氏集团的辉煌，却甘愿以赘婿之身留在苏家。当妻子面对父母，面对家主奶奶的压力，为保护丈夫选择离婚。怎忍妻子如此难捱，索性做万万人之上，为人间真龙，萧然一并力扛四大世家！\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481806,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":16,\"material\":\"https://pan.baidu.com/s/1Z1vEK-tQAePcVxC_IIWP6g?pwd=zm9k\",\"online_time\":\"2024-01-25 00:00:00\",\"time\":1706112000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"老婆在我坟头蹦迪后\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"老婆在我坟头蹦迪后\",\"description\":\"林枫病重时，妻子于秋月伙同奸夫一起直接办葬礼。林枫这才知道自己被绿，抱着对前妻叶婉秋和女儿的愧疚死去。不料却重生回了1990年自己刚要将妻女赶出家门的那一刻。重生的林枫发誓要好好对待前世辜负的妻女。\",\"second_cate\":\"男频重生/年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485376,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/13s_lCBhZnpBHEva5xpL7rg?pwd=jur7\",\"online_time\":\"2024-05-18 00:00:00\",\"time\":1715961600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"老婆我真不是龙帅啊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"老婆我真不是龙帅啊\",\"description\":\"大夏国战神陈青龙征战沙场十年，南征北战，开疆拓土，扫除东西南北四大势力，平息了大夏国持续几百年的战火，并给大夏国带来了前所未有的盛世。因再无战事，陈青龙决定退隐江湖，回到都市完成自己当上门女婿的计划。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485386,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1ujQ2_bhAUmUE39deGpKSGA?pwd=ygbm\",\"online_time\":\"2024-05-18 00:00:00\",\"time\":1715961600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"老子开局就是城主\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"老子开局就是城主\",\"description\":\"小伙穿越到东汉末年附身在一位城主身上，小伙用智慧将小城壮大，与豪绅斗智斗勇最终稳定局面。\",\"second_cate\":\"男频穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482156,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":17,\"material\":\"https://pan.baidu.com/s/1EHh2b4fTkebvvdxI8aFYAg?pwd=e2nu\",\"online_time\":\"2024-02-06 00:00:00\",\"time\":1707148800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"老祖宗驾到\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"老祖宗驾到\",\"description\":\"洛家旁系遭人诬陷，家主洛云溪被人追杀，情急之下躲入洛氏剑冢避难；不想意外唤醒洛氏先祖，化解危机；而后洛氏老祖本想借洛氏大典，洗刷旁系冤屈，不料被老祖宗发现了更大的阴谋，原来洛氏宿敌幽冥已然苏醒，策划了一场巨大的阴谋，欲将洛氏一族推向万劫不复之地.......\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482226,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1JvEe7Bjt_1HZezKhSkOtYQ?pwd=pwwa\",\"online_time\":\"2024-02-08 00:00:00\",\"time\":1707321600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"肆意沉沦\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"肆意沉沦\",\"description\":\"女主温言曾亲眼目睹了父母被残酷害死，她蛰伏多年后，赌上一切变成危险之花回归，向夺取她人生还纸醉金迷的仇人复仇，在勾引男主霍骁步入自己陷阱的过程中，她意外发现了霍骁的秘密，从而陷入命运的漩涡。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483586,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/11fPgP2bJepWyZU3fjBiMmQ?pwd=7pdc\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"股动乾坤\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"股动乾坤\",\"description\":\"男主预见股市未来抓住机会卖掉房子去炒股，却遭到亲戚的质疑，妻子的反对，徒弟的背叛，但他坚信了自己的判断最终赢得了成功，重新与妻子和好如初，过上幸福圆满的生活。\",\"second_cate\":\"男频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488096,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1hJvSnxmXZcJ3oo2nG5oLTw?pwd=7bvc\",\"online_time\":\"2024-06-22 00:00:00\",\"time\":1718985600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"肥妈带球跑\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"肥妈带球跑\",\"description\":\"五年前蛇蝎美人沈茉莉因为嫉妒闺蜜宁岁想靠子嫁进豪门，但由于自己不孕，所以故意给闺蜜宁岁打了激素药，害得闺蜜宁岁变胖之后跟池牧之发生关系，五年后，宁岁减肥成功华丽回归。瘦身成功后的宁岁偶然一次机会遇到了男主池牧之和亲身儿子池西洲，发现对方竟是五年前发生关系的那个人。解开误会后一家人解决了沈茉莉一家人。\",\"second_cate\":\"女频霸总/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485676,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1nLyCDZBwzEZV4z5zt9MdGw?pwd=uvz9\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"肥宅当皇后\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"肥宅当皇后\",\"description\":\"楚盈是一个资深肥宅女，更是资深追星人，日常除了工作就是宅在家追星打榜做数据。她为了追顶流影星夜昊天已经砸了上百万，终于得到在见面会上给夜昊天亲自献花的机会，可她在上台时却因为过胖被夜昊天嫌弃推攘，不小心掉落下台，临死前她心心念念的夜昊天看都没看一眼。她从混沌中醒来，发现自己竟穿越到了古代一个同名同姓的胖妃子身上，胖妃子临死前被害的记忆也涌上脑海——真凶就是王爷夜明礼。\",\"second_cate\":\"女频穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480326,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1JFUm-4AQZkG4DuYngO8RUw?pwd=a2e1\",\"online_time\":\"2023-11-24 00:00:00\",\"time\":1700755200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"胜天半子\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"胜天半子\",\"description\":\"十八年前，幼年的楚家大少楚明轩惨遭爷爷遗弃，被村民高秀媛收养，改名齐轩。十八年后，齐轩受到权贵欺压，养母性命不保！齐轩冲冠一怒，独闯虎穴救母！此时，生父楚有为执掌家族大权，也已踏上了寻找儿子的路！\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486396,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"链接：https://pan.baidu.com/s/1NqpuR_OusAm918eFIGyMPg?pwd=z9kz\\n提取码：z9kz\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-04 00:00:00\",\"time\":1714752000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"脱缰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"脱缰\",\"description\":\"虐剧女主自杀时重生穿越，发现自己身处虐剧，决定对抗编剧安排，改写自己的命运。\",\"second_cate\":\"女频穿书\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481066,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1t4tA09bzb7aHftvWv7TaVw?pwd=7v78\",\"online_time\":\"2023-12-25 00:00:00\",\"time\":1703433600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"腰间指痕\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"腰间指痕\",\"description\":\"她赌气和前任的舅舅闪婚，新婚当天他红着眼说：这一天我等了六年!\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481186,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1XhkrwIZ2DFMFRmwHvfkfrQ?pwd=1qxe\",\"online_time\":\"2023-12-26 00:00:00\",\"time\":1703520000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"腹黑养女\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"腹黑养女\",\"description\":\"穆家养女穆景甜和穆家继承人穆凌峰之间的爱恨纠葛，穆景甜年幼父母意外去世，穆景甜被父亲的合 作伙伴收养名下，成为了穆家养女，而无父无母的穆景甜从小备受苦楚，被真千金欺负，而男主穆凌峰多次出手 相救，二人也开始相互救赎，惺惺相惜，直到一切的谜团揭露出来撕破了穆家的虚伪和无情，穆景甜找到了父母 去世的真相，眼看杀人凶手的儿子就在眼前，她在爱与恨之间难舍难分，而穆凌峰也揭露了真相，他并非穆家亲 生儿子，真相大白后，二人真正的在一起。\",\"second_cate\":\"女频现言\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479356,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1KMuK1J1mkwfGVjDNPM4zrQ?pwd=84ke\",\"online_time\":\"2023-10-19 00:00:00\",\"time\":1697644800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"腹黑娇妻来打工\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"腹黑娇妻来打工\",\"description\":\"在女主10岁时，继父带着女儿女二入赘女主家，谁知生性暴躁的继父每次醉酒后，都会家暴女主和母亲，而身为姐姐的女二也在父亲的怂恿下，对女主不断欺负，母亲最终在继父的折磨下自杀，继父父女并夺走了女主家集团。年幼的女主想复仇，可继父家现在有钱有势，男二帮女主假死出国，15年后女主回国，准备利用男主复仇...\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480766,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1UDUV2E0Og-C2Kk66qzoCaw?pwd=y35e\",\"online_time\":\"2023-12-14 00:00:00\",\"time\":1702483200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"至尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"至尊\",\"description\":\"天下至尊许尽欢下凡历练，令战神燕无双磨练三年再收她为徒。燕无双不知道至尊就是自己的未婚夫许尽欢，决定退婚。许尽欢撞见妻子出轨，并遭到奸夫陈士英等人羞辱。他展示出不凡的身手和背景，此时燕无双前来退婚，激怒许尽欢。\\n在燕无双的入阁拜师宴现场，许尽欢宣布自己的身份，取消燕无双的资格，打脸前妻等人……\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483356,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1zWrBnNduxexQHAe7n7mFyA?pwd=7kyq\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"至尊丐婿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"至尊丐婿\",\"description\":\"千亿总裁沦为乞丐，却娶到美妻，逆袭崛起。即便卑微的乞丐，也有传奇的人生，前妻的背叛，正妻的偏爱，小人物逆风翻盘。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483826,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1E5W6mvYSdxRFerTTUM0NpQ?pwd=p4u5\",\"online_time\":\"2024-03-27 00:00:00\",\"time\":1711468800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"至尊傻婿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"至尊傻婿\",\"description\":\"三年前，一代神尊陈渊，红尘炼心，不料失去记忆修为，神智不清，被唐家唐韵招为赘婿，三年后，唐韵面临危机，危急时刻，陈渊重获修为，以一己之力，扭转乾坤，重回神尊之位。\",\"second_cate\":\"男频/赘婿/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488126,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1Q_VGa8fo1wzvxKYb6J9crQ?pwd=6zd6\",\"online_time\":\"2024-06-22 00:00:00\",\"time\":1718985600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"至尊天师\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"至尊天师\",\"description\":\"五百万年前为镇压魔界阴狱鬼王，上古战神走遍四海八荒找到最后一处天魔神矿，打造出天机剑，并以身殉剑，才得以将阴狱鬼王封印。为守护世间不再受鬼王门徒骚扰，上古战神门下大弟子成为至尊天师，世代守护天机剑。时代更迭，由于鬼王的诅咒，历代天师均无法拔出天机剑，而鬼王存留于人间的一魂也在门徒波斯教和古奥丁国的帮助下逐渐壮大。隐隐有冲破封印的趋势。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480256,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1boL6Q7M1ULdbvDGJrWxvsA?pwd=xujg\",\"online_time\":\"2023-11-22 00:00:00\",\"time\":1700582400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"至尊龙神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"至尊龙神\",\"description\":\"龙神后人李不凡，被女朋友卖到缅北之后，得到龙神传承，逆袭崛起。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484016,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/18Wt2DpuafEZfPTCGNpRuig?pwd=du87\",\"online_time\":\"2024-04-01 00:00:00\",\"time\":1711900800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"致命主妇又美又飒\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"致命主妇又美又飒\",\"description\":\"三年前韩静为了救自己丈夫而毁容，不得已告别职场做起全职太太。然而丈夫的背叛和小三的挑衅，在家庭面前让韩静进退两难。经历过无数次被伤害后，韩静开始反击，击溃丈夫和小三，并迎来了自己的华丽转身。\",\"second_cate\":\"女频复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484686,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1yNEN2UWrkCHGfwAu8kl5hQ?pwd=r1tu\",\"online_time\":\"2024-04-24 00:00:00\",\"time\":1713888000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"良辰美景知几何\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"良辰美景知几何\",\"description\":\"前世的颜心，空有一身医术傍身，相信了不该相信的人，城破家亡的时候，被亲生妹妹推下城楼。幸好苍天有眼，叫颜心重活一世。这次她悬壶救世的初心不改，她决定要将真心交给值得托付的人，而这个人，竟然是前世与她没有交集的少帅景元钊。\",\"second_cate\":\"女频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485126,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1-n2KgFGps8ilYoErXEz_jQ?pwd=8q31\",\"online_time\":\"2024-05-10 00:00:00\",\"time\":1715270400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"花都极品狂神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"花都极品狂神\",\"description\":\"三年前，江家灭门惨案中侥幸逃生的江凡被林诗韵所救，林诗韵为逃避母亲安排的婚姻跟江凡假结婚。三年婚姻，江凡成了所有人眼中的废物赘婿，异界药王分一缕原神助其重生，开启复仇之路！\",\"second_cate\":\"男频都市、赘婿\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483936,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1wr_LByf1_P8tpKumJKFScg?pwd=ct24\",\"online_time\":\"2024-03-29 00:00:00\",\"time\":1711641600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"花都狂龙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"花都狂龙\",\"description\":\"屌丝苏逸泽穿越到一本名叫《花都狂龙》的小说里，成为原本跪舔女主的财阀少爷，他决定逆天改命，从此不再当舔狗，还要掠夺原小说男主的各种机遇和资源！经过一系列的发展，最终打败了小说里的男主，跟女主在一起。\",\"second_cate\":\"男频穿书、逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483126,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1WQMOkVLCP90oZM7RAdAhSg?pwd=w2ww\",\"online_time\":\"2024-03-09 00:00:00\",\"time\":1709913600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"花都纵横之无限逍遥\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"花都纵横之无限逍遥\",\"description\":\"外卖员叶辰不过是送了一次外卖，却卷入到女总裁陈雪与其丈夫离婚的纠葛中，为了协助陈雪报复其老公，叶辰开启了一场神奇的花都逆袭之旅。\",\"second_cate\":\"男频都市逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479326,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/11JBIeD67W1t8dc3orP7Ycw?pwd=pw7d\",\"online_time\":\"2023-10-17 00:00:00\",\"time\":1697472000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"苍蓝之契\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"苍蓝之契\",\"description\":\"有着千年修为的蛇妖白若寒本可以飞升仙界，却为了报恩私自留在凡间嫁给了恩人苏子昊。谁知女二林有有杀害子昊父母并嫁祸白若寒把她推下深海。白若寒幸得闺蜜陆青所救，醒后得知自己怀孕，决定生下孩子并查清凶手，然而苏子昊突患脑癌，白若寒为了救苏子昊不惜以身试药，却因为林有有加害，苏子昊命悬一线，白若寒只好发动骨血祭天，用孩子的命救回苏子昊的命，随后两人查清林有有真实面目，逐渐找回对彼此的爱，在二人的齐心协力下，将林有有绳之以法。然而，就在两人觉得一切圆满结局时，白若寒被最终反派洛晨风的绑架汲取灵力，苏子昊来救却将将丧命，白若寒只好发动自己最后的灵力去救苏子昊，从而灰飞烟灭。最终在白若寒消散时，千年闺蜜陆青不忍，用自己千年修为成全二人姻缘。\",\"second_cate\":\"女频虐剧复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477846,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/18QFp3cU7cizIcw0RrO0JaQ?pwd=ujqu复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-18 00:00:00\",\"time\":1692288000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"苏助理只想带崽跑路\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"苏助理只想带崽跑路\",\"description\":\"苏七七被渣男出轨，醉酒后一夜贪欢，醒来却发现身边的男人竟然是自己的老板贺南舟，于是悄无声息离开。贺南舟误将昨晚的女人当做是继母安排的人，让苏七七负责找到。两人你追我躲的猫鼠游戏中，苏七七发现自己怀孕了……\",\"second_cate\":\"女频都市 闪婚 甜宠 霸道总裁\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482736,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1eZByusHIVBQYgNM7NVKuSA?pwd=rg4n\",\"online_time\":\"2024-02-26 00:00:00\",\"time\":1708876800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"苏小姐请住手\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"苏小姐请住手\",\"description\":\"被错换人生的苏晓彤，二十年后重回千金身份，与豪门公子陆世俊相遇相助相爱。害死亲生母亲的假千金，只看利益，将女儿推向深渊的亲生父母，苏晓彤以智谋和坚韧送罪人入狱。男主与苏晓彤成为彼此救赎，走向幸福。\",\"second_cate\":\"女频都市爱情、悬疑\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484156,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1mR0WxLJb2a5OG8XKzvec7A?pwd=ybw5\",\"online_time\":\"2024-04-05 00:00:00\",\"time\":1712246400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"苏总的罪婚宠妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"苏总的罪婚宠妻\",\"description\":\"有着千年修为的蛇妖白若寒本可以飞升仙界，却为了报恩私自留在凡间嫁给了恩人苏子昊。谁知女二林有有杀害子昊父母并嫁祸白若寒把她推下深海。白若寒幸得闺蜜陆青所救，醒后得知自己怀孕，决定生下孩子并查清凶手。然而苏子昊突患脑癌，白若寒为了救苏子昊不惜以身试药，却因为林有有加害，苏子昊命悬一线。白若寒只好发动骨血祭天，用孩子的命救回苏子昊的命。随后两人查清林有有真实面目，逐渐找回对彼此的爱，在二人的齐心协力下，将林有有绳之以法。然而，就在两人觉得一切圆满结局时，白若寒被最终反派洛晨风的绑架汲取灵力，苏子昊来救却将将丧命，白若寒只好发动自己最后的灵力去救苏子昊，从而灰飞烟灭。最终在白若寒消散时，千年闺蜜陆青不忍，用自己千年修为成全二人姻缘。\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478286,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1HnKgTGyZ-nlabJHar-u0Qg?pwd=jrx9\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"荒岛夺命之龙卷风\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"荒岛夺命之龙卷风\",\"description\":\"陈阳是一个公司的小职员，为了庆祝公司上市，公司老总带着公司员工坐飞机旅游团建，结果遇到了龙卷风，飞机出事，漂到了一个岛上，最后陈阳被老板顾天河与女朋友林瑶害死在了岛上，而陈阳重生到了飞机起飞之前。\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487206,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1uhEsXJhCkFCPP2tZiTLGbA?pwd=du2r\",\"online_time\":\"2024-06-08 00:00:00\",\"time\":1717776000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌娃助攻：笨蛋老爸快追妻！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌娃助攻：笨蛋老爸快追妻！\",\"description\":\"叶天是九星战神夜冥王，下任尊主继承人，维稳边疆后带着战友遗孤在山上隐居六年，六年后老尊主找到叶天，让他准备继任尊主之位，并请叶天保护自己一位老友的女儿。叶天下山，在沈若晴身边做贴身保镖，叶天的儿子（战友遗孤）也跟随着叶天一起在山下闯荡，帮助沈若晴和其朋友教训猥琐男和色狼，并帮沈若晴拿下代理权，沈若晴和朋友在不自觉间爱上叶天。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479956,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1hnqwX37CdJOIdGd5SdkRfw?pwd=7yum\",\"online_time\":\"2023-11-15 00:00:00\",\"time\":1699977600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌宝一加一：抢个总裁当爹地！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌宝一加一：抢个总裁当爹地！\",\"description\":\"顾雨彤为救病危的母亲，被继妹顾倩和继母王翠拉去陪酒，与被陷害的凌爵一夜情，带球跑后，孩子有一天拉着自己参加婚礼，孩子却在婚礼上喊新郎爸爸。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478296,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1IY5YT7fTsvSasIN5BzGsqg?pwd=p58u\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌宝上门，财阀爹地惊呆了！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌宝上门，财阀爹地惊呆了！\",\"description\":\"集团千金林初然因为受到妹妹的陷害和傅时宴误睡身败名裂，被爸爸赶出家门后又被妹妹和继母追杀坠崖。五年后林初然带娃霸气归来准备复仇，却意外和傅时宴相认结婚，渐渐二人先婚后爱。在傅时宴的帮助下，林初然一路打脸开挂，最后惩治了妹妹和继母走上人生巅峰。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479976,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1dS7oZkH61GGpe5Ts8HZI1A?pwd=ticc\",\"online_time\":\"2023-11-15 00:00:00\",\"time\":1699977600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌宝助力：爹地，妈咪超甜的！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌宝助力：爹地，妈咪超甜的！\",\"description\":\"林初然因为担心闺蜜叶雪莹，去酒店寻找，谁料遇上中药的傅时宴，与傅时宴发生了一夜情，事情结束后林初然发现自己怀孕并生下了孩子，叶雪莹设计抢走了林初然的孩子并杀死林初然。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480226,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1dcLvd2qJiMJKCmRJpUrNrQ?pwd=tmm2\",\"online_time\":\"2023-11-21 00:00:00\",\"time\":1700496000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌宝小机灵，叶总求抱抱！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌宝小机灵，叶总求抱抱！\",\"description\":\"女主原本是豪门世家之一江家的掌上明珠，因联姻嫁给男主，由于家族没落，女主成为了人人嫌弃的丧门星，又遭觊觎男主的千金暗算。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478396,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1AaqEFsIq-E_GlzE1pr4Rug?pwd=ycue\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌宝归来妈咪华丽蜕变\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌宝归来妈咪华丽蜕变\",\"description\":\"唐优璇一家被大伯陷害，最终公司易主，家破人亡。怀有身孕的唐优璇误以为爱人顾墨宸设计打掉孩子，死里逃生后生下一对龙凤胎，不料女儿夭折。 伤心欲绝的唐优璇带着儿子远赴异国，五年后强势回归，却再次与顾墨宸纠缠在一起，并得知女儿还活在世上。千帆过尽，真相大白，唐优璇与顾墨宸之间的误会解开，一家四口开始幸福生活。\",\"second_cate\":\"女频萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483846,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1uKlMC7iTdwvuRpxkG9vu2w?pwd=4fxb\",\"online_time\":\"2024-03-27 00:00:00\",\"time\":1711468800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌宝找上门妈咪请签收\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌宝找上门妈咪请签收\",\"description\":\"宋思青曾经的一夜情，意外诞下一女，但因母亲重病，父亲离婚又娶，被视为耻辱，将孩子与宋思青分离，没想到被丢掉的孩子恰好被亲生父亲顾辰时收养，七年后却意外再次相遇……\",\"second_cate\":\"女频萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481646,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1o3LusmhWWDVvdaulHzTE6w?pwd=tjvy\",\"online_time\":\"2024-01-16 00:00:00\",\"time\":1705334400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌宝来袭我替妈妈改嫁总裁大佬\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌宝来袭我替妈妈改嫁总裁大佬\",\"description\":\"女主被男配和婆婆毒害，儿子流落在外冻死在街头，儿子重生后利用前世的信息差，帮助女主躲过渣男的暗害，并建立了自己的事业，和男主联手打脸和复仇男配一家。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487886,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/13c8fyjV3q6dI8yh0uF0dUA?pwd=f7tm\",\"online_time\":\"2024-06-20 00:00:00\",\"time\":1718812800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌宝来袭，总裁妈咪太难追\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌宝来袭，总裁妈咪太难追\",\"description\":\"五年前，女总裁顾婉和小歌手林安相恋并有了女儿，可一场意外车祸后，顾婉失去了记忆，林安误以为顾婉抛弃了自己和女儿，带着女儿离开。五年后，一场阴差阳错让顾婉和林安再次相遇，已是顶流巨星的林安认出了顾婉，不想再和顾婉有接触，在萌娃的助力下，顾婉和林安展开了一场场啼笑皆非的爱恨纠缠，并逐渐解开顾婉失忆的真相。最终，林安放下心结、顾婉也重新爱上林安，一家三口过上幸福生活。\",\"second_cate\":\"女频现代甜虐\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482356,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1RHvBzYm2aPPG9bsb_l3l8Q?pwd=r7ac\",\"online_time\":\"2024-02-11 00:00:00\",\"time\":1707580800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌宝来袭，爹地追妻我助攻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌宝来袭，爹地追妻我助攻\",\"description\":\"林俞心为救父亲，被迫答应恶毒继母漳泽秀去陪富商，阴差阳错和齐景焕一夜情，半夜为了救父亲离开。齐景焕醒来全城搜寻，查监控，找到林俞心，林俞心已经怀孕，在齐老爷子力推下两人成婚。得知林俞心嫁入豪门还怀孕，漳泽秀母女嫉妒不已，认为是林俞心抢了齐景焕，于是林芊柔伪装怀孕，进行长达八个月的密谋。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484216,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1rDHNtkDOrZ82eHjrq5yrkA?pwd=yy83\",\"online_time\":\"2024-04-08 00:00:00\",\"time\":1712505600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌宝来袭：特工妈咪不好惹\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌宝来袭：特工妈咪不好惹\",\"description\":\"原本是组织高级女特工的方（F），在一次任务中被队友枪杀，阴差阳错重生到了懦弱无能的鹿家大小姐鹿暖的身上。为了避风头留下孩子离开，五年后事情平息，回国准备将孩子带回自己身边，并最终和傲娇总裁厉泊言排除艰险走到了一起。\",\"second_cate\":\"女频萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478796,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1D6jP_CLX-X8tI9psuNh3ng?pwd=ar87\",\"online_time\":\"2023-09-27 00:00:00\",\"time\":1695744000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌宝神助攻妈咪别想逃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌宝神助攻妈咪别想逃\",\"description\":\"6岁萌娃陆景皓误会爸爸陆庭枫讨厌妈妈孟雨，但一心想认回自己的亲生妈妈。找回妈妈孟雨后，想要爸妈日久生情，破镜重圆，所以百般撮合。但又怕两人知道对方身份再生嫌隙，所以帮忙隐瞒双方身份。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487196,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1opyN6-6fE6L3-iXOJlaZ8Q?pwd=svd1\",\"online_time\":\"2024-06-08 00:00:00\",\"time\":1717776000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌宝神助攻爹地哪里逃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌宝神助攻爹地哪里逃\",\"description\":\"一场意外的竹林邂逅，令乔婉宁怀孕并诞下龙凤四宝。情敌母亲为了阻止乔婉宁跟夜景川在一起，洗掉了乔婉宁的记忆，并将四宝丢弃到天南地北。八年后，失忆后的乔婉宁和夜景川意外相遇，步入结婚殿堂，不料情敌沈汐汐的出现，令乔婉宁背上了骗婚的罪名，被夜景川罚去扫大街……而当年被丢弃的四个萌宝，已然成长为四个超级大佬，他们的出现，会不会令爹地妈咪的感情峰回路转，走向幸福甜蜜呢？\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481986,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1eSZYp5-7Jy5SgGK2YK43kw?pwd=f3ye\",\"online_time\":\"2024-01-31 00:00:00\",\"time\":1706630400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"萌宝神助攻：妈咪，爹地非你不可\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"萌宝神助攻：妈咪，爹地非你不可\",\"description\":\"苏家大小姐苏安乔为救父亲被迫与相恋的男友五年的男友慕凌深分手，但是嫁给顾家少爷后却被折磨的毫无生气。一次同学会，苏安乔偶遇了归国的慕凌深，这次同学会，成为了一场阴谋被揭开的序幕……\",\"second_cate\":\"女频萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479416,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1a29Y_neKtWIwEhhx5t24Jg?pwd=s48j\",\"online_time\":\"2023-10-21 00:00:00\",\"time\":1697817600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"落难千金复仇记\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"落难千金复仇记\",\"description\":\"苏家千金苏南，本性善良天真，却被出轨的丈夫和妹妹设下杀局，谋求巨额保险。幸而苏南遇到叶宁安拯救，并在叶宁安帮助下，化身万斯集团千金，荣耀归来。她誓以霹雳手段复仇，把失去的一切夺回来。\",\"second_cate\":\"都市女频复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478026,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1QO91gBWQ5Rps5gsTSWG30A?pwd=uzbc\",\"online_time\":\"2023-08-27 00:00:00\",\"time\":1693065600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"蓄意引诱禁欲老公又野又撩\\u0026婚约老公他明宠暗撩\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"蓄意引诱禁欲老公又野又撩\\u0026婚约老公他明宠暗撩\",\"description\":\"姜栀被前男友江祁年背叛后，又遭遇舅舅公司破产危机，为救舅舅公司，姜栀答应履行婚约嫁给商池，并未奢求婚约能长久，但商池屡次维护自己，姜栀逐渐对商池心动，俩人终于历经万难走在了一起。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486966,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1bcIqBNf1-98JSQbhLTobkw?pwd=frgf\",\"online_time\":\"2024-06-06 00:00:00\",\"time\":1717603200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"蓄谋已久乖兮兮奶狗疯缠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"蓄谋已久乖兮兮奶狗疯缠\",\"description\":\"别跟姐姐撒野！霸总得知当年的真相，与小奶狗开启甜甜的恋爱生活…...\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481426,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1YTrxMeD1b2BKluMbyGpIFQ?pwd=m5i5\",\"online_time\":\"2024-01-05 00:00:00\",\"time\":1704384000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"藏龙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"藏龙\",\"description\":\"为替师父报仇，项麟独闯夜皇殿，斩杀十大护法，击杀夜皇。一直寻觅的家人终于找到，却得到全家已被灭门，而未婚妻被废了心智关在狗笼中！老者惶恐：“殿主，你还未上封神台祭祀上天呢”。项麟大怒：“祭祀？我现在只想杀人！”\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481526,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/15VZHnieTecxXTfsu5bsSow?pwd=3cxk\",\"online_time\":\"2024-01-11 00:00:00\",\"time\":1704902400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"虐完我，季总悔不当初\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"虐完我，季总悔不当初\",\"description\":\"总裁三代单传，没想到她一胎三宝，老爷子放话：给我往死里宠！\",\"second_cate\":\"女频总裁萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478536,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1pj6DeVZHB3ikSkziSyUv2Q?pwd=a63t\",\"online_time\":\"2023-09-15 00:00:00\",\"time\":1694707200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"虐文女主觉醒了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"虐文女主觉醒了\",\"description\":\"宋琪惨遭众叛亲离却意外预知自己虐文女主的命运，为打破剧情与“修车工”季宁渊先婚后爱。“凤凰男”前任按照原剧情纠缠，林佳佳嫉妒宋琪多年企图占据她的身份。宋琪守住真心，与爱人携手打破强制人生。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485526,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1NPqE84rL5PlQz91Rfz-NgQ?pwd=by6m\",\"online_time\":\"2024-05-20 00:00:00\",\"time\":1716134400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"蜀山\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"蜀山\",\"description\":\"美女总裁捡了个小乞丐回家，没想到对方竟然是自己千年前的师尊。轮回转世过后，再续千年之约。小乞丐一路横推，所向披靡，重归巅峰王座。\",\"second_cate\":\"男频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485196,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/127qySNQLtvvZlyAYeLbagw?pwd=7p41\",\"online_time\":\"2024-05-12 00:00:00\",\"time\":1715443200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"蟒雀吞龙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"蟒雀吞龙\",\"description\":\"为中夏镇守国门五百年，为中夏打造出神明禁行之禁地的无上道君宁殊。在距自己飞升在即之时，为了报答当年表姑的救命之恩，以及为了寻找炼制飞升丹的药材，选择独自下山。下山途中，结识了中夏第一才女魏云婉。在一次次事件中，魏云婉对其芳心暗许，但随着药材逐渐收集完毕，宁殊即将飞升成仙。俩人的关系又该何去何从。\",\"second_cate\":\"男频玄幻\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483006,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1XwPEh9nCT2jkgx8R_1lGNA?pwd=zdt8\",\"online_time\":\"2024-03-06 00:00:00\",\"time\":1709654400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"被开除后我成了冒牌神尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"被开除后我成了冒牌神尊\",\"description\":\"神尊失踪，天下恐将大乱。叶青山因和失踪的神尊长相一样被神尊下属请为代理，并授予神尊的功法。叶青山得罪的上司因收到神尊假冒的消息，前来挑衅叶青山，无奈被神尊下属所威慑，跪地求饶。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488376,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1qAnBMIM1I4mMxAniZgVlPw?pwd=8263\",\"online_time\":\"2024-06-27 00:00:00\",\"time\":1719417600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"被虐离婚后，傅总跪求回头\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"被虐离婚后，傅总跪求回头\",\"description\":\"沈言嫁给傅星寒三年，身心俱疲，换来的，只是一纸离婚协议及无穷的羞辱与不信任，为什么，她明明把所有的事实都摆在面前，那个男人，却始终不相信她.....\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478146,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/17stendtpEqFVxfeKQIm-7w?pwd=jbub复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-09-04 00:00:00\",\"time\":1693756800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"被谢医生拒绝加好友99次\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"被谢医生拒绝加好友99次\",\"description\":\"宋之意因为过敏去医院看病对谢庭言一见钟情，她鼓起勇气要了谢庭言的三次微信，都被无情拒绝！毫不气馁的宋之意制定了撩谢庭言计划。\",\"second_cate\":\"女频/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488366,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1Lp4YRRgxFeDQHrKwWA3bxg?pwd=eicw\",\"online_time\":\"2024-06-27 00:00:00\",\"time\":1719417600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"被退婚后，我求婚了总裁大叔！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"被退婚后，我求婚了总裁大叔！\",\"description\":\"谢成宴和盛初雪各自订婚当天，谢成宴被订婚对象嫌弃年纪大，而盛初雪被嫌弃不懂风情，被各自的订婚对象携手背叛了。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479096,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1YCTG1MIvSKOJdhIs2XEoWw?pwd=uv4j\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"誓死擒凶\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"誓死擒凶\",\"description\":\"林涛的兄弟意外身亡，他发誓找到出凶手报仇，但他面临家庭、友情、事业的危机接踵而来，当他拨开迷雾接近真凶时，真凶悄然布下大网、伸出嗜血的獠牙。\",\"second_cate\":\"男频犯罪、都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485476,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1SUEHU7JFCIrL-sbdKWatEA?pwd=ny7s\",\"online_time\":\"2024-05-20 00:00:00\",\"time\":1716134400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"许你余生暖又甜\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"许你余生暖又甜\",\"description\":\"沈晚晚直到临死之前，才知道那个男人，至死都在保护她。再来一次，换她来保护他，她要挡在他的面前，替他解决掉那些吸他血的奇葩亲戚，那些暗中谋害他的黑手！\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480666,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1wnVDDYAxt8ASEnqrPdJ5yw?pwd=a1yj\",\"online_time\":\"2023-12-12 00:00:00\",\"time\":1702310400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"许你情深深似海\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"许你情深深似海\",\"description\":\"乔言隐婚三年，成了顾烨霆见不得光的妻子。三年来她捧着一颗真心却受尽冷待，一切的一切让乔言幡然醒悟，她毅然决定离婚，可前夫却像疯了一样，日日纠缠着她，用尽手段求她复合。乔言已对这段感情失望透顶，可接踵而来的谜团却直指当年父母车祸死亡的真相，原来在她所不知道的暗流涌动中，顾烨霆也还拥有着别的秘密。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481386,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1uOn1PTe8-tRp3l829ZlHzw?pwd=73g7\",\"online_time\":\"2024-01-03 00:00:00\",\"time\":1704211200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"许我一世情深\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"许我一世情深\",\"description\":\"林乐悠奄奄一息，男友与死神签订契约，换回一命，条件是会忘了她。再次爱上林乐悠，就是男友的死期。五年后，林乐悠带着两个孩子出现在楚家家宴上，就在男友恢复记忆的那一刻，小三拔刀刺向林乐悠......\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485286,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1hRjUv4CxGY4DI4YbGUb1fg?pwd=bpit\",\"online_time\":\"2024-05-16 00:00:00\",\"time\":1715788800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"误入房间后，被顶头上司宠入怀\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"误入房间后，被顶头上司宠入怀\",\"description\":\"司部门聚餐，纪抒含喝多迷糊进了总裁房间，于是两个人便相遇了。因为害怕霍泽骁误会报复，睡完偷溜，没注意到帮闺蜜宋小念打印的简历落在霍泽骁房间，霍泽骁因此认错人。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479906,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1wqmm07zUXCktfLZBJvjhNA?pwd=xziy\",\"online_time\":\"2023-11-14 00:00:00\",\"time\":1699891200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"误诊后季小姐她见人就发疯\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"误诊后季小姐她见人就发疯\",\"description\":\"全职妈妈季苏楠，为了家庭全身心的付出，却遭遇婆婆的嫌弃，儿子的不尊重，丈夫更是红颜知己在旁。逆来顺受的她，在确诊癌症后，再也不堪忍受全家对她的轻视和侮辱，决定在生命的最后，为自己活一次，破罐破摔的季苏楠，性情大变，放飞自我，手撕恶婆婆，怒揭绿茶小三的面具，更是让丈夫清清楚楚看到自己的渣，却不想意图败家意外成为投资高手，癌症是误诊，丈夫陆宴臣更是对她呵护有加，季苏楠在找回自己尊严的同时，亦找回和丈夫消失的爱！\",\"second_cate\":\"女频女强\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483146,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1h2Gck_dN3d_fVH5sDZPX4Q?pwd=hszu\",\"online_time\":\"2024-03-09 00:00:00\",\"time\":1709913600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"诱他沦陷\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"诱他沦陷\",\"description\":\"姜烟不是好人，为了报仇，她蛰伏在薄公馆，用尽手段心机，拿薄老爷作复仇第一刀。\\n薄矜留洋归来，识出姜烟人畜无害面具下那张沁着毒的狡诈面孔。\\n薄老爷葬礼，薄矜作为儿子出席。\\n两人擦身而过时。\\n薄矜那一声‘姨娘’带着玩味，对她来讲，是试探。\\n姜烟低头敛目，轻柔唤他一声‘少爷’，做足了伪装。\\n自此，薄矜放她在心上好多年\",\"second_cate\":\"女频民国\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720477836,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Uymn2yTA8nPIxBfzcI857g?pwd=vvbq复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-15 00:00:00\",\"time\":1692028800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"请别弄丢我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"请别弄丢我\",\"description\":\"三年前，海陆集团总裁陆景辰前往白云镇处理拆迁项目，途中遭仇家报复被扔进海里，后被路过的陈念所救。在相处中两人逐渐产生爱意，谁知陆景辰却在去拍婚纱照这天，发生了车祸被原未婚妻找到。\",\"second_cate\":\"女频/霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488056,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"链接：https://pan.baidu.com/s/1LVF64lvVKh3cp4O1Kl1XFA?pwd=gft7\\n提取码：gft7\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"2024-06-22 00:00:00\",\"time\":1718985600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"请和我闺蜜结婚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"请和我闺蜜结婚\",\"description\":\"沈墨嫁给周宇文后遭到丈夫和婆婆百般苛责，更被送到精神病院。逃回家后，沈墨撞见丈夫与闺蜜出轨现场被二人灭口。再次醒来，沈墨发现回到5年前，决定改变自己生活，认识了顾景曜，而他心里藏着与沈墨有关的秘密。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485656,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1eV87-x2nWF0YH3rIm4JTFA?pwd=u3ut\",\"online_time\":\"2024-05-23 00:00:00\",\"time\":1716393600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"读心游戏\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"读心游戏\",\"description\":\"向燃，生命将止步于30岁。心灰意冷之下，他接受了一桩“包办”婚姻。新娘正是大学时代深爱过的女生宁婉。当年携手出国的约定，究竟是谁没来赴约？婚姻里，他们言不由衷，互相伤害。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484746,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1NKJ-6kWsi4fOdn64_iliHg?pwd=fyt7\",\"online_time\":\"2024-04-26 00:00:00\",\"time\":1714060800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"读心萌宝竟是大佬\\u0026读心萌宝是大佬\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"读心萌宝竟是大佬\\u0026读心萌宝是大佬\",\"description\":\"神女为了天下苍生，献祭自己后附身于侯府小姐季瑶身上，面对一次次危机，季瑶展现出超凡的智慧与勇气，引领家族走向复兴，故事以亲情、权力斗争为背景，生动描绘了季瑶从天真小女孩成长为家族守护者的成长历程。\",\"second_cate\":\"女频/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488156,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1svCunzmXtlUH9mJxrfXqIw?pwd=96x5\",\"online_time\":\"2024-06-23 00:00:00\",\"time\":1719072000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"谁懂啊，霍总是个恋爱脑\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"谁懂啊，霍总是个恋爱脑\",\"description\":\"相亲撞见公司老板，她转头就跑，谁料老板一把抱起她：“乖，叫老公！”\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481676,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1q7x_lOmcotE9ZHqy-pOJyg?pwd=binh\",\"online_time\":\"2024-01-18 00:00:00\",\"time\":1705507200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"谎言与甜蜜\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"谎言与甜蜜\",\"description\":\"方宛如沉寂在和睦的家庭、丈夫的宠爱、可爱的儿子的幸福生活中。然而完美生活背后，却充斥着丈夫李世豪的谎言，丈夫的出轨被发现，看似坚固的幸福开始逐渐出现裂痕，原本完美的生活也随之开始动摇。\\n故事开篇讲述方宛如偶然间发现自己丈夫李世豪出轨，幻想杀死李世豪，但是最终方宛如还是努力克制自己，火速提出离婚，李世豪净身出户。李世豪为了拿回在方宛如家里藏的私房钱，以孩子为筹码回到家中，此举却让方宛如看清李世豪的真面目，外面不仅仅有一个女人，其中还包括自己的闺蜜，并且李世豪离婚前已经转移了公司的大部分财产......\",\"second_cate\":\"女频家庭、甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480396,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1CXYFJwutS8AoFOzc00Qoog?pwd=q1e5\",\"online_time\":\"2023-11-27 00:00:00\",\"time\":1701014400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"谎颜\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"谎颜\",\"description\":\"五年前，韩江雪被未婚夫陷害入狱，受狱霸欺凌，得知其谋害父母，决心复仇。五年后，她化名凌霄，成为小提琴教师，接近前夫，并联合狱中伙伴，计划向渣男展开复仇。\",\"second_cate\":\"女频复仇/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487476,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1n8VmnNB1m7WJ0dNP8dbT_w?pwd=mqbq\",\"online_time\":\"2024-06-13 00:00:00\",\"time\":1718208000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"谢你赠我三千风霜\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"谢你赠我三千风霜\",\"description\":\"隐婚多年的乔言，又一次因为顾夜霆的白月光被冷漠的丢下，她肚子里的孩子也因此流产，这一次，她决定不再忍耐……\",\"second_cate\":\"女频情感、虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480006,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ogOjrIeNlYc4lpMF0bTf5g?pwd=uvan\",\"online_time\":\"2023-11-16 00:00:00\",\"time\":1700064000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"谢秘书和她的三位上司\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"谢秘书和她的三位上司\",\"description\":\"谢听晚本是富家千金，却没想到谢家一夜破产，男友顾时宴也在这个时候突然联系不上了，她不得不中断学业回国。三年后，谢听晚成为了顾家三少爷顾明弋最器重的助理，也意外发现前男友竟是老板的二哥。谢听晚被迫卷入顾家三兄弟争夺家产的大战中，而她也因为跟母亲酷似的长相，被顾父当成了弥补遗憾的工具，她在三人间游走盘桓，调查当年真相，可当一切浮出水面，她却不知该作何抉择……\",\"second_cate\":\"女频都市情感\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483756,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1IQRdPxefCzlDGYwZd6JIWg?pwd=eu2r\",\"online_time\":\"2024-03-25 00:00:00\",\"time\":1711296000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"豪门\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"豪门\",\"description\":\"叶问天用秘术封印了八大隐世豪门继承人的记忆。叶辰的父母由于不遵守豪门祖训，被叶辰爷爷派人杀死。为了向爷爷报仇，叶辰带领七个刚认识的朋友，默默发育，终于在五年前来到了大夏顶点。\",\"second_cate\":\"男频逆袭/打脸\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485446,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1K2_cavhC90PcDruhnIxQWA?pwd=xmnn\",\"online_time\":\"2024-05-19 00:00:00\",\"time\":1716048000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"豪门千金归来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"豪门千金归来\",\"description\":\"乔沐柔救下被追杀的顾弘琛后回到孤儿院发现自己是乔家失散多年的千金。朋友得知此事，和乔沐柔同乘一辆车回城。路上不小心发生车祸，管家身亡，朋友打晕乔沐柔，将乔沐柔的坠子抢走冒充她身份回到乔家。乔沐柔被路过的顾弘琛救下。朋友的一系列举动让姑姑对她的身份产生怀疑，乔沐柔失忆，顾弘琛谎称乔沐柔是他未婚妻留在身边，朋友在宴会上重新遇见乔沐柔，之后便想方设法想要除掉乔沐柔，乔沐柔在顾弘琛的帮助下重新夺回身份。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480216,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1jW215aTUbZSp3MpFNYRgjw?pwd=6987\",\"online_time\":\"2023-11-21 00:00:00\",\"time\":1700496000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"豪门相亲假千金她装不下去了\\n（爆款老剧）\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"豪门相亲假千金她装不下去了\\n（爆款老剧）\",\"description\":\"顾熙15岁时在苏家给大小姐苏玉当贴身丫鬟，隐忍最终夺回属于自己的人生。陆家私生子陆景晟虽享尽荣华富贵但身份低微被父亲当联姻工具。在父亲家族面前有手段和城府但在女主面前温柔有礼，布局只为和顾熙在一起。\",\"second_cate\":\"女频霸总、都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488666,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1TOubk3Q4_R64dNgzTSFwTQ?pwd=anyb\",\"online_time\":\"2024-07-01 00:00:00\",\"time\":1719763200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"豪门萌娃惹不得\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"豪门萌娃惹不得\",\"description\":\"陆晨轩和宁潇潇很恩爱，家庭有钱和睦美满，学校要求填写家庭调查表，陆晨轩从小教育孩子要低调。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479106,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1gSMGkYiSLFzecu_LXNolCg?pwd=25h9\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"豪门顶级大小姐\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"豪门顶级大小姐\",\"description\":\"女主顾凌依本是富家千金，却因为父亲不和母亲去世，在医院被抱错，女主跟着婆婆捡到后生活在乡下，女主成年后被奶奶找到接回家中。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478466,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1SDElS26bY07jIdIseri-Ag?pwd=qxcb\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"财阀继承人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"财阀继承人\",\"description\":\"王氏财团的小少爷王峰，人生目标是当纨绔，奈何被亲哥陷害贪污集团20亿公款，还差点被灭口。一朝反杀，王峰成为王平，替身归来，誓要夺回一切，成为财阀继承人。\",\"second_cate\":\"男频复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485626,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1A-LfLMLZmhNBWFw26wkI_w?pwd=xbnm\",\"online_time\":\"2024-05-23 00:00:00\",\"time\":1716393600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"贪婪家族之传世珍宝\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"贪婪家族之传世珍宝\",\"description\":\"父亲脑梗去世。两儿子因财产分配离心，两儿子又得知有古董玉镯，争抢中玉镯不幸掉落在地碎成几瓣。邻居凑钱完成了父亲的遗愿，将他生前的诗集出版成册。破碎的老玉镯也被修复了，完好地放在书架上。\",\"second_cate\":\"通用家庭伦理\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485306,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1ViJyXAN33d63SN6Tq5uHuQ?pwd=61s8\",\"online_time\":\"2024-05-16 00:00:00\",\"time\":1715788800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"贪欢\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"贪欢\",\"description\":\"余笙是个资深摄影师，因为家里破产，父亲自杀，导致严重的心理创伤，摄影作品没有性张力，外界传闻江郎才尽。为了解决问题，余笙尝试着接触异性，偶遇了一个大胆的模特新人秦浩东，不小心落入秦浩东的追爱“陷阱”，在秦浩东粘着她的时候起了怜悯和恻隐之心。两人在工作和生活中不断产生剪不断的牵连。最终走到一起。\",\"second_cate\":\"女频甜宠/职场/姐弟恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480916,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1sWtRPNkNiiIO5rAmFkdghA?pwd=4ccu\",\"online_time\":\"2023-12-19 00:00:00\",\"time\":1702915200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"贵妃娘娘的职场指南\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"贵妃娘娘的职场指南\",\"description\":\"慕容乐意外穿越到现代，因为花边新闻与未婚夫退婚。受伤的夏浅浅一直暂住谢景琛家中，在两个人的相处中感情逐渐升温。夏浅浅告诉谢景琛，自己并非夏浅浅，而是慕容乐，一个被皇上抄家的贵妃。两人又将何去何从呢？\",\"second_cate\":\"女频穿越重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484286,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1YwYL9nLDknCIGsEWMpDHcQ?pwd=76gs\",\"online_time\":\"2024-04-10 00:00:00\",\"time\":1712678400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"赖上美女总裁\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"赖上美女总裁\",\"description\":\"美女总裁救了个修车工，没想到对方竟然千亿集团的继承人。十年过后，功成名就的修车工回来赖上美女总裁，一路横推，带着老婆冲上世界之巅。\",\"second_cate\":\"男频逆袭/爽剧\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486216,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1d9Sm-faMvUzjk5FSRnogrQ?pwd=y1ng\",\"online_time\":\"2024-05-31 00:00:00\",\"time\":1717084800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"赘婿之天眼觉醒\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"赘婿之天眼觉醒\",\"description\":\"男主洛身患胰腺癌晚期，妻子张燕不救反而逼迫其签保险合同被气到病重昏迷，昏迷后进入佩戴玉佩空间里，意外获得医术传承并且与其有婚约的千金大小姐韩霜雪再续情缘。\",\"second_cate\":\"男频超能力/鉴宝\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720488386,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1yE5p6iwt0okiNN-eBEYdhg?pwd=j772\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"超时空同居之白月光上位手册\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"超时空同居之白月光上位手册\",\"description\":\"女主通过一扇门完成物理穿越，在2003年和2023年来回穿越，利用时间差完成自身的逆袭，同时在年轻版和中年版的男主身上纠结，“三角恋”虐恋纠葛。\",\"second_cate\":\"女频穿越、虐恋、逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483726,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1hafm4KEJU2T2XjecubNX4g?pwd=st95\",\"online_time\":\"2024-03-24 00:00:00\",\"time\":1711209600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"超级打工皇帝\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"超级打工皇帝\",\"description\":\"螺丝厂员工林飞兢兢业业十年，却屡遭上司赵腾打压，更因为发现赵腾倒卖工厂器械而面临开除的命运，林飞忍无可忍，决心反抗。在厂长的帮助下，一步步化解赵腾的明枪暗箭，并在此过程中结识了唐金燕、柳雨菲、温晓曼等志同道合的朋友，一起找到了赵腾及其帮凶的罪证，将其绳之以法。\",\"second_cate\":\"男频逆袭、都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481206,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1Fa8odNYlh2Bmax5B2Nohog?pwd=eyph\",\"online_time\":\"2023-12-28 00:00:00\",\"time\":1703692800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"超级神豪归来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"超级神豪归来\",\"description\":\"故事围绕着神秘男主林风展开，他是全球千亿身家黑客之子，却在30年生活中一直被隐藏身份，过着屈辱的生活。当意外得知自己身世后，开始走上人生巅峰。他不仅要面对背叛他的前妻苏梦婷，还要应对情敌张明的讥讽和周围市侩小人的嘲笑。与此同时，林风还与苏梦婷、李雨晴等女性角色产生了深厚的感情纠葛。他们的命运交织在一起，共同经历了爱情、亲情的考验。最终，林风凭借智慧和勇气，在惊心动魄的商战中成功击败了张明，携佳人共度辉煌。\",\"second_cate\":\"男频神豪\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480076,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1bFdm_w_3mD1uE2qTBLtLDw?pwd=j2e7\",\"online_time\":\"2023-11-17 00:00:00\",\"time\":1700150400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"超级车手\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"超级车手\",\"description\":\"楚阳是一名赛车手，为了凑女儿的医药费参加比赛，被威胁跑假赛，楚阳拒绝后被恶少赵凯报复，绑架了楚阳母亲和女儿。楚阳无奈之下拨通前妻电话，一举剿灭反派一伙，最终二人破镜重圆。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486426,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1OKl45tGgQYcTcAFHLMx-YA?pwd=v8hm\",\"online_time\":\"2024-05-07 00:00:00\",\"time\":1715011200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"踹了渣男后，我嫁入了豪门\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"踹了渣男后，我嫁入了豪门\",\"description\":\"做了五年的家庭主妇。苏如暖才明白，她是丈夫请来的免费工具。果断离婚后，她和千亿富豪达成协议。你帮我复仇，我暂代你未婚妻一职。富豪笑话她，“苏如暖，你真是够蠢的，给人做牛做马，最后发现连孩子都不是自己的！”苏如暖，“秦总也好不到哪里去，大把年纪了，还要租我这个蠢人向家里交差，行情太差！”傲娇千亿富豪\\u0026二婚小娇妻。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480036,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1u1tgZAmbFywclyj0klacjQ?pwd=41ya\",\"online_time\":\"2023-11-16 00:00:00\",\"time\":1700064000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"踹掉渣男后三个哥哥团宠我\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"踹掉渣男后三个哥哥团宠我\",\"description\":\"新婚前夕，宋南溪惨遭渣男背叛，身败名裂，一无所有！关键时刻，失散多年的三个大佬哥哥找来，她摇身一变成豪门大小姐，从此，开启团宠人生，虐渣不手软，走上人生巅峰。\",\"second_cate\":\"女频现言\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483596,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1H0UfzwAzzKvrL0FFmIhl5A?pwd=7isf\",\"online_time\":\"2024-03-22 00:00:00\",\"time\":1711036800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"踹掉渣男后我被三个大佬宠上天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"踹掉渣男后我被三个大佬宠上天\",\"description\":\"傅家大小姐傅语夏隐瞒身份，嫁给顾思远，三年来靠卖猪肉支持他创业。顾思远功成名就后却带着小三上门与她离婚。身为商业、医学界、娱乐圈顶流三个大佬哥哥来撑腰，助她手撕渣男，收获幸福。\",\"second_cate\":\"女频豪门、虐渣\",\"episode\":0,\"platform\":\"\",\"update_time\":1720489006,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1SXKM9zVVd_IwW1kGdrSyOw?pwd=nryp\",\"online_time\":\"2024-07-09 00:00:00\",\"time\":1720454400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"身份曝光前女友悔不当初\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"身份曝光前女友悔不当初\",\"description\":\"陈轩的公司遭受徐氏集团打压濒临破产，为解决公司危机，陈轩打算将自己以前借给兄弟王浩的钱要回来，却没想到王浩不仅翻脸不认人，还百般羞辱于他。幸好关键时刻福伯到来，告知不仅其父亲竟是京海首富、先前打压他公司的徐氏大小姐徐初晴还是她的未婚妻。而他，只要完成三个考验就可以继承千亿家产。于是他重新振作，完成父亲考验、打脸前女友，并且逐步揽权家族产业，成为京海第一富豪。\",\"second_cate\":\"男频都市、逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482256,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1zEhNEtdq3hUhvLoAHTqAmg?pwd=5fmv\",\"online_time\":\"2024-02-08 00:00:00\",\"time\":1707321600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"身体互换后清冷霸总他怀了我的崽\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"身体互换后清冷霸总他怀了我的崽\",\"description\":\"男女主两人互换灵魂之后两人约定保守秘密，相处之后两人互生情愫...\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484586,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/14aWMydFcZfX1T_18dQPW8w?pwd=wguj\",\"online_time\":\"2024-04-19 00:00:00\",\"time\":1713456000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"轩辕九鼎之众神黄昏\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"轩辕九鼎之众神黄昏\",\"description\":\"欧洲众神入侵华夏，黄帝为了保护蚩尤等人，血脉献祭，历经五千年后重生觉醒。\",\"second_cate\":\"男频斩神\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480506,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1RNzuL1MHXP0yiutuKqofcg?pwd=ibdj\",\"online_time\":\"2023-12-06 00:00:00\",\"time\":1701792000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"轩辕医圣\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"轩辕医圣\",\"description\":\"南临风变成轩辕医圣回归为冤死的爷爷洗脱罪名，回去找到前妻却被前妻侮辱，和前妻司晴儿一刀两断之后发现救命恩人另有他人，在路上偶然遇见孟千歌发现她就是救自己的人，于是隐姓埋名在她旁边作保镖，由此发生了一系列的事情。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481556,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/17BVufDmtAC3BckWh_ZT_Mw?pwd=gx5v\",\"online_time\":\"2024-01-12 00:00:00\",\"time\":1704988800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"迟来的母爱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"迟来的母爱\",\"description\":\"沈知意幼时在集市上和家人走丢，十八年后就在林家人即将认回她的时候被林思媛冒领身份，林家人更是纵容假千金林思媛对沈知意处处刁难和羞辱，好在傅明熙护着她，最终真相大白，林家人后悔不已，寻求沈知意原谅。\",\"second_cate\":\"女频苦情/亲情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487756,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1tBeswkYKd4_2wmcW8sQh9g?pwd=94tp\",\"online_time\":\"2024-06-18 00:00:00\",\"time\":1718640000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"追龙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"追龙\",\"description\":\"徐南归来，亲眼看到妹妹住狗窝，每天吃剩菜剩饭，他瞬间怒了。\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480546,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1oJoFGMLGDtFTtktSlJFZ8Q?pwd=x7ih\",\"online_time\":\"2023-12-06 00:00:00\",\"time\":1701792000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"退圈后，被双大佬宠翻了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"退圈后，被双大佬宠翻了\",\"description\":\"五年前，练习生韩萱被闺蜜所害，失去出道资格，阴差阳错跟总裁何旭宸发生一夜情，并生育一女。五年后，何旭宸收购天合集团，再遇天合集团员工韩萱，并没有认出她是当年的女人。但是在接触中产生感情。同时，韩萱驻唱的酒吧老板，叶家大少叶承泽也对韩萱有了情意。在两个大佬的宠爱帮助下，韩萱再次出道，惩治了当年害自己的闺蜜。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482716,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/16huOlikRdTH0YwZzmEkYmA?pwd=gtdb\",\"online_time\":\"2024-02-26 00:00:00\",\"time\":1708876800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"退婚后，我闪婚了财阀大佬\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"退婚后，我闪婚了财阀大佬\",\"description\":\"豪门弃女江若为反抗家族包办婚姻与路边乞丐结婚，没想到乞丐竟然是帝国总裁，且看小乞丐如何化身总裁替老婆撑腰的同时开展追妻路。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720478306,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1dZsCEnb_MG4Benqa1c33XQ?pwd=g6ef\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"逆世重修\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"逆世重修\",\"description\":\"凌毅上一世酗酒赌博，家暴妻女，是别人口中无恶不作的废物丈夫。直到女儿小小癌症离世，妻子齐诗韵绝望跳楼自杀后才幡然醒悟。凌毅自杀时误入仙界，苦修十万年逆转时空，回到了上一世妻女死亡之前的几日。这一世凌毅利用自己的能力横推江州，护妻救女，最终得偿所愿……\",\"second_cate\":\"男频高手下山\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482546,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1sAeXYDIGVrvGX90Uog3TTQ?pwd=6rsn\",\"online_time\":\"2024-02-18 00:00:00\",\"time\":1708185600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"逆天医神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"逆天医神\",\"description\":\"天门医皇陈天浩，隐身于徐家并帮助其崛起的过程中，与徐夏柳之间的情感纠葛以及与龙海药王等人的利益冲突，最终暴露陈天浩的身份，王者归来。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481906,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/159MkaeDGu9k__aS4lAEHdQ?pwd=2s6q\",\"online_time\":\"2024-01-29 00:00:00\",\"time\":1706457600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"逆天帝尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"逆天帝尊\",\"description\":\"现代小伙叶枫意外穿越到强者为尊的修行世界，却是不能修炼的废物，在新婚夜被家族少主和新婚妻子羞辱，被活活打死，却意外觉醒至强法宝混沌炼天炉，成为逆天之人。之后叶枫被圣地大教误认为天命之子，邂逅红颜，在红颜知己和至宝炼天炉的帮助下，一路逆袭，斩灭所有仇敌，踏足修行界巅峰。\",\"second_cate\":\"男频玄幻\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481136,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1m94-Le18lqjTbnLetj5jOw?pwd=q3vg\",\"online_time\":\"2023-12-25 00:00:00\",\"time\":1703433600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"逆天邪神归来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"逆天邪神归来\",\"description\":\"一次闭关，走火入魔，叶凡神魂被困神界百年，成为六界至尊后踏破虚空回到人界，人界肉身因为失魂痴傻五年，被锦盛集团总裁陆雪琪收养，在叶凡神魂回归之后，为报恩留在陆雪琪身边，意外发现龙戒，得知寻找十年的小女孩正是陆雪琪，两人修成正果。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720478176,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1dedgFC855JcKDjksKDJIRQ?pwd=e4cs复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-09-03 00:00:00\",\"time\":1693670400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"逆袭之我在校园当女王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"逆袭之我在校园当女王\",\"description\":\"关夕谣被肖雪儿和跟班们欺负，被哥哥救下并告知她首富家大小姐的身份。肖雪儿仗着自己是校董的女儿要开除夕谣，被夕谣哥哥制止教训。\",\"second_cate\":\"女频逆袭\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479046,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Rpp5g7d4BnCTINByhkGPHA?pwd=riar\",\"online_time\":\"2023-10-11 00:00:00\",\"time\":1696953600,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"逆袭千金\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"逆袭千金\",\"description\":\"顾熙原本是豪门千金，却家道中落，成为了豪门小姐苏玉的女佣，结果被苏玉当做挡箭牌去应付家族联姻，却被亿万贵公子陆景晟看中，进而发展出一段错位的感情。\",\"second_cate\":\"女频甜宠，逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483456,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1lFtDwoWBVcbPsezkt2U5-g?pwd=yuh3\",\"online_time\":\"2024-03-19 00:00:00\",\"time\":1710777600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"逆袭打工人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"逆袭打工人\",\"description\":\"大叔在地铁上被恶毒女周艳琳诬陷偷拍，男主江飞仗义替大叔说话，结果被周艳琳煽动众人暴打一通，奄奄一息，应差阳错却开启了玉佩内的医仙传承，并获得一双古医神眼，开启了一段逆袭人生！\",\"second_cate\":\"男频小人物逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480676,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1aSTvG8ige73LfsjTydqBwg?pwd=xhhg\",\"online_time\":\"2023-12-12 00:00:00\",\"time\":1702310400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"逆袭，老板娘夸我太给力\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"逆袭，老板娘夸我太给力\",\"description\":\"外卖员叶辰不过是送了一次外卖，却卷入到女总裁陈雪与其丈夫离婚的纠葛中，为了协助陈雪报复其老公，叶辰开启了一场神奇的花都逆袭之旅。\",\"second_cate\":\"男频都市逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478206,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ul5L1tEaNhnBXoolLcAJgA?pwd=hb7s\",\"online_time\":\"2023-09-07 00:00:00\",\"time\":1694016000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"逆鳞从离婚开始\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"逆鳞从离婚开始\",\"description\":\"修罗阁主上萧澈惨遭奸人暗害，被闽城第一美阮幼微所救。为报恩情，他隐藏身份和阮幼微结婚，并暗中给予阮氏集团全力帮助，直至阮氏集团问鼎闽城第一世家。谁知此时，阮幼微自恃身份，因看不起萧澈赘婿的身份要和他离婚……\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480796,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1DOMOoP9R-aUpEny7Ge1oWA?pwd=wnwi\",\"online_time\":\"2023-12-15 00:00:00\",\"time\":1702569600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"逍遥小食仙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"逍遥小食仙\",\"description\":\"孟尘本是食神后人，在绝味岛与小师妹终日相伴，乐得逍遥。因师父之命被迫出山赘入苏城唐家。途中救下云巅大酒店老板唐婉婉，成她家酒楼一名门童，一身高超厨艺助力唐家重振雄风，最终功成名就，直登人生巅峰。\",\"second_cate\":\"男频赘婿/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485906,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/19Ybqn0EJXokbD5MN5OwNyQ?pwd=6i29\",\"online_time\":\"2024-05-27 00:00:00\",\"time\":1716739200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"逍遥武仙医\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"逍遥武仙医\",\"description\":\"玄气派之主叶逍遥后代叶秋，受玄真派奸人孙龙陷害，连遭毁家之难、杀母之仇、诬陷之罪、夺妻之恨，终是以血脉觉醒正气诀传承，立志复仇。\",\"second_cate\":\"男频神医\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720478006,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Be54GX3M1CTk8q1XnZCk3Q?pwd=aaqm复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-24 00:00:00\",\"time\":1692806400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"透视神医喜当爹\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"透视神医喜当爹\",\"description\":\"李峰五年前惨遭小人陷害，一家上下殒命当场，无一幸免！唯有他，恰遇女神仙天降，与其进行合体双休，保全性命，之后随仙在深山中苦修五年，学成通世修为。归来都市后，在一次相亲中，遇到洛雪静以及自己的孩子。五年前究竟发生了什么？男主又将怎样查明陷害家人的真凶呢？\",\"second_cate\":\"男频神医\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478926,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"\\nhttps://pan.baidu.com/s/1qj-ixVuNNvXUBLmK_d31xg?pwd=h93p\",\"online_time\":\"2023-10-01 00:00:00\",\"time\":1696089600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"通天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"通天\",\"description\":\"夜枫从小被投入边军历练，即将立为夜北王。因为自己从军需要隐藏身份，所以夜枫一直装作无业游民，就在夜枫决定立苏雨冰为王妃的前一晚，苏雨冰却背叛了他。夜枫决定在王妃晚宴上收回苏雨冰的一切。\",\"second_cate\":\"男频/赘婿/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488146,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1StoB085DYYH9mOOIbHvKxw?pwd=5spj\",\"online_time\":\"2024-06-23 00:00:00\",\"time\":1719072000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"遇见你以后\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"遇见你以后\",\"description\":\"遭遇家族破产，父亲又突发心脏病病危入院，男友失踪亲戚漠视，最终林云溪只能以出卖尊严的方式换取父亲医疗费用，在大伯一家的陷害下，为了自保和傅斯尘定下合同婚约成为‘假夫妻’，在与傅斯尘相处过程中慢慢喜欢上他，而在傅斯尘想要对她真正表白那晚，林云溪提出了离婚，傅斯尘赌气答应，直到傅斯尘母亲与林云溪见面解开误会，傅斯尘又重新追回了林云溪。\",\"second_cate\":\"女频甜宠、霸总\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482406,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1Dt7G5uozUm_d4vVnsm-HVQ?pwd=6gti\",\"online_time\":\"2024-02-11 00:00:00\",\"time\":1707580800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"遇见你的微光\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"遇见你的微光\",\"description\":\"亲眼见到母亲身亡的许念因PTSD变成哑巴，父亲又将情人娶进家门并带来岁数相近的继女，自此父亲冷漠以对，继母江宛丽与其女许瑶欺辱刁难。然而许念为搞清母亲死亡真相只能伪装，实际却是善良有高智商的黑莲花。冷面霸总顾洺衍童年遭遇让他患有被害妄想症，怀疑父亲顾涛之死是许家和顾宏宇勾结的阴谋，想要利用许念查出真相，套路许念签订婚姻契约，却不知自己才是猎物。两人在感情路上从互套互演到假戏真做。\",\"second_cate\":\"女频都市、爱情、婚姻\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483606,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":5,\"material\":\"https://pan.baidu.com/s/1EZZe641HTTTaURwhmU0jYg?pwd=75ak\",\"online_time\":\"2024-03-22 00:00:00\",\"time\":1711036800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"遥远的诺言\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"遥远的诺言\",\"description\":\"十五年前，乔司辰被二丫救下，多年来一直在寻找对方。十五年后，乔司辰因为被人设计不得不娶了杀父仇人的哑巴女儿付星月，他把怨气撒在付星月身上，却不知，付星月就是自己一直在找的人。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487056,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1W9ARqy_ytxXhkA_bo-O-Ww?pwd=mg7d\",\"online_time\":\"2024-06-07 00:00:00\",\"time\":1717689600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"郡马无敌\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"郡马无敌\",\"description\":\"林风因查妻子出轨，被奸夫和妻子合谋杀害从而穿越到大宇王朝雨萱郡主的骏马之身，此时适逢雨萱郡主与天柔郡主争夺藩王继承权。为保天柔郡主上台，林风前身被杀害，李浩扬也欲趁机诱骗并占有雨萱郡主，林风苏醒力退李浩扬，深知自己陷入险境的他，决心以现代知识改写命运，带领县民从贫穷走向富裕……\",\"second_cate\":\"男频重生古装\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479516,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1_aOjQ7shA7ygc0bKw0uPMg?pwd=snx4\",\"online_time\":\"2023-10-28 00:00:00\",\"time\":1698422400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"都市之修仙归来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"都市之修仙归来\",\"description\":\"陈凡被京都武家逐出家门，后流落星城被干妈高玉兰救下。误入秘境习得修仙之法，成为长生殿殿主。为了了结姻缘、报恩高玉兰、复仇京都武家下山，通过自己的手段和手下龙国六大势力的协助，治好了高玉兰的双腿并为其成立龙国最大的医药集团玉兰医药、复仇了京都武家包括依附于京都武家的众人、并且和虞诗菲完成了这段命中注定的姻缘。\",\"second_cate\":\"男频都市修仙\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480106,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/198ufVEjNH9GM6O2Ky789Gw?pwd=tg8q\",\"online_time\":\"2023-11-18 00:00:00\",\"time\":1700236800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"都市奇门医圣\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"都市奇门医圣\",\"description\":\"医圣许青，为了报恩，入赘章氏，暗中帮助妻子掌舵章氏，而妻子却在许青要向她表明医圣身份的明堂会诊之前，选择了离婚，并在明堂会诊宴会上，质疑许青身份…\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480596,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1niDGf9IQY5nY_3-v_kGF_A?pwd=xyra\",\"online_time\":\"2023-12-07 00:00:00\",\"time\":1701878400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"都市奇门少主\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"都市奇门少主\",\"description\":\"大夏神君陆辰为护大夏，献祭魂魄，封印圣碑，成为了一个受人嘲笑的傻子，封印圣碑的陆辰，沦为了楚家的赘婿，受尽了世人的白眼和无尽的欺辱。五年后，叶家大少为了娶楚凌雪，竟然殴打陆辰。这个曾经的神君，魂魄归位，潜龙归天，一飞冲天，面对为了守护自己忠贞不渝的妻子，陆辰发誓，要踏平一切敢于欺辱他妻子的人……\",\"second_cate\":\"男频赘婿 战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482306,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1-zoaxUetxmGKtv7alxD_uw?pwd=31jq\",\"online_time\":\"2024-02-09 00:00:00\",\"time\":1707408000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"都市妖孽医尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"都市妖孽医尊\",\"description\":\"因女友背叛，叶辰受尽屈辱，血启家族传承，得到金手指后，从此一路崛起。主要剧情，围绕着苏清雪和顾梦涵，在两者的家族，追求者之间，来回产生矛盾冲突，装逼打脸，纯新媒体风，快节奏爽文短剧。\",\"second_cate\":\"男频都市神医\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483226,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1mMQI6qDad4xIiBmR7abncw?pwd=m8ai\",\"online_time\":\"2024-03-12 00:00:00\",\"time\":1710172800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"都市最强仙婿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"都市最强仙婿\",\"description\":\"京城四大家族之首族长叶毅，被大哥暗害，其子叶秋三岁就被其大伯叶元勋送到战神盟监狱，本想让其在监狱度过一生，没想叶秋在监狱中遇到战神盟盟主逍遥子，并拜其为师，叶秋在监狱中打败了镇狱虎王阿虎，并且得到逍遥子800年修为，逍遥子封住叶秋功力三年，安排叶秋出狱与梁州张家女儿张语嫣履行婚约，叶秋入赘三年，忍气吞声，功力解封当日，叶秋施展天神掌，飞天打败黑龙帮小弟，并且暗中调查叶元勋，发现叶元勋勾结倭寇，最终打败叶元勋以及日本一众战神，在都市修仙，过程中结识多位红颜知己，最终开启昆仑仙境，准备进入其中！\",\"second_cate\":\"男频高手出狱都市修仙赘婿\",\"episode\":0,\"platform\":\"\",\"update_time\":1720477786,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1K5-oX5exPED0OcshSSV5sA?pwd=3vec复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-11 00:00:00\",\"time\":1691683200,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"都市极品医神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"都市极品医神\",\"description\":\"小说爆款IP改编，本故事由网文大神风会笑的《都市极品医神》改编、讲述五年前叶家被灭、废物叶辰神秘失踪。五年后，叶辰带着一身通天地泣鬼神的修为回来，一步步追寻当年的真相。\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720477726,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1NfH0MuATG3IcDp6OPQ3UNQ?pwd=jw2a复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-16 00:00:00\",\"time\":1692115200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"都市狂飙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"都市狂飙\",\"description\":\"男主人公(陈志)本是一代“秋名山车神”因被女友劈腿且联合富二代，陷害陈志入狱，陈志得知这一切都是自己女友策划的，在伤心绝望中意外获得系统认主，出狱后本想过着普通的生活，奈何前女友与富二代不依不饶。后续引发出孙家族洛家联姻的阴谋，以及上一辈人的恩怨仇恨，最终各有各的归宿，与惩罚。\",\"second_cate\":\"男频系统神豪逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478486,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1gQC5Pp1PA5O8Uhon88zpTw?pwd=kzux\",\"online_time\":\"2023-09-14 00:00:00\",\"time\":1694620800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"都市超级神眼\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"都市超级神眼\",\"description\":\"夏辰惜为了救父亲，被闺蜜哄骗，然后重金求子，夏辰惜意外被林长庚英雄救美，看上林长庚，林长庚以为是骗子,后林长庚意外获得透视，同时与女总裁夏辰惜邂逅一段美妙的姻缘。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478386,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1FDe-0ieJ2TohChfstDd5oQ?pwd=cw8x\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"都市逍遥医神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"都市逍遥医神\",\"description\":\"王野，当代真武山天师，因身怀绝脉，活不过二十五岁，老天师逆天改命，助其多得五年寿命，但想要彻底治好身体，还需要七位女子的精血入药，王野带着老天师准备的婚书下山，寻找自己的未婚妻，之后帮助楚云溪，上官若心，沈晴雪，唐宛如四女，解决家族和自身的危难，同时运用天师手段，斩妖除魔，维护华国太平，五人之间建立了深厚的情谊，而王野的家族也找到了王野，在拜师宴上，王家力挺王野，出手教训了屡屡针对王野的几大家族，拜师宴结束后，王家要求王野回家继承家产，并迎娶家族为他准备的未婚妻。\",\"second_cate\":\"男频逆袭/高手下山\",\"episode\":0,\"platform\":\"\",\"update_time\":1720482086,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1w53oN3xvSvfhCYatbCWEFw?pwd=vq3h\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重启之超级人生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重启之超级人生\",\"description\":\"洛辰是个穿越者，在修仙界成长为逍遥仙尊，为了拯救苍生，补天身死，却在死后穿越回原本世界，并夺舍重生了一个豪门纨绔大少，原本正高兴可以享福潇洒一生，却发现原身因为懦弱无用，家产几乎被大伯等亲人夺走，还要将其抹杀，为了继续自己的潇洒纨绔生活，洛辰对大伯等人进行反击，并同时和一名名豪门大小姐结识，最终打败大伯一家以及妄图统治青省，同为穿越者的敌人，成为青省共主。\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482816,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1i8vKUVSHS3fZOBo9frB4pQ?pwd=xqru\",\"online_time\":\"2024-02-28 00:00:00\",\"time\":1709049600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重回1998之麻辣媳妇不好惹\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重回1998之麻辣媳妇不好惹\",\"description\":\"夏希妍用十年时间从一无所有的村姑变成女首富，在她为夏氏集团十周年庆典的时，自己的三个孩子却披麻戴孝闯入宴会揭开自己多年前抛夫弃子和情人私奔丑事。重来一次夏希妍改好一心只为家庭，获得家庭事业双丰收。\",\"second_cate\":\"女频年代、重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488606,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1YxAqU-nkTbnwSjLN5NK0uA?pwd=tdyc\",\"online_time\":\"2024-06-30 00:00:00\",\"time\":1719676800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重回90年代\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重回90年代\",\"description\":\"上一世，陈萧被未婚妻背叛，父母被构陷不堪屈辱而亡，自己更被仇人亲手杀死。这一世，他重生归来在父亲的灵堂上！他将亲手为父亲雪仇！救下母亲！曾经失去的一切，他都会一一拿回来！\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486566,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1PyQp8msNsbyx7miHlReiuQ?pwd=vw1r\",\"online_time\":\"2024-05-20 00:00:00\",\"time\":1716134400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重回98当首富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重回98当首富\",\"description\":\"陆鸣前世嗜赌成性，逼得老婆自杀，女儿被他的前女友刘洁和吴勇做局跳楼，得知真相的陆鸣痛不欲生，被吴勇推下楼而死，意外重生到1998年，老婆跳楼前夕。陆鸣痛改前非，发誓找吴勇和刘洁报仇，与此同时，吴勇和刘洁却在晚上放火，想烧死陆鸣一家……\",\"second_cate\":\"男频重生年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479596,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1bfWHtxbsOHUu08PT02lkGw?pwd=7yif\",\"online_time\":\"2023-11-03 00:00:00\",\"time\":1698940800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重回九零谁与争锋\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重回九零谁与争锋\",\"description\":\"男主林风，前世因为赌博，害的家破人亡，妻离子散，最后在一场赌博中，被一群疯狂的赌徒从高楼上扔下，死后，林风重生回到了上个世纪90年代。林风在好友兼小舅子大龙的帮助下，开启了自己辉煌的创业之路。\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486666,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1D4k7coxdQH87_PgCQZ4A4Q?pwd=fjyy\",\"online_time\":\"2024-05-28 00:00:00\",\"time\":1716825600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重回巅峰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重回巅峰\",\"description\":\"婚礼现场被曝出女朋友怀了别人的野种，对方有权有势，被骗了彩礼的陈默一怒之下怒了一下，直到一个女人找上他。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484056,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1M6vqvmlE45vhrQIzA_xtZw?pwd=jutj\",\"online_time\":\"2024-04-03 00:00:00\",\"time\":1712073600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重回白金年代\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重回白金年代\",\"description\":\"一代枭雄叶继祖重回1997后，利用前世知识和信息差拯救妻女，并在股市，房地产行业中以碾压之势完爆反派，最终在亚洲金融危机期间豪赚五百亿，书写一段精彩的人生传奇。\",\"second_cate\":\"男频重生逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481076,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1kimJ2l2IREyi2iKpDtzPFw?pwd=b2iy\",\"online_time\":\"2023-12-25 00:00:00\",\"time\":1703433600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重复千年后成为都市战神\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重复千年后成为都市战神\",\"description\":\"吴辰被困7月7日千年，学会了人类所有知识，但仍未脱离轮回。最后一次，吴辰想通刷所有曾干过的事，没想到一天之内竟完成七七八八，随后准备再去救苏清影，和她有了一夜欢愉，惊喜地发现自己跳脱了轮回。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486286,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1mA_Y0XS-9nAtZ4FfNGwDJQ?pwd=xyd5\",\"online_time\":\"2024-04-21 00:00:00\",\"time\":1713628800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重活一世金玉满堂\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重活一世金玉满堂\",\"description\":\"2018年，赌鬼陈磊在病入膏肓之际，身价百亿的大女儿前来，一把火与他同归于尽。悔恨中，陈磊重生1995 年，上辈子陈磊因赌博，害得妻子和小女儿被活活烧死在家，大女儿从小被拐卖，颠沛流离。这辈子陈磊决定戒赌，戒酒，爱护妻女，与妻女过上幸福美满的一生。\",\"second_cate\":\"男频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481156,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1ELT-o-KYELJeeo_oS9IqjQ?pwd=8sfc\",\"online_time\":\"2023-12-25 00:00:00\",\"time\":1703433600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重爱你们\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重爱你们\",\"description\":\"男主林川五年前因为赌博，导致家破人亡，老婆跳楼、女儿车祸，自己浑浑噩噩度过了5年之后。决定一死了之，买来百草枯喝下，随后昏死，却突然穿越到了5年前，这是他老婆孟家瑶跳楼那天……\",\"second_cate\":\"男频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479216,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1yQxWNFzEZsHgDmAW_FgTUQ?pwd=c4vt\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生1975开局撕毁回城调令\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生1975开局撕毁回城调令\",\"description\":\"当年为了国家事业做贡献，错过了女儿的成长人生，如今重生到调令那一天，要重活一世，让妻女幸福一生。\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485116,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1BDUnDXJHf2CKe8ZG-FkHSQ?pwd=bmc4\",\"online_time\":\"2024-05-10 00:00:00\",\"time\":1715270400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生1999\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生1999\",\"description\":\"叶星带着对老婆鹿小雨和女儿叶萌萌的遗憾回到1999年，决定弥补上一世因自己造成的不好的事情。叶星利用自己能预知未来的优势，让许斌的公司市值蒸蒸日上，叶星自己也创造了股市传奇。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479296,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1bRqHNBy247750kd0YDthDQ?pwd=fkxc\",\"online_time\":\"2023-10-17 00:00:00\",\"time\":1697472000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生2000之沸腾人生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生2000之沸腾人生\",\"description\":\"煤矿大亨谢仁杰的女儿跳河自杀，谢仁杰为救女儿，意外重生回2000年。浪子回头金不换，谢仁杰一边洗掉赌棍的帽子，赢回妻女信任，一边低价收购煤矿，投资房地产，炒股，赚的风生水起，感情事业双丰收。\",\"second_cate\":\"男频穿越、重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485296,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1JSKZnsPuH-9YGXASqhVAUg?pwd=8qii\",\"online_time\":\"2024-05-16 00:00:00\",\"time\":1715788800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生2000之王牌助理\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生2000之王牌助理\",\"description\":\"男主前世被老婆和兄弟背叛，合谋害死了肖云的父母，设计安排人绑架自己，欺骗肖云到东南亚救人，结果将肖云害死，谋夺了肖云的财产，肖云死后重生，救下了自己亲梅竹马的美女总裁郑雨涵，协助郑雨涵打造商业帝国，中途遇到云里巴巴创始人马秦，王林等前世大佬，投资他们，最终成为商业巨亨。\",\"second_cate\":\"男频重生商战\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478066,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/11OV8EtKi-jDQNrFc6A1gCQ?pwd=rfdn复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-28 00:00:00\",\"time\":1693152000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生2000后我走向了人生巅峰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生2000后我走向了人生巅峰\",\"description\":\"前世他遭人算计，深爱的妻子在他面前被逼自杀。最终他带着一生的悔恨与仇人同归尽！他张开眼睛，竟发现自己重生到了妻子自杀的当天。这一世，他誓要找出幕后黑手，也要倾尽全力，弥补对妻子的悔恨。\",\"second_cate\":\"男频重生年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478826,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1aV8FQWdSNW-Vw8-p6pndAQ?pwd=svjv\",\"online_time\":\"2023-09-28 00:00:00\",\"time\":1695830400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生2004\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生2004\",\"description\":\"郑浩前世家庭不幸，被老婆出轨害死，重生到2004年。重活一世的他，先跟坏女人退婚，又抓住商机，大把挣钱。由于他知道很多未来之事，大家都相信他的预知能力，跟他一起挣钱。改版命运，整治恶人。\",\"second_cate\":\"男频重生/复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485736,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1NvNug968wh9d5T9l25Rhyw?pwd=gmr5\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生2014\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生2014\",\"description\":\"张百万被妻子和奸夫害死，死之前得知自己只是一个接盘侠。前妻赵菲儿的出轨也是身为闺蜜陈晓美的陷害。男主重生到赵菲儿被冤枉出轨跳楼自杀那刻。拥有未来记忆的男主在商场无往不利并让女主成为最幸福的女人。\",\"second_cate\":\"男频重生/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485776,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1CLGy-V8Ne_d5U_Dw1MDkNA?pwd=jpkw\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生90之娱乐教父\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生90之娱乐教父\",\"description\":\"前世徐天洋为了女友赵姣姣的前程，甘愿放弃自己的前程，供赵姣姣念最好的音乐学院将她培养成举世闻名的大明星，哪知道赵姣姣成名后却劈腿别人，并且害死了徐天洋全家最后更是与奸夫合谋，一朝重生回到90年代徐天洋挺身而出，当面揭露赵姣姣的面目，徐天洋当即唱出后世的经典歌曲，成为90年代万众瞩目的新星。然而徐天洋却声称自己要成为娱乐教父，并且彻底崛起！\",\"second_cate\":\"男频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484506,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1Rajp76Egupf181fv2CnIAA?pwd=ts7v\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生主宰\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生主宰\",\"description\":\"为救被绑架的妻子，新晋首富林峰将全部财产转移给自己的好兄弟。不料这竟是兄弟与妻子的一场阴谋，林峰被害致死。临死前发誓要向二人复仇，结果重生回十年前。重活一世，林峰决心不再重蹈覆辙。\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486886,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1eufE9ntOH-exzCanj9bC3g?pwd=57tu\",\"online_time\":\"2024-06-05 00:00:00\",\"time\":1717516800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生之万物之主\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生之万物之主\",\"description\":\"宋今结婚前在女友张梦洁引诱下为爱结扎。不料发现张梦洁和赵亮偷情被气死，因祸得福得到万物抽牌器，打脸张梦洁和赵亮且还清负债。宋今利用万物抽牌器，直接将项玉带到项南面前，项南浑身颤抖，跪下恭敬磕头。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486626,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1HZNNlZOSwaKt-rMkh2wYxA?pwd=3vut\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生之傻王的绝世王妃\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生之傻王的绝世王妃\",\"description\":\"江元夏新婚日被妹妹陷害，重生后血脉觉醒，医毒双绝，当众退婚并闪婚嫁给看热闹的傻子--瑞王。嫁入瑞王府后，发现傻王身边危机四伏，于是动手铲除了嚣张的眼线陈公公。坏妹妹江新柔抢了她的原配夫婿端王爷，可是两人屡次下手追杀和陷害元夏夫妻俩，都被他们一一化解，端王逐渐气恼江新柔是个蠢女人后悔娶了她。与此同时江元夏发现瑞王装傻，两人互相摊牌了身份，一个是医毒双绝万花门主，一个是武力可抵千军的冰罗门主，两人在博弈中感情升温，傻王在挨揍中逐渐走入了江元夏的心，并帮她回娘家出气，还帮她救母亲。\",\"second_cate\":\"女频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479556,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1vwkr8HvkRw0MmJXZTaA3oA?pwd=pkxk\",\"online_time\":\"2023-11-02 00:00:00\",\"time\":1698854400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生之农门肥妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生之农门肥妻\",\"description\":\"世界级厨师苏晚意外穿越成古代肥婆，面对困境和偏见，她决心减肥并利用现代厨艺发家致富。与丈夫许亦云经历种种挑战，她不仅克服困难还揭开丈夫真实身份—王爷。两人共同成长，最终幸福生活在一起。\",\"second_cate\":\"女频/穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488676,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1JhPDp5GX8K3_H8m8aOy8Cg?pwd=ig3j\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生之大少归来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生之大少归来\",\"description\":\"财阀长子李俊泽被女友和弟弟背叛失去了一切，最终惨死。李俊泽重生回到了五年前，看着出现在面前的绿茶，遇到还把自己当成傻子的弟弟，李俊泽发誓要让伤害过自己的所有人，付出百倍千倍的代价！\",\"second_cate\":\"男频穿越/重生\",\"episode\":0,\"platform\":\"\",\"update_time\":1720488286,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/18QCH1AgagowxQCFnUqpSjg?pwd=rbaj\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生之姐就是霸总\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生之姐就是霸总\",\"description\":\"一次偶然的机会，让柯巧巧决定要利用世界杯球赛这一契机与男友景佑一同投身创业洪流。就算有人阻碍，也均被化解。最终，在孔孚集团的继承人之争中，景佑凭借出色的实力和能力，成功获得了继承人的身份。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487586,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1nMJIYovPkaihP53RJaENfw?pwd=tru2\",\"online_time\":\"2024-06-15 00:00:00\",\"time\":1718380800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生之娱乐教父\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生之娱乐教父\",\"description\":\"林杰是隐藏多年的娱乐圈教父双木先生，他为了捧红自己的老婆董迎雪，主动现身与如云传媒女总裁云霞妃接触。谁承想突如其来的喜讯冲昏了董迎雪，竟与林杰离婚。董迎雪的这一举动，却让她自己陷入了更深的漩涡中......\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487846,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/15VoxgO9i9rM7c5lV6JLM2Q?pwd=17m6\",\"online_time\":\"2024-06-19 00:00:00\",\"time\":1718726400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生之我是娱乐圈天后\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生之我是娱乐圈天后\",\"description\":\"秦杉带着前世的遗憾重生归来。前辈的打压、众人的嘲讽，都未将她击垮，她凭借着自己的实力和上一世的记忆，在演艺圈崭露头角。与魏少雄因误会而结识，在共同奋斗中建立了深厚的情感。最终秦杉获得了影后的殊荣。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487696,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1NqgKbX4luBwGWehioRK0PQ?pwd=96a5\",\"online_time\":\"2024-06-17 00:00:00\",\"time\":1718553600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生之我用罐头换飞机\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生之我用罐头换飞机\",\"description\":\"上一世无恶不作的恶棍秦霄意外重生，这一世秦霄觉醒，带着来自未来的记忆和经验自带外挂做生意。卖薯片、开玉石、拍地皮，炒股票，更是在重要时刻想出了用罐头换飞机的办法解决了生意危机。最后，他用自己的真心让妻子重新爱上自己，还用智慧打败了三合会的仇人，为上一世的自己和家人报仇雪恨。\",\"second_cate\":\"男频年代 重生 逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483526,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1ZdXaMb-yBWYdYvrK7pyxTQ?pwd=h28h\",\"online_time\":\"2024-03-20 00:00:00\",\"time\":1710864000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生之我靠古玩再发家\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生之我靠古玩再发家\",\"description\":\"陈阳得知女儿不是亲生的，准备提出离婚的时候，被妻子和小舅子陷害。在坠楼之时，他重生到当年定亲那一天，他果断拒绝了当时已怀孕的唐丽娜。在这个重生的九十年代，他发现了自己的真爱方子微，决定在一世重新来过，运用自己的认知从古玩市场淘货发家起来……\",\"second_cate\":\"男频重生年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478956,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ohPNojYikD8AOPQ7lM2NBw?pwd=g89k\",\"online_time\":\"2023-10-02 00:00:00\",\"time\":1696176000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生之盖世无双\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生之盖世无双\",\"description\":\"苏依雪为了给弟弟还债和林凡敌人勾结害死林凡，可林凡却意外重生到他和苏依雪结婚当天，已经看清苏依雪真面目的林凡果断悔婚，把彩礼给了钟灵并带走他，并从此不再隐藏身份，只为找到当年害死自己以及母亲的真凶。\",\"second_cate\":\"男频都市、重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488636,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/15AE44LnU4ySLeU6Q3Eb32A?pwd=ppaa\",\"online_time\":\"2024-06-30 00:00:00\",\"time\":1719676800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生之虐渣白眼狼女儿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生之虐渣白眼狼女儿\",\"description\":\"叶云知作为家庭主妇，任劳任怨，但丈夫和女儿都非常看不起她，将她当成保姆使唤。不久叶云知患上乳腺癌。巨大的不甘让叶云知重生重生后，叶云知主动找到娘家认错破冰。她隐藏自己的身份开始寻找他们犯罪的证据，在沈珈的多次作梗下，叶云知不知道自己的亲生女儿居然就在自己的眼皮子底下受苦，沈珈的生日宴上她蓄意联合赵凡杀了甄真，计划被叶庭琛识破。沈珈做的恶事终于败露。叶云知也终于知道真相。\",\"second_cate\":\"女频重生、虐渣\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488866,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"链接：https://pan.baidu.com/s/1S4_OyBLhkQpbUZXQ1f6_nw?pwd=fs8d\\n提取码：fs8d\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生之都市修真\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生之都市修真\",\"description\":\"修真者苏夜遭人算计围杀。死后灵魂穿越地球，附体在一个被逐出家门的废物大少身上。正当苏夜准备苟住发育，炼气修真的时候，废物大少的未婚妻林清瑶找上门来，要和苏夜履行婚约。苏夜发现林清瑶竟然和自己前世相恋而不能在一起的师傅长得一模一样。苏夜自以为是天意，决定和林清瑶结婚，却不想他已卷入一场豪门争斗的漩涡之中。但所有不知道原本的废物大少早已死去，现在苏夜体内居住的是一名修真者的灵魂。\",\"second_cate\":\"男频玄幻修仙\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479526,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1nv1OYYWh6d8R3e2rmNqSJQ?pwd=sutq\",\"online_time\":\"2023-10-27 00:00:00\",\"time\":1698336000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生从底层赌棍逆袭百亿大佬\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生从底层赌棍逆袭百亿大佬\",\"description\":\"刘辛年轻时创业失利，在损友引诱逐渐堕落，成了吃喝赌无一不沾的烂人，气死母亲，拖死老婆，害死女儿。在他被债主夏践追债砍死时，带着悔恨离世。再睁眼，刘辛回到了2010年，那时候自己刚刚开始堕落，老婆的小病还没拖成绝症，女儿乖巧，母亲健在，为了弥补前世的遗憾，刘辛痛改前非，借助自己前世的记忆，在贵人白佳丽的帮助下一步一步成为商界奇才，最终斗倒了前世害死自己的夏利，成为江城新晋首富，不但为曾经的自己报了仇，也给了全家一个光明灿烂的未来。 \",\"second_cate\":\"男频重生/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484996,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1eCCqgkRMR7V4aQeen3FfWQ?pwd=wrkx\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生八九空手套白狼\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生八九空手套白狼\",\"description\":\"江帆意外重生回到八十年代后，及时阻止妻女死亡，之后改过自新，利用自己的机智，白手起家，通过空手套白狼的方式，进行创业，并弥补过去遗憾。\",\"second_cate\":\"男频重生年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481176,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/107I7dLbLD09bZhJYxFhIyQ?pwd=ffgi\",\"online_time\":\"2023-12-26 00:00:00\",\"time\":1703520000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生医妃不好惹\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生医妃不好惹\",\"description\":\"现代医生穿越回古代重生，医术通天为王爷，公主，皇帝等医病\",\"second_cate\":\"女频穿越重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484426,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1brWlxaWpcJXvkhFf0MF0Hg?pwd=sw64\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生名门贵妇\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生名门贵妇\",\"description\":\"上辈子江意暖错信奸人，眼睁睁的看着儿子死在她面前，重活一世，她洗心革面，抱紧残疾老公的大腿，带着自己的儿子，打脸渣男贱女。\",\"second_cate\":\"女频现代、重生、大女主\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480516,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1op7mBm3iJkppAopkSu3Ymw?pwd=ce1n\",\"online_time\":\"2023-12-06 00:00:00\",\"time\":1701792000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生后我强吻了最狠的三爷\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生后我强吻了最狠的三爷\",\"description\":\"顾念念睡前看小说，看完结局愤愤不平地入睡。顾念念一觉醒来穿成书中5年前的女主顾念。顾念念决心替原小说女主报仇。被闻风丧胆男主三爷宠上了天，穿书后的顾念则爱惨了男主，治好男主的偏执症。\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485236,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1R7PL_lCuD3Oc2sxrCCB1qw?pwd=sdub\",\"online_time\":\"2024-05-13 00:00:00\",\"time\":1715529600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生后我报复了渣男全家\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生后我报复了渣男全家\",\"description\":\"丈夫赵阳为了继承妻子夏若星娘家的财产联合父亲弟弟制造了一场车祸将夏家全家杀害，连带着即将临盆的夏若星。夏若星重生回半年前，决定改变这一切，让赵家三父子得到应有的惩罚。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481826,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1xHwZnu8hYACgn2kY6vh1Cw?pwd=acky\",\"online_time\":\"2024-01-25 00:00:00\",\"time\":1706112000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生后，夫人的马甲掀翻全场\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生后，夫人的马甲掀翻全场\",\"description\":\"\\\"霍家千金霍薇宁，重生前被妹妹霍雨柔多次利用、腹诽，在旁人眼里是一个坏人，不尊重丈夫墨景渊，多次与人私奔，最终被人陷害，看着丈夫墨景渊为救自己进入火海之中。重生归来，是多马甲的霍家大小姐， 她手刃渣男，脚踩贱女，虐白莲花妹妹，揍渣前男友，将所有可能伤害到他的人统统挡到门外！\\\"\",\"second_cate\":\"女频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478966,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1TwqeCnCuz2WypJgUAJ5Yrg?pwd=t2gv\",\"online_time\":\"2023-10-03 00:00:00\",\"time\":1696262400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生后，她转身投入死对头怀抱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生后，她转身投入死对头怀抱\",\"description\":\"前世她辜负了他，他却为她而死！重生醒来，她一头扎进他怀里……\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481376,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1eZiUbc-aDSDrMpUwpBzQVQ?pwd=y9n3\",\"online_time\":\"2024-01-03 00:00:00\",\"time\":1704211200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生后，我被首富千金上门逼婚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生后，我被首富千金上门逼婚\",\"description\":\"杨浩爱老婆爱到愿意为小舅子捐肾，却不想自己看错人，被老婆一家迫害致死。身死之后，他意外重生到了2008年。这一世，杨浩早已经看透了人心，一心一意只爱上一世辜负的学姐王琳，并靠着信息差一步步建立起了自己的商业帝国，成为了这颗星球上数一数二的人物。\",\"second_cate\":\"男频都市重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478786,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1TulkD_wJipbMPCOBAZZcXQ?pwd=9ds7\",\"online_time\":\"2023-09-27 00:00:00\",\"time\":1695744000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生回到五年前\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生回到五年前\",\"description\":\"男主林川五年前因为赌博，导致家破人亡，老婆跳楼、女儿车祸，自己浑浑噩噩度过了5年之后。决定一死了之，买来百草枯喝下，随后昏死，却突然穿越到了5年前，这是他老婆孟家瑶跳楼那天……\",\"second_cate\":\"男频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479226,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Ez0VFk119yPHpdA3blxIcA?pwd=gj94\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生女团，豪门总裁跪求原谅\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生女团，豪门总裁跪求原谅\",\"description\":\"总裁，夫人的遗物中发现了孕检单，他颤着手接过，撕心裂肺…\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477756,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1k-inN8iVoF7PtA-uIUc1nw?pwd=czsb复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-16 00:00:00\",\"time\":1692115200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生嫡女无限嚣张\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生嫡女无限嚣张\",\"description\":\"大夏京都有两女名扬天下，一个是丞相府大小姐，才貌双绝，气质出众，是贵族少女中的标杆领袖。\",\"second_cate\":\"女频古装\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478456,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1xoYN7bI1eE__2_fnN1n2ZA?pwd=7fjd\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生开局舔狗金制霸系统\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生开局舔狗金制霸系统\",\"description\":\"男主陈远是一名小职员，发现女朋友林书彤跟酒吧经理偷情，一怒之下持刀威胁两人，被警察击毙。本该死去的陈远却觉醒了最强舔狗系统，自己只要给女人花钱就能获得奖励，于是陈远走上了一条讨伐拜金女之路。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486296,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/10o8Y6z-fYPwp7820JX_WiQ?pwd=dn5s\",\"online_time\":\"2024-04-25 00:00:00\",\"time\":1713974400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生归来虐渣男\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生归来虐渣男\",\"description\":\"沈氏集团总裁沈兮月得知怀孕当天撞破丈夫潘在成与情妇冷若雪偷情，二人对沈兮月痛下杀手，沈兮月大难不死遇到整形医生韩厉帮她修复伤疤，并安排韩家千金新身份，追思会上青梅竹马的顾子旭突然闯入并坚信沈兮月没有死\",\"second_cate\":\"女频穿越/重生\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486406,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"链接：https://pan.baidu.com/s/19NxQi_SkMyZXHLqLw1F18A?pwd=sfi3\\n提取码：sfi3\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-04 00:00:00\",\"time\":1714752000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生成他的白月光\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生成他的白月光\",\"description\":\"苏汐前生被渣男前男友萧墨深联手继妹苏妍儿害死，临死前才知道老公黎川有多么爱她。重生后，她用尽办法想要挽回，可是苏妍儿不想让他们真的复合，挑拨离间设计陷害，而苏汐清醒躲避，并和黎川的情感越来越深，终不辜负彼此的情意。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479616,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ulG9il-ecz5EHaaIpgI_Zg?pwd=wz92\",\"online_time\":\"2023-11-03 00:00:00\",\"time\":1698940800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生成婚前\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生成婚前\",\"description\":\"前世，沈又夏被未婚夫顾帆和表妹赵默默算计，家产被夺痛失所有，葬身大海。重生后，为了虐渣复仇，夺回家产她展开环环相扣的计划。\",\"second_cate\":\"女频霸总/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485936,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"链接：https://pan.baidu.com/s/1BvY_8gu5IpAwIefcyM8Rsg?pwd=qv55\\n提取码：qv55\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-27 00:00:00\",\"time\":1716739200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生我有信息差\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生我有信息差\",\"description\":\"男主林川五年前因为赌博，导致家破人亡，老婆跳楼、女儿车祸，自己浑浑噩噩度过了5年之后。决定一死了之，买来百草枯喝下，随后昏死，却突然穿越到了5年前，这是他老婆孟家瑶跳楼那天……\",\"second_cate\":\"男频重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479236,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1sopU2F4LoYoQStY_D3KteQ?pwd=97rz\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生暖婚轻宠妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生暖婚轻宠妻\",\"description\":\"莫诗诗被继母逐出家门改名莫诗意，母亲因病住院被莫菁菁姐妹害死。莫莎莎死后，沈穆寒认定是莫诗意所害，用假意温存骗取她与他结婚，婚后不断折磨莫诗意。在丧子之痛中绝望离世，重生后带着复仇怒焰归来。\",\"second_cate\":\"女频重生/复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485716,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1DVpTeYOKYBjCuiS6rd9i4g?pwd=8cvb\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重生财阀：回到1992\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重生财阀：回到1992\",\"description\":\"财阀大佬意外重生到1992年的渣男身上，不料1992年的渣男是烂赌鬼，而自己前世是财阀大佬，从此利用自己的聪明才智摆平渣男赌鬼欠下所有的债务并成立新的财阀帝国，最后携手娇妻上演一场你浓我情的恩爱之旅。\",\"second_cate\":\"男频重生年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479786,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1lYHpqTz9lbN1AB0Rcm3szg?pwd=2361\",\"online_time\":\"2023-11-09 00:00:00\",\"time\":1699459200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重返2000之王者归来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重返2000之王者归来\",\"description\":\"重生一世，陈浩决定不再蹉跎岁月，徒耗青春。前世错过的，遗憾的，可望不可求的，他统统都要。时势造英雄，风云出我辈！\",\"second_cate\":\"男频都市重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478666,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1iFFVOhe4LKPxiwhw2JF0OA?pwd=dinu\",\"online_time\":\"2023-09-25 00:00:00\",\"time\":1695571200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"重逢再说我爱你\\u0026爱你我已无可救药\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"重逢再说我爱你\\u0026爱你我已无可救药\",\"description\":\"为让纪庭轩做上心脏病手术，江晚瑜被迫跟纪庭轩分离，纪庭轩因此恨上江晚瑜，同时纪母抱走了江晚瑜生的男孩。六年后江晚瑜因为女儿和同学打架一事，再次与纪庭轩重逢，两人开始了爱恨反复拉扯的虐心之恋。\",\"second_cate\":\"女频虐恋/带球跑\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488486,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1Cu1UgYibVzBuuC67U7IiHw?pwd=nbnw\",\"online_time\":\"2024-06-28 00:00:00\",\"time\":1719504000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"野蛮女友拳拳到肉\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"野蛮女友拳拳到肉\",\"description\":\"从小在孤儿院长大的林芝艺和弟弟小南相依为命。为了赚钱给小南看病，林芝艺答应替同为孤儿院长大的姜依柔相亲嫁人。谁知替嫁对象不但身为霸总还是她青梅竹马的小伙伴路邵峰，而姜依柔却发现自己的身份竟然是因为小时候抢了林芝艺的玉佩而得来，便开始了一段与林芝艺争夺路邵峰的故事。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484886,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/118J4thQxdodcY58JhajVig?pwd=yxpd\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"金榜题名之高考状元\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"金榜题名之高考状元\",\"description\":\"刘向东因成绩优异被带走，村民误传其是坏人，一家人也遭受全村人欺负，只有小静帮助。在这几年时间，小静被迫嫁人。刘向东平乱，救了两个公主，几年后，凯旋而归，回村历经磨难，和小静结婚。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487876,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1akdY3yW4I4vJwj-3UZlmzw?pwd=76h3\",\"online_time\":\"2024-06-20 00:00:00\",\"time\":1718812800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"金牌纨绔日常\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"金牌纨绔日常\",\"description\":\"叶辰从小跟随一位名为“昆仑老人”的老者修行。一直到叶辰学有所成，昆仑老人才告诉叶辰，他将带着叶辰身世秘密的一块玉璧分成了九块玉佩，分别替叶辰定下了九个娃娃亲。只有找到全部九块玉佩，才能解开叶辰的身世之谜。\",\"second_cate\":\"男频奇幻/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484526,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1BHSGfSLWbDzwRJxWw8w-qA?pwd=69ur\",\"online_time\":\"2024-04-18 00:00:00\",\"time\":1713369600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"银河里的时光\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"银河里的时光\",\"description\":\"夏时光的原生家庭恶劣，生病等钱的父亲、刻薄寡爱的母亲和吸血鬼哥哥，被逼着高考前去打工贴补家用，因此发挥失常，上了大专。谈的男朋友也不是东西，花她的钱还出轨，甚至看不起她。好在她善良坚强，同时打好几份工依旧热爱生活，面对渣男，当断则断。她有稀有的RH阴性血型，因此和受伤的傅时彦发生关系并救下了他。本应由此成为周家大少奶奶的夏时光，却被闺蜜谢锦柔抢去功劳...\",\"second_cate\":\"女频/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488226,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/12YDFmNTPS4XuSstzsz4S5g?pwd=67uk\",\"online_time\":\"2024-06-25 00:00:00\",\"time\":1719244800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"错爱为奴被逼嫁给死对头\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"错爱为奴被逼嫁给死对头\",\"description\":\"十年前，初恋自杀，叶楚辰誓复仇。十年后，他抓宋妍逼仇人现身，在相处中又逐渐爱上了宋妍。宋妍虽然表面顺从，但私下计划着逃离。最终，叶楚辰复仇失败，在遗憾中离世，宋妍这时却发现自己早已深深爱上。\",\"second_cate\":\"女频虐恋\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486556,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1sw38buDY4uTSWWo1wCkdvw?pwd=6wk8\",\"online_time\":\"2024-05-18 00:00:00\",\"time\":1715961600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"错过后的再相爱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"错过后的再相爱\",\"description\":\"陆思涵父亲被抓当天，她到男友江南昊家求助，男友却和富婆出国。多年后陆思涵遇危险，来救她的人恰是江南昊。江南昊想弥补但陆思涵害怕再次受伤。陆思涵追查江南昊背后阴谋，没想到竟追查到父亲被害的幕后真凶。\",\"second_cate\":\"女频/虐恋\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487996,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"链接：https://pan.baidu.com/s/1V8VpnZauaQj1d3vgRerf1g?pwd=pfho\\n提取码：pfho\\n--来自百度网盘超级会员V4的分享\",\"online_time\":\"2024-06-21 00:00:00\",\"time\":1718899200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"锦衣回乡\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"锦衣回乡\",\"description\":\"富贵不还乡，如锦衣夜行！外出打工七年，陈凡一步一步将自己的公司带到了万亿市值，不过一向低调的他却从来都没声张，而是坚信闷声发大财。就在陈言准备带着他的第十家公司上司敲钟的时候，他却忽然收到的老家人的消息，自己的母亲就快要病死了……\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481246,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1jj6cK2o76UKxSKMEC7hGng?pwd=rmac\",\"online_time\":\"2023-12-29 00:00:00\",\"time\":1703779200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"镇北圣帅\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"镇北圣帅\",\"description\":\"第一武圣宁恪统领边境军征战三年，驱除外敌，获封“镇北圣帅”。对外宁恪出身不祥，四年前受到神秘人指点，一举成为夏国第一武圣，从此平步青云横扫外敌，成为名副其实的第一战神，也受到国主和几位军务大臣的高度重视，堪称国宝级的将帅。但他一直在悄悄追查自己的身世...\",\"second_cate\":\"男频穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477996,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1KRvZxRO0pRIrJI6LQODQwQ?pwd=jtyv复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-24 00:00:00\",\"time\":1692806400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"镇北皇\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"镇北皇\",\"description\":\"镇北王失踪，冷凝找到同名同姓，长相一样的萧寒假冒镇北王稳定局势。萧寒结婚当天被绿，还被高利贷追债，走投无路答应冷凝救场，通过模仿镇北王言行举止成功应对各大势力试探，上演了一出“真假镇北王”的大戏。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485026,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"链接：https://pan.baidu.com/s/1sbjTmsx1OxwvNKpbWJReaA?pwd=o4p3\\n提取码：o4p3\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-03 00:00:00\",\"time\":1714665600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"镇国 龙帅\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"镇国 龙帅\",\"description\":\"镇国龙帅萧辰被北疆王陷害五马分尸，北疆王威胁要灭萧辰全家，关键时刻萧辰挣脱束缚，却没能阻止被灭门。父母已死，妹妹失踪，妻子被辱。萧辰冲冠一怒，四道狼烟起，烽火杀人时，萧辰誓要血债血偿。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"\",\"update_time\":1720478056,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1pFywEuMMduq2e2nTeBtmUA?pwd=h7gw\",\"online_time\":\"2023-08-28 00:00:00\",\"time\":1693152000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"镇国强龙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"镇国强龙\",\"description\":\"新媒体爆款ip+战神爆款演员，付费墙前催泪煽情，不一样的虐心战神\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477706,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/13yr3OOu2HFl7sF4e9UbrkA?pwd=cqdc复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-15 00:00:00\",\"time\":1692028800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"长生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"长生\",\"description\":\"叶无双本是修仙之人，在突破天境之时，财神，战帝，医皇，龙权，赤霄，天峻等徒弟纷纷前来恭贺叶无双飞仙，在即将飞升之时，却发现自己还有一记万年前的情劫未渡，于是下凡尘出世历劫难。一万年前的情缘洛曦已经轮回转世，成为苏天峻女儿，苏天峻惊喜万分给师祖叶无双和女儿一纸婚书，两人姻缘就此展开。 叶无双拿着婚书前往苏家，不知情的苏家人嫌弃叶无双一穷二白要求入赘，叶无双说出自己苏青云宗宗主的身份，却被无情嘲笑吹牛。苏氏即将来临的祭祖大典上，苏家宾客纷纷献上至宝，不见叶无双的礼物，众人嘲讽，更有甚者要求苏小姐当场与叶无双断了婚约，众人欺压叶无双之际，龙家孙女龙映月前来替叶无双找回面子，收拾众人。\",\"second_cate\":\"男频热血\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480556,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1U-cQDtHo-JKpMapFufIk_w?pwd=pk8v\",\"online_time\":\"2023-12-07 00:00:00\",\"time\":1701878400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚厚爱：总裁老公撩上瘾\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚厚爱：总裁老公撩上瘾\",\"description\":\"唐楚楚救了季皓渊爷爷，季皓渊的爷爷为了报恩，让季皓渊和唐楚楚结婚。季皓渊不愿意直接出国了。季爷爷一番折腾，让季皓渊和唐楚楚登记结婚。三年后季皓渊回国要和唐楚楚离婚，让唐楚楚去宴会上找他，唐楚楚同意，在宴会上两人因为意外发生关系，季皓渊误会唐楚楚是特殊行业者，要给唐楚楚钱。唐楚楚拒绝，季皓渊讨厌唐楚楚，唐楚楚离开，闺蜜因为想拿下季皓渊手里的古董修复单子，唐楚楚和季皓渊再次有了交际，季皓渊拒绝把单子给唐楚楚和闺蜜做，唐楚楚在酒店和客户沟通被纨绔子弟欺负，唐楚楚借助季皓渊逃跑，季皓渊救下唐楚楚,带唐楚楚去医院，季皓渊得知唐楚楚是自己的老婆，两人吃饭，遇到喜欢季皓渊的富家千金，千金欺负唐楚楚，唐楚楚反击，千金故意安排人去撞唐楚楚，唐楚楚和闺蜜去酒吧遇到流氓，季皓渊打脸流氓，唐楚楚去给季皓渊买礼物，遇到了老同学，季皓渊帮唐楚楚打脸，两人幸福在一起!\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480176,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1yn_yOofOO57IqkducivsdA?pwd=vcpd\",\"online_time\":\"2023-11-20 00:00:00\",\"time\":1700409600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后和傅少互飙演技\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后和傅少互飙演技\",\"description\":\"女顶流云轻轻和广告公司老板傅景言是一对死对头，他们为对抗家里的要求，伪造身份去相亲，却阴差阳错相到了彼此。一边是真实身份里互相看不惯，一边是虚假身份里二人互相试探和隐瞒，擦出笑料不断，两个人也在其中找到了心动的感觉。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481456,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1rkUXLBXP-rpF7eR46nuxcA?pwd=fts9\",\"online_time\":\"2024-01-08 00:00:00\",\"time\":1704643200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后她带萌娃惊艳全球\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后她带萌娃惊艳全球\",\"description\":\"一场意外，让江城第一世家贵族大少霍宴臣，与姜家不受欢迎的大小姐姜晚意邂逅。六年后，姜晚意因未婚生子遭受继母压迫而选择相亲，却不料遭遇极品妈宝男和其母亲的极尽嘲讽。另一边，找了姜晚意整整六年的霍宴臣，在得到消失时不顾一切找来。却不料姜晚意因六年来遭遇的苦楚对“他”这个中夏总裁愤恨不已。无奈，霍宴臣只得隐藏身份默默陪伴，不惜一切代价照顾他们母子。然而当真相揭晓，一切又该何去何从……\",\"second_cate\":\"女频闪婚、甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482396,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1H00OtQ4n-5yv6XL4Ana28A?pwd=ymrf\",\"online_time\":\"2024-02-11 00:00:00\",\"time\":1707580800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后成了满级大佬心尖宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后成了满级大佬心尖宠\",\"description\":\"本剧以女主孟宁为中心，讲述孟宁大学时期因意外怀孕被迫退学，被诬陷剽窃作品，初恋男友远赴国外后患上抑郁症，进而选择性失忆，忘记了自己生过孩子的事实。6年后与晟宇集团霸道总裁傅廷修乌龙相亲，先婚后爱，两人一路磕磕碰碰，兜兜转转，最终发现霸道总裁傅廷修的真实身份以及6年前夺走她第一次的男人也正是傅廷修，二人阴差阳错结成正果，最后名正言顺过上双向奔赴的幸福生活。\",\"second_cate\":\"女频闪婚/先婚后爱/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481996,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1gTC7e_fvqgqED9cEh58Zxw?pwd=qryk\",\"online_time\":\"2024-02-01 00:00:00\",\"time\":1706716800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后我实力藏不住了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后我实力藏不住了\",\"description\":\"李千帆为了逃婚，下山以九块九价格与苏子域闪婚，成为苏家赘婿，和苏子域一起去了光明医院解决莫家医闹。救了已经宣布死亡的莫老，然而莫老为了让李千帆的医术为莫家所用，竟逼李千帆离婚入赘莫家。\",\"second_cate\":\"男频穿越/都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484166,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1lMt2UCncF9xp3VcYW1vNqQ?pwd=e3gc\",\"online_time\":\"2024-04-06 00:00:00\",\"time\":1712332800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后我成了首富的掌上明珠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后我成了首富的掌上明珠\",\"description\":\"富家千金简欣被恶毒的后妈和继妹欺负，设计她被恶霸欺侮，正巧为陆季川所搭救。二人因为各自处境定下闪婚契约，二人冥冥注定产生情意，在和两边家庭的对抗中产生更多羁绊……\",\"second_cate\":\"女频闪婚\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479396,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1DnmZ-aXmkZzBL0e1OHXU-Q?pwd=46wf\",\"online_time\":\"2023-10-21 00:00:00\",\"time\":1697817600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后我跟总裁互换了身体\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后我跟总裁互换了身体\",\"description\":\"这是一段关于打工人与老板互换身份地位的故事，宋谨行是大老板，每天除了工作就是工作，情感生活一片空白，钟阮星是普通打工人一枚，每天为了生存奔波，生活的压力让她时不时说几句丧气话。有一天，两人竟然交换灵魂，她懂了当大老板的压力，他明白了小人物生存的不容易，他们之间因理解而靠近。\",\"second_cate\":\"女频闪婚\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484486,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1FZMxsy2wQkXM87KfUz7qmw?pwd=uams\",\"online_time\":\"2024-04-17 00:00:00\",\"time\":1713283200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后战少每天逼我生崽\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后战少每天逼我生崽\",\"description\":\"十七年前，姜若烟被生父和继母夺了遗产扔到山野，被七位高人收养。十七年后，姜若烟霸气回归（马甲，中医泰斗，隐形富豪），去未婚夫和继姐的婚礼成功抢婚，从此她成了上流圈人人笑话的战家四少奶奶。战景妄不满家族联姻，与姜若烟针锋相对。姜若烟暴打纨绔富二代，手撕继姐小白莲，勇夺生父霸占的遗产，一系列的操作让战景妄刮目相看。战景妄提出形婚，哪想自己啪啪打脸爱上女主，霸气护妻，与姜若烟发生一系列的爱恨情仇......\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484276,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1xY4AJ4Tvr0I9z-wFzdRXMQ?pwd=4xvg\",\"online_time\":\"2024-04-10 00:00:00\",\"time\":1712678400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后爱上来自海洋的你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后爱上来自海洋的你\",\"description\":\"穆北辰因被家人催婚，决定选个演员假结婚，就在这时候，他无意间救了人鱼于美美，于美美调戏了穆北辰之后迅速溜走，却因为一条海洋之心，被迫留在了穆北辰身边。\",\"second_cate\":\"女频轻喜\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481776,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/15Dwfx7YE5ft2GnHPLoBovA?pwd=b4cm\",\"online_time\":\"2024-01-22 00:00:00\",\"time\":1705852800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后老公天天给钱花\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后老公天天给钱花\",\"description\":\"顾洛为继承家产，闪婚了盲人老公，结婚后，却发现老公并不瞎，而且是全城首富建业集团的老总。顾洛和傅沉夫妻联手打脸渣男贱女，夺回家产，并收获幸福生活。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483896,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1m8ahBYG7XzKVdhlmPnxkQw?pwd=zsrd\",\"online_time\":\"2024-03-29 00:00:00\",\"time\":1711641600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后被醋王总裁宠上天\\u0026闪婚豪门总裁宠妻悠着点\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后被醋王总裁宠上天\\u0026闪婚豪门总裁宠妻悠着点\",\"description\":\"沈棠溪为逃避家里的结婚安排与林屿舟闪婚，不知其为豪门总裁。林屿舟职场上提拔沈棠溪，生活中帮助解决家庭问题，两人感情升温。可惜好景不长，两人产生误会，但好在二人感情坚定，最终解除误会在一起。\",\"second_cate\":\"女频/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488246,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1nVJcB-k0NpTwi3H0zpLbEw?pwd=g96f\",\"online_time\":\"2024-06-25 00:00:00\",\"time\":1719244800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后金主老公有了读心术\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后金主老公有了读心术\",\"description\":\"婚礼当天，在褚砚迟的刻意安排下，简宁发现未婚夫周子衡和继妹简雨薇搞在了一起，但为了能够拿回母亲被简家侵占的财产，威逼利诱的哄褚砚迟完成婚礼。但简宁并不知小助理褚砚迟其实就是褚家神秘家主。从此简宁发现自己遇到困难总是能够迎刃而解，简宁也开始了对褚砚迟的维护，并且越来越对褚砚迟有好感，最终简宁在褚砚迟的帮助下解决妹妹等人，拿回公司并查明了事情的真相，最终误会解开两个人重归于好。\",\"second_cate\":\"女频闪婚\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482956,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1dHhKETMgbuHRSVNMPn8bbA?pwd=kga2\",\"online_time\":\"2024-03-04 00:00:00\",\"time\":1709481600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后霍少马甲藏不住了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后霍少马甲藏不住了\",\"description\":\"慕浅浅中学时救下被群殴的霍邵琛并留下手帕，两人情根深种。多年后慕浅浅被亲妹陷害，意外和霍邵琛发生关系并被媒体知晓。为挽回家族声誉，霍邵琛提出结婚。她和霍邵琛化解亲妹和后妈羞辱成功揭穿阴谋并修成正果。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487486,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1jruUmRMi4ZvoMWjcIILQVg?pwd=qrve\",\"online_time\":\"2024-06-13 00:00:00\",\"time\":1718208000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后顶流老公的马甲藏不住了！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后顶流老公的马甲藏不住了！\",\"description\":\"一朝国破家亡，本是高高在上的公主钱心潼一夜之间失去至亲，却没想到再次睁眼，自己居然来到了现代，还出现在了男人的床上，更有趣的是，这个男人和自己的心上人金逸驰长相极为相似，钱心潼没料到，看起来不近女色的金逸驰居然是现代社会的顶流明星，闪婚后的金逸驰变本加厉，在一次次在撩拨和强攻中钱心潼终于败下阵来，然而此时，钱心潼意识到，这个男人似乎还有着另一层身份.……\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482756,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1vQXMdQ_XrzJu5oWSWl8IzQ?pwd=ucar\",\"online_time\":\"2024-02-26 00:00:00\",\"time\":1708876800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后，傅先生马甲藏不住了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后，傅先生马甲藏不住了\",\"description\":\"孟宁被逼着去相亲，阴差阳错与京市权势滔天的傅家掌权人闪婚了。 她一直以为自己的丈夫是个无房的普通人，想着就这样平淡的过一辈子。 直到有一天，她发现了丈夫的秘密。 直到她恢复记忆，发现自己曾有个女儿。 他指着与自己相似的女儿问她：“这怎么解释？” 她一脸懵：“…不知道啊。” 他说：“看来得好好加深印象，给女儿再添个弟弟妹妹了。” 她：“……” 原来兜兜转转，还是你……\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477766,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1cgncuRpZgE9J7uEP7IIv-g?pwd=ywcu\",\"online_time\":\"2023-08-09 00:00:00\",\"time\":1691510400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后，慕总他不装了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后，慕总他不装了\",\"description\":\"一不小心在民政局门口拉了个陌生男人闪婚，却不知闪婚对象就是自己打算拒嫁的未婚夫。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484736,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1V21ac1YqqEaWJ5zL_z9qaA?pwd=unri\",\"online_time\":\"2024-04-26 00:00:00\",\"time\":1714060800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚后，豪门老公马甲藏不住\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚后，豪门老公马甲藏不住\",\"description\":\"孟宁被逼着去相亲，阴差阳错与京市权势滔天的傅家掌权人闪婚了。 她一直以为自己的丈夫是个无房的普通人，想着就这样平淡的过一辈子，丈夫也怕他的身世影响关系，藏着身份偷偷宠着孟宁。直到有一天，孟宁发现了丈夫的豪门秘密。\",\"second_cate\":\"女频闪婚甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479156,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/13OFql28e2_EHcZUkZ_ti-Q?pwd=xzu2\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚大佬竟是娃他爹\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚大佬竟是娃他爹\",\"description\":\"五年前，江迟晚被人陷害和陆铭泽一夜情，生下孩子江澜，五年后阴差阳错之下再次遇见陆铭泽。后来也知道江澜是自己的儿子，之前没有认回两人是因为家庭原因，最终在小孩江澜的助攻之下，江迟晚和陆铭泽修成正果。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486736,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1ia7epQta8azJuycyxuhXgg?pwd=b54k\",\"online_time\":\"2024-06-03 00:00:00\",\"time\":1717344000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚当天，我怀上了豪门继承人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚当天，我怀上了豪门继承人\",\"description\":\"佟桦得知要被赌鬼养父嫁给债主抵债，在陆爷爷撮合下与素未谋面的陆煜川闪婚。结果还是被养父强硬塞给债主，陆煜川将她解救出来。之后一同去医院探望陆爷爷，在并不知陆煜川真实身份情况下，两人开启同居生活。在佟桦布置下，陆煜川冰冷的家有了烟火味，但两人仍对闪婚关系略有抵触。陆爷爷为了助攻小曾孙的出世，给他们一人一杯下了药的牛奶……\",\"second_cate\":\"女频闪婚/甜宠/马甲\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482136,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1t5EywxVA2ozV8n2EYiD4xg?pwd=e8vq\",\"online_time\":\"2024-02-05 00:00:00\",\"time\":1707062400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚急诊，沈医生！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚急诊，沈医生！\",\"description\":\"实习医生林念瑶酒后误睡顶头上司沈昱珩，慌忙逃窜，却被好闺蜜夏怡冒名顶替，霸占人生。林念瑶和沈昱珩在日常相处中感情渐浓，却得知闺蜜屡次对自己痛下杀手。这次，林念瑶决定反击。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486866,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1On6f6RX15SSqdoLhIE_AdA?pwd=3dtx\",\"online_time\":\"2024-06-05 00:00:00\",\"time\":1717516800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚总裁太上头\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚总裁太上头\",\"description\":\"她是流落在外的真千金！却惨遭渣男背叛，养父母更是要将她卖给大几十岁的老男人！情急之下，她闪婚地摊小贩！谁料小贩摇身一变，成了事业有成多金帅气的总裁！从次渣男贱女，直接横推！狠毒父母，手拿把掐！夫人看不惯的人，虐！夫人喜欢的东西，买！千亿总裁，宠妻如命！\",\"second_cate\":\"女频闪婚\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481706,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1EYj_GUdHVkU0Qho6iHMQYQ?pwd=2392\",\"online_time\":\"2024-01-19 00:00:00\",\"time\":1705593600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚总裁太难缠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚总裁太难缠\",\"description\":\"凤凰男劈腿闺蜜，合伙算计黎漾，准备把她嫁给大山里的老男人！怎料黎漾接错了人，错把总裁当成老男人，接到民政局领证了，总裁将错就错，娶了黎漾，本来以为只是一场各取所需的合作，谁料两个人付出了各自的真心。\",\"second_cate\":\"女频/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488236,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1DEsLY3eMDQfYrnt-BkCHxA?pwd=nb7n\",\"online_time\":\"2024-06-25 00:00:00\",\"time\":1719244800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚总裁老公宠翻天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚总裁老公宠翻天\",\"description\":\"陆悠悠与洛景琛闪婚，洛景琛在出国之前，给陆悠悠三百万生活费。陆悠悠用洛景琛给的钱，开设了工作室。陆悠悠因业务需求，与洛景琛结识，两人误以为对方有婚姻和另一伴。直到有一天，一个人的出现彻底揭开真相。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487686,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/10zqDfG8QUsSJHSyXMk3WKw?pwd=8wag\",\"online_time\":\"2024-06-16 00:00:00\",\"time\":1718467200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚成瘾顶头上司是我老公\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚成瘾顶头上司是我老公\",\"description\":\"林舒的奶奶将林舒托付给了闺蜜老友的孙子，随后两个人面也没见过就直接闪婚上了床，之后更是独自生下了孩子带大，直到六年后林舒与顾廷修机缘巧合的再次相遇，爱上对方，最后发现自己结婚证上的人是自己爱的人。\",\"second_cate\":\"女频豪门、萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488836,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1-EKkAM-tOFNu24jAYmJYqA?pwd=rd4k\",\"online_time\":\"2024-07-05 00:00:00\",\"time\":1720108800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚热恋进行时\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚热恋进行时\",\"description\":\"黎安安被男友张维一家百般算计，黎安安愤而退婚。老邻居顾奶奶当场写下一亿八的支票，替孙子顾遇白求娶黎安安。黎安安当场表态愿意嫁给顾遇白，但条件是彩礼要给十八万，由此被顾遇白误会是个为钱出卖感情的拜金女。顾遇白无奈与黎安安领证，顾遇白使出浑身解数，只为了总裁马甲不掉。但随着相处，顾遇白发现自己误会了黎安安。一次意外让顾遇白身份暴露，黎安安生气提出离婚，顾遇白开启追妻火葬场，黎安安却为了不被同事特殊对待而提出“隐婚”，于是堂堂千亿总裁顾遇白过上了“每天求一个名分”的日子。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482006,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1UcBSdkVlrjv2P-hjBS83Mg?pwd=h8ej\",\"online_time\":\"2024-02-01 00:00:00\",\"time\":1706716800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚老公他当真了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚老公他当真了\",\"description\":\"纪念婚礼当天被男友出轨好友，并骗走了所有积蓄，急需用钱的她阴差阳错和男主谭邵廷闪婚，男主因误会女主是拜金心机女人，一直误会重重，最终在女主准备离婚之际，两人误会解除，圆满在一起。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485146,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/14TNPMPS4K_BojSpj90y93Q?pwd=e2xy\",\"online_time\":\"2024-05-11 00:00:00\",\"time\":1715356800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚老公是影帝\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚老公是影帝\",\"description\":\"落魄千金莫知意和中学同学张志明、李春娇酒吧狂欢，醉酒的莫知意电梯偶遇大明星陆栖尘，被路人拍到引发“电梯迷情”公关危机。陆栖尘为报复莫知意，买下其爸爸留下的唯一遗产别墅，让莫知意无家可归。莫知意为拿回房子，在媒体面前诬陷陆栖尘，为解决公关危机，两人契约结婚，并要求对方保密，并约定一年后离婚还其房子，婚姻期间莫知意得为有严重洁癖的陆栖尘做保姆。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483336,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1wvtuo_4o20t0rj_CO0tW9A?pwd=mjjx\",\"online_time\":\"2024-03-15 00:00:00\",\"time\":1710432000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚老公竟然是全球首富\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚老公竟然是全球首富\",\"description\":\"沐念慈本来是沐家的千金大小姐，但是在沐念慈很小的时候，父母意外去世，家道中落，沐念慈此后便寄居在舅妈王碧芳的家里，被王碧芳和她的女儿王晓霞从小欺负到大，艰难地生活。但艰难的生活并没有击垮沐念慈，反而形成了沐念慈独立自强，敢爱敢恨的性格。沐念慈一直积极努力生活，在拒绝了舅妈王碧芳强制给自己安排的结婚对象孟杰后，沐念慈转头就与完全不相识的孟言澈闪婚了。\",\"second_cate\":\"女频闪婚，甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483436,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/13GiTcKUOJ8Eki1CYY3yQaw?pwd=kmh3\",\"online_time\":\"2024-03-19 00:00:00\",\"time\":1710777600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚豪门总裁老公又宠又撩\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚豪门总裁老公又宠又撩\",\"description\":\"姜莹莹看清前男友本性分手，当场抓了个男人闪婚。没想到外表可怜小奶狗内心是阴郁变态，从高中就跟踪、偷窥她。他一边偷偷给予姜莹莹工作上帮助，一边又为姜莹莹谈恋爱而发疯。姜莹莹毫不知情“羊入虎口”。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485836,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1677RUr93Qo33NNuHg1T-Ig?pwd=3t42\",\"online_time\":\"2024-05-25 00:00:00\",\"time\":1716566400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚闪离欧小姐前夫孕吐了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚闪离欧小姐前夫孕吐了\",\"description\":\"欧千雪是中医未毕业学生。与开发商老板祁逸轩达成婚约条件。离婚后两人因醉酒一夜情，欧千雪便怀孕了。因欧千雪的怀孕，连带着祁逸轩身体产生妊娠伴随综合征。最奇怪的是，只要祁逸轩靠近欧千雪，妊娠反应就会消失。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487026,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1J6GswYj_HFkGmtsm5jCWrg?pwd=cjcs\",\"online_time\":\"2024-06-06 00:00:00\",\"time\":1717603200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚霸总放肆宠\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚霸总放肆宠\",\"description\":\"沈南夕和顾君怀闪婚结婚，，顾君怀和沈南夕被亲妈撮合圆房。之后沈南夕实习进入顾君怀公司当总裁助开启地下恋情，期间有顾君怀青梅竹马的回来，有追求沈南夕的富少卧底公司，沈南夕被老公和婆婆宠上天。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480166,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1mvsuRVGM2jdUWT8n7av4nA?pwd=84rv\",\"online_time\":\"2023-11-20 00:00:00\",\"time\":1700409600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闪婚高冷女总裁\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闪婚高冷女总裁\",\"description\":\"龙国第一战神林战天，厌倦杀戮，假死退隐恢复本名林晨，而被迫与未婚妻楚氏集团总裁楚曦月协议结婚，楚曦月却心属救命恩人林战天。之后两人经历林战神葬礼入场券、纨绔子弟追求威胁、公司副总裁争斗、恶少绑架报复等一系列事件，双方渐生情愫的故事。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482636,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1zoy90N9ksYejXtyJpw8hIw?pwd=bcgg\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闺蜜\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闺蜜\",\"description\":\"唐知夏被闺蜜和继妹联手设计，被一位神秘男子夺去清白。五年后她携子回国。一名男子声称要报答唐知夏母亲的救命之恩，面对男子的执着纠缠与闺蜜的恶毒陷害，唐知夏会如何选择，她又将如何面对这错综复杂的局面呢？\",\"second_cate\":\"女频/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488336,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1LNRM4W4TcDpu2AyVUO2R0w?pwd=7t8c\",\"online_time\":\"2024-06-27 00:00:00\",\"time\":1719417600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"闻先生的马甲又掉了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"闻先生的马甲又掉了\",\"description\":\"被渣男背叛的女总裁，点了一个男公关。两人春风一度后，开始了她逃他追的故事。\",\"second_cate\":\"女频都市甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480876,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1z61Smj5QQoTbV_9EF2Tq1w?pwd=a4sh\",\"online_time\":\"2023-12-18 00:00:00\",\"time\":1702828800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"阎王令\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"阎王令\",\"description\":\"秦峰本是阎王殿主，遭奸人陷害被女主救起，却误以为自己是被女主的姐姐所救甘做赘婿陪着女主姐姐，经历种种事情后逐渐认清真相最终和女主确定终生。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭/\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487346,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1BJSAxjuzJfcwzuxSvHA31A?pwd=urn4\",\"online_time\":\"2024-06-10 00:00:00\",\"time\":1717948800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"陆总住手吧，你虐错夫人了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"陆总住手吧，你虐错夫人了\",\"description\":\"服务生苏晚被新婚的丈夫陆宴下令折磨。身心的折磨让苏晚依稀想起自己似乎有个青梅竹马的爱恋之人，殊不知，那人就是自己的总裁丈夫！宿命的拉扯让陆宴与苏晚在生死危机后情愫暗生。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484536,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1f-aEYMigs-04ynA0hlZCfQ?pwd=4uhc\",\"online_time\":\"2024-04-18 00:00:00\",\"time\":1713369600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"陆总的长公主太有财\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"陆总的长公主太有财\",\"description\":\"一代长公主家破人亡后，竟神奇穿今，总裁老公竟然就是前世的大仇人，且看她如何在现代呼风唤雨，手刃渣男和接踵而至的白莲花。\",\"second_cate\":\"女频古穿现甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483736,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1U3VvPmJqyRzQcIViHJ0ibA?pwd=ps58\",\"online_time\":\"2024-03-24 00:00:00\",\"time\":1711209600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"陆总，夫人她罪不至死\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"陆总，夫人她罪不至死\",\"description\":\"本剧讲述了一场车祸夺走了陆霆川大哥的生命，罪魁祸首苏念瑶一直试图创造各种误会妄图拆散感情深厚的陆霆川和苏向晚两人。经过重重误会，陆霆川终于知道最后的真相，他意图找苏向晚去弥补自己的过错，可奈何苏向晚早已患上癌症生命垂危...\",\"second_cate\":\"女频都市虐恋\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479726,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1wGuXivlrP0ESxHFes5BJfQ?pwd=v3bs\",\"online_time\":\"2023-11-09 00:00:00\",\"time\":1699459200,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"陈三全的妖孽人生\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"陈三全的妖孽人生\",\"description\":\"大山出身的孤儿陈三全，为了报答那个女人，为了藏兵山山村里孩子们能继续读书，和女人做了一个约定，一定会出人头地，之后毅然决然选择离开大山，在江州，陈三全遇到了各种人和事件。他最初在城西工地工作，遭遇了工地恶霸老六的欺凌。凭借着自己的勇气和智慧，陈三全不仅成功反击老六，还获得了其他工人的尊重。后来，陈三全意外地受到了万盛房产总裁宋青莲的注意，被邀请担任她的临时保镖。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480286,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Bs5NEPPdZPveTwd8tKgVMw?pwd=fgd5\",\"online_time\":\"2023-11-23 00:00:00\",\"time\":1700668800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"隐世天骄退个婚咋这么难\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"隐世天骄退个婚咋这么难\",\"description\":\"凌月为解除婚约装成贪财女。高家内斗，凌月化解，却暴露自己并非真贪财。马婉婷为报复凌月设局陷害反被揭穿。凌月利用回归宴揭露柳家阴谋夺回母亲遗产并得知幼时绑架真相。凌月与高文浩化解误会。\",\"second_cate\":\"通用霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485886,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":19,\"material\":\"链接：https://pan.baidu.com/s/1IJhTAl9uprP0gBShB3VzXA?pwd=36on\\n提取码：36on\\n--来自百度网盘超级会员V3的分享\",\"online_time\":\"2024-05-26 00:00:00\",\"time\":1716652800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"隐世龙凤之相错亲嫁对郎\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"隐世龙凤之相错亲嫁对郎\",\"description\":\"苏雨薇作为苏氏集团大小姐被迫相亲，和顾氏集团总裁顾青云闪婚。两人互相隐瞒身份，互不暴露。产生一些啼笑皆非的故事。妹妹苏千凝绑架并且想杀害苏雨薇，最终顾青云以身犯险救下苏雨薇，最终幸福的生活在一起。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720485846,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1EYBNdr7j-R6kLhf8f9XOUw?pwd=dk55\",\"online_time\":\"2024-05-25 00:00:00\",\"time\":1716566400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"隐婚池总超甜哒\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"隐婚池总超甜哒\",\"description\":\"落魄千金江晴晴在花店兼职打工，意外救下被下药的归国公子池岱，而昏暗之下，二人没有记清彼此，只在心里种下暧昧的种子。隔日，二人被家长以娃娃亲的由头推到一起相亲，他们心里各自有人，因此对对方颇有抵触，却没有意想到，他们就是彼此的命定之人。命运纠缠中，两人何时认出彼此？相伴共生，两人能否共克外敌？\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480746,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1pfbJ1D2_N40RdoEkday0NQ?pwd=xvn5\",\"online_time\":\"2023-12-14 00:00:00\",\"time\":1702483200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"隐婚甜妻：财阀老公太会撩！\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"隐婚甜妻：财阀老公太会撩！\",\"description\":\"沈潇然被陈纯纯嘲讽又丑又穷，赌气参加为刚回国的总裁陆君恒的挑选夫人的宴会，被误认成保洁的陆君恒帮助沈潇然做造型，教沈潇然如何追总裁，沈潇然在这期间和陆君恒产生感情。宴会当天，沈潇然闪亮登场，艳压所有人，陈纯纯恼怒下欺负沈潇然，戴着面具的陆君恒为沈潇然出头，选沈潇然为总裁夫人，为沈潇然戴上戒指时遭到她的拒绝。沈潇然逃离后四处寻找陆君恒，向陆君恒表白，不想当总裁夫人了，愿意养陆君恒，一起吃苦，结果发现陆君恒就是总裁本人。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478596,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1GSOyBg--jLksFZ7IK9qyNQ?pwd=h36d\",\"online_time\":\"2023-09-21 00:00:00\",\"time\":1695225600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"隐形富豪的姐弟恋\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"隐形富豪的姐弟恋\",\"description\":\"一个全职太太被丈夫背叛后，蜕变成霸道总裁，最后嫁给了比自己小且帅的隐形富豪。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484706,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":6,\"material\":\"https://pan.baidu.com/s/1MG5ahpbGbQZUSxvpxOXF-Q?pwd=2yef\",\"online_time\":\"2024-04-25 00:00:00\",\"time\":1713974400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"隐龙天骄\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"隐龙天骄\",\"description\":\"身为圣君的丈夫林枫和身为女总裁的老婆苏清颜两人相互恩爱、但又彼此隐瞒身份，不断给到彼此意外惊喜、并联手对抗反派的故事。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484346,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1WiBpMBCCJQ7Z53-5swiH8A?pwd=7gax\",\"online_time\":\"2024-04-11 00:00:00\",\"time\":1712764800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"隐龙潜行\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"隐龙潜行\",\"description\":\"大夏战神、修罗王萧尘，隐藏身份守护体内含解毒基因的白亦彤，却遭遇了各方势力的针对，大夏与白家的安危全系在他一人身上…...\",\"second_cate\":\"男频战神、都市\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480586,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1pjhKhyHDnrlpZehX3vqt0w?pwd=3pk5\",\"online_time\":\"2023-12-07 00:00:00\",\"time\":1701878400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"雄冠天下\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"雄冠天下\",\"description\":\"八大国联合侵入，龙神出世，镇压万军。自此以后，华国雄冠天下，举世无敌。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486306,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1e6rRA3C4Ucyu7xWkBWQgjQ?pwd=9yjf\",\"online_time\":\"2024-04-25 00:00:00\",\"time\":1713974400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"雄爸崛起\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"雄爸崛起\",\"description\":\"叶冲本是首富之子，却因为被敌人刺杀差点出事被柳飘飘相救，柳飘飘又因为不想答应家族联姻，嫁给八十岁的老头，着急和叶冲结了婚。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478726,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1N8rZrvtywFrLu0RmPpMVGg?pwd=wanv\",\"online_time\":\"2023-09-25 00:00:00\",\"time\":1695571200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"雪国列车之末世存亡\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"雪国列车之末世存亡\",\"description\":\"龙神林阳带下属萧晴雪回乡相亲，登上凛冬列车，全球冰封末日恰在此时降临，凛冬列车成为了最后的诺亚方舟，十年来被恶人霸占，末端贫民饱受压迫。十年后林阳因殴打觉醒，以救世主的身份反抗压迫。\",\"second_cate\":\"男频末日/战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487306,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1F863_sQxbgEsrY8qXAfrqA?pwd=yf74\",\"online_time\":\"2024-06-09 00:00:00\",\"time\":1717862400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"震惊！我能听到皇帝的心声\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"震惊！我能听到皇帝的心声\",\"description\":\"溺水被救后，徐美人自己都懵逼了：原本她是为救父兄、才答应反派混成后宫妃子好刺杀狗皇帝的，但事儿还没成自己就差点淹死，醒来竟然能听到狗皇帝的心声了！徐美人利用‘听心声’的能力来左右狗皇帝，岂不更安全有效？此后，她凭借此能力在后宫混得风生水起，也渐渐发现狗皇帝并非表面看上去那么残暴冷血，最终，徐美人帮助皇帝携手对抗反派，解救了自己的父兄，开创了盛世！\",\"second_cate\":\"女频轻喜剧甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482296,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1NlTkpMTOrwZLGHN0kYRdDQ?pwd=ppr4\",\"online_time\":\"2024-02-09 00:00:00\",\"time\":1707408000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"霍少的闪婚新娘\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"霍少的闪婚新娘\",\"description\":\"乔霏在宾馆救助了被继母迫害的霍凌寒，二人在房间共度一夜。乔霏为救母急需医药费，霍凌寒得知后，替她支付并提出契约结婚。乔霏误以为霍凌寒是穷人，但感激他救母，同意结婚，但婚后却发现他是帝国总裁。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487536,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1zwjVYAso8epV8vxEEXYFXQ?pwd=nnec\",\"online_time\":\"2024-06-14 00:00:00\",\"time\":1718294400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"霍总那对龙凤胎和你长的很像\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"霍总那对龙凤胎和你长的很像\",\"description\":\"单亲妈妈时浅带着龙凤胎金豆和银豆返城上学，意外遇到霍景川，霍景川发现时浅是五年前和自己有过一段情的女人，于是隐藏身份，以败家子和时浅相交，期间二人经历多重波折，笑中有甜，霍景川不知不觉被时浅所吸引，而时浅也最终发现霍景川就是金豆银豆的爸爸，最后二人相爱，一家四口团团圆圆。\",\"second_cate\":\"女频现代、宝宝元素、轻喜剧\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481096,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1L81Pk5vJFkpB7a0YcGaw9g?pwd=kr25\",\"online_time\":\"2023-12-25 00:00:00\",\"time\":1703433600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"霍爷哑妻是神医\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"霍爷哑妻是神医\",\"description\":\"女主小时候被后妈欺负导致变成聋哑人，忍辱负重长大后，借机嫁入霍家，借用霍家的势力，开始复仇的道路。\",\"second_cate\":\"女频替嫁/神医/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482846,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1zpbBJqQ4XnPHSLpwxYU0Rg?pwd=pcbi\",\"online_time\":\"2024-02-29 00:00:00\",\"time\":1709136000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"霸总的攻略手册\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"霸总的攻略手册\",\"description\":\"我就是一个普普通通的报社记者而已，晋升指标即将被抢走这怎么能忍，看我以身作饵，揭开这个伪君子的真面目。却没有想到，这次任务差点把我小命玩没了。那只能攻略一个霸道总裁，带着他一起做任务了。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484336,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1dE1_7P0fIpHiUIm76bHJMg?pwd=g487\",\"online_time\":\"2024-04-11 00:00:00\",\"time\":1712764800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"霸王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"霸王\",\"description\":\"战神叶锋暗中帮助妻子林珊珊一家，没想到被林家当做赘婿抛弃。林珊珊将自己的成功归功于个人努力，并与夜城四大家族朱家公子朱鹏飞搞在了一起，妄图称霸夜城。他们不知道自己所拥有的一切都是叶锋所赐予的。\\n叶锋被逐出林家，豪门极尽贬低之能。叶锋不得不展现自己的实力，一夜之间将夜城四大家族除名。林家在朱鹏飞的欺骗下，反而将叶锋当做骗子，处处为难。在售楼处，叶锋打脸看不起人的售楼处经理和自以为是的朱鹏飞。\\n云雪集团的沈漫雪，为了报答叶锋恩情，对其不离不弃，鼎力支持。叶锋也对其仗义相助。沈漫雪做演员的闺蜜出言不逊，搬出自己的靠山，没想到被叶锋手下戳穿假身份，当场打脸。\\n\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481956,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1eHjtS65T4FXDGARgOqNu3w?pwd=j3ma\",\"online_time\":\"2024-01-31 00:00:00\",\"time\":1706630400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"霸道老公不好惹\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"霸道老公不好惹\",\"description\":\"洛暖暖因为自己的设计稿被抄袭，去希尔顿酒店找老板理论，却意外在路上救了陆云舟的母亲陆阿姨。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477916,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1JV96RTlhWEidChvex0r5oQ?pwd=yj8r复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-19 00:00:00\",\"time\":1692374400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"霹雳双娃爹地快追妈咪又跑了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"霹雳双娃爹地快追妈咪又跑了\",\"description\":\"骆倾北不幸被继妹陷害，与男主发生了一段不愉快的经历。而男主并没有记住女主的长相，使得女主在怀孕后受到了父亲的冷落，被迫前往乡下居住。男主的属下误以为继妹是女主，从而引发了一系列的误解和冲突。尽管遭遇了种种困境，女主并没有放弃希望，她在六年后带着儿子回到了国内，希望能找到失散多年的女儿。同时，女儿也在寻找真正的母亲，希望能揭开这个家庭的真相。\",\"second_cate\":\"女频萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483136,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/17qjkXvT1n8lvuZSWTCHvSA?pwd=ffrv\",\"online_time\":\"2024-03-09 00:00:00\",\"time\":1709913600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"青帝\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"青帝\",\"description\":\"仙界的青帝仙主，渡劫失败，重生回到了他21岁，大学刚毕业，被父母让他从宣县过来，来滨江市的寻找工作，暂时住在小姨家里。\",\"second_cate\":\"男频都市修仙\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479806,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/14fEAdj3-T19qjPTuabEqjA?pwd=9ru6\",\"online_time\":\"2023-11-10 00:00:00\",\"time\":1699545600,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"非凡\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"非凡\",\"description\":\"可爱粘人的贴身未婚妻，竟是杀手榜幕后大佬。\",\"second_cate\":\"女频女版战神\",\"episode\":0,\"platform\":\"\",\"update_time\":1720480276,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1tD7yTudUgQQNl3FtOdgUeA?pwd=y86a\",\"online_time\":\"2023-11-23 00:00:00\",\"time\":1700668800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"顶楼权贵之恶女复仇记\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"顶楼权贵之恶女复仇记\",\"description\":\"国产版顶楼，所有人居住在一栋高耸入云的“维纳斯之宫”，楼层越高权利越大，欲望如同深渊，让人不择手段，而我就要做这个恶女，整治这个世界！\",\"second_cate\":\"女频穿越、重生\",\"episode\":0,\"platform\":\"\",\"update_time\":1720489026,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"链接：https://pan.baidu.com/s/10LUmCdQN35ThGGZrqPB9Qg?pwd=oit9\\n提取码：oit9\\n--来自百度网盘超级会员V10的分享\",\"online_time\":\"2024-07-09 00:00:00\",\"time\":1720454400,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"顶流练习生！夫人要出道\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"顶流练习生！夫人要出道\",\"description\":\"总裁夫人叶希音隐藏身份做练习生，本想凭自己的实力出道入圈，却不想第一天报到，就遭到一直嫉妒自己的大学同学陆星瑶的打压针对。陆星瑶冒充了叶希音总裁夫人的身份，害怕叶希音抢自己的风头，叶希音看在同学一场和陆星瑶家庭困难的份上本不想与之计较，奈何陆星瑶得寸进尺、变本加厉……叶希音忍无可忍，狠狠教其怎样做人。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481546,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1xq9w4GdfkvA-2RvW96ZR8A?pwd=qp8d\",\"online_time\":\"2024-01-11 00:00:00\",\"time\":1704902400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"顾总以死相逼求复婚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"顾总以死相逼求复婚\",\"description\":\"闺蜜章彤彤想要摆脱男友顾少廷，设计下药秦蓁与男友顾少廷一夜情，事后章彤彤脱身嫁给富二代谢宇，秦蓁顾少廷两人成婚。穷小子顾少廷豪门总裁身份暴露。章彤彤心有不甘，欲抢回豪门少奶奶身份，设计引发二人矛盾误会。秦蓁心灰意冷之下不再软弱，展开反击。\",\"second_cate\":\"女频豪门总裁\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479166,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1pvQBfeUJ4inQWZQjVd7cLA?pwd=6gks\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"顾总以死相逼求复婚1\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"顾总以死相逼求复婚1\",\"description\":\"闺蜜章彤彤想要摆脱男友顾少廷，设计下药秦蓁与男友顾少廷一夜情，事后章彤彤脱身嫁给富二代谢宇，秦蓁顾少廷两人成婚。穷小子顾少廷豪门总裁身份暴露。章彤彤心有不甘，欲抢回豪门少奶奶身份，设计引发二人矛盾误会。秦蓁心灰意冷之下不再软弱，展开反击。\",\"second_cate\":\"女频豪门总裁\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479176,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1PHEuzOd6yUuF7jGiqTkFnA?pwd=ciq7\",\"online_time\":\"2023-10-13 00:00:00\",\"time\":1697126400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"顾总别宠了，夏小姐又在装柔弱了\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"顾总别宠了，夏小姐又在装柔弱了\",\"description\":\"夏浅浅前世被初恋男友欺骗，举报了深爱自己的顾铭修强暴自己，转头却被初恋男友和妹妹联手送入了地狱。重生回来后的夏浅浅，发誓要找回自己真正的爱人，顺便送那对下地狱。\",\"second_cate\":\"女频现言甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478606,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1L_VJ30QXB2PfIGUrTkkZDw?pwd=48pm\",\"online_time\":\"2023-09-21 00:00:00\",\"time\":1695225600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"顾总当戏精我是专业的\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"顾总当戏精我是专业的\",\"description\":\"耿直豪爽的财迷苏向晚为摆脱家庭的吸血，经常扮演别人指定角色赚快钱，偶然间遇见了顾氏总裁顾昀琛，而顾昀琛为摆脱催婚，雇佣苏向晚作为妻子，两人立即闪婚，本是契约关系，但两人在相处的过程中却逐渐爱上对方。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484516,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1EUvNZcq92I2avEZJeJ7MfQ?pwd=saqk\",\"online_time\":\"2024-04-18 00:00:00\",\"time\":1713369600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"顾总替嫁妹妹不好惹\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"顾总替嫁妹妹不好惹\",\"description\":\"同胞胎姐姐不堪凌辱跳楼自杀，妹妹为了调查姐姐的死因，隐瞒姐姐身亡的消息，用姐姐的身份进入姐姐的家庭和公司中进行调查。在这个过程中，和身为姐夫的男主逐渐解除误会，并产生了感情，最后共同调查出姐姐身亡的真相，让恶有恶报，同时两个人走到了一起。\",\"second_cate\":\"女频替嫁、甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480846,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1_Xe5IbCq6A3cavSDpC7zRQ?pwd=g4aw\",\"online_time\":\"2023-12-16 00:00:00\",\"time\":1702656000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"顾总的抓马女友\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"顾总的抓马女友\",\"description\":\"赵一萌被母亲逼婚，去参加一场婚礼，机缘巧合之下，她结识了破坏婚礼现场的富少顾泽风，顾泽风伪装成穷小子，引得赵一萌同情。两人因为一个契机，住到同一屋檐下，为了让对方帮助自己追求另一半，开始了互虐互助的抓马日常，最终，两人发现，对方才是自己最为喜欢的人，而他们，也看清了一直爱慕的另一半的丑恶嘴脸，在经历了反派的种种做妖之后，他俩终于携手共赴爱河。\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482506,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1tZzeeGbndbF5AifvDa3LtQ?pwd=ecad\",\"online_time\":\"2024-02-15 00:00:00\",\"time\":1707926400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"顾总的甜蜜代驾\\u0026顾总简小姐才是你心上人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"顾总的甜蜜代驾\\u0026顾总简小姐才是你心上人\",\"description\":\"简柠代驾时误与顾时宴发生关系，但之后却被闺蜜梁思乔冒领身份，梁思乔顺势成为顾时宴女友。梁思乔为攀附豪门不断陷害简柠，甚至伪造怀孕以巩固地位。但好在简柠和顾时宴识破梁思乔阴谋，最终走到一起。\",\"second_cate\":\"女频霸总/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487866,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1OyP0J8dB9Z5YM4uW01w8_w?pwd=fj67\",\"online_time\":\"2024-06-19 00:00:00\",\"time\":1718726400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"顾总的首富前妻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"顾总的首富前妻\",\"description\":\"慕雅欣被人诬陷害死丈夫顾北泽的大哥，顾母为了报仇，放火烧死慕雅欣。怀有身孕的慕雅欣死里逃生，并生下儿子慕少少。五年后，慕雅欣以“设计女皇”爱丽丝的身份强势回归，寻找当年顾大哥的死亡真相，千帆过尽，真相大白，慕雅欣与顾北泽之间的误会解开，一家三口迎来幸福生活。\",\"second_cate\":\"女频现言\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483516,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/17NJfpKiHvqYN2QTBNgUlBQ?pwd=gxww\",\"online_time\":\"2024-03-20 00:00:00\",\"time\":1710864000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"顾氏夫人马甲满天下\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"顾氏夫人马甲满天下\",\"description\":\"扮丑下山后我居然拥有了三个未婚夫？！外室生的白莲花还霸占了我的位置？！可惜他们不知道我身怀无数马甲，看我拳打南山敬老院，脚踢北海幼儿园！属于我的，我都会一件不差的拿回来！就是这三个男人...怎么还甩不掉了？！\",\"second_cate\":\"女频都市言情 马甲 团宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482166,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1kspRYGClqMdebEdyhxBvYg?pwd=jqrg\",\"online_time\":\"2024-02-06 00:00:00\",\"time\":1707148800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"顾门深深盼沉归\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"顾门深深盼沉归\",\"description\":\"影帝顾沉为救跳海女子溺水，醒来发现魂穿到了被救女子、李家三少奶奶温雨瓷身上。温雨瓷因父亲欠债才被逼嫁给李家，可婚后丈夫出轨还家暴她，她走投无路才自尽。醒来后的顾沉继承了温雨瓷的记忆，开始逆袭。\",\"second_cate\":\"女频穿越、重生\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486506,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1inPu5GxdnfVbJR4vtxRxuQ?pwd=k46f\",\"online_time\":\"2024-05-15 00:00:00\",\"time\":1715702400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"预知未来\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"预知未来\",\"description\":\"男主在工地搬砖做美梦被监工训斥时，男主意外获得超能力预知未来，预测到监工会有危险，提醒之后结果真的发生。后救下女主，从此，开启了爽意人生。\",\"second_cate\":\"男频超能力/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488856,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1p9OuuQ5DP3FW_rXSZtBepA?pwd=a36f\",\"online_time\":\"2024-07-05 00:00:00\",\"time\":1720108800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"预知梦\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"预知梦\",\"description\":\"沈清拥有预知梦的能力，梦到的事都会应验。她梦到一辆公交车爆炸全车人死亡，她决心阻止，与逃过一劫的医生李燃一拍即合，一同查找预知梦的真相，经过不懈努力，二人终于阻止灾祸拯救了全城的人。\",\"second_cate\":\"通用/其他\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488086,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1S8i4W82hzOfBxHNxcT7bGA?pwd=2jk6\",\"online_time\":\"2024-06-22 00:00:00\",\"time\":1718985600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"预知笔记本\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"预知笔记本\",\"description\":\"任子阳先被谢洋设计陷害,生意失败,欠下巨额使务,随后谢泽又上门漏迫交出任家传家宝.不曾想这传泉宝只是一本普通的笔记本任子阳因此被打成重伤,不过好在任子阳发现这本笔记本的秘密随后凭这本可以频知未来的笔记東,联手江家江璃在谢浅浅的辅助下,拍卖会夺取唐伯虎真迹, 识破苏扶影的阴阳公司寿宴上阻止谢江联姻,设计龙景林诈骗案,废弃工厂 营救江璃和谢浅浅，多次挫败谢家父子的阴谋,并在这个过程中不断成长最终任子阳重新夺回自己失去的一切.所有的罪恶也得到了应有的审判.\",\"second_cate\":\"男频金手指、反转、逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481976,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/10E6g3K56sUmsCDMGqjQ5hg?pwd=wquj\",\"online_time\":\"2024-01-31 00:00:00\",\"time\":1706630400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"领证当天，被豪门老公掐腰索吻\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"领证当天，被豪门老公掐腰索吻\",\"description\":\"林夕渺拒绝家人安排的婚约与王赫结婚，婚礼现场和王赫宣誓的时候，白月光跑来抢婚，还成功抢走了王赫，林夕渺被抢婚后大家议论纷纷。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"\",\"update_time\":1720478656,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1k38C92GO5N1_24xirSILFw?pwd=wviq\",\"online_time\":\"2023-09-25 00:00:00\",\"time\":1695571200,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"颜值就是正义吗\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"颜值就是正义吗\",\"description\":\"普通的公司女职员，因长相丑陋、愚钝笨拙，饱受同事的排挤和领导的蔑视。就在她误以为命犯桃花，被公司老总的二儿子看上的时候，才发觉一切不过是其女友用来戏耍她的诡计。不堪其辱的女主意欲跳楼自杀，却被神秘天使救下，并在他神力的帮助下获得了绝美的容貌，且看她如何利用天使机制打倒了宿敌、留下了美貌，和所爱之人走到了一起，完成了人生的逆袭。\",\"second_cate\":\"女频穿越、现代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480946,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1qbhB6AgIMOpjiDknNaKc1g?pwd=5sry\",\"online_time\":\"2023-12-20 00:00:00\",\"time\":1703001600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"风云再起1980\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"风云再起1980\",\"description\":\"陆雄白手起家，创立宏图集团，身家百亿，却在病入膏肓之际时才发现儿子并非亲生，妻子李娆也背叛了自己，反倒是真正爱着自己，并为他诞下女儿的方惠兰一生凄苦，陆雄含恨而终，重生于即将迎娶李娆的那一天，这一世，陆雄将重新崛起，给深爱他的方惠兰一个幸福美满，富足快乐的家。 \",\"second_cate\":\"男频重生年代\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482976,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1wh-8xby9tLu3DzXfunFuCQ?pwd=c2ru\",\"online_time\":\"2024-03-06 00:00:00\",\"time\":1709654400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"风暴\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"风暴\",\"description\":\"林猛一直努力工作，却有一个不靠谱的养父，还受着以王大龙为首的地痞压榨。有幸认识了江城首富的女儿徐雅琳，但不能阻止王大龙的欺负，甚至对林猛的妹妹林静起了歹心。关键时刻，林猛的亲生父亲及时出现。\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486356,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":6,\"material\":\"https://pan.baidu.com/s/1w-RcGj_nqtH4exC1c-B8Iw?pwd=nzw7\",\"online_time\":\"2024-04-30 00:00:00\",\"time\":1714406400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"风流小神医和四个绝色师姐\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"风流小神医和四个绝色师姐\",\"description\":\"神医殿被蛊王攻陷，老殿主失踪，新任殿主叶凡也因重伤失忆流落民间，却又遭未婚妻孔雪背叛跌落高楼，多重刺激下叶凡恢复记忆，但因旧伤未愈，武力值不足，处处被蛊王势力掣肘。叶凡为了找寻老殿主下落和治疗伤势，带着一纸婚约找上上官家，想借助纯阴之体疗伤，却屡陷阴谋，遭遇迫害……\",\"second_cate\":\"男频战神/小神医\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483296,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/15Ap3-KhDCKOh-g46k5oakQ?pwd=tjvc\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"风流皇太子\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"风流皇太子\",\"description\":\"不慎穿越到废柴太子身上！开局被贬！被退婚！被羞辱！没关系，看我如何强势逆袭，一统天下！\",\"second_cate\":\"男频古装穿越\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478616,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1tScB47HwDVrsn5ADM8zMsg?pwd=qbeg\",\"online_time\":\"2023-09-25 00:00:00\",\"time\":1695571200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"风起时见你\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"风起时见你\",\"description\":\"沈莫笛和霍铭泽各自相亲，都遭遇了奇葩，霍铭泽帮沈莫笛解围脱身，二人也埋下好感的种子。沈莫笛父亲重病，弟弟聋哑，但一家人互相守望，不离不弃。霍铭泽为沈莫笛的善良坚强打动，帮她解决一个又一个难题，而沈莫笛也在生活、工作上坚定地支持霍铭泽所有的决定。 两颗受伤的心被彼此温暖、救赎……\",\"second_cate\":\"女频甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481586,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":9,\"material\":\"https://pan.baidu.com/s/1Q42rmN95ERMCsuDhEDBiqg?pwd=8xtq\",\"online_time\":\"2024-01-15 00:00:00\",\"time\":1705248000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"飞虎除三害之无双大反派\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"飞虎除三害之无双大反派\",\"description\":\"男主杨飞虎穿越书中世界成为天命反派，利用金手指魔戒分别吊打神殿龙王，九龙赌王，鬼面毒医，首富继承人，剑圣等天命主角，最终粉碎反派阴谋，守护家国利益，剧情跌宕起伏，反转不断。\",\"second_cate\":\"男频都市爽文，反套路，穿书，战神，医圣\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720483816,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"https://pan.baidu.com/s/1cDlyWNe8C72pNUuMQsNbrw?pwd=97zw\",\"online_time\":\"2024-03-27 00:00:00\",\"time\":1711468800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"首富之王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"首富之王\",\"description\":\"外卖员杜霖惨遭女友背叛，上演羞辱戏码，气愤中骑着电动车穿越时空，误打误撞杀死流寇头目，被朝廷册封为大将军，到京城受封时，利用计算机打败倭国神算大师，方便面硬刚生鱼片，电动车跑败千里马，然后回到现代，变卖皇帝的赏赐发财，回古代迎娶英武女将军周允儿。\\n他掌握时空穿梭技能，在古今穿梭，互通有无，把古代名人字画、珍玩玉器，带回现代来拍卖，回程时又把化品、小家电等带到古代作为奢侈品卖给有钱人，甚至连薯条薯片汉堡的技术都传到古代，开起加盟店，赚取高额利润，积攒泼天富贵，走上人生巅峰。更因粗通历史而未卜先知，赢得众人青睐。他把曾经欺负、鄙视他的冷漠无情的亲友、咬牙切齿的仇人、趋炎附势的同学都一一打险，让曾经骑在他头上的经理转而成为他的马前卒，对他唯命是从。让曾经给他戴绿帽子的富二代赵龙倾家荡产，饱受摧残，不敢再得瑟。之前无耻给杜霖戴绿帽的水性杨花的前女友秦露，又反过来对杜霖死缠烂打，哭着喊着要复合，让杜霖不厌其烦。杜霖在现代大杀四方后，又回到古代惩治卖官鬻爵的大太监刘忠贤。流民作乱，周允儿甘愿成为人质，杜霖为营救美娇妻，也为黎民苍生，斥巨资从现代采购粮米油盐，拯救十万挣扎在死亡线上的流民，让他们安居乐业，各有所养。\",\"second_cate\":\"男频古代神豪\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479466,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1ee0Rw1J_4oSc4ose1gjCjA?pwd=xjmp\",\"online_time\":\"2023-10-27 00:00:00\",\"time\":1698336000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"首富千金离婚后飒翻豪门\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"首富千金离婚后飒翻豪门\",\"description\":\"诗南是大夏首富千金，三年前为逃婚离家出走，结果被周慕欺骗，以为周慕是自己救命恩人，隐藏身份和周慕结婚，后看清他的真面目，不再委曲自己，一路打脸渣男贱女，收获美好爱情。\",\"second_cate\":\"女频豪门、虐渣\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488806,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Cbk-IxyhkS7F1-qSBKAPDQ?pwd=3iyn\",\"online_time\":\"2024-07-04 00:00:00\",\"time\":1720022400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"首富回村\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"首富回村\",\"description\":\"已成为三江集团总裁的高飞打算回馈乡里，没成想高家村人误以为高飞是个打工仔，对其各种羞辱。高飞忍耐不住爆发，打算暴露身份打脸高家人。但高家人根本不相信高飞的真实身份，还得知弟弟被新娘家的各种羞辱，并要求提高彩礼、入赘……高飞挺身而出……\",\"second_cate\":\"男频神豪/女婿\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479846,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Khw53wDgxgkp9IifzsjeBA?pwd=rczs\",\"online_time\":\"2023-11-13 00:00:00\",\"time\":1699804800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"马甲藏不住后傅先生宠我上天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"马甲藏不住后傅先生宠我上天\",\"description\":\"孟宁阴差阳错闪婚了，有天她发现丈夫竟然是傅家掌权人傅廷修。傅廷修一直藏着身份偷偷爱着孟宁，而突然成为豪门夫人的孟宁却有些不适应，此时一个被家人凌虐的小女孩泡泡也引起了她的注意。\",\"second_cate\":\"女频/甜宠\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488106,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1rZb2LyEL5xxcNoAlCHnCAQ?pwd=i76y\",\"online_time\":\"2024-06-22 00:00:00\",\"time\":1718985600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"骆总你夫人超能打\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"骆总你夫人超能打\",\"description\":\"太子骆云显遭到三皇子骆云城的陷害被皇帝赐死，护国女将军阮软以赴死的决心去营救骆云显，结果遭到敌人暗算，古穿今到现代横店拍摄现场；醒来后发现自己竟穿越懂啊现代成为了戏子的替身，还在现代遇到了太子骆云显和三皇子骆云城.....\",\"second_cate\":\"女频穿越 都市爱情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720481046,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1Chjckd5ZdWqtyBejH9imXg?pwd=e37e\",\"online_time\":\"2023-12-22 00:00:00\",\"time\":1703174400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"高手下山五个师姐宠上天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"高手下山五个师姐宠上天\",\"description\":\"乾元山上，叶轩已经修炼八年，功参造化，师傅劝下山履行婚约，同时五位师姐早已经下山，让男主可以去找她们，叶轩回忆五位师姐，有婚要结，有仇要报，随后下山。\",\"second_cate\":\"男频高手下山\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482526,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1QMNK2PCaxfl7gb2saG1dRQ?pwd=d5ug\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"高手下山，九个未婚妻退婚\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"高手下山，九个未婚妻退婚\",\"description\":\"十年前，京城叶家被灭满门，只剩叶辰一人生还。 叶辰先天绝脉，为续命不得不留在昆仑山殿。 然…… 九封婚书的出现，彻底改变了叶辰的一生。\",\"second_cate\":\"男频高手下山\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477716,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1hIEeBcCXr_8tq8xX4veU8w?pwd=57ft\",\"online_time\":\"2023-08-15 00:00:00\",\"time\":1692028800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"高手下山，我有六个姐姐\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"高手下山，我有六个姐姐\",\"description\":\"多年前，帝都一流世家楚家被灭，楚青阳父母离奇遇害，被送到孤儿院收养，后被美女师傅带上山，并教授武学，使得楚青阳青出于蓝胜于蓝，美女师傅觉得也到了化解恩怨的时候，借着让楚青阳下山寻找六个姐姐的关系，让楚青阳化解当年恩怨。\",\"second_cate\":\"男频高手下山\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479666,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Q00dkhNgs67KXwVDodbKDg?pwd=fhz2\",\"online_time\":\"2023-11-06 00:00:00\",\"time\":1699200000,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"高攀不起\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"高攀不起\",\"description\":\"被拜金女友直播分手，成为全城笑料，却意外获得9000万亿舔狗金。\",\"second_cate\":\"男频都市\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720484106,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1mWSbXzxDL4hAiPE_DDPvlg?pwd=8j74\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"高考万岁之金榜题名\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"高考万岁之金榜题名\",\"description\":\"程序员江夏开发出了世界顶尖的人工智能系统，却被老板窃取成果并被炒了鱿鱼。江夏生气至极当场晕厥，不曾想却穿越回高三时期，发现自己成了一名学霸，这一世的江夏走上了一条与前世完全不同的道路。\",\"second_cate\":\"男频高考、重生\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720488536,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1z6MUjVfQ7ChlXrH2pBnywg?pwd=m58z\",\"online_time\":\"2024-06-29 00:00:00\",\"time\":1719590400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"高考录取之长姐为母\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"高考录取之长姐为母\",\"description\":\"王氏姐弟自幼丧母，家中贫困，姐姐将走出大山的机会让给弟弟，为了给弟弟凑学费，姐姐受尽亲戚们的屈辱和李楚生的侵犯最终将弟弟抬出了大山。王氏族人听信李楚生的挑拨，要将王雪华活祭，关键时刻王建国挺身而出。\",\"second_cate\":\"女频\",\"episode\":0,\"platform\":\"\",\"update_time\":1720488966,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":15,\"material\":\"链接：https://pan.baidu.com/s/1gQD5L4avdHwa9qxPGpPIAA?pwd=nhco\\n提取码：nhco\\n--来自百度网盘超级会员V10的分享\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"魂穿苦情女主我才不当恋爱脑\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"魂穿苦情女主我才不当恋爱脑\",\"description\":\"一朝穿越，她成了苦守寒窑十八年的王宝钏，第一天，她就丢了篮筐，这野菜，谁爱挖，谁去挖！她身怀储物空间，这寒窑，她也不守了，至于她那十年不回家的老公薛平贵，就让给代战公主吧。“西凉王携代战公主，参见皇后娘娘。”跪在大殿上的薛平贵抬头，看到坐在凤座上的女人，是被他抛弃的发妻。\",\"second_cate\":\"女频现穿古\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482776,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1CG2FRD6I8C-JWTleIkEVgg?pwd=a68y\",\"online_time\":\"2024-02-26 00:00:00\",\"time\":1708876800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"鸿蒙大帝\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"鸿蒙大帝\",\"description\":\"叶家长子叶昊，在家族血脉测试中被青梅宋雨薇陷害污为杂血被赶出家门，并被宋雨薇联合叶家次子叶修抢夺心头血，濒死之际通过母亲送于的玉佩意外传送到鸿蒙殿获得鸿蒙传承。\",\"second_cate\":\"男频战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486766,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1YC1zgf7id4qv3XSSw9q9Jw?pwd=c79f\",\"online_time\":\"2024-06-01 00:00:00\",\"time\":1717171200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"鹿死谁手\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"鹿死谁手\",\"description\":\"富家公子哥振宇携妻子馨儿在酒店给孩子办满月酒，老板为做生意隔壁安排阿伟为父亲办追思会，振宇教训欺骗自己的老板。阿伟发现馨儿就是自己深爱的女人，俩人在振宇面前诉说心声，振宇阿伟展开一场激烈争斗。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486416,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1akPwCm3N0L2XyFNIO3RcaA?pwd=wi81\",\"online_time\":\"2024-05-06 00:00:00\",\"time\":1714924800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"麒麟\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"麒麟\",\"description\":\"林风遭亲信背叛险身死，宋家小女救后收留于府中。林风能力觉醒，误以为是宋家大女宋雅妍救自己，拿出麒麟圣物并准备麒麟榜宴报恩求婚。宋雅妍联合许耀华戏耍林风和苏慕雪，林风决定让苏慕雪荣登天下麒麟之榜。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486616,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":16,\"material\":\"https://pan.baidu.com/s/1XRPn3NcB1jnLQ8P1Pjer1w?pwd=hsp8\",\"online_time\":\"2024-05-24 00:00:00\",\"time\":1716480000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"麒麟无双\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"麒麟无双\",\"description\":\"叶麟隐姓埋名送外卖五年，只为守护妻子苏清研，没想到遭苏家排挤陷入离婚危机。随后叶麟在凤鸣宴上出风头打脸苏家人。小野二郎策划阴谋，挑动各方势力对抗盛元会。叶麟买下传国玉玺，逆转局势，击败小野二郎。\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487466,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/18zpXDrBBaVAWCugmwEIuCw?pwd=hzfb\",\"online_time\":\"2024-06-13 00:00:00\",\"time\":1718208000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"麒麟王\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"麒麟王\",\"description\":\"本故事讲述了一个本来被众人瞧不起的平凡人物沈麒麟，五年前外出征战，为星国立下赫赫战功。五年后，当成为麒麟王的沈麒麟荣耀归来，先被未婚妻退婚，又被众人嘲讽，历经折辱，又如何让从前瞧不起他的人畏惧臣服、并俘获美人心的故事。\",\"second_cate\":\"男频战神、都市、情感\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483466,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1CkVLuFzOLjUIDyb0dMp4tQ?pwd=e21m\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"麒麟臂\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"麒麟臂\",\"description\":\"讲述了神界至尊洛枫，遭师兄叶扬暗算陨落至下修界，附体同名少年，从而开始了重返神界、复仇与一统下修界的传奇故事。在下修界借残魂苏醒的洛枫，决心重获麒麟臂报仇雪恨。在一系列的修炼和战斗中，洛枫逐渐展现出超凡实力，收复了下修界一众势力，并与天真浪漫的师妹江曼相互爱慕。最终，洛枫开启天门重返神界，与叶扬进行了一场惊天动地的决战。并用下修界悟出的全新拳法—麒麟拳第四式“吞天”成功获胜。\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486896,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/13-puEzGZvNGlpVSwWM7KqA?pwd=bna4\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"麒麟赘婿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"麒麟赘婿\",\"description\":\"五年前，他被妻子背叛，被挖双肾，弃尸荒野。五年后，他的妻子沈傲雪已是身价百亿的女总裁。就在沈傲雪公司上市的那天，叶辰强势归来！\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479426,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1f3lpGyOkLoUwrJUvw0HvCw?pwd=fufi\",\"online_time\":\"2023-10-24 00:00:00\",\"time\":1698076800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"麻雀千金\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"麻雀千金\",\"description\":\"千金小姐被偷偷调换，二十年后卷土重来，被亲妈认出，喜提养子未婚夫，打脸团宠假千金。\",\"second_cate\":\"女频霸总/甜宠/团宠/萌宝\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720486496,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/1Ovl8eYob7PSkkDeDcNPNVA?pwd=kfrb\",\"online_time\":\"2024-05-14 00:00:00\",\"time\":1715616000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"黎总的替嫁娇妻路太野\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"黎总的替嫁娇妻路太野\",\"description\":\"黎景夜以为萧安悦姐姐是自己的救命恩人，不顾一切要娶她，姐姐却以为黎景夜身世普通不想嫁。为了自己办的流浪动物救助站能够维持下去，萧安悦代替自己的姐姐嫁给了黎景夜，新婚当天黎景夜离开，一走就是三年，三年后黎景夜回归却和萧安悦一直阴差阳错没有遇见。萧安悦为了挣钱意外成为黎景夜的私人医生，两人逐渐熟络起来后黎景夜发现萧安悦原来就是自己的新婚妻子，黎景夜对萧安悦更加宠爱，这一切被姐姐看在眼里十分嫉妒，姐姐得知黎景夜是首富想和萧安悦换回来，并在黎景夜向萧安悦求婚的当天揭开二人身份，黎景夜误会萧安悦，以为姐姐就是自己的救命恩人，和萧安悦分开与姐姐在一起，但经过一系列纠葛后，黎景夜发现自己的救命恩人竟然是萧安悦，由此重新追求萧安悦和萧安悦在一起。\",\"second_cate\":\"女频言情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480186,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/13tycy5VboP6KzHTsvuS0sQ?pwd=uxys\",\"online_time\":\"2023-11-20 00:00:00\",\"time\":1700409600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"黑化女神的逆袭之路\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"黑化女神的逆袭之路\",\"description\":\"刚接到怀孕的消息，准备告知丈夫，方妍却撞见丈夫许峰、闺蜜艾丽私会，被丈夫、闺 蜜联手算计，抛尸荒野。 负责抛尸的两个人见方妍还有一口气，留手放了方妍一马。逃出荒野的方妍意外遇见权贵贺瑾风。贺瑾风欣赏方妍的才能和韧性，决定帮其报仇， 但前提是方妍从此成为自己下属，帮助自己对付季氏集团总裁季泽宇。方妍被仇恨蒙蔽，报仇心切，答应贺瑾风并与其签下赌约，成为贺瑾风的棋子，凭借贺瑾风势力，搭上季氏集团总裁季泽宇，开始逆袭人生！\",\"second_cate\":\"女频复仇\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479566,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1U3F2-rjQ-_vaXPcZFidEGA?pwd=tt69\",\"online_time\":\"2023-11-02 00:00:00\",\"time\":1698854400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"黑暗里的一束光之妈妈的爱\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"黑暗里的一束光之妈妈的爱\",\"description\":\"五岁瞎眼女孩张萌，十二年前被父亲张磊卖给人贩子，母亲王淑芬怒将张磊打伤逃走。十二年后，王淑芬偶然遇到改名为李萌的张萌。王淑芬通过胎记认出自己亲生女儿。二人互相保护对方，共同承担一切。\",\"second_cate\":\"女频亲情\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720486256,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/1JTbDr4MqPBUnXUwAi-dEuQ?pwd=p64k\",\"online_time\":\"2024-05-31 00:00:00\",\"time\":1717084800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"黜龙\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"黜龙\",\"description\":\"他是镇守边疆的夜天子，统兵百万，护国数载，剿灭北莽时却被暗算，成了顾家的傻子女婿，两年之后，封印解除，战神强势回归，什么顶级家族，什么四大豪门，都是弹指可灭的蝼蚁……\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482436,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/10P8aNlfPJ0TugLMdCrIlUQ?pwd=4u66\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"齐天\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"齐天\",\"description\":\"在惊天动地的一战中，龙国至尊叶天行遭到最亲密之人的陷害，命悬一线。临死前，他得知女儿仍在世间。他的无限悔恨激起了他内心深处的力量。面对复杂的国家背叛阴谋，他踏上了一段救赎之旅，寻找妻子，拯救女儿。在这场生死较量中，叶天行如何揭开背叛之谜，挫败深层阴谋，保护家族荣耀？加入他的战斗，见证一场家族荣誉和国家忠诚的终极考验。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480126,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1uTZWwQAPIFDAJvEGtSOYUA?pwd=s4f3\",\"online_time\":\"2023-11-19 00:00:00\",\"time\":1700323200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙临\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙临\",\"description\":\"大夏鬼面龙帅齐飞失忆送外卖，在酒店无意中撞破妻子袁欢跟黄万盛的奸情，争执之下被花瓶砸破了脑袋，他重新恢复了记忆，还找到小时候对自己有救命之恩的林若溪，知道林若溪要被林家高聘礼卖出去后，齐飞带着起死回生丹和万亿项目抢亲，最终把林若溪抢回到身边，齐飞还帮着林若溪对付想要吞并帝豪集团的高家姐弟。在斗争中，齐飞不仅帮林若溪一一挫败敌人算计，还发现背后支持高家的幕后黑手，那就是想要吞并各大世家和鬼面铁骑的萧天霸，在王侯宴和镇敌宴的最后较量中，齐飞现身，击败萧天霸赢得最后胜利，还当众向林若溪求婚，让林若溪成为全城最漂亮最幸福的女人。\",\"second_cate\":\"男频战神/女婿\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720479546,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1FewWexqS7QZwux_vO4-6Fg?pwd=nf1k\",\"online_time\":\"2023-11-02 00:00:00\",\"time\":1698854400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙临五洲\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙临五洲\",\"description\":\"五洲之主凌羽收集散落世间的龙珠，在此之时传来帝都云家逼婚凌羽的未婚妻裴雨嫣的消息，凌羽火速赶往帝都，目的正是保护裴雨嫣，收回三枚龙珠，此外向云家复仇。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720477956,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Hd98qO970hIz3ciAOHxMzA?pwd=ew2b复制这段内容后打开百度网盘手机App，操作更方便哦\",\"online_time\":\"2023-08-24 00:00:00\",\"time\":1692806400,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙主至尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙主至尊\",\"description\":\"天朝至尊龙主在路边接客偶然帮助了韩雪依，三年间韩雪依成为大明星、一手打拼出韩氏集团，却被母亲、姐姐弟弟侵占，三年后归来的林近枫，迎娶韩雪依，帮助落难的韩雪依恢复事业，同时不断打脸忘恩负义的众人。\",\"second_cate\":\"男频现代/鉴宝/超能力/系统\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720487086,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":6,\"material\":\"https://pan.baidu.com/s/1b6NlqYUbGu4H1Y0J4xe2cw?pwd=c58n\",\"online_time\":\"2024-06-07 00:00:00\",\"time\":1717689600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙争虎斗\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙争虎斗\",\"description\":\"身为高级黑客的徐氏集团私生子徐家三少徐清华（男一）突然现身，引发各方势力蠢蠢欲动，大哥和二姐为了各自目的皆欲置其于死地，宫氏集团总裁宫雪（女一）为了报恩极力保护男主，其他势力该如何站队？各个财阀的角逐在海城上演，一场关于利益争夺、正邪较量、人性考验的大戏拉开序幕。\",\"second_cate\":\"男频都市/爽文\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484026,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":7,\"material\":\"https://pan.baidu.com/s/1Z-rcuwPcJu_o3s7Ex85ACQ?pwd=ttxc\",\"online_time\":\"2024-04-01 00:00:00\",\"time\":1711900800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙头棍之谁主沉浮\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙头棍之谁主沉浮\",\"description\":\"陆天野与陈文泽来海城发展，卷入洪山堂和龙虎会的纷争。陆天野智斗龙虎会，联手段一山除内奸并加入洪山堂。在沈玉锦和洪山堂众人帮助下，揭露陈文泽与近藤阴谋，陈文泽幡然醒悟选择与近藤同归于尽。\",\"second_cate\":\"男频民国（非穿越、重生）\",\"episode\":0,\"platform\":\"\",\"update_time\":1720487386,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1UKcGss6LCrGcNFDn_Qh78A?pwd=shbd\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙尊\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙尊\",\"description\":\"十年前，他被灭满门，十年后他成了秩序顶端的男人！他为了突破天人之境，只身独闯缅北。所有人都以为战神已死之时，他涅槃重生！当年失去的，他要百倍奉还！\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"\",\"update_time\":1720479676,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1y5ao0CgmqqYiZn64A-PdJw?pwd=38hu\",\"online_time\":\"2023-11-08 00:00:00\",\"time\":1699372800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙尊驾临\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙尊驾临\",\"description\":\"当了三年杀猪佬的天龙帝尊楚天，神功大成再度出山之际，却被妻子白胜雪离婚，楚天看透白胜雪，也发现自己报错了恩，多年前救他一命的其实是杨飞雪。而此时，杨飞雪正在被竞拍……\",\"second_cate\":\"男频都市战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478366,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/155bwCg5Qrabmr2ssLCXLbQ?pwd=44cc\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙帝的女人\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙帝的女人\",\"description\":\"男主隐藏身份，在追妻宠女的过程中，打脸各路反派.\",\"second_cate\":\"男频\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720482046,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":12,\"material\":\"https://pan.baidu.com/s/13rUnxlKroqTDnPcXHW8TTw?pwd=51c7\",\"online_time\":\"2024-02-04 00:00:00\",\"time\":1706976000,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙归\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙归\",\"description\":\"陈潇因为守护边境，打击走私集团而身受重伤，被云州宋家女总裁宋轻歌所救。却因为重伤导致了身体受损，双目失明，不得不暂时隐藏身份。陈潇与宋轻歌日久生情，结成夫妻。在宋轻歌的安排下，陈潇成为了一名盲人按摩师。在隐藏身份的过程中，陈潇暗中收集珍稀药材恢复实力，治疗眼睛。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720480356,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1LFE3W3zTJRzbs6He3TNLyA?pwd=mres\",\"online_time\":\"2023-11-24 00:00:00\",\"time\":1700755200,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙归令\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙归令\",\"description\":\"武术世家长子苗天羽因其独门秘术惨被灭门妻女被俘，老天医翁然拯救其性命并授于医术武术，5年期限已到，苗天羽下山势必调查清楚当年苗家被灭门之灾的凶手，夺回属于自己的一切。\",\"second_cate\":\"男频战神\",\"episode\":0,\"platform\":\"\",\"update_time\":1720483626,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/157kTnpZ629kjiOp6klea4w?pwd=xs5w\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙爸无双\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙爸无双\",\"description\":\"万言风本是首富万家大少爷，因被人陷害流落民间，入赘叶家，没想到女儿在学校竟被外国小孩欺负。\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720478446,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1Zhi9MjGb_7bDwqtFTfRhkQ?pwd=qejg\",\"online_time\":\"2023-09-11 00:00:00\",\"time\":1694361600,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙王殿\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙王殿\",\"description\":\"龙王殿殿主萧阳闭关五百年期间，其在人界的分身成为叶家赘婿。在萧阳出关之前一天离奇饿死。萧阳当即前往人界收回分身，意外和叶云舒绑定婚契，只有叶云舒亲自解除婚约才能解除这段因果。萧阳本尊降临人界，面对昔日欺辱过他的人，一一报复回去。\",\"second_cate\":\"男频战神都市\",\"episode\":0,\"platform\":\"\",\"update_time\":1720478516,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":0,\"material\":\"https://pan.baidu.com/s/1PyFstMJyaJW9RSy9R_z4Fg?pwd=rsuq\",\"online_time\":\"2023-09-14 00:00:00\",\"time\":1694620800,\"is_close\":1,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙虎兄弟\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙虎兄弟\",\"description\":\"原是低调的龙帮老大，十年前江城中只手遮天，因亲哥哥被人杀死后自己又遭人陷害，入狱十年，但是由于位高权重在监狱里颇有威望，三方黑白权道上都要给李霄龙面子，李霄龙出来后本想过着普通人的生活，结果回到家发现母亲已经上吊，妻子不见…\",\"second_cate\":\"男频战神/兄弟情\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483016,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":14,\"material\":\"https://pan.baidu.com/s/1oNVMvZkuxm4XllOnVHDW3g?pwd=abmi\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙蛇起陆\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙蛇起陆\",\"description\":\"三年前我齐牧被陷害入狱，未婚妻背叛甘愿沦为权贵的玩物，父亲被豪门活活殴死，而我在监狱苦受折磨，好在天道轮回，无敌人间一甲子的叶无道收我为徒，传我内功，助我锄尽人间不平事。强拆我家？灭！强娶至亲？屠！一介草民齐牧今日必砸断权贵脊梁！\",\"second_cate\":\"男频都市、战神\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720483696,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":8,\"material\":\"https://pan.baidu.com/s/1W_EudBmroYWeEVzskPro0A?pwd=fuvv\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙行天下\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙行天下\",\"description\":\"痴呆的秦阳，一心只想照顾好自己的儿子。却被儿子百般嫌弃，一次机缘巧合之下，他竟然发现，妻子和他人有染，儿子也不是自己的。激愤难忍的他，上前理论，却被百般羞辱，最终被人推下楼去，却因此恢复了所有记忆，原来他的真实身份是....\",\"second_cate\":\"男频逆袭\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482416,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":10,\"material\":\"https://pan.baidu.com/s/1azFxBu7JfV14KnLrCnYxXw?pwd=71jv\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙迹之城英雄崛起\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙迹之城英雄崛起\",\"description\":\"传奇游戏入侵现实，怪物肆虐人间，秩序瞬间崩塌，人命如草芥。但是，有一群传奇玩家却继承了游戏中的属性和能力，成为了玛法大陆金字塔顶端的存在。男主角高成前世经历巨变遗憾身死，无意中重生回到巨变前三天。这一次，他发誓要用尽所能将游戏等级拉满，弥补前世遗憾，重建人类秩序。原本只是一个人的传奇之路，遇到不同人之后正式重启，但这段传奇之路到底是确有此事还是……\",\"second_cate\":\"男频传奇游戏+战神+重生+末日\",\"episode\":0,\"platform\":\"kuaishou\",\"update_time\":1720482456,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":11,\"material\":\"https://pan.baidu.com/s/1339wEdGdLm-NAWrr9JWj8A?pwd=j9pm\",\"online_time\":\"0001-01-01 00:00:00\",\"time\":-62135596800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"},\"龙驭九霄\":{\"id\":0,\"is_hot\":0,\"appid\":\"qr_48262ecc1ede61d20d3926650ccf5d0c\",\"first_cate\":\"video\",\"type\":\"bihai\",\"title\":\"龙驭九霄\",\"description\":\"九霄神尊被陷害惨死狱中，转世重生到5年前的婚礼现场，从此逆天改命灭掉阳城各大家族势力，最终发现大boss竟然是自己的亲弟弟...\",\"second_cate\":\"男频赘婿/兵王/战神/逆袭\",\"episode\":0,\"platform\":\"tikTok,kuaishou\",\"update_time\":1720484456,\"image_url\":\"\",\"is_end\":0,\"pay_episode\":13,\"material\":\"https://pan.baidu.com/s/19-1jSS6_FFeH8fnO3hY7FA?pwd=3fh9\",\"online_time\":\"2024-04-16 00:00:00\",\"time\":1713196800,\"is_close\":0,\"key\":\"deda72066ac1aacfa3e345e21e361227\"}}"

	imgs := make(map[string]string, 0)
	imgs1 := make([]string, 0)
	//imgList := []string{
	//	"660b9bfa154ee.png",
	//	"660cbf0d46c84.jpg",
	//	"66039e6854992.jpg",
	//	"65fce30c99a8e.jpg",
	//	"660a69a9ab8cb.jpg",
	//	"6614cd227a117.jpg",
	//	"6613ac7c0aab6.jpg",
	//	"660e0d7413fbf.jpg",
	//	"660d0b144e56e.jpg",
	//	"660bd7b804357.png",
	//	"660bb145745fd.jpg",
	//	"65fce4a950b82.jpg",
	//	"660cb32b203bb.jpg",
	//	"660cbc683779a.jpg",
	//	"660bb6d5b24c0.jpg",
	//	"660b70ff892f3.jpg",
	//	"660a65413d3d6.jpg",
	//	"6606412652a6f.jpg",
	//	"6606230b515ea.jpg",
	//	"6603e86ab2665.jpg",
	//	"66013488521e3.jpg",
	//	"65fd528d2782c.jpg",
	//	"66054109b3dc3.png",
	//	"66052d7ac8b8b.jpg",
	//	"6603c3d58e8d1.jpg",
	//	"66038282c0744.jpg",
	//	"660291dd5cf0f.jpg",
	//	"660270ea0db06.jpg",
	//	"6602554716c04.jpg",
	//	"66024b84bf58e.jpg",
	//	"660246981a83b.jpg",
	//	"6601535c3ba1d.jpg",
	//	"66011db58fbc5.jpg",
	//	"65fd039846e14.jpg",
	//	"66050ddeced6f.jpg",
	//	"66023881349bf.jpg",
	//	"660513a29a73b.jpg",
	//	"66023b53d1ae1.jpg",
	//	"65e7d873d2927.jpg",
	//	"66067ed42993a.jpg",
	//	"660677d198505.jpg",
	//	"66065dd484d47.jpg",
	//	"6606428b0ab76.jpg",
	//	"66067a059c56a.jpg", "65a5198f0dcba.jpg", "65a6041eccecf.jpg", "65a6428c0c42e.jpg", "65a78586b1de9.jpeg", "65a889249e2b9.jpg", "65aa8d764ab63.jpg", "65aa918fba6b7.jpg", "65add82fddca6.jpg", "65adfcfe3ea0b.jpg", "65ae20b676537.jpg", "65af2a6f97e2b.jpg", "65b0dc206b39b.jpg", "65b6ff9ac347d.jpg", "65b8a83f9419f.jpg", "65b8b6e72b661.jpg", "65b9b0b1589de.jpg", "65b9c833923b5.jpg", "65b9cfc556de1.jpg", "65b9d3bb16933.jpg", "65b9eca6899a8.jpg", "65b9ed4301dce.png", "65b9f5ac1dbf7.jpg", "65b30cd05dbf7.jpg", "65b38dc9c7056.jpg", "65b39b334f684.jpg", "65b73ad816e6b.jpg", "65b75f701cdf0.jpg", "65b87b7386fb4.jpg", "65b318c2c4b60.jpg", "65b777fcf2258.png", "65b869fd5a875.jpg", "65b3442d933d7.jpg", "65b3741d4fab3.jpg", "65b7111da6fa2.png", "65b7727f225db.jpg", "65b8559cc1875.jpg", "65b8748e2b282.jpg", "65b329558e276.jpg", "65ba18ba2e191.jpg", "65bafc1116ad5.jpg", "65bb1c36f1181.jpg", "65bb5a3060134.jpg", "65bb1689a7589.jpg", "65bb58009d5a3.jpg", "65bc4b5e0f1a5.jpg", "65bc5bc887a15.jpg", "65bc616e7da15.jpg", "65bc75625cff3.jpg", "65bc496220fb6.jpg", "65bc551491f30.jpg", "65bef2af6b614.jpg", "65befcb283404.jpg", "65bf3f68baa06.jpg", "65bf4cfe152b5.jpg", "65bf5fb3485f5.jpg", "65bf31cc057ad.jpg", "65bf110e64a77.jpg", "65bf228ad3780.jpg", "65bf568cd7155.jpg", "65bf210488061.jpg", "65c0ae5c1cdd1.jpg", "65c1d9e641984.jpg", "65c2e5a21d73b.jpg", "65c2ef74e9753.jpg", "65c2f5f4ebbab.jpg", "65c2f6d4e6634.jpg", "65c2f567b766c.jpg", "65c2f343967f4.jpg", "65c30f76b752c.jpg", "65c31ed3c815a.jpg", "65c041ed93823.jpg", "65c066f754b6c.jpg", "65c072fab7991.jpg", "65c04847d50f8.jpg", "65c3046508f90.jpg", "642d1ecf0ea94.jpg", "642da83d1a820.png", "644a1845e7b5b.jpeg", "644a17729c368.jpeg", "644b4a64c3a44.jpg", "645b2e4adc72c.png", "646c8c8864878.png", "649bd41f925c0.png", "649e893c975d0.jpg", "649e9824bee88.jpg", "650a4f5ad03fe.jpeg", "650bf8d29ba88.jpg", "650ec56cde3e5.jpg", "650f0800d9237.png", "652c988c44eb4.jpg", "652cffe1279cc.jpg", "652d0b27d8b06.jpg", "652d2fc44556c.jpg", "652e2eafce6f0.jpg", "652e5b943f134.jpg", "652e477d9a9ac.jpg", "652f9d5691b4d.png", "652f954b3b25e.jpg", "652fa3a57036a.jpg", "652fad6170c04.jpg", "653a0a3bbf80d.jpg", "653d13f027b0c.jpg", "653eee6d1847d.jpg", "653f0de90f67c.jpg", "653f6dce8b12f.jpeg", "653f16ed1839d.jpg", "653f62a4a094d.jpg", "653f711b6b49c.jpg", "653f5009e5d0e.jpg", "653f76442308e.jpg", "654da980047f1.jpg", "654daa4c8a9b7.jpg", "654daaa5576f5.jpg", "654df6b34bb6b.jpg", "654dffb3d78d4.jpg", "654e0c13486ab.jpg", "655b3afa45ac4.jpg", "655b020f02e01.jpg", "655c636aec3db.jpg", "655c642e57a0d.jpg", "655db1434555c.jpg", "655dc6dca2418.jpg", "655ddeb6e723c.jpg", "655ecd1ba910e.jpg", "655ed85cbf575.jpg", "655ed225d4b3f.jpg", "655ee0b09b4e9.jpg", "655ef7d6523ba.jpg", "655efd7a2f847.jpg", "655efe250b879.jpg", "656d4f72a5d23.jpg", "656d7f7133e20.jpg", "656d8e9e21326.jpeg", "656d8ee8ccf69.jpeg", "656d8f4b545af.jpeg", "656d9b840442c.jpg", "656d72f456437.jpg", "656d648fa88bc.jpg", "656d859d3b575.jpg", "656d5165b19d1.jpg", "656e9a613ebec.jpg", "656e93d059d3d.jpg", "656e991cb0847.jpg", "656ea33ce440c.jpg", "656ea455a3ac2.jpg", "656edb8a1c925.jpg", "656fde1358200.jpg", "656ff2bfd55ae.jpg", "657aa20a0311f.jpg", "657aac620e017.jpg", "657ad6885b791.jpg", "657aded123350.jpg", "657c1baa65793.jpg", "657c2c6ece9e0.jpg", "657c474e548ee.jpg", "657c768915207.jpg", "657fbc62e646a.jpg", "657fc54323352.jpg", "657feacf2dd5f.jpg", "657fecbb38b70.jpg", "657feeaf22b7a.jpg", "658a4f308a6a6.jpg", "658a8bf42cd38.jpg", "658a8c44d3088.jpg", "658a8cf75969d.jpg", "658a80c5ee5ae.jpg", "658b9c962e62a.jpg", "658b970481b43.jpg", "658bc8609b74c.jpg", "658c08ca2116a.jpg", "658c388e771dd.jpg", "658d1d4f6ad40.jpg", "658d29a69a3be.jpg", "658e2a37ac031.jpg", "658e52f491bc0.jpg", "659b7d9988c83.jpg", "659bbc0a3fe4e.jpg", "659cb174655d7.jpg", "659dfc1936c90.jpg", "659e0e233676d.jpg", "659f5b695ec87.jpg", "6422a13a3a4d8.jpg", "6487de492fb3f.jpg", "6492ad69746a5.png", "6492d24c2b590.png", "6492d2683387f.jpg", "6492d24291689.png", "6507d324aa07d.jpg", "6507f2f722f26.jpg", "6513ed97695d7.jpg", "6513f8b90c82f.png", "6524cd2cf381a.jpg", "6524dedaa60d7.jpg", "6530a0a91d64f.jpg", "6530b52993bc0.jpg", "6530c1aac7499.jpg", "6530d8b489a0f.jpeg", "6530e3c6bea85.jpg", "6530e0169819c.jpg", "6530ea4d1c5a8.jpg", "6530f9f9f3bd3.jpg", "6530f85f02d30.jpg", "6530f94360358.jpg", "6538a22748113.jpg", "6538b6189330d.jpg", "6538d27fd6c6d.jpg", "6538d17620f29.jpg", "6538dda4a8975.jpg", "6538de1d6b1f9.jpg", "6538de46eb374.jpg", "6538de69dde43.jpg", "6540ae05c6175.jpg", "6540bae2c9aef.jpeg", "6541f8de2d7eb.jpg", "6541f64639ebd.jpg", "6548bd40eda6a.jpg", "6549a80ba0b20.jpg", "6551d6c9e50ef.jpg", "6555d4901c38d.jpg", "6556f45585b36.jpg", "6566c9f0e882d.jpg", "6567eafc95557.jpg", "6572ccdb526b8.jpg", "6572cd26eea9b.jpg", "6572e733a0bfd.jpg", "6576cc6c62098.jpg", "6576ccf219121.jpg", "6576e5d265349.jpg", "6576e56e3ffbf.jpg", "6577c6ff55741.jpg", "6582a9dcab8e0.jpg", "6582a9ea18efb.jpg", "6582c44c56966.jpg", "6583b4fc8cd0b.jpg", "6588f6883114f.jpg", "6593d6160c4ee.jpg", "6594e260deb65.jpg", "64461f1ae9d2b.jpg", "64491d446c42a.jpg", "64491dc097d4d.jpg", "64678d450fa9e.jpg", "64814a4c371ca.jpeg", "64893a7ea3922.jpg", "64896bf90356c.jpg", "64911aa827fef.png", "65000fa17e995.jpg", "65011e632d878.jpg", "65042e2a67295.jpg", "65110b42a72d4.jpg", "65114aa6d3a00.jpg", "65127cd37bd5c.jpg", "65223bf464aa3.jpg", "65225f0d58dac.jpg", "65253bff9267f.jpg", "65263f91c0b27.jpg", "65275f745040f.jpg", "65279b075fb09.jpg", "65323dc42ed16.jpg", "65362cd6d51c4.jpg", "65389dcebd5e0.jpg", "65406baf30a93.jpg", "65407f9b0f514.jpg", "65431f99c0f67.jpg", "65432b2675fb8.jpg", "65435c86b10f3.jpg", "65485f87ed3e0.jpeg", "65489d67850e0.jpg", "65531e64bcbb0.jpg", "65531e74530ef.jpg", "65543d37caa40.jpg", "65549ad6757e4.jpg", "65558ad2206af.jpg", "65605a0848b42.jpg", "65696fdd13705.jpg", "65698c37660b7.jpg", "65780bb4542fb.jpg", "65781cddd77c0.jpg", "65781d217457b.jpg", "65782d542d76f.png", "65795a5dad1eb.jpg", "65796a775b5b7.jpg", "65810a1dc1c49.jpg", "65810ad810e9f.jpg", "65810b527b9c3.jpg", "65853bf4a40bb.jpg", "65853efd19b50.png", "65857a3395571.jpg", "65869cc6c1d8a.png", "65894baf1b260.jpg", "65967f4c14529.jpg", "65968f764d31c.png", "65976b440305d.jpg", "65977e9892553.jpg", "638867df2ae2a.jpg", "643914cb6370b.png", "644499f916726.jpeg", "644626f508999.jpg", "650808dead1eb.png", "650901da459f4.jpg", "651150e2b5883.jpg", "651404e443be0.jpg", "651593f9a8802.jpg", "652278b4c196f.jpg", "652364d3c40a2.jpg", "652524c7509f1.jpg", "652780a27b2cc.jpg", "653251b04f1e6.jpg", "653736ed118bb.jpg", "653748fa6b17a.jpg", "654311b5c0821.jpg", "655198d547aeb.jpg", "655328f361222.jpg", "655497b1222c9.jpg", "656026a3b5b83.jpg", "656418e2e26e5.jpg", "656470f814fb8.jpg", "656571de9f910.jpg", "658110ddccad0.png", "658257d20a91c.png", "658268e76cbb1.jpg", "658269f95de70.jpg", "658511f288bf6.jpg", "658537ce0e243.jpg", "658538a00cf49.jpg", "658569b13b412.jpg", "658922ff925b3.jpg", "658947f5c86ac.jpg", "659516ac162d4.jpg", "659545c555614.jpg", "6512634e9b125.jpg", "6515008f92a76.jpg", "6515014ddccfd.jpg", "6521224f13216.jpg", "6522173a40b63.jpg", "6522241b055ad.jpg", "6525212c3dcb2.jpg", "6540873adc7ed.jpg", "6542241e4f010.jpeg", "6543231fc8c57.jpg", "6553291d93fe0.jpg", "6557184a6b2d1.jpg", "6564683f56189.jpg", "6564709d38e3b.jpg", "6582920c73698.jpg", "6585320a9201f.jpg", "6595492b6c603.jpg", "6596171b55a6f.jpg", "6597840ad809a.jpg", "64897789e7694.jpg", "65155617c11f1.jpg", "65238043ab6f4.jpg", "65252484b39f3.jpg", "65431042a4994.jpg", "65431750a7ed8.jpg", "65436059dbb6d.jpg", "65811129bed0a.jpg", "65826821c4dbf.jpg", "65827003c4884.jpg", "65964820d0c9b.jpg", "652126745cf46.jpg", "652640291fc2e.jpg", "652644408d85f.png", "654370736cfe4.jpg", "655323858c4a7.jpg", "656441786fa3a.jpg", "656714842ab5c.jpg", "657811858cd64.jpg", "658557103ac42.jpg", "658922652c92e.jpg", "6570042792baa.jpg", "6570336228f27.jpeg", "6578078359e83.jpg", "6578091436dec.jpg", "6592605141cb2.jpg", "65365344692ec.jpg", "65671412968c3.jpg", "649106829546d.jpg", "651054233580a.jpg", "653615380212f.jpg", "656832506472b.jpg", "6511521156036.jpg", "6522511134904.jpg", "63edfd0dae958.jpg", "63ee0af0cf149.jpg", "63f312a3563f9.jpg", "64a3e4f9c34a3.jpg", "64a4d955c3971.jpg", "64a4e6e07b09b.jpg", "64a29e20d5c8f.jpg", "64a29f037c74d.jpg", "64a29fa1be3cb.jpg", "64a62a5c9525c.png", "64a78c4082219.jpg", "64a687dce796c.png", "64a52927e9334.jpg", "64ab9407cec30.jpg", "64ab748568fa1.jpg", "64ae31d39982a.png", "64af6cc64ed5a.jpg", "64afa2d3223eb.jpg", "64b0ff9f92720.jpg", "64b4d4a30d1bb.jpg", "64b9f0bac7bc2.jpg", "64ba59c062043.jpg", "64be44edbc70b.jpeg", "64bf40a229711.jpg", "64c20e0b3d5fd.jpeg", "64c39cddac3de.jpg", "64c788933f092.jpg", "64cb13d8a5559.png", "64cc9fdf14cf6.jpg", "64cca9b2c6a4d.jpg", "64ccb0cd4ede7.png", "64ccc7c65b7b1.png", "64ce2f523d63b.jpg", "64d1a2d7bc9d0.jpg", "64d1ed4218870.png", "64d4a3efc937c.jpg", "64d5ac13eda1c.jpg", "64d5bda35d4b2.png", "64d9ce5c0ea16.jpg", "64d9dd3e47c03.jpg", "64d9ee93d3ecc.jpg", "64d9fa2773870.jpg", "64d20ccdd3aa9.jpg", "64d34d07110f5.jpg", "64d314e5d59e5.jpg", "64d0641e03959.jpg", "64d242753a0aa.jpg", "64dafbdbab831.jpg", "64db2e86e0ba3.jpg", "64db026a84ac5.jpg", "64db3946283cb.jpg", "64dd9a6d8416b.jpg", "64ddc189ccfa7.jpg", "64dde6dc8016e.jpg", "64dde0825bde3.jpeg", "64dee5ef69160.jpg", "64dee6d16a4d2.jpg", "64dee65ce9686.png", "64dee170edee4.png", "64dee534e6b5f.png", "64dee6921fe2d.jpg", "64e5d3d5b78bd.jpeg", "64e5d4032abeb.jpeg", "64e33ad456798.jpg", "64e47bc46f986.jpg", "64e57f3d7a26f.jpeg", "64e57fbe1e316.jpeg", "64e62a18c8f56.jpg", "64e84d4cce4d9.jpg", "64e852ab692ec.jpg", "64ed674f33e7e.jpg", "64ee9df0519ca.jpg", "64eeef6fe5262.jpg", "64eef9ab0c2a9.jpg", "64f6a248772ac.png", "64f7e2e001302.jpg", "64f9535f1982a.png", "64fee80518ad2.jpg", "64fef29df4212.jpg", "64ffdc754a609.jpg", "64ffee63823e6.jpg", "65a4a52f53f7e.jpg", "65a4affe4e6df.jpg", "65a4f240960eb.jpg", "65a5e5fe2cb71.jpg", "65a5eff29b50c.jpg", "65a5f32519658.jpg", "65a5fa311e8d4.jpg", "65a7a4b915188.png", "65a8a4184b0d2.jpg", "65a9f36fc346d.jpg", "65a48dcbad365.jpg", "65a50b98d7b60.png", "65a51e2e1c736.jpg", "65a73fb7eba41.jpg", "65a79ef5ed196.jpg", "65a883a80c4b3.jpg", "65bca5589b31f.jpg", "65c065b8a656b.jpg", "65c344773460a.jpg", "65c06d3cdcf50.jpg", "65c19df159ed0.jpg", "65c1bb5d1a895.jpg", "65c1bd62e9c41.jpg", "65c2e784d60d2.jpg", "65c346f51c60a.jpg", "65d441bd00492.jpg", "65d442d12e1a5.jpg", "65d55d4093601.jpg", "65d71fbbd8c68.jpg", "65d80bd5cfef4.jpg", "65d85cb730701.jpg", "65d85cd821b97.jpg", "65d87bdd20187.jpg", "65d810cebd00e.jpg", "65d5611cbc2bc.jpg", "65d55687a019f.jpg", "65dc41f3ccbec.jpg", "65dc483fdf927.jpg", "65dc020335ee3.png", "65dd4f24b8b24.jpg", "65dd48c5c52e1.jpg", "65dd59dea2a9f.jpg", "65dec6bab5f27.jpg", "65dee2599fe46.jpg", "65bc8d98228f3.jpg", "65c0735d60dee.jpg", "65d2e0ac9482d.jpg", "65d6ba31205d9.jpg", "65d6c93d31c49.jpg", "65d6cb067b973.jpg", "65d8adc8cb35e.jpg", "65d40b3b7e2de.jpg", "65f7b4639a53d.jpg",
	//	"65f7ae682d856.jpg",
	//	"65f3f6ede56d5.jpg",
	//	"65f7a7276559e.png",
	//	"65f2bfb1e8569.jpg",
	//	"65f1181236847.jpg",
	//	"65f00ba253e02.jpg",
	//	"65efb440e99f0.jpg",
	//	"65ee78034927e.jpg",
	//	"65eae05f9f2ee.jpg",
	//	"65ead11e6d4bb.jpg",
	//	"65eaab033619b.png",
	//	"65eaa43f55725.jpg",
	//	"65ea7a865059a.jpg",
	//	"65ea6929e2020.jpg",
	//	"65e96c37169c3.jpg",
	//	"65e96b1d99820.jpg",
	//	"65e9637d2bf91.jpg",
	//	"65e92ccc4b414.jpg",
	//	"65e91f70a3565.jpg",
	//	"65e84483243dd.jpg",
	//	"65e8216379501.jpg",
	//	"65e6d1de24bee.jpg",
	//	"65e6b0430dd27.jpg",
	//	"65e6a77ba5be3.jpg",
	//	"65e690070683e.jpg",
	//	"65e5869e8c448.jpg",
	//	"65e55c4842726.jpg",
	//	"65e54c2f18df5.jpg",
	//	"65e542d85c40a.jpg",
	//	"65e2c6624014f.jpg",
	//	"65e1998b65b5f.jpg",
	//	"65e58d2cb21b4.jpg",
	//	"65e16cc356e89.jpg",
	//	"65e1625ac0aa3.jpg",
	//	"65e0180624098.jpg",
	//	"65e00f1dc9762.jpg",
	//	"65e0055a2163e.jpg",
	//	"65dff0ba8e2e3.jpg",
	//	"65deeb124e400.jpg",
	//	"65dd9f255d879.png",
	//	"65dd7c48d9994.png",
	//	"65d86c16ed4ab.jpg",
	//	"65ded7378d712.jpg",
	//	"65eed1b3ee0a3.jpg",
	//	"65f7c6bba819f.jpg",
	//	"65e547e820888.jpg",
	//	"65efe7e5963c2.jpg",
	//	"65f3acc15d457.jpg",
	//	"660109a6f3341.jpg",
	//	"65e68cbf7eec2.jpg",
	//	"65fceeef97942.jpg",
	//	"65faa84f4fd5e.jpg",
	//	"65e14590d3d0e.jpg",
	//	"65fa5169962c9.jpg",
	//	"65fa93f307a40.JPG",
	//	"65f3f0e752006.jpg",
	//	"65f10eb9ce3d5.jpg",
	//	"65effec8b1eed.jpg",
	//	"65dffc2e43114.jpg",
	//	"66029e60d4949.jpg",
	//	"660108e7967c2.jpg",
	//	"65fd50702eef0.jpg",
	//	"65fbf5ad41666.jpg",
	//	"65fbda3f4f39b.jpg",
	//	"65fbd9994c4ce.jpg",
	//	"65faacc4bb10c.jpg",
	//	"65faa50e822a7.jpg",
	//	"65fa9041b7095.jpg",
	//	"65fa7fff8319b.jpg",
	//	"65fa7aafe8a7f.jpg",
	//	"65fa4939d7808.jpg",
	//	"65fa3f2ebb027.jpg",
	//	"65f9516813f34.jpg",
	//	"65f8f1cbe1a73.jpg",
	//	"65f8eee4df23a.jpg",
	//	"65f8eb2c046ee.jpg",
	//	"65f7bcd5a8548.jpg",
	//	"65f4093c406a8.jpg",
	//	"65f3f055ee5da.jpg",
	//	"65f3efb4c278d.jpg",
	//	"65f255ed1d941.jpg",
	//	"65ee6cc9b1ad8.jpg",
	//	"65fd030189fdd.jpg",
	//	"65f1774e986c4.jpg",
	//	"65f943fe1feec.jpg",
	//	"65effdf3b79a1.jpg",
	//	"65e7e1994eb8c.jpg",
	//	"65e685948b68d.jpg",
	//	"65e1475a7df1d.jpg"}
	//imgList2 := make([]string, 0)
	for i := 1; i <= utils.StrToInt(c.Query("p")); i++ {
		time.Sleep(time.Microsecond * 1000)
		arr := make(map[string]md.Cinema5bmsData)
		json.Unmarshal([]byte(data), &arr)
		args := map[string]string{
			"page":      utils.IntToStr(i),
			"page_size": "100",
		}
		token := "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJpc3MiOiJodHRwOlwvXC9kaXN0cmlidXRpb25hcGkucWlucm9ubWVkaWEuY29tXC9hcGlcL3YxXC91c2VyXC9sb2dpblwva2V5IiwiaWF0IjoxNzA3MTg4NzU3LCJleHAiOjE3MzMzOTY3NTcsIm5iZiI6MTcwNzE4ODc1NywianRpIjoiaDR4cXFGcExWYnFEMldRNyIsInN1YiI6MTQ4LCJwcnYiOiJjOTNiNDZiY2RhZDI2MTYyMjIyMWJhMzM5MDZkNTZiNjk4ZGYzOGVlIn0.cagIMOdME5m6NFhtRfGDbUjauM_MnO7Ihe70XBiYvxk"
		list, _ := playlet_bihai.VideoList(token, args)
		tmp := make([]md.Bihai, 0)
		err := json.Unmarshal([]byte(gjson.Get(list, "data.list").String()), &tmp)
		fmt.Println(list)
		fmt.Println(err)
		if len(tmp) == 0 {
			break
		}
		for _, v := range tmp {
			name, _ := zhToUnicode([]byte(v.Name))
			fmt.Println(string(name))
			imgs[string(name)] = v.ImgUrl
			imgs1 = append(imgs1, v.ImgUrl)
			bmsData, ok := arr[string(name)]
			//imgs3 := ""
			//v.ImgUrl, imgs3 = getimg(string(name), v.ImgUrl, imgList)

			if ok {

				bmsData.ImageUrl = v.ImgUrl
				bmsData.Episode = v.VideoNum
				bmsData.Id = v.Id
				uniqueId := php2go.Md5(bmsData.Appid + "_" + bmsData.Type + "_" + bmsData.FirstCate + "_" + utils.IntToStr(bmsData.Id))

				commAddNew(uniqueId, bmsData)
				//if utils.InArr(imgs3, imgList) == false {
				//	imgList2 = append(imgList2, imgs3)
				//}
			}

		}
	}

	utils.FilePutContents("img", utils.SerializeStr(imgs))
	utils.FilePutContents("img1", utils.SerializeStr(imgs1))
	//utils.FilePutContents("img2", utils.SerializeStr(imgList2))

}
func BihaiStoryAdd(c *gin.Context) {
	for i := 1; i <= utils.StrToInt(c.Query("p")); i++ {
		time.Sleep(time.Microsecond * 1000)

		args := map[string]string{
			"page":      utils.IntToStr(i),
			"page_size": "500",
		}
		token := "46b8d2af5d3f6d5891e20e0a56052313"
		list, _ := story.GetYxList(token, args)
		tmp := make([]md.BihaiStory, 0)
		json.Unmarshal([]byte(gjson.Get(list, "data.list").String()), &tmp)
		if len(tmp) == 0 {
			break
		}
		for _, v := range tmp {
			name, _ := zhToUnicode([]byte(v.BookName))
			bmsData := md.Cinema5bmsData{
				Description: v.Description,
				IsEnd:       0,
				OnlineTime:  v.CreatedAt,
				Type:        "bihai",
				Title:       string(name),
				UpdateTime:  int(time.Now().Unix()),
				Time:        int(utils.TimeStdParseUnix(v.CreatedAt)),
				Appid:       "ttd02aa6974f166cca01",
				IsClose:     0,
				IsHot:       0,
				FirstCate:   "story",
				Platform:    "tikTok",
			}
			bmsData.ImageUrl = v.BookUrl
			bmsData.Id = v.Id
			var result *elastic.SearchResult
			boolQuery := elastic.NewBoolQuery() // 创建bool查询
			rangeQuery := elastic.NewMatchQuery("video_id.keyword", utils.IntToStr(bmsData.Id))
			boolQuery.Must(rangeQuery)
			rangeQuery2 := elastic.NewMatchQuery("appid.keyword", bmsData.Appid)
			boolQuery.Must(rangeQuery2)
			rangeQuery1 := elastic.NewRangeQuery("task_end_time").Gt(time.Now().Unix())
			boolQuery.Must(rangeQuery1)
			key := md2.ZhiosTikTokTaskDetailEsIndex
			esWhere := es.EsClient.Search().
				Index(key).
				TrackTotalHits(true).
				Query(boolQuery)
			result, _ = esWhere. // 设置查询条件
						Size(1). // 设置分页参数 - 每页大小,设置为0,代表不返回搜索结果，仅返回聚合分析结果
						From(0).
						Pretty(true). // 返回可读的json格式
						Do(context.Background())
			if result != nil && len(result.Hits.Hits) > 0 {
				for _, hit := range result.Hits.Hits {
					if hit == nil {
						continue
					}
					jsonByte, marErr := hit.Source.MarshalJSON()
					var tmps md.TikTokTaskDetailSecond
					if marErr == nil {
						err := json.Unmarshal(jsonByte, &tmps)
						if err == nil {
							bmsData.OnlineTime = time.Unix(int64(tmps.TaskStartTime), 0).Format("2006-01-02 15:04:05")
							bmsData.Time = tmps.TaskStartTime
							uniqueId := php2go.Md5(bmsData.Appid + "_" + bmsData.Type + "_" + bmsData.FirstCate + "_" + utils.IntToStr(bmsData.Id))
							commAddNew(uniqueId, bmsData)
						}
					}
				}
			} else {
				bmsData.IsClose = 1
				uniqueId := php2go.Md5(bmsData.Appid + "_" + bmsData.Type + "_" + bmsData.FirstCate + "_" + utils.IntToStr(bmsData.Id))
				commAddNew(uniqueId, bmsData)
			}

		}
	}

}
func BeiwoStoryAdd(c *gin.Context) {
	for i := 1; i <= utils.StrToInt(c.Query("p")); i++ {
		time.Sleep(time.Microsecond * 1000)

		args := map[string]string{
			"page": utils.IntToStr(i),
		}
		token := "zhiying"
		list, _ := story.GetBookList(token, args)
		tmp := make([]md.BeiwoStory, 0)
		json.Unmarshal([]byte(gjson.Get(list, "data").String()), &tmp)
		for _, v := range tmp {
			bmsData := md.Cinema5bmsData{
				Description: v.Describe,
				IsEnd:       0,
				OnlineTime:  "",
				Type:        "beiwo",
				Title:       v.Name,
				UpdateTime:  int(time.Now().Unix()),
				Time:        0,
				Appid:       "tt8a93fc2e15affaaa01",
				IsClose:     0,
				IsHot:       0,
				FirstCate:   "story",
				Platform:    "tikTok",
			}
			bmsData.ImageUrl = v.CoverUrl
			bmsData.Id = v.Id
			var result *elastic.SearchResult
			boolQuery := elastic.NewBoolQuery() // 创建bool查询
			rangeQuery := elastic.NewMatchQuery("video_id.keyword", utils.IntToStr(bmsData.Id))
			boolQuery.Must(rangeQuery)
			rangeQuery2 := elastic.NewMatchQuery("appid.keyword", bmsData.Appid)
			boolQuery.Must(rangeQuery2)
			rangeQuery1 := elastic.NewRangeQuery("task_end_time").Gt(time.Now().Unix())
			boolQuery.Must(rangeQuery1)
			key := md2.ZhiosTikTokTaskDetailEsIndex
			esWhere := es.EsClient.Search().
				Index(key).
				TrackTotalHits(true).
				Query(boolQuery)
			result, _ = esWhere. // 设置查询条件
						Size(1). // 设置分页参数 - 每页大小,设置为0,代表不返回搜索结果，仅返回聚合分析结果
						From(0).
						Pretty(true). // 返回可读的json格式
						Do(context.Background())
			if result != nil && len(result.Hits.Hits) > 0 {
				for _, hit := range result.Hits.Hits {
					if hit == nil {
						continue
					}
					jsonByte, marErr := hit.Source.MarshalJSON()
					var tmps md.TikTokTaskDetailSecond
					if marErr == nil {
						err := json.Unmarshal(jsonByte, &tmps)
						if err == nil {
							bmsData.OnlineTime = time.Unix(int64(tmps.TaskStartTime), 0).Format("2006-01-02 15:04:05")
							bmsData.Time = tmps.TaskStartTime
							uniqueId := php2go.Md5(bmsData.Appid + "_" + bmsData.Type + "_" + bmsData.FirstCate + "_" + utils.IntToStr(bmsData.Id))
							commAddNew(uniqueId, bmsData)
						}
					}
				}
			} else {

				bmsData.IsClose = 1
				uniqueId := php2go.Md5(bmsData.Appid + "_" + bmsData.Type + "_" + bmsData.FirstCate + "_" + utils.IntToStr(bmsData.Id))
				commAddNew(uniqueId, bmsData)
			}

		}
	}
}
func getimg(name, imgUrl string, imgList []string) (string, string) {
	imgPath := "E:\\go_api\\zhimeng\\static\\img\\"

	fileName := path.Base(imgUrl)

	split := strings.Split(fileName, "?")
	if utils.InArr(split[0], imgList) {
		return "http://teamplate.zhios.cn/" + split[0], split[0]
	}
	res, err := http.Get(imgUrl)
	if err != nil {
		fmt.Println("A error occurred!")
		return "", ""
	}
	defer res.Body.Close()
	// 获得get请求响应的reader对象
	reader := bufio.NewReaderSize(res.Body, 32*1024)

	file, err := os.Create(imgPath + split[0])
	if err != nil {
	}
	// 获得文件的writer对象
	writer := bufio.NewWriter(file)

	written, _ := io.Copy(writer, reader)
	fmt.Printf("Total length: %d", written)
	return "http://teamplate.zhios.cn/" + split[0], split[0]
}
func zhToUnicode(raw []byte) ([]byte, error) {
	str, err := strconv.Unquote(strings.Replace(strconv.Quote(string(raw)), `\\u`, `\u`, -1))
	if err != nil {
		return nil, err
	}
	return []byte(str), nil
}
func Cinema(c *gin.Context) {
	svc2.Cinema5bms()
}
func TikTokTask(c *gin.Context) {
	//appidList := "tt38e94e54a7d70c4601" //碧海
	//appidList := "tt8a93fc2e15affaaa01" //被窝
	appidList := c.Query("appid")
	//appidList := "ttd02aa6974f166cca01" //言湘故事会
	split := strings.Split(appidList, "_")
	j := utils.StrToInt(c.Query("num"))
	for _, v := range split {
		isEnd := 0
		fmt.Println(v)
		for i := 1; i <= j; i++ {
			time.Sleep(time.Microsecond * 1000)
			if isEnd == 1 {
				break
			}
			var endTime = utils.StrToInt64(c.Query("times")) + int64(i*7*86400)
			if endTime > time.Now().Unix() {
				isEnd = 1
				endTime = time.Now().Unix()
			}
			startTime := endTime - 7*86400

			param := map[string]interface{}{
				"appid":             v,
				"create_start_time": startTime,
				"create_end_time":   endTime,
			}
			api, _ := tik_tok.TaskApi("query_app_task_id/", svc2.TikTokTaskToken(), zhios_third_party_utils.SerializeStr(param))
			taskIds := gjson.Get(api, "data.task_ids").String()
			fmt.Println(taskIds)
			if taskIds == "" || taskIds == "[]" {
				fmt.Println(endTime)
				continue
			}
			svc2.CommAddTask("tik_tok_task_"+v, taskIds)
			var tmp = make([]int64, 0)
			json.Unmarshal([]byte(taskIds), &tmp)
			svc2.GetTaskDetail(v, tmp)
			fmt.Println(endTime)
		}

	}
}
func KujiangAdd(c *gin.Context) {
	data := md3.KujiangData
	var kujiang []md.KuJiang
	json.Unmarshal([]byte(data), &kujiang)
	kujiangMap := make(map[string]md.KuJiang)
	for _, v := range kujiang {
		kujiangMap[utils.IntToStr(v.BookId)] = v
	}
	for i := 1; i < 3; i++ {

		args := map[string]string{
			"merchant_id": "379",
			"apiKey":      "JvsazPU8iZA9nZfd",
			"type":        "2",
			"page":        utils.IntToStr(i),
			"timestamp":   zhios_third_party_utils.Int64ToStr(time.Now().Unix()),
			"page_size":   "100",
			"search_date": "2023-01-01 - " + time.Now().Format("2006-01-02"),
		}
		list, _ := playlet_kujiang.VideoList("78376572d88d3c154a524b7c2303d26c", args)
		datas := make([]map[string]interface{}, 0)
		json.Unmarshal([]byte(gjson.Get(list, "data.data").String()), &datas)
		for _, v := range datas {
			kujiangData := kujiangMap[utils.AnyToString(v["book_id"])]
			if kujiangData.BookId == 0 {
				continue
			}
			name, _ := zhToUnicode([]byte(utils.AnyToString(v["book_name"])))
			introduce, _ := zhToUnicode([]byte(utils.AnyToString(v["introduce"])))
			tmp := md.Cinema5bmsData{
				Description: string(introduce),
				Episode:     int(utils.AnyToInt64(v["chapters"])),
				ImageUrl:    utils.AnyToString(v["cover"]),
				IsEnd:       0,
				PayEpisode:  int(utils.AnyToInt64(v["pay_chapters"])),
				Material:    kujiangData.WebDiskUrl,
				OnlineTime:  utils.AnyToString(v["publiced_at"]),
				Type:        "kujiang",
				Title:       string(name),
				UpdateTime:  int(time.Now().Unix()) - i*10,
				Time:        int(utils.TimeStdParseUnix(utils.AnyToString(v["publiced_at"]))),
				Appid:       "ttbed9c86421e54c8501",
				Id:          int(utils.AnyToInt64(v["book_id"])),
				IsClose:     0,
				IsHot:       0,
				FirstCate:   "video",
				SecondCate:  kujiangData.Category,
			}

			uniqueId := php2go.Md5(tmp.Appid + "_" + tmp.Type + "_" + tmp.FirstCate + "_" + utils.IntToStr(tmp.Id))
			fmt.Println(uniqueId)
			tmp.Key = uniqueId
			doc, _ := es.FirstDoc(md2.ZhiosNewVideo, uniqueId)
			for _, v1 := range kujiangData.BookShelf {
				if v1.OnlineStatus == 1 {
					tmp.Platform = "kuaishou"
					if doc != nil && strings.Contains(gjson.Get(string(doc.Source), "platform").String(), "tikTok") {
						tmp.Platform = "tikTok,kuaishou"
					}
				}
			}
			if tmp.Platform == "" {
				tmp.IsClose = 1
			}
			commAddNew(uniqueId, tmp)
		}
	}

}

func BihaiFile(c *gin.Context) {
	rFile, _ := c.FormFile("file")
	file, err := rFile.Open()
	if err != nil {
		c.String(400, "文件格式错误")
		return
	}
	//es.CreateIndexIfNotExists(md2.ZhiosTpdarenEsIndexNew, md2.ZhiosTpdarenNewEsMapping)

	defer file.Close()
	reader := csv.NewReader(bufio.NewReader(file))
	i := 0
	date := "2024"
	data := make(map[string]md.Cinema5bmsData)
	for {
		line, err := reader.Read()
		if err != nil {
			break
		}
		if i == 0 {
			i++
			continue
		}
		if len(line) == 0 {
			break
		}
		material := ""
		tqm := strings.ReplaceAll(line[8], " 复制这段内容后打开百度网盘手机App，操作更方便哦 \n--来自百度网盘超级会员v3的分享", "")
		Description := line[6]
		Cate := strings.ReplaceAll(line[3], "\n", "")
		PayEpisode := line[7]
		OnlineTime := strings.ReplaceAll(line[0], " ", "")
		ex := strings.Split(OnlineTime, "\n")
		OnlineTime = ex[0]
		Title := line[1]
		Title = strings.ReplaceAll(Title, "🔥", "")
		if strings.Contains(Title, "病娇反派攻略计划") {
			date = "2023"
		}
		if date == "2024" && OnlineTime == "11.26" {
			OnlineTime = "1.26"
		}
		if strings.Contains(tqm, " 提取码") == false {
			material = tqm
		} else {
			ex := strings.Split(tqm, " 提取码: ")
			material = ex[0]
			if strings.Contains(material, "?pwd=") == false {
				material += "?pwd=" + ex[1]
			}

		}
		material = strings.ReplaceAll(material, "链接:", "")
		material = strings.ReplaceAll(material, " ", "")
		t, _ := utils.TimeParse("2006.1.2", date+"."+OnlineTime)
		tmp := md.Cinema5bmsData{
			Description: Description,
			IsEnd:       0,
			PayEpisode:  utils.StrToInt(PayEpisode),
			Material:    material,
			OnlineTime:  t.Format("2006-01-02 15:04:05"),
			Type:        "bihai",
			Title:       Title,
			UpdateTime:  int(time.Now().Unix()) - i*10,
			Time:        int(t.Unix()),
			Appid:       "qr_48262ecc1ede61d20d3926650ccf5d0c",
			IsClose:     0,
			IsHot:       0,
			FirstCate:   "video",
			SecondCate:  Cate,
			Platform:    "",
		}
		if utils.InArr(line[5], []string{"已上线"}) == false && utils.InArr(line[5], []string{"已发布"}) == false && utils.InArr(line[5], []string{"已发布/已上架"}) == false {
			tmp.IsClose = 1
		}
		if utils.InArr(line[4], []string{"已发布"}) || utils.InArr(line[4], []string{"已发布/已上架"}) {
			tmp.Platform += "tikTok"
		}
		if utils.InArr(line[5], []string{"已发布"}) || utils.InArr(line[5], []string{"已发布/已上架"}) || utils.InArr(line[5], []string{"已上线"}) {
			if tmp.Platform != "" {
				tmp.Platform += ","
			}
			tmp.Platform += "kuaishou"
		}
		uniqueId := php2go.Md5(tmp.Appid + "_" + tmp.Type + "_" + tmp.FirstCate + "_" + utils.IntToStr(tmp.Id))
		tmp.Key = uniqueId
		data[tmp.Title] = tmp
		i++
	}
	fmt.Println(utils.SerializeStr(data))
	utils.FilePutContents("datas", utils.SerializeStr(data))

	e.OutSuc(c, utils.SerializeStr(data), nil)
}
func File(c *gin.Context) {
	rFile, _ := c.FormFile("file")
	file, err := rFile.Open()
	if err != nil {
		c.String(400, "文件格式错误")
		return
	}
	//es.CreateIndexIfNotExists(md2.ZhiosTpdarenEsIndexNew, md2.ZhiosTpdarenNewEsMapping)

	defer file.Close()
	reader := csv.NewReader(bufio.NewReader(file))
	i := 0
	for {
		line, err := reader.Read()
		if err != nil {
			c.String(400, err.Error())
			return
		}
		if i == 0 {
			i++
			continue
		}
		//line 就是每一行的内容
		fmt.Println(line)
		var tmp md.TpdarenNew
		material := ""
		tqm := line[9]
		Description := line[10]
		Episode := line[13]
		Cate := line[11]
		ImageUrl := line[16]
		PayEpisode := line[14]
		OnlineTime := line[0]
		Title := line[6]
		Id := line[5]
		if strings.Contains(tqm, " 提取码") == false {
			material = tqm
		} else {
			ex := strings.Split(tqm, " 提取码: ")
			material = ex[0]
			if strings.Contains(material, "?pwd=") == false {
				material += "?pwd=" + ex[1]
			}

		}
		material = strings.ReplaceAll(material, "链接:", "")
		material = strings.ReplaceAll(material, " ", "")
		OnlineTime = strings.ReplaceAll(OnlineTime, "年", "-")
		OnlineTime = strings.ReplaceAll(OnlineTime, "月", "-")
		OnlineTime = strings.ReplaceAll(OnlineTime, "日", "")
		t, _ := utils.TimeParse("2006-1-2", OnlineTime)
		tmp = md.TpdarenNew{
			Description:       Description,
			Episode:           utils.StrToInt(Episode),
			Cate:              Cate,
			ImageUrl:          ImageUrl,
			IsEnd:             0,
			PayEpisode:        utils.StrToInt(PayEpisode),
			Material:          material,
			OnlineTime:        OnlineTime + " 00:00:00",
			Type:              "dianzhong",
			Title:             Title,
			Data:              utils.SerializeStr(line),
			DouyinTheaterId:   1,
			KuaishouTheaterId: 2,
			UpdateTime:        int(time.Now().Unix()) - i*10,
			Time:              int(t.Unix()),
			Appid:             "31517",
			Id:                Id,
			IsClose:           0,
		}

		i++
		fmt.Println(tmp)
		var uniqueId = ""
		if utils.InArr(line[3], []string{"已上架"}) {
			tmp.VideoType = "kuaishou"
			uniqueId = php2go.Md5(tmp.Appid + "_" + tmp.Type + "_" + tmp.VideoType + "_" + tmp.Id)
			fmt.Println(uniqueId)
			commAdd(uniqueId, tmp)
		}
		if utils.InArr(line[2], []string{"已上架"}) {

			tmp.VideoType = "douyin"
			uniqueId = php2go.Md5(tmp.Appid + "_" + tmp.Type + "_" + tmp.VideoType + "_" + tmp.Id)
			fmt.Println(uniqueId)
			commAdd(uniqueId, tmp)
		}
	}

}
func FileNew(c *gin.Context) {
	rFile, _ := c.FormFile("file")
	file, err := rFile.Open()
	if err != nil {
		c.String(400, "文件格式错误")
		return
	}
	//es.CreateIndexIfNotExists(md2.ZhiosTpdarenEsIndexNew, md2.ZhiosTpdarenNewEsMapping)

	defer file.Close()
	reader := csv.NewReader(bufio.NewReader(file))
	i := 0
	for {
		line, _ := reader.Read()
		//if err != nil {
		//	c.String(400, err.Error())
		//	return
		//}
		if i == 0 {
			i++
			continue
		}
		if line[0] == "待定" || line[0] == "" {
			continue
		}
		//line 就是每一行的内容
		fmt.Println(line)
		material := ""
		tqm := line[11]
		Description := line[11]
		Episode := line[15]
		Cate := line[13]
		ImageUrl := line[18]
		PayEpisode := line[16]
		OnlineTime := line[0]
		Title := line[8]
		Id := line[7]
		if Title == "命运的游戏之源起" {
			fmt.Println(123)
		}
		exId := strings.Split(Id, "&")

		Id = strings.ReplaceAll(exId[0], " ", "")
		exTitle := strings.Split(Title, "&")
		Title = strings.ReplaceAll(exTitle[0], " ", "")
		Title = strings.ReplaceAll(Title, "（", "(")
		exTitle1 := strings.Split(Title, "(")
		Title = exTitle1[0]
		if strings.Contains(tqm, " 提取码") == false {
			material = tqm
		} else {
			ex := strings.Split(tqm, " 提取码: ")
			material = ex[0]
			if strings.Contains(material, "?pwd=") == false {
				material += "?pwd=" + ex[1]
			}

		}
		material = strings.ReplaceAll(material, "链接:", "")
		material = strings.ReplaceAll(material, " ", "")
		OnlineTime = strings.ReplaceAll(OnlineTime, "/", "-")
		OnlineTime = strings.ReplaceAll(OnlineTime, "年", "-")
		OnlineTime = strings.ReplaceAll(OnlineTime, "月", "-")
		OnlineTime = strings.ReplaceAll(OnlineTime, "日", "")
		t, _ := utils.TimeParse("2006-1-2 15:04:05", OnlineTime+" "+line[1])
		tmp := md.Cinema5bmsData{
			Description: Description,
			Episode:     utils.StrToInt(Episode),
			ImageUrl:    ImageUrl,
			IsEnd:       0,
			PayEpisode:  utils.StrToInt(PayEpisode),
			Material:    material,
			OnlineTime:  OnlineTime + " " + line[1],
			Type:        "dianzhong",
			Title:       Title,
			UpdateTime:  int(time.Now().Unix()) - i*10,
			Time:        int(t.Unix()),
			Appid:       "31517",
			Id:          utils.StrToInt(Id),
			IsClose:     0,
			IsHot:       0,
			FirstCate:   "video",
			SecondCate:  Cate,
			Platform:    "tikTok,kuaishou",
		}
		if utils.InArr(line[3], []string{"已上架"}) == false && utils.InArr(line[5], []string{"已上架"}) == false {
			continue
		}
		if utils.InArr(line[5], []string{"已上架"}) == false {
			tmp.Platform = "kuaishou"
		}
		if utils.InArr(line[3], []string{"已上架"}) == false {
			tmp.Platform = "tikTok"
		}

		uniqueId := php2go.Md5(tmp.Appid + "_" + tmp.Type + "_" + tmp.FirstCate + "_" + utils.IntToStr(tmp.Id))
		fmt.Println(uniqueId)
		commAddNew(uniqueId, tmp)
		i++

	}

}
func FileTwo(c *gin.Context) {
	rFile, _ := c.FormFile("file")
	file, err := rFile.Open()
	if err != nil {
		c.String(400, "文件格式错误")
		return
	}
	//es.CreateIndexIfNotExists(md2.ZhiosTpdarenEsIndexNew, md2.ZhiosTpdarenNewEsMapping)

	defer file.Close()
	reader := csv.NewReader(bufio.NewReader(file))
	i := 0
	for {
		line, err := reader.Read()
		if err != nil {
			c.String(400, err.Error())
			return
		}
		if i == 0 {
			i++
			continue
		}
		if strings.Contains(line[0], "年") == false {
			break
		}
		//line 就是每一行的内容
		fmt.Println(line)
		var tmp md.TpdarenNew
		material := ""
		tqm := line[7]
		Description := line[8]
		Episode := line[11]
		Cate := line[9]
		ImageUrl := line[14]
		PayEpisode := line[12]
		OnlineTime := line[0]
		Title := line[4]
		Id := line[3]
		if strings.Contains(tqm, " 提取码") == false {
			material = tqm
		} else {
			ex := strings.Split(tqm, " 提取码: ")
			material = ex[0]
			if strings.Contains(material, "?pwd=") == false {
				material += "?pwd=" + ex[1]
			}

		}
		material = strings.ReplaceAll(material, "链接:", "")
		material = strings.ReplaceAll(material, " ", "")
		OnlineTime = strings.ReplaceAll(OnlineTime, "年", "-")
		OnlineTime = strings.ReplaceAll(OnlineTime, "月", "-")
		OnlineTime = strings.ReplaceAll(OnlineTime, "日", "")
		t, _ := utils.TimeParse("2006-1-2", OnlineTime)
		tmp = md.TpdarenNew{
			Description:       Description,
			Episode:           utils.StrToInt(Episode),
			Cate:              Cate,
			ImageUrl:          ImageUrl,
			IsEnd:             0,
			PayEpisode:        utils.StrToInt(PayEpisode),
			Material:          material,
			OnlineTime:        OnlineTime + " 00:00:00",
			Type:              "dianzhong",
			Title:             Title,
			Data:              utils.SerializeStr(line),
			DouyinTheaterId:   1,
			KuaishouTheaterId: 2,
			UpdateTime:        int(time.Now().Unix()) - i*10,
			Time:              int(t.Unix()),
			Appid:             "31517",
			Id:                Id,
			IsClose:           0,
		}

		i++
		fmt.Println(tmp)
		var uniqueId = ""
		tmp.VideoType = "kuaishou"
		uniqueId = php2go.Md5(tmp.Appid + "_" + tmp.Type + "_" + tmp.VideoType + "_" + tmp.Id)
		fmt.Println(uniqueId)
		commAdd(uniqueId, tmp)

		tmp.VideoType = "douyin"
		uniqueId = php2go.Md5(tmp.Appid + "_" + tmp.Type + "_" + tmp.VideoType + "_" + tmp.Id)
		fmt.Println(uniqueId)
		commAdd(uniqueId, tmp)
	}

}
func FileTwoNew(c *gin.Context) {
	rFile, _ := c.FormFile("file")
	file, err := rFile.Open()
	if err != nil {
		c.String(400, "文件格式错误")
		return
	}
	//es.CreateIndexIfNotExists(md2.ZhiosNewVideo, md2.ZhiosNewVideoEsMapping)

	defer file.Close()
	reader := csv.NewReader(bufio.NewReader(file))
	i := 0
	for {
		line, err := reader.Read()
		if err != nil {
			c.String(400, err.Error())
			return
		}
		if i == 0 {
			i++
			continue
		}
		if line[2] != "" {
			continue
		}
		//line 就是每一行的内容
		fmt.Println(line)
		material := ""
		tqm := line[7]
		Description := line[8]
		Episode := line[11]
		Cate := line[9]
		ImageUrl := line[14]
		PayEpisode := line[12]
		OnlineTime := line[0]
		if strings.Contains(line[0], "年") == false {
			OnlineTime = "2023年" + OnlineTime + "1日"
		}
		Title := line[4]
		Id := line[3]
		if strings.Contains(tqm, " 提取码") == false {
			material = tqm
		} else {
			ex := strings.Split(tqm, " 提取码: ")
			material = ex[0]
			if strings.Contains(material, "?pwd=") == false {
				material += "?pwd=" + ex[1]
			}

		}
		material = strings.ReplaceAll(material, "链接:", "")
		material = strings.ReplaceAll(material, " ", "")
		OnlineTime = strings.ReplaceAll(OnlineTime, "年", "-")
		OnlineTime = strings.ReplaceAll(OnlineTime, "月", "-")
		OnlineTime = strings.ReplaceAll(OnlineTime, "日", "")
		t, _ := utils.TimeParse("2006-1-2", OnlineTime)
		i++
		tmp := md.Cinema5bmsData{
			Description: Description,
			Episode:     utils.StrToInt(Episode),
			ImageUrl:    ImageUrl,
			IsEnd:       0,
			PayEpisode:  utils.StrToInt(PayEpisode),
			Material:    material,
			OnlineTime:  OnlineTime + " 00:00:00",
			Type:        "dianzhong",
			Title:       Title,
			UpdateTime:  int(time.Now().Unix()) - i*10,
			Time:        int(t.Unix()),
			Appid:       "31517",
			Id:          utils.StrToInt(Id),
			IsClose:     0,
			IsHot:       0,
			FirstCate:   "video",
			SecondCate:  Cate,
			Platform:    "tikTok,kuaishou",
		}
		uniqueId := php2go.Md5(tmp.Appid + "_" + tmp.Type + "_" + tmp.FirstCate + "_" + utils.IntToStr(tmp.Id))

		fmt.Println(uniqueId)
		commAddNew(uniqueId, tmp)
	}

}
func commAddNew(uniqueId string, tmp md.Cinema5bmsData) {
	tmp.Key = uniqueId
	doc, _ := es.FirstDoc(md2.ZhiosNewVideo, uniqueId)
	if doc == nil && tmp.IsClose == 0 {
		createDocRet, err := es.CreateDoc(md2.ZhiosNewVideo, uniqueId, tmp)
		if err != nil {
			return
		}
		fmt.Printf("CreateDoc ==> %+v \n\n", createDocRet)
	} else {
		createDocRet, err := es.UpdateDoc(md2.ZhiosNewVideo, uniqueId, tmp)
		if err != nil {
			return
		}
		fmt.Printf("CreateDoc ==> %+v \n\n", createDocRet)
	}
}

func FileSecond(c *gin.Context) {
	rFile, _ := c.FormFile("file")
	file, err := rFile.Open()
	if err != nil {
		c.String(400, "文件格式错误")
		return
	}
	//es.CreateIndexIfNotExists(md2.ZhiosTpdarenEsIndexNew, md2.ZhiosTpdarenNewEsMapping)

	defer file.Close()
	reader := csv.NewReader(bufio.NewReader(file))
	i := 0
	day := 12
	for {

		line, err := reader.Read()
		if err != nil {
			c.String(400, err.Error())
			return
		}
		if i == 0 {
			i++
			continue
		}
		//line 就是每一行的内容
		fmt.Println(line)
		t := time.Now()
		var tmp md.TpdarenNew
		material := ""
		tqm := line[7]
		Description := line[8]
		Episode := line[11]
		Cate := line[9]
		ImageUrl := line[14]
		PayEpisode := line[12]
		Title := line[4]
		Id := line[3]
		if strings.Contains(tqm, " 提取码") == false {
			material = tqm
		} else {
			ex := strings.Split(tqm, " 提取码")
			material = ex[0]
			if strings.Contains(material, "?pwd=") == false {
				material += "?pwd=" + ex[1]
			}
		}
		material = strings.ReplaceAll(material, "链接:", "")

		tmp = md.TpdarenNew{
			Description:       Description,
			Episode:           utils.StrToInt(Episode),
			Cate:              Cate,
			ImageUrl:          ImageUrl,
			IsEnd:             0,
			PayEpisode:        utils.StrToInt(PayEpisode),
			Material:          material,
			OnlineTime:        time.Date(t.Year(), time.Month(day), 1, 0, 0, 0, 0, t.Location()).Format("2006-01-02 15:04:05"),
			Type:              "dianzhong",
			Title:             Title,
			Data:              utils.SerializeStr(line),
			DouyinTheaterId:   1,
			KuaishouTheaterId: 2,
			UpdateTime:        int(time.Now().Unix()) - i*10,
			Time:              int(time.Date(t.Year(), time.Month(day), 1, 0, 0, 0, 0, t.Location()).Unix()),
			Appid:             "31517",
			Id:                Id,
			IsClose:           0,
		}
		i++
		var uniqueId = ""
		tmp.VideoType = "kuaishou"
		uniqueId = php2go.Md5(tmp.Appid + "_" + tmp.Type + "_" + tmp.VideoType + "_" + tmp.Id)
		fmt.Println(uniqueId)
		commAdd(uniqueId, tmp)

		tmp.VideoType = "douyin"
		uniqueId = php2go.Md5(tmp.Appid + "_" + tmp.Type + "_" + tmp.VideoType + "_" + tmp.Id)
		fmt.Println(uniqueId)
		commAdd(uniqueId, tmp)
	}

}
func FileDown(c *gin.Context) {
	rFile, _ := c.FormFile("file")
	file, err := rFile.Open()
	if err != nil {
		c.String(400, "文件格式错误")
		return
	}

	defer file.Close()
	reader := csv.NewReader(bufio.NewReader(file))
	i := 0
	for {
		line, err := reader.Read()
		if err != nil {
			c.String(400, err.Error())
			return
		}
		if line[1] == "ID" {
			continue
		}

		//line 就是每一行的内容
		fmt.Println(line)
		tmp := md.TpdarenNew{
			Type:  "dianzhong",
			Appid: "31517",
			Id:    line[1],
		}
		tmp.IsClose = 1

		i++
		var uniqueId = ""
		if utils.InArr(line[3], []string{"快手下架", "版权到期", "全媒体下架", "全平台下架", "版权到期，全平台下架", "只能H5用"}) {
			tmp.VideoType = "kuaishou"
			uniqueId = php2go.Md5(tmp.Appid + "_" + tmp.Type + "_" + tmp.VideoType + "_" + tmp.Id)
			fmt.Println(uniqueId)
			commDown(uniqueId, tmp)
		}
		if utils.InArr(line[3], []string{"抖音下架", "版权到期", "全媒体下架", "全平台下架", "版权到期，全平台下架", "只能H5用", "抖音/微信下架"}) {

			tmp.VideoType = "douyin"
			uniqueId = php2go.Md5(tmp.Appid + "_" + tmp.Type + "_" + tmp.VideoType + "_" + tmp.Id)
			fmt.Println(uniqueId)
			commDown(uniqueId, tmp)
		}

	}

}
func FileDownNew(c *gin.Context) {
	rFile, _ := c.FormFile("file")
	file, err := rFile.Open()
	if err != nil {
		c.String(400, "文件格式错误")
		return
	}

	defer file.Close()
	reader := csv.NewReader(bufio.NewReader(file))
	i := 0
	for {
		line, err := reader.Read()
		if err != nil {
			c.String(400, err.Error())
			return
		}
		if line[1] == "ID" {
			continue
		}

		//line 就是每一行的内容
		fmt.Println(line)
		tmp := md.Cinema5bmsData{
			Type:  "dianzhong",
			Appid: "31517",
			Id:    utils.StrToInt(line[1]),
		}
		uniqueId := php2go.Md5(tmp.Appid + "_" + tmp.Type + "_video_" + utils.IntToStr(tmp.Id))
		doc, _ := es.FirstDoc(md2.ZhiosNewVideo, uniqueId)
		if doc == nil {
			continue
		}
		var tmp1 md.Cinema5bmsData
		json.Unmarshal(doc.Source, &tmp1)
		if tmp1.Id == 0 {
			continue
		}
		if utils.InArr(line[3], []string{"版权到期", "全媒体下架", "全平台下架", "版权到期，全平台下架", "只能H5用"}) {
			tmp1.IsClose = 1
		}
		i++
		tmp.Platform = "tikTok,kuaishou"
		if utils.InArr(line[3], []string{"抖音下架", "抖音/微信下架"}) {
			tmp.Platform = "kuaishou"
		}
		if utils.InArr(line[3], []string{"快手下架"}) {
			tmp1.Platform = "tikTok"
		}
		es.UpdateDoc(md2.ZhiosTpdarenEsIndexNew, uniqueId, tmp)

	}

}
func commAdd(uniqueId string, tmp md.TpdarenNew) {
	doc, _ := es.FirstDoc(md2.ZhiosTpdarenEsIndexNew, uniqueId)
	if doc == nil {
		createDocRet, err := es.CreateDoc(md2.ZhiosTpdarenEsIndexNew, uniqueId, tmp)
		if err != nil {
			return
		}
		fmt.Printf("CreateDoc ==> %+v \n\n", createDocRet)
	} else {
		createDocRet, err := es.UpdateDoc(md2.ZhiosTpdarenEsIndexNew, uniqueId, tmp)
		if err != nil {
			return
		}
		fmt.Printf("CreateDoc ==> %+v \n\n", createDocRet)
	}
}
func commDown(uniqueId string, tmp md.TpdarenNew) {
	doc, _ := es.FirstDoc(md2.ZhiosTpdarenEsIndexNew, uniqueId)
	if doc == nil {

	} else {
		var tmpDoc md.TpdarenNew
		json.Unmarshal(doc.Source, &tmpDoc)
		tmpDoc.IsClose = tmp.IsClose
		createDocRet, err := es.UpdateDoc(md2.ZhiosTpdarenEsIndexNew, uniqueId, tmpDoc)
		if err != nil {
			return
		}
		fmt.Printf("CreateDoc ==> %+v \n\n", createDocRet)
	}
}
